# File: 2Cocolog_Perl.pl
# Date            Author        number of nodes
# 2004/5/24       Walking Lint  226
# 2004/5/9        Walking Lint  226
# 2004/5/9        Walking Lint  226 (2Kitaguni_Perl->2Cocolog_Perl)
# 2004/5/3        Walking Lint  226
# 2004/5/1        Walking Lint  225
# 2004/4/26       Walking Lint  225
# 2004/4/23       Walking Lint  191
# 2004/4/18       Walking Lint  189
# 2004/4/17       Walking Lint  188
# 2004/4/11       Walking Lint  181
# 2004/4/10       Walking Lint  176
# 2004/4/9        Walking Lint  279
# 2004/4/9        Walking Lint  186 (2Hatena_Perl->2Kitaguni_Perl)
# 2004/4/9        Walking Lint  186
# 2004/4/3        Walking Lint  186
# 2004/4/2        Walking Lint  176
# 2004/3/27       Walking Lint  172
# 2004/3/23       Walking Lint  170
# 2003/12/4       Walking Lint  169
# 2003/11/24      Walking Lint  168
# 2003/11/19      Walking Lint  164
# 2003/11/17      Walking Lint  162
# 2003/11/14      Walking Lint  161
# 2003/11/5       Walking Lint  161
# 2003/11/5       Walking Lint  159
# 2003/10/17      Walking Lint  159
# 2003/10/15      Walking Lint  148
# 2003/10/10      Walking Lint  147
# 2003/10/9       Walking Lint  144
# 2003/10/6       Walking Lint  142
# 2003/10/5       Walking Lint  131
# 2003/10/4       Walking Lint  130
# 2003/10/3       Walking Lint  128
# 2003/10/1       Walking Lint  93
# 2003/10/1       Walking Lint  92
# 2003/10/1       Walking Lint  80 (TextWithStructureWriter_Perl->2Hatena_Perl)
# 2003/10/1       Walking Lint  80
# 2003/5/8        Walking Lint  74
# 2003/5/8        Walking Lint  60 (2PowerPoint_Perl->TextWithStructureWriter_Perl)
# 2003/2/12       Walking Lint  60
# 2002/11/10      Walking Lint  33 (2PowerPoint_Perl->2PowerPoint_Perl)
# 2002/11/9       Walking Lint  29
# 2002/6/4        Walking Lint  29 (CSVWriter_Perl->2PowerPoint_Perl)
# 2002/3/10       Walking Lint  20

=pod

=head1 NAME

2Cocolog_Perl.pl - to cocolog

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$to_file = shift; # actually not assumed ... now ...
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
@htmlelements = ('!doctype', 'a', 'center', 'div', 'embed', 'head', 'li', 'link', 'meta', 'ol', 'p', 'table', 'title', 'ul'); # actually embed can not be used ... see [[`lktv - I[vEuOER~jeB!http://ch.kitaguni.tv/docs/about/10tag.html]]
my $root = {}; # this is needed ...
$crlf = ' CR' . 'LF ';
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if (length($to_file) != 0) {
  open OUT, ">$to_file";
  $outfilehandle = 'OUT';
} else {
  $outfilehandle = 'STDOUT';
}
open OUT, ">$to_file";
$count = 0;
if (defined($root->{CHILD}->{CHILD}) and $root->{CHILD}->{NAME} =~ /[0-9]+\/[0-9]+\/[0-9]+/) { # currently ...
  &genoutline($root, 1);
} elsif (defined($root->{CHILD})) {
  my $cn = $root->{CHILD};
  while (1) {
    &gennode($cn, 2);
    if (not defined($cn->{NEXT})) {
      last;
    }
    $cn = $cn->{NEXT};
  }
}
if (length($to_file) != 0) {
  close OUT;
  DebugPrint("generated $to_file");
}
sub genhtml {
  my($nd) = @_;
  my $nm = $nd->{NAME};
  DebugPrint("nm = $nm");
  my $attr = $nd->{TYPE};
  DebugPrint("attr = $attr");
  my $txt = $nd->{TEXT};
  DebugPrint("txt = $txt");
  my $ret = '';
  if (length($attr) != 0) {
    $ret = '<' . $nm . ' ' . $attr . '>';
  } else {
    $ret = '<' . $nm . '>';
  }
  $ret .= $txt;
  my $cn = $nd->{CHILD};
  if (defined($cn)) {
    while (1) {
      if (not defined($inhibitimg) and ($cn->{NAME} =~ /_part/) and ($cn->{TYPE} =~ /\.jpg$/)) {
        if (length($cn->{TEXT}) != 0) {
          $ret .= "<img src=\"$cn->{TYPE}\" $cn->{TEXT}></img>";
        } else {
          $ret .= "<img src=\"$cn->{TYPE}\"></img>";
        }
      } elsif (&ishtmlelement($cn->{NAME})) { # currently ... think later for html element and script ...
        $ret .= &genhtml($cn);
      } else {
        # do nothing ... currently ...
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
  $ret .= '</' . $nm . '>';
  DebugPrint("ret = $ret");
  return $ret;
}
sub genoutline {
  my($nd, $level) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &gennode($cn, $level);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub gennode {
  my($cn, $level) = @_;
  Trace("enter gennode(cn = " . $cn->{NAME} . ")");
  $name = $cn->{NAME};
  if (($name =~ /^_/) or ($cn->{KIND} =~ /!/)) { # exclude
    # do nothing
  } elsif (&ishtmlelement($name)) { # currently ... think later for html element and script ...
    print $outfilehandle "\n" . &genhtml($cn) . "\n";
  } elsif (not &ishtmlelement($name)) {
    if (($level == 1) or ($level > 2)) { # do nothing for date or ...
    } elsif ($level == 2) { # shou koumoku
      $type = $cn->{TYPE};
      if (length($type) != 0) {
        $type =~ s/[ ]*֌W//;
        $title = "\n" . "*[" . $type . "]" . $name . "\n\n";
      } else {
        $title = "\n" . "*[̑]" . $name . "\n\n";
      }
      print $outfilehandle $title;
      $count += length($title);
      $text = $cn->{TEXT};
      $text =~ s/\n*\([0-9:]+\)\n*$//;
      if (length($text) > 0) {
        # treat for pre ...
        @lines = split(/$crlf/, $text);
        $in_pre = 0;
        $in_ul = 0;
        $in_ol = 0;
        $found_space = 1;
        $text = '';
        foreach $line (@lines) {
          if ($in_pre) {
            if (($line =~ /<\/pre>/) or ($line =~ /<\/div>/)) {
              $in_pre = 0;
              $line =~ s/<\/div>/<\/pre>/; # hack ...
            }
            $text .= "\n" . $line;
          } else {
            if ($line =~ /^- /) {
              $line =~ s/^-/<li>/;
              if ($in_ul == 0) {
                $in_ul = 1;
                $text .=  "<ul>" . $line;
              } else {
                $text .=  "\n" . $line;
              }
              $found_space = 1;
            } elsif ($line =~ /^\+ /) {
              $line =~ s/^\+/<li>/;
              if ($in_ol == 0) {
                $in_ol = 1;
                $text .=  "<ol>" . $line;
              } else {
                $text .=  "\n" . $line;
              }
              $found_space = 1;
            } elsif (($line =~ /^E/) and not ($line =~ /^EE/)) {
              $line =~ s/^E/<li> /;
              $text .=  "\n" . $line;
              $found_space = 1;
            } elsif (($line =~ /^/) and not ($line =~ /^/)) {
              $line =~ s/^/<li> /;
              $text .=  "\n" . $line;
              $found_space = 1;
            } else {
              if ($in_ul and (length($line) == 0)) {
                $in_ul = 0;
                $text .=  "</ul>\n";
              } elsif ($in_ol and (length($line) == 0)) {
                $in_ol = 0;
                $text .=  "</ol>\n";
              }
              if (($line =~ /<pre>/) or ($line =~ /<div class="code">/)) {
                $in_pre = 1;
                $line =~ s/<div class="code">/<pre>/;
              }
              if (length($line) == 0) {
                $text .= "\n\n";
                $found_space = 1;
              } else {
                if ($line =~ /<\/div>/) {
                  if ($in_ul) {
                    $text .= "</ul>" . $line;
                    $in_ul = 0;
                  } elsif ($in_ol) {
                    $text .= "</ol>" . $line;
                    $in_ol = 0;
                  } else {
                    $text .= "\n" . $line;
                  }
                  $found_space = 0;
                } elsif ($found_space) {
                  $text .= $line;
                  $found_space = 0;
                } else {
                  $text .= " " . $line;
                }
              }
            }
          }
        }
        $text =~ s/<div class="ref">/BEGREF/g; # this is hack ...
        $text =~ s/<\/div>/ENDREF/g; # this is hack ...
        $text =~ s/\t/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/g; # this is hack ...
        $text =~ s/\[\[([^!]*!.*?)\]\]/BEGQUOTE$1ENDQUOTE/g; # not actually but for simplicity ... think later ...
        $text =~ s/BEGQUOTE([^!]*?)ENDQUOTE/[[$1]]/g; # not actually but for simplicity ... think later ...
        $text =~ s/BEGQUOTE(.*?)!([^!]*)ENDQUOTE/<a href=$2>$1<\/a>/g; # not actually but for simplicity ... think later ...
        $text =~ s/BEGREF[ \n]*/\n<blockquote>/g; # hack ... think later ...
        $text =~ s/BEGREF-/\n<blockquote>-/g; # hack ... think later ...
        $text =~ s/ ENDREF/<\/blockquote>\n/g; # hack ... think later ...
        $text =~ s/\n*ENDREF/<\/blockquote>\n/g; # hack ... think later ...
        $text =~ s/<br[ ]*\/>/<br>/g; # hack ... think later ...
        $text =~ s/\n\n\n*/\n\n/g; # hack ... think later ...
        $text =~ s/\n\n(<[uo]l>)/\n$1/g; # hack ... think later ...
        $text .= "\n";
        print $outfilehandle $text;
        $count += length($text);
      }
    }
    &genoutline($cn, $level + 1);
  } else {
    &genoutline($cn, $level);
  }
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    $str =~ tr/A-Z/a-z/;
    if ($str eq $htmlelement) {
      return 1;
    }
  }
  return 0;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
