# File: 2Hatena_Perl.pl
# Date            Author        number of nodes
# 2005/10/21      Walking Lint  189

=pod

=head1 NAME

2Hatena_Perl.pl - to hatena

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Tk;
$use_default_category = shift;
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
@htmlelements = ('!doctype', 'a', 'center', 'div', 'head', 'li', 'link', 'meta', 'ol', 'p', 'table', 'title', 'ul');
my $root = {}; # this is needed ...
$crlf = ' CR' . 'LF ';
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if (length($to_file) != 0) {
  open OUT, ">$to_file";
  $outfilehandle = 'OUT';
} else {
  $outfilehandle = 'STDOUT';
}
open OUT, ">$to_file";
$count = 0;
if (defined($root->{CHILD}->{CHILD}) and $root->{CHILD}->{NAME} =~ /[0-9]+\/[0-9]+\/[0-9]+/) {
  &genoutline($root, 1);
} elsif (defined($root->{CHILD})) {
  my $cn = $root->{CHILD};
  while (1) {
    &gennode($cn, 2);
    if (not defined($cn->{NEXT})) {
      last;
    }
    $cn = $cn->{NEXT};
  }
}
if ($count > 256 * 4 * 64) {
  DebugPrint("$count > 64K (NG)");
} else {
  DebugPrint("$count <= 64K (OK)");
}
if (length($to_file) != 0) {
  close OUT;
  DebugPrint("generated $to_file");
}
if ($count > 256 * 4 * 64) {
  $height = 50;
  $width = 120;
  $mw = MainWindow->new;
  $mw->title("");
  $can = $mw->Canvas(-width => $width, -height => $height, -background => "white")
    ->pack();
  $can->createText($width / 2, $height / 2, -text => "$count > 64K (NG)", -anchor => 'c');
  MainLoop();
}
sub genhtml {
  my($nd) = @_;
  my $nm = $nd->{NAME};
  my $attr = $nd->{TYPE};
  my $txt = $nd->{TEXT};
  my $ret = '';
  if (length($attr) != 0) {
    $ret = '<' . $nm . ' ' . $attr . '>';
  } else {
    $ret = '<' . $nm . '>';
  }
  $ret .= $txt;
  my $cn = $nd->{CHILD};
  if (defined($cn)) {
    while (1) {
      if (not defined($inhibitimg) and ($cn->{NAME} =~ /_part/) and ($cn->{TYPE} =~ /\.jpg$/)) {
        if (length($cn->{TEXT}) != 0) {
          $ret .= "<img src=\"$cn->{TYPE}\" $cn->{TEXT}></img>";
        } else {
          $ret .= "<img src=\"$cn->{TYPE}\"></img>";
        }
      } elsif (&ishtmlelement($cn->{NAME})) {
        $ret .= &genhtml($cn);
      } else {
        # do nothing ... currently ...
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
  $ret .= '</' . $nm . '>';
  DebugPrint("ret = $ret");
  return $ret;
}
sub genoutline {
  my($nd, $level) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &gennode($cn, $level);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub gennode {
  my($cn, $level) = @_;
  $name = $cn->{NAME};
  if (($name =~ /^_/) or ($cn->{KIND} =~ /!/)) {
    # do nothing
  } elsif (&ishtmlelement($name)) {
    print $outfilehandle "\n" . &genhtml($cn) . "\n";
  } elsif (not &ishtmlelement($name)) {
    if (($level == 1) or ($level > 2)) { # do nothing for date or ...
    } elsif ($level == 2) {
      $type = $cn->{TYPE};
      $name =~ s/^\[[^\]]*\]( )*//;
      if (length($type) != 0) {
        $type =~ s/[ ]*֌W//;
        $title = "\n" . "*[" . $type . "]" . $name . "\n\n";
      } elsif ($use_default_category == 1) {
        $title = "\n" . "*[̑]" . $name . "\n\n";
      } else {
        $title = "\n" . "*" . $name . "\n\n";
      }
      print $outfilehandle $title;
      $count += length($title);
      $text = $cn->{TEXT};
      $text =~ s/\n*\([0-9:]+\)\n*$//;
      if (length($text) > 0) {
        # treat for pre ...
        @lines = split(/$crlf/, $text);
        $in_pre = 0;
        $found_space = 1;
        $text = '';
        foreach $line (@lines) {
          $line =~ s/\[\[(.*?!(?:[^\[\]]*?|\[\[[^\]\[]*?\]\]|\[[^\[\]]*?\])*?)\]\]/BEGQUOTE$1ENDQUOTE/g; # not actually but for simplicity ... think later ...
          $line =~ s/^\*/HEADSTAR/;
          if ($in_pre) {
            if (($line =~ /<\/pre>/) or ($line =~ /<\/div>/)) {
              $in_pre = 0;
              $line =~ s/<\/div>/<\/pre>/; # hack ...
            }
            $line =~ s/http:/[]http:[]/; # hack ...
            $text .= "\n" . $line;
          } else {
            if (($line =~ /<pre>/) or ($line =~ /<div class="code">/)) {
              $in_pre = 1;
              $line =~ s/<div class="code">/<pre>/;
            }
            if (length($line) == 0) {
              $text .= "\n";
              $found_space = 1;
            } elsif ($line =~ /^http:\/\//) {
              $text .=  "[]" . $line . "[]";
            } elsif ($line =~ /^(-|\+) /) {
              $text .=  "\n" . $line;
              $found_space = 1;
            } elsif (($line =~ /^E/) and not ($line =~ /^EE/)) {
              $line =~ s/^E/- /;
              $text .=  "\n" . $line;
              $found_space = 1;
            } elsif (($line =~ /^/) and not ($line =~ /^/)) {
              $line =~ s/^/- /;
              $text .=  "\n" . $line;
              $found_space = 1;
            } else {
              if ($line =~ /<\/div>/) {
                $text .= "\n" . $line;
                $found_space = 0;
              } elsif ($found_space) {
                $text .= $line;
                $found_space = 0;
              } else {
                $text .= " " . $line;
              }
            }
          }
        }
        $text =~ s/<div class="ref">/BEGREF/g; # this is hack ...
        $text =~ s/<\/div>/ENDREF/g; # this is hack ...
        $text =~ s/<pre>/\n><pre>/g; # this is hack ...
        $text =~ s/<\/pre>/<\/pre></g; # this is hack ...
        $text =~ s/\t/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/g; # this is hack ...
        $text =~ s/BEGQUOTE([^!]*?)ENDQUOTE/[[$1]]/g; # not actually but for simplicity ... think later ...
        $text =~ s/BEGQUOTE(.*?)!([^!]*)ENDQUOTE/<a href="$2">$1<\/a>/g; # not actually but for simplicity ... think later ...
        $text =~ s/BEGREF[ \n]*/\n>>\n/g; # hack ... think later ...
        $text =~ s/BEGREF-/\n>>\n-/g; # hack ... think later ...
        $text =~ s/ ENDREF/\n<<\n/g; # hack ... think later ...
        $text =~ s/ENDREF/<<\n/g; # hack ... think later ...
        $text =~ s/HEADSTAR/ */g;
        $text =~ s/<br[ ]*\/>/<br>/g; # hack ... think later ...
        $text =~ s/\n\n\n*/\n\n/g; # hack ... think later ...
        $text =~ s/http:\/\/d.hatena\.ne\.jp\//http:\/\/d.hatena\.ne\.jp\/\.\//g; # hack ... think later ...
        $text =~ s/\n-- /\n -- /;
        $text .= "\n";
        print $outfilehandle $text;
        $count += length($text);
      }
    }
    &genoutline($cn, $level + 1);
  } else {
    &genoutline($cn, $level);
  }
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    $str =~ tr/A-Z/a-z/;
    if ($str eq $htmlelement) {
      return 1;
    }
  }
  return 0;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
