# File: 2PowerPoint_Perl.pl
# Date            Author        number of nodes
# 2003/2/12       Walking Lint  60
# 2002/11/10      Walking Lint  33 (2PowerPoint_Perl->2PowerPoint_Perl)
# 2002/11/9       Walking Lint  29
# 2002/6/4        Walking Lint  29 (CSVWriter_Perl->2PowerPoint_Perl)
# 2002/3/10       Walking Lint  20

=pod

=head1 NAME

2PowerPoint_Perl.pl - to .txt which PowerPoint can import

=head1 DESCRIPTION

activate as plug-in (assuming certain outline structure ... think later ...)

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
DebugPrint("from_file = $from_file");
@htmlelements = ('a', 'center', 'div', 'li', 'ol', 'p', 'table', 'ul');
my $root = {}; # this is needed ...
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
&treathtmlelements($root);
open OUT, ">$to_file";
&genoutline($root, 1);
close OUT;
DebugPrint("generated $to_file");
sub genoutline {
  my($nd, $level) = @_;
  Trace("enter genoutline " . $nd->{NAME});
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      $name = $cn->{NAME};
      print OUT "\t" x ($level - 1) . $name . "\n";
      &genoutline($cn, $level + 1);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    if (($str eq $htmlelement) or ($str eq '<' . $htmlelement . '>')) {
      return 1;
    }
  }
  return 0;
}
sub treathtmlelements {
  my($nd) = @_;
  if (&ishtmlelement($nd->{NAME}) or $nd->{NAME} =~ /^_/) {
    &delnode($nd);
    return;
  }
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      my $ncn = $cn->{NEXT};
      &treathtmlelements($cn);
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
