# File: 2SJIS_Perl.pl
# Date            Author        number of nodes
# 2005/3/22       Walking Lint  56
# 2003/12/14      Walking Lint  54
# 2003/9/3        Walking@Lint 49
# 2003/8/31       Walking@Lint 32
# 2003/8/17       Walking@Lint 23
# 2003/6/21       Walking Lint  21
# 2003/6/21       Walking Lint  21 (ToSJIS_Perl->2SJIS_Perl)
# 2003/6/21       Walking Lint  21
# 2003/6/21       Walking Lint  21 (FromUTF8_Perl->ToSJIS_Perl)
# 2003/6/2        Walking Lint  21
# 2003/6/2        Walking Lint  12 (BreakLines_Perl->FromUTF8_Perl)
# 2003/4/9        Walking Lint  105

=pod

=head1 NAME

2SJIS_Perl.pl - convert to sjis

=head1 DESCRIPTION

activate as filter...

=head1 AUTHOR

Walking Lint

=cut

use Jcode;
use File::Basename;
$from_file = shift;
if (defined($from_file)) {
  $to_file = $from_file;
  $basename = basename($to_file);
  if ($basename =~ /(\.[^\.]+$)/) {
    $to_file =~ s/(\.[^\.]+$)/_sjis$1/;
  } else {
    $to_file .= '_sjis';
  }
  open IN, $from_file or die("Cannot open $from_file: $!\n");
  open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
  $foundcharset = 0;
  while (<IN>) {
    if (not $foundcharset) {
      $_ =~ s/charset=utf-8/charset=Shift_JIS/; # this is hack ... ^^
    } else {
      $foundcharset = 1;
    }
    $_ =~ s/\n$//;
    Jcode::convert(\$_, 'sjis');
    print OUT $_ . "\n";
  }
  close IN;
  close OUT;
  DebugPrint("generated " . $to_file);
} else { # actually this does not work correctly ... user upper case ...
  while (<STDIN>) {
    Jcode::convert(\$_, 'sjis');
    print $_;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
