# File: 2UTF8_Perl.pl
# Date            Author        number of nodes
# 2003/9/19       Walking Lint  52
# 2003/9/19       Walking Lint  49 (2SJIS_Perl->2UTF8_Perl)
# 2003/9/3        Walking@Lint 49
# 2003/8/31       Walking@Lint 32
# 2003/8/17       Walking@Lint 23
# 2003/6/21       Walking Lint  21
# 2003/6/21       Walking Lint  21 (ToSJIS_Perl->2SJIS_Perl)
# 2003/6/21       Walking Lint  21
# 2003/6/21       Walking Lint  21 (FromUTF8_Perl->ToSJIS_Perl)
# 2003/6/2        Walking Lint  21
# 2003/6/2        Walking Lint  12 (BreakLines_Perl->FromUTF8_Perl)
# 2003/4/9        Walking Lint  105

=pod

=head1 NAME

2UTF8_Perl.pl - convert to utf-8 (also set to clipboard)

=head1 DESCRIPTION

activate as filter...

=head1 AUTHOR

Walking Lint

=cut

use Jcode;
use File::Basename;
use Win32::Clipboard;
$from_file = shift;
if (defined($from_file)) {
  $to_file = $from_file;
  $basename = basename($to_file);
  if ($basename =~ /(\.[^\.]+$)/) {
    $to_file =~ s/(\.[^\.]+$)/_utf8$1/;
  } else {
    $to_file .= '_utf8';
  }
  open IN, $from_file or die("Cannot open $from_file: $!\n");
  open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
  $foundcharset = 0;
  while (<IN>) {
    if (not $foundcharset) {
      $_ =~ s/charset=Shift_JIS/charset=utf-8/; # this is hack ... ^^
    } else {
      $foundcharset = 1;
    }
    $_ =~ s/\n$//;
    Jcode::convert(\$_, 'utf8');
    print OUT $_ . "\n";
  }
  close IN;
  close OUT;
  DebugPrint("generated " . $to_file);
} else { # actually this does not work correctly ... user upper case ...
  $clip = Win32::Clipboard->new;
  $breaklater = 0;
  while (<STDIN>) {
    if ($_ =~ /^__EOF__[\n\r]*$/) {
      last;
    } elsif ($_ =~ /__EOF__[\n\r]*$/) {
      $_ =~ s/__EOF__[\n\r]*$//;
      $breaklater = 1;
    }
    Jcode::convert(\$_, 'utf8');
    print $_;
    $clip->Set($_);
    if ($breaklater) {
      last;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
