# File: AssocCommentInText_Perl.pl
# Date            Author        number of nodes
# 2006/7/19       Walking Lint  251
# 2006/7/14       Walking Lint  244
# 2006/7/13       Walking Lint  96
# 2006/7/12       Walking Lint  79
# 2006/7/12       Walking Lint  159 (GenRefRelationsFromPatents_Perl->AssocCommentInText_Perl)
# 2006/5/9        Walking Lint  159
# 2006/5/8        Walking Lint  154
# 2005/4/13       Walking Lint  105
# 2005/4/7        Walking Lint  94
# 2005/4/4        Walking Lint  84
# 2005/4/2        Walking Lint  51
# 2005/4/2        Walking Lint  265 (AugmentFTermWithPatent_Perl->GenRefRelationsFromPatents_Perl)
# 2005/3/31       Walking Lint  265
# 2005/3/24       Walking Lint  265
# 2005/3/23       Walking Lint  263
# 2005/3/17       Walking Lint  263
# 2005/3/16       Walking Lint  224
# 2005/3/14       Walking Lint  277
# 2005/3/11       Walking Lint  273
# 2005/3/10       Walking Lint  267
# 2005/3/9        Walking Lint  235
# 2005/3/8        Walking Lint  154
# 2005/3/7        Walking Lint  128
# 2005/3/6        Walking Lint  126
# 2005/3/6        Walking Lint  123 (PatentMapWriter_Perl->AugmentFTermWithPatent_Perl)
# 2005/3/5        Walking Lint  123
# 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl)
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85
use lib '.';
use CVTree_Perl;
$is_us = shift;
$from_file = shift;
$to_file = $from_file;
my $root = {};
$crlf = ' CR' . 'LF ';
$templatesfolder = $ENV{TEMPLATESFOLDER};
$db = $templatesfolder . '\division';
dbmopen %relation, $db, 0666; # try this ...
if (defined($from_file)) {
  $filtering = 0;
  &initnode($root, 'root', '', '', '');
  &gentree($root, $from_file);
  &get_relation($root);
  &set_relation($root);
  &savetree($root, $to_file);
} else {
  $filtering = 1;
  @lines = <STDIN>;
  &get_relation_body(\@lines);
  @outlines = ();
  &set_relation_body(\@lines);
  foreach $outline (@outlines) {
    print $outline;
  }
}
dbmclose %relation;
DebugPrint("generated $to_file");
sub get_relation {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &get_relation($cn);
      if (defined($cn->{TEXT})) {
        @lines = split(/$crlf/, $cn->{TEXT});
        &get_relation_body(\@lines);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub get_relation_body {
  my($lines_ref) = @_;
  if ($is_us == 1) {
    foreach $line (@$lines_ref) {
      if ($line =~ /^<!--/) {
        if ($line =~ /<!-- [^ ]+ ([^\(]+)\(([^\)]+)\)/) {
          $name = $1;
          $division = $2;
          $name =~ s/[ ]+|@|\x81\xA3|\x81\xA5//g; # this is hack ...
          $name =~ s/\([0-9]+\)$//; # this is hack ...
          if (not defined($relation{$name}) or ($relation{$name} eq '???')) {
            $relation{$name} = $division;
            DebugPrint("registered relation{$name} = $relation{$name}");
          }
        }
      }
    }
  } else {
    $prev_line = '';
    foreach $line (@$lines_ref) {
      if ($line =~ /^<!--/) {
        if ($prev_line =~ /- \[\[[^ ]+ ([^ ]+(?:[ ]+|@)[^ ]+) /) {
          $name = $1;
          $name =~ s/[ ]+|@|\x81\xA3|\x81\xA5//g; # this is hack ...
          $name =~ s/\([0-9]+\)$//; # this is hack ...
          if (not defined($relation{$name}) or ($relation{$name} eq '???')) {
            $line =~ /<!-- (.*) -->/;
            $relation{$name} = $1;
          }
        }
      } else {
        $prev_line = $line;
      }
    }
  }
}
sub set_relation {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &set_relation($cn);
      if (defined($cn->{TEXT})) {
        @lines = split(/$crlf/, $cn->{TEXT});
        @outlines = ();
        &set_relation_body(\@lines);
        $cn->{TEXT} = join($crlf, @outlines);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub set_relation_body {
  my($lines_ref) = @_;
  if ($is_us == 1) {
    foreach $line (@$lines_ref) {
      if ($line =~ /^<!--/) {
        if ($line =~ /<!-- [^ ]+ ([^\(]+)\(([^\)]+)\)/) {
          $name = $1;
          $division = $2;
          $name =~ s/[ ]+|@|\x81\xA3|\x81\xA5//g; # this is hack ...
          $name =~ s/\([0-9]+\)$//; # this is hack ...
          if ($division eq '???') {
            if (defined($relation{$name}) and not ($relation{$name} eq '???')) {
              DebugPrint("changed comment to $name");
              $line =~ s/\?\?\?/$relation{$name}/;
            }
          }
        } elsif ($line =~ /<!-- [^ ]+ ([^ ]+) /) {
          $name = $1;
          if (defined($relation{$name})) {
            DebugPrint("added comment to $name");
            $line =~ s/$name/$name\($relation{$name}\)/;
          }
        }
      }
      push @outlines, $line;
    }
  } else {
    $prev_line_was_comment = 0;
    $prev_line = '';
    foreach $line (@$lines_ref) {
      if ($line =~ /^<!--/) {
        if ($line eq '<!-- ??? -->') {
          if ($prev_line =~ /- \[\[[^ ]+ ([^ ]+(?:[ ]+|@)[^ ]+) /) {
            $name = $1;
            $name =~ s/[ ]+|@|\x81\xA3|\x81\xA5//g; # this is hack ...
            $name =~ s/\([0-9]+\)$//; # this is hack ...
            if (defined($relation{$name}) and not ($relation{$name} eq '???')) {
              DebugPrint("changed comment to $name");
              if ($filtering == 1) {
                $line = '<!-- ' . $relation{$name} . ' -->' . "\n";
              } else {
                $line = '<!-- ' . $relation{$name} . ' -->';
              }
            }
          }
        }
        $prev_line_was_comment = 1;
        $prev_line = '';
      } elsif ($prev_line_was_comment == 1) {
        $prev_line_was_comment = 0;
        $prev_line = $line;
      } else {
        if ($prev_line =~ /- \[\[[^ ]+ ([^ ]+[ ]+[^ ]+) /) {
          $name = $1;
          $name =~ s/[ ]+|@|\x81\xA3|\x81\xA5//g; # this is hack ...
          $name =~ s/\([0-9]+\)$//; # this is hack ...
          if (defined($relation{$name})) {
            DebugPrint("added comment to $name");
            if ($filtering == 1) {
              push @outlines, '<!-- ' . $relation{$name} . ' -->' . "\n";
            } else {
              push @outlines, '<!-- ' . $relation{$name} . ' -->';
            }
          }
        }
        $prev_line_was_comment = 0;
        $prev_line = $line;
      }
      push @outlines, $line;
    }
    if ($prev_line_was_comment == 0) {
      if ($prev_line =~ /- \[\[[^ ]+ ([^ ]+[ ]+[^ ]+) /) {
        $name = $1;
        $name =~ s/[ ]+|@|\x81\xA3|\x81\xA5//g; # this is hack ...
        $name =~ s/\([0-9]+\)$//; # this is hack ...
        if (defined($relation{$name})) {
          DebugPrint("added comment to $name");
          if ($filtering == 1) {
            push @outlines, '<!-- ' . $relation{$name} . ' -->' . "\n";
          } else {
            push @outlines, '<!-- ' . $relation{$name} . ' -->';
          }
        }
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
