# File: AugmentFTermWithPatent_Perl.pl
# Date            Author        number of nodes
# 2006/3/27       Walking Lint  318
# 2006/3/24       Walking Lint  315
# 2006/3/22       Walking Lint  311
# 2006/3/20       Walking Lint  302
# 2005/7/12       Walking Lint  280
# 2005/4/28       Walking Lint  272
# 2005/3/31       Walking Lint  265
# 2005/3/24       Walking Lint  265
# 2005/3/23       Walking Lint  263
# 2005/3/17       Walking Lint  263
# 2005/3/16       Walking Lint  224
# 2005/3/14       Walking Lint  277
# 2005/3/11       Walking Lint  273
# 2005/3/10       Walking Lint  267
# 2005/3/9        Walking Lint  235
# 2005/3/8        Walking Lint  154
# 2005/3/7        Walking Lint  128
# 2005/3/6        Walking Lint  126
# 2005/3/6        Walking Lint  123 (PatentMapWriter_Perl->AugmentFTermWithPatent_Perl)
# 2005/3/5        Walking Lint  123
# 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl)
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

AugmentFTermWithPatent_Perl.pl - augment fterm with patent

=head1 DESCRIPTION

activate as program ex. AugmentFTermWithPatent_Perl () // "CurrentFile"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Jcode;
use File::Basename;
use Time::localtime;
$is_US = shift;
$from_file = shift;
$fterms_to_check = join('\t', @ARGV);
my $root = {};
my $root2 = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
&setmap($root);
&augmentfterm();
sub setmap {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if (($is_US == 0) and ($cn->{NAME} eq 's') or ($is_US == 1) and ($cn->{NAME} =~ /^Patent\/Publication Number/)) { # for MicroPatentReader
        $text = $cn->{TEXT};
        ($company, $name, $patent_num, $patent_name, $file, $id) = split(/\t/, $text);
        if ($cn->{KIND} =~ /!/) {
          $text =~ s/$company/$company */; # this is hack ...
        }
        my $ccn = $cn->{CHILD};
        $found_fterm = '';
        $found_fterm2 = '';
        while (1) {
          if (($is_US == 0) and ($ccn->{NAME} =~ /^(|㗝l|ol||lĎ|Ql)/)) {
            my $cccn = $ccn->{CHILD};
            while (1) {
              if ($cccn->{NAME} eq 'e^[iQlj') { # try this ...
                $found_fterm = $cccn->{TEXT};
              } elsif ($cccn->{NAME} eq 'e^[ieiXj') {
                $found_fterm2 = $cccn->{TEXT};
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
          }
          if (($is_US == 1) and ($ccn->{NAME} eq 'CLASSIFICATION')) { # this is for MicroPatentReader
            my $cccn = $ccn->{CHILD};
            while (1) {
              if ($cccn->{NAME} eq 'US Class') {
                $item = $cccn->{TEXT};
                $item =~ /([0-9][0-9][0-9])([0-9][0-9][0-9])([0-9A-Z]*)/;
                $pc = $1;
                $pc2 = $2;
                $added_pc2 = $3;
                $pc =~ s/^[0]+//; # this may be hack ...
                $pc2 =~ s/^[0]+//; # this may be hack ...
                $added_pc2 =~ s/[0]+$//; # this may be hack ...
                if (length($added_pc2) != 0) {
                  if ($added_pc2 =~ /^[0]+([A-Z]+)$/) {
                    $pc2 .= $1;
                  } elsif ($added_pc2 =~ /[A-Z]+/) {
                    $pc2 .= $added_pc2;
                  } else {
                    $pc2 .= '.' . $added_pc2;
                  }
                }
                $index = $pc . '_' . $pc2;
                $pcs{$pc}++;
                if (defined($pc2s{$pc})) {
                  $pc2s{$pc} = $pc2s{$pc} . ' _SEP_ ' . $pc2 . ' ' . $text;
                } else {
                  $pc2s{$pc} = $pc2 . ' ' . $text;
                }
                $map{$index}++;
                if (defined($map_content{$index})) {
                  $map_content{$index} = $map_content{$index} . ' _SEP_ ' . $text; # this is hack ...
                } else {
                  $map_content{$index} = $text;
                }
                last;
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
        if (length($found_fterm2) != 0) {
          $found_fterm = $found_fterm2;
        }
        if (length($found_fterm) != 0) {
          @items = split(/\t/, $found_fterm);
          my $cnt = 0;
          foreach $item (@items) {
            if ($cnt % 2 == 0) {
              $fterm = $item;
            } else {
              @fsubterms = split(/[ ]+/, $item);
              foreach $fsubterm (@fsubterms) {
                $index = $fterm . '_' . $fsubterm;
                $pcs{$fterm}++;
                if (defined($pc2s{$fterm})) {
                  $pc2s{$fterm} = $pc2s{$fterm} . ' _SEP_ ' . $fsubterm . ' ' . $text;
                } else {
                  $pc2s{$fterm} = $fsubterm . ' ' . $text;
                }
                $map{$index}++;
                if (defined($map_content{$index})) {
                  $map_content{$index} = $map_content{$index} . ' _SEP_ ' . $text; # this is hack ...
                } else {
                  $map_content{$index} = $text;
                }
              }
            }
            $cnt++;
          }
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
# hack ??? but it works...
sub mydirname {
  my($fn) = @_;
  $fn = jcode($fn)->euc;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  $res = jcode($res)->sjis;
  return $res;
}
sub augmentfterm {
  foreach $pc (sort keys %pcs) {
    $found_pc = 0;
    if ((length($fterms_to_check) != 0) and not ($fterms_to_check =~ /$pc/)) {
      next;
    }
    $pc_file = &mydirname($from_file) . "\\" . $pc . ".pat";
    &initnode($root2, 'root', '', '', '');
    &gentree($root2, $pc_file);
    $nd = $root2->{CHILD}->{CHILD};
    while ($nd != undef) { # defined did not function ... so
      if (not $nd->{NAME} =~ /<a/) {
        if ($is_US == 1) {
          $pc2 = $nd->{NAME};
          $pc2 =~ s/^[0]+//; # this may be hack ...
          $index = $pc . '_' . $pc2;
        } else {
          $index = $pc . '_' . $nd->{NAME};
        }
        if (defined($map{$index})) {
          $found_pc = 1;
          @map_contents = split(/ _SEP_ /, $map_content{$index});
          foreach $map_content (@map_contents) {
            ($company, $name, $patent_num, $patent_name, $file, $id) = split(/\t/, $map_content);
            $file =~ s/\.txt$//;
            $file = '<a href="' . $file . '.htm">' . $file . '</a>';
            &addchildnode($nd, $file, '', '', $company . "\t" . $name . "\t" . $patent_num . "\t" . $patent_name . "\t" . $id);
          }
        }
      }
      $nd = &getnext($nd);
    }
    if ($found_pc) {
      &savetree($root2, $pc_file);
      DebugPrint("augmented $pc_file");
    } else {
      DebugPrint("node not found in augmenting $pc_file");
      @pc2s = split(/ _SEP_ /, $pc2s{$pc});
      foreach $pc2 (@pc2s) {
        DebugPrint("pc2 = $pc2");
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
