# File: BasicReader_Perl.pl
# Date            Author        number of nodes
# 2004/3/13       Walking Lint  579
# 2004/3/12       Walking Lint  576
# 2004/3/11       Walking Lint  522
# 2003/10/3       Walking Lint  515
# 2003/9/27       Walking Lint  505
# 2003/6/25       Walking Lint  492
# 2003/5/17       Walking Lint  454
# 2003/3/24       Walking Lint  448
# 2003/3/20       Walking Lint  394
# 2003/3/20       Walking Lint  464 (JavaScriptReader_Perl->BasicReader_Perl)
# 2003/3/19       Walking Lint  397
# 2003/3/18       Walking Lint  341
# 2003/3/14       Walking Lint  358 (JavaReader_Perl->JavaScriptReader_Perl)
# 2003/3/13       Walking Lint  353 (PerlReader_Perl->JavaReader_Perl)
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

BasicReader_Perl.pat

=head1 DESCRIPTION

activate as plug-in or filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
@langelements = ('begin', 'break', 'case', 'default', 'do', 'else', 'elseif', 'end', 'exit', 'for', 'goto', 'if', 'import', 'loop', 'next', 'select', 'switch', 'when');
$typepattern = '(?:const|set)[ \t]+';
$subdef = '(?:class|function|sub|type)';
$deleteditem = '^(?:end|loop|next)$';
$comment = '\'';
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.bas';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&rescuetree($root);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("linewithoutindent = $linewithoutindent");
  if ($linewithoutindent eq $comment) {
    if ($linewithoutindent =~ /^'\*+$/) {
      DebugPrint("bar comment1");
      return 1;
    } else {
      $name = '_';
      $indentedcomment = '';
      DebugPrint("comment1");
      return 0;
    }
  }
  $comment_part = '';
  if (not ($line =~ /!DOCTYPE/)) { # this is hack ...
    $line =~ s/($comment.*)$//; # this is hack ...
    if (defined($1)) {
      $comment_part = $1;
    }
  }
  $line =~ /^([\t ]*)((?:[^'])*)/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  DebugPrint("level = $level");
  $argline = '';
  if (length($comment_part) != 0) {
    $text = $comment_part;
    $indentedcomment = $text;
    $indentedcomment =~ s/^$comment( )?//;
    DebugPrint("indentedcomment = $indentedcomment");
    $text =~ s/^$comment[\t ]*//;
    if (length($linewithoutindentandcomment) == 0) {
      if ($indentedcomment =~ /^\*+$/) {
        DebugPrint("bar comment2");
        return 1;
      } else {
        $name = '_';
        DebugPrint("comment2");
        return 0;
      }
    }
  }
  $name =~ s/[ \t]+$//;
  $name =~ s/^[ \t]*\}[ \t]*//;
  $name =~ s/[ \t]*<\/[^>]+>[ \t]*//; # this is hack ...
  if ($name =~ /[ \t]*then[ \t]*$/i) {
    $name =~ s/[ \t]*\then[ \t]*$//i;
  }
  DebugPrint("name = [" . $name . "] text = [" . $text . "]");
  if (($name eq 'end') or ($name =~ /^end[ \t]/i) or (length($name) == 0)) { # end or } ... } is already deleted ...
    return 1; # skip this line ... think later ...
  # func def with arg and type
  # 
  # [[uṽR[hɂā@@K\@@Gۂ܁`!http://crocro.com/pc/write/hide/chimarl09_03.html]]
  # 
  # [[R[h\@@K\@@Gۂ܁`!http://crocro.com/pc/write/hide/chimarl09_02.html]]
  } elsif ($name =~ /^$subdef[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]+)[ \t]*\([\t ]*(.*)[\t ]*\)[\t ]+as[\t ]*(.+)[ \t]*$/i) {
    $name = $1;
    DebugPrint("funcdef with arg - $name");
    $type = $3;
    $argline = $2;
  # func def with arg
  # 
  # [[uṽR[hɂā@@K\@@Gۂ܁`!http://crocro.com/pc/write/hide/chimarl09_03.html]]
  # 
  # [[R[h\@@K\@@Gۂ܁`!http://crocro.com/pc/write/hide/chimarl09_02.html]]
  } elsif ($name =~ /^$subdef[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]+)[ \t]*\([\t ]*(.*)[\t ]*\)[ \t]*$/i) {
    $name = $1;
    DebugPrint("funcdef with arg - $name");
    $argline = $2;
  } elsif ($name =~ /^($subdef)[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]+)[ \t]*$/i) { # func def without arg
    $name = $2;
    if ($1 =~ /class/i) {
      $kind = ' () + ';
    } elsif ($1 =~ /type/i) {
      $kind = ' () + ';
      $type = 'Type'; # not sure but ...
    }
    DebugPrint("funcdef without arg - $name");
  } elsif ($name =~ /^(const|dim|global|static)[ \t]+((?:[a-zA-Z0-9_\$\@\(\)\[\]\{\}\.\-\>\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,[\t ]*)+)[\t ]*(\([^\)]+\))[\t ]+as[\t ]*(.+)[ \t]*$/i) { # dim decl
    $name = $2;
    DebugPrint("dim array decl - $name");
    $kind = ' (out) ';
    $type = $4 . '  ' . $3;
    if ($1 =~ /static/i) {
      $kind .=  '/ ';
    } elsif ($1 =~ /global/i) {
      $kind .=  '? ';
    } elsif ($1 =~ /const/i) {
      $kind .=  '^ ';
    }
  } elsif ($name =~ /^(const|dim|global|static)[ \t]+((?:[a-zA-Z0-9_\$\@\(\)\[\]\{\}\.\-\>\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,[\t ]*)+)[\t ]+as[\t ]*(.+)[ \t]*$/i) { # dim decl
    $name = $2;
    DebugPrint("dim decl - $name");
    $kind = ' (out) ';
    $type = $3;
    if ($1 =~ /static/i) {
      $kind .=  '/ ';
    } elsif ($1 =~ /global/i) {
      $kind .=  '? ';
    } elsif ($1 =~ /const/i) {
      $kind .=  '^ ';
    }
  } elsif ($name =~ /^(const|dim|global|static)[ \t]+((?:[a-zA-Z0-9_\$\@\(\)\[\]\{\}\.\-\>\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,[\t ]*)+)$/i) { # simple dim decl
    $name = $2;
    DebugPrint("simple dim decl - $name");
    $kind = ' (out) ';
    if ($1 =~ /static/i) {
      $kind .=  '/ ';
    } elsif ($1 =~ /global/i) {
      $kind .=  '? ';
    } elsif ($1 =~ /const/i) {
      $kind .=  '^ ';
    } else {
      $type = $1;
      $type =~ tr/A-Z/a-z/;
    }
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,[\t ]*)+)[\t ]*([\+\-\*\/\.]=)[\t ]*(.+);?$/) { # inout pattern1
    $name = $1;
    DebugPrint("inout pattern1 - $name");
    $kind = ' (inout) ';
    $type = $2 . ' ' . $3;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,[\t ]*)+)[\t ]*(=~)[\t ]*(.+);?$/) { # inout pattern2
    $name = $1;
    DebugPrint("inout pattern2 - $name");
    $kind = ' (inout) ';
    $type = $2 . ' ' . $3;
  } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([a-zA-Z0-9_\$\@\[\]\{\}\.\'\"\(\)]+)[\t ]*\{[\t ]*(.*);?$/)) { # block ... think later ... this is hack
    $name = $1;
    DebugPrint("block - $name");
    $kind .= '~ '; # may not be good ...
    $argline = $2;
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)\([\t ]*(.*)[\t ]*\);?$/) { # static func call with param
    $name = '->' . $1;
    DebugPrint("static -> func call - $name");
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)\([\t ]*(.*)[\t ]*\);?$/) { # static func call with param
    $name = $1;
    DebugPrint("static func call - $name");
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)\([\t ]*(.*)[\t ]*\)[\t ]+if[\t ]+(.*);?$/) { # static func call with if ... think later ...
    $name = $1;
    DebugPrint("static func call with if - $name");
    $type = $2 . ' if ' . $3;
  } elsif (($name =~ /^(var)[\t ]+([^;]+);?$/)) { # my decl
    $name = $2;
    DebugPrint("my decl - $name");
    $kind = ' (out) ';
    $type = $1;
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@]+)[\t ]+(.+)$/) and &islangelement($1)) { # control statement with param ...
    $name = $1;
    DebugPrint("control statement with param - $name");
    $type = $2;
    DebugPrint("type = $type");
    $type =~ s/[ \t]*{[ \t]*$//;
    $type =~ s/^\((.*)\)$/$1/;
    $name =~ tr/A-Z/a-z/;
    if ($name eq 'select') {
      $name = 'switch'; # better ??
      $type =~ s/^case[ \t]+//i;
    } elsif (($name eq 'case') and ($type =~ /^else$/i)) {
      $name = 'default';
      $type = '';
    } elsif (($name eq 'do') and ($type =~ /^until[ \t]+/i)) {
      $name = 'until';
      $type =~ s/^until[ \t]+//i;
    } elsif ($name =~ /$deleteditem/i) {
      return 1;
    }
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@\-\>\:\(\)\"\.]+);?$/)) { # and &islangelement($1) %% control statement (not actually ...)
    $name = $1;
    DebugPrint("control statement - $name");
    if (&islangelement($name)) {
      $name =~ tr/A-Z/a-z/;
      if ($name =~ /$deleteditem/i) {
        return 1;
      }
    }
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\: \-\>\*\+\&\"\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,|[\t ])+)[\t ]*((?:\([^\)]+\)|\.[^\.= \t]+)+)[\t ]*=[\t ]*(.+)$/) { # assignment
    $name = $1;
    $index = $2;
    $init_value = $3;
    $name =~ s/[ \t]+$//;
    $type = '';
    DebugPrint("assignment with index - $name");
    if ((not $name =~ /(\))$/) and ($name =~ /([ \t]+[^ \t]+)$/)) { # and ($name =~ /^((?:$typepattern)+)([^;]+);?/) %% hack???
      if ($name =~ /^((?:$typepattern)+)(.+)/i) {
        $type = $1;
        $name = $2;
        if ($name =~ /^([_a-zA-Z0-9]+)[ ]+([_a-zA-Z\*].*)/) { # this is hack ... treat class name
          $type .= $1;
          $name = $2;
        }
      } elsif ($name =~ /^([_a-zA-Z0-9]+)[ ]+([_a-zA-Z\*].*)/) {
        $type = $1;
        $name = $2;
      }
      $type =~ s/[\t ]+$//;
    }
    if ($type =~ /^set$/i) {
      $kind = ' (out) * ';
      $type = '';
    } else {
      $kind = ' (out) ';
    }
    $type =~ s/[ \t]+/ /g;
    $init_value =~ s/[ \t]+/ /g;
    $type .= $index . '  ' . $init_value; # not sure ... think later ...
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\: \-\>\*\+\(\)\&\"\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,|[\t ])+)[\t ]*=[\t ]*(.+)$/) { # assignment
    $name = $1;
    $init_value = $2;
    $name =~ s/[ \t]+$//;
    $type = '';
    DebugPrint("assignment - $name");
    if ((not $name =~ /(\))$/) and ($name =~ /([ \t]+[^ \t]+)$/)) { # and ($name =~ /^((?:$typepattern)+)([^;]+);?/) %% hack???
      if ($name =~ /^((?:$typepattern)+)(.+)/i) {
        $type = $1;
        $name = $2;
        if ($name =~ /^([_a-zA-Z0-9]+)[ ]+([_a-zA-Z\*].*)/) { # this is hack ... treat class name
          $type .= $1;
          $name = $2;
        }
      } elsif ($name =~ /^([_a-zA-Z0-9]+)[ ]+([_a-zA-Z\*].*)/) {
        $type = $1;
        $name = $2;
      }
      $type =~ s/[\t ]+$//;
    }
    if ($type =~ /^const$/i) {
      $kind = ' (out) ^ ';
      $type = '';
    } elsif ($type =~ /^set$/i) {
      $kind = ' (out) * ';
      $type = '';
    } else {
      $kind = ' (out) ';
    }
    $type =~ s/[ \t]+/ /g;
    $init_value =~ s/[ \t]+/ /g;
    $type .= '  ' . $init_value;
  } elsif (($name =~ /^([a-zA-Z_\$\@\:][0-9a-zA-Z_\$\@\:\.]*)[\t ]+([^;]+);?$/)) { # statement with param (not actually ...)
    $name = $1;
    DebugPrint("statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]+$//;
    DebugPrint("type = $type");
    if ($type =~ /^as[ \t]+(.+)$/i) { # this is hack ...
      $type = $1;
      $kind = ' (out) ';
    }
  } elsif (length($text) != 0) { # not sure but ...
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  } else {
    return 1;
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  # try here filtering ...
  while (<$infilehandle>) {
    push @lines, $_;
  }
  @processed_lines = ();
  $tmp_line = '';
  foreach $line (@lines) {
    if ($line =~ /_$/) {
      if (length($tmp_line) != 0) {
        chop $tmp_line;
        $tmp_line2 = $line;
        $tmp_line2 =~ s/^[ \t]*/ /;
        $tmp_line .= $tmp_line2;
      } else {
        $tmp_line = $line;
      }
      $tmp_line =~ s/_$//;
    } elsif (not ($line =~ /^[ \t]*'/) and ($line =~ /[,=]( \t)*$/)) { # this is hack ...
      # do nothing...
      if (length($tmp_line) != 0) {
        chop $tmp_line;
        $tmp_line2 = $line;
        $tmp_line2 =~ s/^[ \t]*/ /;
        $tmp_line .= $tmp_line2;
      } else {
        $tmp_line = $line;
      }
    } else {
      if ($line =~ /^([ \t]*)dim/i) {
        $pre_space = $1;
        @dimlines = split(/,[ \t]*/, $line);
        $line = shift @dimlines;
        if (length($tmp_line) != 0) {
          chop $tmp_line;
          $tmp_line2 = $line;
          $tmp_line2 =~ s/^[ \t]*/ /;
          $tmp_line .= $tmp_line2;
        } else {
          $tmp_line = $line;
        }
        push @processed_lines, $tmp_line;
        foreach $dimline (@dimlines) {
          push @processed_lines, $pre_space . 'dim ' . $dimline;
        }
        $tmp_line = '';
      } elsif ($line =~ /^([ \t]*)([^:']+)+:[ \t]/) {
        $pre_space = $1;
        @dimlines = split(/:[ \t]*/, $line);
        $line = shift @dimlines;
        if (length($tmp_line) != 0) {
          chop $tmp_line;
          $tmp_line2 = $line;
          $tmp_line2 =~ s/^[ \t]*/ /;
          $tmp_line .= $tmp_line2;
        } else {
          $tmp_line = $line;
        }
        push @processed_lines, $tmp_line;
        foreach $dimline (@dimlines) {
          push @processed_lines, $pre_space . $dimline;
        }
        $tmp_line = '';
      } else {
        if (length($tmp_line) != 0) {
          chop $tmp_line;
          $tmp_line2 = $line;
          $tmp_line2 =~ s/^[ \t]*/ /;
          $tmp_line .= $tmp_line2;
        } else {
          $tmp_line = $line;
        }
        push @processed_lines, $tmp_line;
        $tmp_line = '';
      }
    }
  }
  foreach (@processed_lines) {
    $_ =~ s/[\n\t ]+$//;
    if ((length($_) != 0)) {
      if (&extractparams($_)) {
        $prevname = '';
        next;
      }
      if ($name eq 'exit') { # hack ???
        $type = '';
      } elsif (($name eq 'for') and ($type =~ /^each[ ]+/i)) {
        $name = 'foreach';
        $type =~ s/^each[ ]+//i;
      } elsif ($type =~ /[ ]+then[ ]*$/i) {
        $type =~ s/[ ]+then[ ]*$//i;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        DebugPrint("** 1 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        DebugPrint("** 2 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
        } elsif (($name eq '_text') and ($prevname eq '_text')) { # ($cur->{NAME} eq '_text')
          $cur->{TEXT} .= " \CRLF " . $text;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      } else {
        DebugPrint("** 3 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        until ($prevlevel <= $level) {
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevname = $name;
      $previndentedcomment = $indentedcomment;
      $prevlevel = $level;
      my $argkind = " \(in\) \& ";
      if ($kind =~ /~/) {
        if ($name =~ /\(([^\)]+)\)$/) {
          $name =~ s/[\t ]*\(([^\)]+)\)$//;
          $cur->{NAME} = $name;
          $argline2 = $1;
          my @args2 = reverse split(/[\t ]*,[\t ]*/, $argline2);
          foreach $arg (@args2) {
            if ($arg =~ /=/) {
              $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
              &addchildnode($cur, $1, $argkind, '  ' . $2, '');
            } else {
              &addchildnode($cur, $arg, $argkind, '', '');
            }
          }
        }
      }
      if (length($argline) != 0) {
        my @args = split(/[\t ]*,[\t ]*/, $argline);
        foreach $arg (@args) {
          $argtype = '';
          if ($arg =~ /=/) { # not sure but ...
            $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
            &addchildnode($cur, $1, $argkind, '  ' . $2, '');
          } else {
            DebugPrint("arg = $arg");
            if ($arg =~ /^byval[ \t]+(.*)/i) {
              $arg = $1;
              $argkind .= '% ';
            }
            if ($arg =~ /((?:[a-zA-Z0-9_\$\@\(\)\[\]\{\}\.\-\>\x824f-\x829a\x829f-\x82f0\x8340-\x8396\x889f-\xfc4b]|,[\t ]*)+)[ \t]+as[ \t]+(.*)/i) {
              $arg = $1;
              $argtype = $2;
            }
            &addchildnode($cur, $arg, $argkind, $argtype, '');
          }
        }
        if (length($body) != 0) {
          &extractparams($body);
          &addchildnode($cur, $name, $kind, $type, $text);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub getcondandstmt {
  my($str) = @_;
  @chars = split(//, $str);
  $pre = '';
  $post = '';
  $level = 0;
  foreach $char (@chars) {
    if ($char eq '(') {
      $level++;
      if ($level > 1) {
        $pre .= $char;
      }
    } elsif ($char eq ')') {
      $level--;
      if ($level == 0) {
        last;
      } else {
        $pre .= $char;
      }
    } else {
      $pre .= $char;
    }
  }
  $post = substr($str, length($pre) + 2);
  return ($pre, $post);
}
sub islangelement {
  my($str) = @_;
  $str =~ tr/A-Z/a-z/;
  foreach $langelement (@langelements) {
    if ($str eq $langelement) {
      return 1;
    }
  }
  return 0;
}
sub rescuetree {
  my($nd) = @_;
  if (not defined($nd->{NEXT})) {
    return;
  }
  $cn = $nd->{NEXT};
  while (1) {
    if (defined($cn->{NEXT})) {
      $ncn = $cn->{NEXT};
      $found_next = 1;
    } else {
      $found_next = 0;
    }
    &delnode($cn);
    &addchildnode2($nd, $cn);
    if (not $found_next) {
      last;
    }
    $cn = $ncn;
  }
}
# not actually
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
# not actually
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
  if (defined($nd->{CHILD})) {
    # for case - when / else
    my $cn = $nd->{CHILD};
    $foundcase = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'case') {
        $foundcase = 1;
        $casenode = $cn;
      } elsif ($foundcase) {
        if (($cn->{NAME} eq 'else') or ($cn->{NAME} eq 'when')) {
          &delnode($cn);
          &addchildnode2($casenode, $cn);
        }
      } else {
        $foundcase = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
    # for begin - rescue / ensure
    my $cn = $nd->{CHILD};
    $foundbegin = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'begin') {
        $foundbegin = 1;
        $beginnode = $cn;
      } elsif ($foundbegin) {
        if (($cn->{NAME} eq 'ensure') or ($cn->{NAME} eq 'rescue')) {
          &delnode($cn);
          &addchildnode2($beginnode, $cn);
        }
      } else {
        $foundbegin = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
    # for do loop while
    my $cn = $nd->{CHILD};
    $founddo = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'do') {
        $founddo = 1;
        $donode = $cn;
      } elsif ($founddo) {
        if (($cn->{NAME} eq 'loop')) {
          $donode->{TYPE} = $cn->{TYPE};
          $donode->{TYPE} =~ s/^while /while /i;
          &delnode($cn);
        }
      } else {
        $founddo = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
