# File: CPPReader_Perl.pl
# Date            Author        number of nodes
# 2007/3/29       Walking Lint  771
# 2007/3/27       Walking Lint  757
# 2007/3/25       Walking Lint  757
# 2007/3/24       Walking Lint  754
# 2003/10/3       Walking@Lint 752
# 2003/9/27       Walking@Lint 736
# 2003/7/7        Walking Lint  723
# 2003/6/21       Walking Lint  720
# 2003/6/20       Walking Lint  695
# 2003/6/17       Walking Lint  552
# 2003/6/16       Walking Lint  552
# 2003/6/10       Walking Lint  551
# 2003/6/9        Walking Lint  551
# 2003/6/6        Walking Lint  491
# 2003/5/27       Walking Lint  469
# 2003/5/17       Walking Lint  369
# 2003/5/16       Walking Lint  363
# 2003/4/10       Walking Lint  359
# 2003/4/9        Walking Lint  361
# 2003/3/14       Walking Lint  361
# 2003/3/14       Walking Lint  358 (JavaReader_Perl->CPPReader_Perl)
# 2003/3/13       Walking Lint  353 (PerlReader_Perl->JavaReader_Perl)
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

CPPReader_Perl.pl - C/C++ reader

=head1 DESCRIPTION

activate as plug-in or filter or at start up

=head1 AUTHOR

walkinglint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
use Jcode;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
@langelements = ('#include', 'begin', 'break', 'case', 'default', 'else', 'exit', 'for', 'if', 'next', 'switch', 'while');
$parenpattern = '\((?:[^\(\)]|\((?:[^\(\)]|\((?:[^\(\)]|\([^\)]*\))*\))*\))*\)';
$continuationpattern = '(\|\||\&\&|,|=|\+|\-|\%)[ \t]*'; # end of prev line
$continuationpattern2 = '[ \t]*(,|\"|\|\||\&\&|\-[^\-]|\+[^\+]|\/[^\/\*]|\%)'; # start of next line
$typepattern = '(?:auto|bool|char|double|enum|extern|final|float|int|interface|long|private|protected|public|short|static|String|struct|typedef|union|unsigned|var|void|volatile)(?:[ \t]*\[[ \t]*\])*[ \t]+'; # var is for JavaScript
$subdef = '';
$comment = '(//|/\*+)';
$comment_begin = '/\*+';
$comment_end = '\*/';
$to_file =~ s/\.[^\.]+$/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.cpp';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line, $nd) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("linewithoutindent = $linewithoutindent");
  if ($linewithoutindent eq $comment) {
    $name = '_';
    $indentedcomment = '';
    DebugPrint("comment only");
    return 0;
  }
  if ($in_init) {
    $line =~ s/^[ \t]*//;
    if ($line =~ /(\}[ ]*;[ ]*)$/) {
      $line =~ s/$1$//;
      if (length($ini) == 0) {
        $ini = $line;
      } else {
        $ini .= ' CR' . 'LF ' . $line;
      }
      &insnode($nd, '_text', ' (' . 'in) &  ', '', $ini);
      $in_init = 0;
    } else {
      if (length($ini) == 0) {
        $ini = $line;
      } else {
        $ini .= ' CR' . 'LF ' . $line;
      }
    }
    return 1;
  }
  if ($in_comment) {
    $linewithoutindent =~ s/$comment_end[.\n]*$//;
    if ($line =~ /$comment_end/) {
      $in_comment = 0;
      if (length($linewithoutindent) == 0) {
        DebugPrint("null end comment");
        return 1;
      }
    }
    $text = $linewithoutindent;
    $name = '_';
    $indentedcomment = $text;
    $indentedcomment =~ s/^\* //;
    DebugPrint("in comment");
    return 0;
  } elsif (($line =~ /$comment_begin/) and not ($line =~ /$comment_end/)) {
    $in_comment = 1;
    if ($linewithoutindent =~ /^$comment_begin[ \t\n]*$/) {
      $indentedcomment = '';
      DebugPrint("null begin comment");
      return 1;
    }
  }
  $line =~ s/($comment.*)$//; # this is hack ...
  if (defined($1)) {
    $comment_part = $1;
    $comment_part =~ s/$comment_end$//;
  } else {
    $comment_part = '';
  }
  $line =~ /^([\t ]*)(.*)/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  DebugPrint("level = $level");
  $argline = '';
  if (defined($comment_part)) {
    $text = $comment_part;
    $indentedcomment = $text;
    $indentedcomment =~ s/^$comment( )?//;
    $text =~ s/^$comment[\t ]*//;
    DebugPrint("text = $text");
    if (length($linewithoutindentandcomment) == 0) {
      $name = '_';
      $indentedcomment = $text;
      DebugPrint("comment");
      return 0;
    }
  }
  if (($name =~ /^\}[ \t]*([^;]+);$/)) { # struct elements ... this is hack ...
    $name = '_struct_';
    DebugPrint("struct elements ... - $name");
    $kind = ' (out) '; # not used...
    $type = $1;
    return 0;
  }
  $name =~ s/[ \t]+$//;
  $name =~ s/^[ \t]*\}[ \t]*//;
  $found_paren = 0;
  if ($name =~ /[ \t]*{[ \t]*$/) {
    $name =~ s/[ \t]*\{[ \t]*$//;
    $found_paren = 1;
  }
  DebugPrint("name = [" . $name . "] text = [" . $text . "]");
  if ((length($name) == 0)) { # end or } ... } is already deleted ...
    return 1; # skip this line ... think later ...
  } elsif ($name =~ /^(#[a-zA-Z0-9_]+)[ \t]+(.*)$/) { # preprocess statement
    $name = $1;
    DebugPrint("preprocess statement - $name");
    $type = $2;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.]|,|[\t ]+|[\+\-\*\/\&\|\^\%][^=])+)[\t ]*((?:[\+\-\*\/\&\|\^\%]|<<|>>)=)[\t ]*([^;]+);?$/) { # inout pattern1
    $name = $1;
    $type = $2; # actually not
    $init_value = $3; # actually not
    $name =~ s/[ \t]+$//;
    DebugPrint("inout pattern1 - $name");
    $kind = ' (inout) ';
    $type =~ s/[ \t]+/ /g;
    $init_value =~ s/[ \t]+/ /g;
    $type = $type . ' ' . $init_value;
  } elsif ($name =~ /^([a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]+)[\t ]*(\+\+|\-\-);$/) { # increment/decriment
    $name = $1;
    DebugPrint("increment/decriment - $name");
    $kind = ' (inout) ';
    $type = $2; # actually not
  } elsif ($name =~ /^(\+\+|\-\-)[\t ]*([a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]+);$/) { # increment/decriment right???
    $name = $2;
    DebugPrint("increment/decriment - $name");
    $kind = ' (inout) ';
    $type = $1; # actually not
  } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([a-zA-Z0-9_\$\@\[\]\{\}\.\'\"\(\)]+)[\t ]*\{[\t ]*([^;]*);?$/)) { # block ... think later ... this is hack
    $name = $1;
    DebugPrint("block - $name");
    $kind .= '~ '; # may not be good ...
    $argline = $2;
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\.[^;]+);?$/) { # method
    $name = '->' . $1;
    DebugPrint("-> method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\.[^;]);?$/) { # method
    $name = $1;
    DebugPrint("method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)\([\t ]*([^;]*)[\t ]*\);?$/) { # static -> func call
    $name = '->' . $1;
    DebugPrint("static -> func call - $name");
    $type = $2;
  } elsif (($name =~ /^(for)[\t ]+(.+)$/)) { # for statement with param ...
    $name = $1;
    DebugPrint("for statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    $type =~ s/^\((.*)\)$/$1/;
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@]+)[\t ]*([^;]+);?$/) and &islangelement($1)) { # control statement with param ...
    $name = $1;
    DebugPrint("control statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    $type =~ s/^\([ \t]*(.*)\)$/$1/;
    $type =~ s/[ \t]*$//;
    if ($name eq 'case') {
      $type =~ s/[ \t]*:$//;
    } elsif (($name eq 'else') and ($type =~ /if/)) {
      $name = 'elseif';
      $type =~ s/^if[ \t]*\([ \t]*(.*)\)$/$1/;
    }
  } elsif (($name =~ /^([^\(]+)[ \t]+([^( \t]+)[\t ]*\(([^\)]+)\)[ \t]*(const)?$/)) {
    $name = $2;
    DebugPrint("func decl with param - $name");
    $type = $1;
    if (length($4) != 0) {
      $type .= '  ' . $4;
    }
    $argline = $3;
  } elsif (($name =~ /^([^\(]+)[ \t]+([^( \t]+)[\t ]*\(([ \t]*)\)[ \t]*(const)?$/)) {
    $name = $2;
    DebugPrint("func decl without param - $name");
    $type = $1;
    if (length($3) != 0) {
      $type .= '  ' . $3;
    }
  } elsif (($name =~ /^([^( \t]+)[\t ]*\(([^\)]+)\)[ \t]*(const)?$/)) {
    $name = $1;
    DebugPrint("func decl with param - $name");
    if (length($3) != 0) {
      $type = '  ' . $3;
    }
    $argline = $2;
  } elsif (($name =~ /^([^( \t]+)[\t ]*\(([ \t]*)\)[ \t]*(const)?$/)) {
    $name = $1;
    DebugPrint("func decl without param - $name");
    if (length($2) != 0) {
      $type = '  ' . $2;
    }
  } elsif (($name =~ /^(.*)[\t ]*class[ \t]+([^ \t]+)[ \t]+:[ \t]+(.*)$/)) { # class def with :
    $name = $2;
    DebugPrint("class def with : - $name");
    $type = $1 . '  ' . $3; # changed CV to accept this ...
    $kind = ' () + ';
  } elsif (($name =~ /^(.*)[\t ]*class[ \t]+([^ \t]+)$/)) { # class def
    $name = $2;
    DebugPrint("class def - $name");
    $type = $1;
    $kind = ' () + ';
  } elsif (($name =~ /^state[ \t]+([^ \t\{;]*)[ \t]*([^ \t]+)[ \t]*$/)) { # state $name {
    $kind = ' () ';
    if ($2 eq ';') {
      $type = $1;
      DebugPrint("state $type ;");
      $name = 'state';
    } else {
      $name = $1;
      DebugPrint("state $name {");
      $type = 'state';
    }
  } elsif (($name =~ /^(.*[\t ]*struct)[ \t]+([^ \t]+)$/)) { # struct def
    $name = $2;
    DebugPrint("struct def  - $name");
    $type = $1;
    $kind = ' () + ';
  } elsif (($name =~ /\)[ ]*;?$/) and ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([ \t]*(.*)$/)) { # static func call with param
    $org_name = $name;
    $name = $1;
    if ($found_paren) {
      $argline = $2;
      $argline =~ s/\);?$//;
      DebugPrint("func decl without type ... - $name");
    } else {
      $type = $2;
      if ($type =~ /\(((?:[^\(\)]|\([^)]*\))*)\)[ ]*;?$/) {
        $type = $1;
        $name = $org_name;
        $name =~ s/[ \t]*\(([^\(\)]|\([^)]*\))*\)[ ]*;?$//;
      } else {
        $type =~ s/\)[ ]*;?$//;
      }
      DebugPrint("static func call with param - $name");
    }
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@\-\>\:]+);?$/)) { # and &islangelement($1) %% control statement (not actually ...)
    $name = $1;
    DebugPrint("control statement - $name");
    if ($name =~ /^default[ \t]*:$/) {
      $name =~ s/[ \t]*:$//;
    }
  } elsif (($name =~ /^(enum|return|using)[ \t]+([^;]*);?$/)) { # return
    $name = $1;
    DebugPrint("return - $name");
    $type = $2;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\: \-\>\*\+\(\)\&]|,|[\t ])+)[\t ]*=[\t ]*([^;]+);?$/) { # assignment
    $name = $1;
    $init_value = $2;
    $name =~ s/[ \t]+$//;
    $type = '';
    DebugPrint("assignment - $name");
    if ((not $name =~ /(\))$/) and ($name =~ /([ \t]+[^ \t]+)$/)) { # and ($name =~ /^((?:$typepattern)+)([^;]+);?/) %% hack???
      if ($name =~ /^((?:$typepattern)+)([^;]+);?/) {
        $type = $1;
        $name = $2;
        if ($name =~ /^([_a-zA-Z0-9]+)[ ]+([_a-zA-Z\*].*)/) { # this is hack ... treat class name
          $type .= $1;
          $name = $2;
        }
      } elsif ($name =~ /^([_a-zA-Z0-9]+)[ ]+([_a-zA-Z\*].*)/) {
        $type = $1;
        $name = $2;
      }
    }
    $kind = ' (out) ';
    $type =~ s/[ \t]+/ /g;
    $init_value =~ s/[ \t]+/ /g;
    $type .= '  ' . $init_value;
  } elsif (($name =~ /^((?:$typepattern)+)([^;]+);?$/)) { # decl statement without init
    $type = $1;
    $name = $2;
    if ($type =~ /interface/) {
      $kind = ' () ';
    } else {
      $kind = ' (out) ';
    }
    $type =~ s/[ \t]+$//;
    if ($name =~ /^(struct|union)$/ and $found_paren) { # not sure but ...
      $type .= ' ' . $name;
      $name = '_';
      $kind = ' () + ';
    } elsif ($name =~ /^([_a-zA-Z0-9]+)[ ]+([_a-zA-Z\*].*)/) { # this is hack ... treat class name
      $type .= ' ' . $1;
      $name = $2;
    }
    if (($name =~ /=$/) and $found_paren) { # try this ...
      $name =~ s/[ ]*=$//;
      $in_init = 1;
      $ini = '';
      DebugPrint("decl statement with multi line init - $name");
    } elsif ($found_paren) {
      DebugPrint("struct decl statement - $name");
    } else {
      DebugPrint("decl statement without init - $name");
    }
  } elsif (($name =~ /^(.+)[ \t]+([^ \t;]+);?$/)) { # decl using defined class
    $type = $1;
    $name = $2;
    if ($type eq 'state') {
      DebugPrint("state $name");
      $kind = ' () ';
    } else {
      DebugPrint("decl using defined class - $name");
      $kind = ' (out) ';
    }
  } elsif (length($text) != 0) { # not sure but ...
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  } else {
    return 1;
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  $in_comment = 0;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  $breaklater = 0;
  while (<$infilehandle>) {
    if ($_ =~ /^__EOF__[\n\r]*$/) {
      last;
    } elsif ($_ =~ /__EOF__[\n\r]*$/) {
      $_ =~ s/__EOF__[\n\r]*$//;
      $breaklater = 1;
    }
    push @lines, $_;
    if ($breaklater) {
      last;
    }
  }
  @lines1 = ();
  $tmp_line = '';
  $prev_is_continuation = 0;
  $in_init = 0;
  foreach $line (@lines) {
    $line =~ s/[ \t\n]+$//;
    Jcode::convert(\$line, 'sjis');
    if (length($line) == 0) {
      next;
    }
    if ((not $in_init) and ($line =~ /$continuationpattern$/)) { # pattern to concatenate ...
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 1;
    } elsif ((not $in_init) and ($line =~ /^$continuationpattern2/)) {
      if (length($tmp_line) != 0) {
        $line =~ s/^[ \t]*/ /;
        $tmp_line = $tmp_line . $line;
      } else {
        $tmp_line = $line; # should not happen ...
      }
      $prev_is_continuation = 0;
    } else {
      if ($in_init) {
        if ($line =~ /\}[ ]*;[ ]*$/) {
          $in_init = 0;
        }
      } else {
        if ($line =~ /=[ ]*\{[ ]*$/) {
          $in_init = 1;
        }
      }
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 0;
    }
  }
  if (length($tmp_line) != 0) {
    push @lines1, $tmp_line;
  }
  @lines2 = ();
  &process_multi_statement(\@lines1, \@lines2);
  @processed_lines = ();
  &process_multi_statement(\@lines2, \@processed_lines);
  $in_init = 0;
  $ini = '';
  foreach (@processed_lines) {
    $_ =~ s/[\n\t ]+$//;
    if ((length($_) != 0)) {
      if (&extractparams($_, $cur)) {
        $prevname = '';
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        if (($cur != $root) and ($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
          DebugPrint("here we are");
          DebugPrint("previndentdcomment = $previndentedcomment");
          DebugPrint("indentedcomment = $indentedcomment");
          DebugPrint("cur->{TEXT} = $cur->{TEXT}");
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
        } elsif (($cur != $root) and ($name eq '_text') and ($prevname eq '_text')) { # ($cur->{NAME} eq '_text')
          $cur->{TEXT} .= " \CRLF " . $text;
        } elsif (($cur != $root) and ($name eq '_struct_')) {
          $cur->{TYPE} .= "  " . $type;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      } else {
        until ($prevlevel <= $level) {
          if ($cur->{PARENT} == $root) { # hack ???
            last;
          }
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        if ($name eq '_struct_') {
          $cur->{TYPE} .= "  " . $type;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      }
      $prevname = $name;
      $previndentedcomment = $indentedcomment;
      $prevlevel = $level;
      my $argkind = " \(in\) \& ";
      $argline =~ s/^[ \t]+//;
      $argline =~ s/[ \t]+$//;
      if (length($argline) != 0) {
        my @args = split(/[\t ]*,[\t ]*/, $argline);
        foreach $arg (@args) {
          if ($arg =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>\*\: ]|,[\t ]*)+)[\t ]*=[\t ]*(.+)$/) { # assignment
            my $name = $1;
            my $init_value = $2;
            my $type = '';
            DebugPrint("arg - assignment - $arg");
            if ($name =~ /([ \t]+[^ \t]+)$/) {
              $type = $name;
              $name = $1;
              $type =~ s/[ \t]+[^ \t]+$//;
              $name =~ s/^[ \t]+//;
            }
            $type .= '  ' . $init_value;
            &addchildnode($cur, $name, $argkind, $type, '');
          } elsif ($arg =~ /([ \t]+[^ \t]+)$/) {
            $type = $arg;
            $name = $1;
            $type =~ s/[ \t]+[^ \t]+$//;
            $name =~ s/^[ \t]+//;
            &addchildnode($cur, $name, $argkind, $type, '');
          } else {
            DebugPrint("arg - default - $arg");
            &addchildnode($cur, $arg, $argkind, '', '');
          }
        }
        if (length($body) != 0) {
          &extractparams($body);
          &addchildnode($cur, $name, $kind, $type, $text);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub islangelement {
  my($str) = @_;
  foreach $langelement (@langelements) {
    if ($str eq $langelement) {
      return 1;
    }
  }
  return 0;
}
sub process_multi_statement {
  my($from_array_ref, $to_array_ref) = @_;
  foreach $line (@$from_array_ref) {
    DebugPrint("line = " . $line);
    if ($line =~ /^([ \t]*)(try)[ \t]*\{([^\}]+)\}[ \t]*(catch)[ ]*([^\/\*]+)(\/[\/\*].+)?$/) { # pattern for try ...
      $indent = $1;
      $try = $2;
      $block = $3;
      $catch = $4 . ' ' . $5;
      $com = $6;
      push @$to_array_ref, $indent . $try . $com;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
      push @$to_array_ref, $indent . $catch;
    } elsif ($line =~ /^([ \t]*)(if|for|while)[ \t]*(\((?:[^\(\)]|\((?:[^\(\)]|\((?:[^\(\)]|\([^\)]*\))*\))*\))*\))[ \t]*\{([^\}]+)\}[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      DebugPrint("here we are ... $1 / $2 / $3 / $4 / $5");
      push @$to_array_ref, $1 . $2 . ' ' . $3 . $5;
      $indent = $1;
      $block = $4;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif ($line =~ /^([ \t]*)(if|for|while)[ \t]*($parenpattern)[ \t]*([^;]);[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' ' . $3 . $5;
      $indent = $1;
      $inner_statement = $4;
      push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
    } elsif ($line =~ /^([ \t]*)([a-zA-Z_0-9]+)[ \t]*:[ \t]*(.+)$/) { # pattern for label with statement ... case default ???
      push @$to_array_ref, $1 . $2 . ':';
      push @$to_array_ref, $1 . $3;
    } elsif ($line =~ /^([ \t]*)((?:$typepattern)+)([^\{]+)[ \t]*\{([^\}]+)\}[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      $indent = $1;
      $decl_type = $2;
      $decl_items = $3;
      $block = $4;
      $com = $5;
      $decl_type =~ s/[ \t]+$//;
      push @$to_array_ref, $indent . $decl_type . ' ' . $decl_items . ' {' . $com;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif (($line =~ /^[^\(\{]+,/) and ($line =~ /^([ \t]*)((?:$typepattern)+)([^;<]+);[ \t]*(\/[\/\*].+)?$/)) { # pattern for decl ... hack...
      $indent = $1;
      $decl_type = $2;
      $decl_items = $3;
      $com = $4;
      $decl_type =~ s/[ \t]+$//;
      @inner_statements = split(/[ \t]*,[ \t]*/, $decl_items);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . $decl_type . ' ' . $inner_statement . ';' . $com; # better ?
        $com = '';
      }
    } elsif (($line =~ /^[^\(\{]+,/) and ($line =~ /^([ \t]*)([_a-zA-Z0-9]+)([^;<]+);[ \t]*(\/[\/\*].+)?$/)) { # pattern for decl with class ... hack...
      $indent = $1;
      $decl_type = $2;
      $decl_items = $3;
      $com = $4;
      $decl_type =~ s/[ \t]+$//;
      @inner_statements = split(/[ \t]*,[ \t]*/, $decl_items);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . $decl_type . ' ' . $inner_statement . ';' . $com; # better ?
        $com = '';
      }
    } elsif ($line =~ /^([ \t]*)(else[ \t]+if|if|for|while)[ \t]*($parenpattern)[ \t]*([^;]+;)[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' ' . $3 . $5;
      push @$to_array_ref, $1 . '  ' . $4;
    } elsif ($line =~ /^([ \t]*)(else|try)[ \t]*\{([^\}]+)\}[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . $4;
      $indent = $1;
      $block = $3;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif ($line =~ /^([ \t]*)\}?[ \t]*(else|try)[ \t]*([^;]+;)[ \t]*(.*)$/) { # pattern for line line control statement
      $indent = $1;
      $name = $2;
      $block = $3;
      $com = $4;
      push @$to_array_ref, $indent . $name . $com;
      push @$to_array_ref, $indent . '  ' . $block;
    } elsif ((not $line =~ /^[ \t]*for[ \t\(]/) and ($line =~ /;[^;\}]+;[ \t]*(\/[\/\*].+)?$/)) { # hack ...
      $line =~ /^([ \t]*)/;
      $indent = $1;
      @inner_statements = split(/[ \t]*;[ \t]*/, $line);
      for ($i = 0; $i <= $#inner_statements; $i++) { # - 1 is needed for \n ?
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . $inner_statement . ';'; # better ?
      }
    } else {
      push @$to_array_ref, $line;
    }
  }
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
  if (defined($nd->{CHILD})) {
    # for case - when / else
    my $cn = $nd->{CHILD};
    $foundcase = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'case') {
        $foundcase = 1;
        $casenode = $cn;
      } elsif ($foundcase) {
        if (($cn->{NAME} eq 'else') or ($cn->{NAME} eq 'when')) {
          &delnode($cn);
          &addchildnode2($casenode, $cn);
        }
      } else {
        $foundcase = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
