# File: Calendar_Perl.pl
# Date            Author        number of nodes
# 2003/3/23       Walking Lint  120
# 2003/2/25       Walking Lint  119
# 2002/12/25      Walking Lint  110
# 2002/12/9       Walking Lint  110
# 2002/12/7       Walking Lint  81
# 2002/11/20      Walking Lint  36

=pod

=head1 NAME

Calendar_Perl.pl - generate calendar

=head1 DESCRIPTION

ex1. perl.exe Calendar_Perl.pl 0 1
ex2. perl.exe Calendar_Perl.pl 0 2003 1

=head1 AUTHOR

Walking Lint

=cut

use Time::localtime;
$verbose = 0;
$perl = $ENV{PERL};
$perl =~ s/"//g;
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
if (@ARGV == 3) {
  $verbose = shift; # this is hack ...
  $textmode = 1;
  $year = shift;
  $month = shift;
  $today = 99; # hack
} elsif (@ARGV == 2) {
  $verbose = shift; # this is hack ...
  $textmode = shift;
  $tm = localtime;
  $year = $tm->year + 1900;
  $month = $tm->mon + 1;
  $today = $tm->mday;
} else { # @ARGV == 0 or 1
  $textmode = shift;
  $tm = localtime;
  $year = $tm->year + 1900;
  $month = $tm->mon + 1;
  $today = $tm->mday;
}
$memo = '';
$from_file = $templatesfolder . '\Memo.pat';
@dates = ();
if ($textmode and -e $from_file) {
  $/ = undef;
  open IN, $from_file || die("Can't open $from_file: $!\n");
  $memo = <IN>;
  $memo =~ s/root \(\) .*//;
  close IN;
}
$lastday = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$month - 1] + ($month == 2 && ($year % 4 == 0 && $year % 100 != 0 || $year % 400 == 0));
if ($textmode) {
  printf " --------- $year/$month ---------\n\n Sn  Mn  Tu  Wd  Th  Fr  St\n";
} else {
  print <<END;
<table bgcolor="white">
<tr>
<td colspan="7" align="center">
$year/$month
</td>
</tr>
<tr align="center">
<td>Sn</td><td>Mn</td><td>Tu</td><td>Wd</td><td>Th</td><td>Fr</td><td>St</td>
</tr>
<tr align="right">
END
}
$count = 1;
foreach $_ (&yobi($year, $month), 1 .. $lastday) {
  if ($textmode) {
    $datepattern = sprintf("%d\/(%d|%02d)\/(%d|%02d)([^0-9]|\$)", $year, $month, $month, $_, $_);
    $date = sprintf("%d\/%02d\/%02d", $year, $month, $_);
    $datestr = $_;
    if ($_ == $today) {
      $datestr = '*' . $datestr;
    }
    if ($memo =~ /$datepattern/) {
      $datestr = $datestr . '+';
      push @dates, $date;
    } else {
      $datestr = $datestr . ' ';
    }
    $day = sprintf("%4s", $datestr);
  } else {
    $day = "<td>$_</td>";
    if ($count % 7 == 1) {
      $day = "<td><font color=\"red\">$_</font></td>";
    } elsif ($count % 7 == 0) {
      $day = "<td><font color=\"blue\">$_</font></td>";
    }
  }
  print $day;
  if ($count % 7 == 0) {
    if ($textmode) {
      print "\n";
    } else {
      print <<EMD;
</tr>
<tr align="right">
EMD
    }
  }
  $count++;
}
if ($textmode) {
  print "\n\n";
  if ($verbose) {
    foreach $date (@dates) {
      $line = '';
      @lines = ();
      open IN, '"' . $perl . '" "' . $templatesfolder . '\ViewMemo_Perl.pl" "' . $date . '" |' or die "cannot execute script";
      @lines = <IN>;
      $line .= join('', @lines);
      close IN;
      print $line;
    }
  }
} else {
  print <<END;
</tr>
</table>
END
}
sub yobi {
  my($year, $month) = @_;
  if ($month == 1 || $month == 2) {
    $year--;
    $month += 12;
  }
  $cnt = int($year + int($year / 4) - int($year / 100) + int($year / 400) +int((13 * $month + 8) / 5) + 1) % 7;
  @ret = ();
  foreach (1..$cnt) {
    push @ret, '';
  }
  return @ret;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
