# File: CheckLinksInTree_Perl.pl
# Date            Author        number of nodes
# 2007/1/11       Walking Lint  89
# 2007/1/11       Walking Lint  89 (CheckLinksInFile_Perl->CheckLinksInTree_Perl)
# 2005/11/20      Walking Lint  89
# 2005/10/28      Walking Lint  83
# 2005/2/14       Walking Lint  81
# 2005/2/14       Walking Lint  57 (CheckLinks_Perl->CheckLinksInFile_Perl)
# 2003/6/24       Walking Lint  52
# 2003/6/10       Walking Lint  34
# 2002/11/19      Walking Lint  32
# 2002/11/19      Walking Lint  22 (ExtractLinks_Perl->CheckLinks_Perl)

=pod

=head1 NAME

CheckLinksInTree_Perl.pl - check links from url

=head1 DESCRIPTION

ex. perl.exe CheckLinksInTree_Perl.pl "http://member.nifty.ne.jp/WalkingLint/MyTwoCents.html"

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use LWP::Simple;
use HTML::LinkExtor;
use File::Basename;
$from_file = shift;
$error_only = shift;
$dir = &mydirname($from_file);
open IN, $from_file or die("Cannot open $from_file: $!\n");
@lines = <IN>;
foreach $line (@lines) {
  while ($line =~ /\!([^\!]+)\]\]/g) {
    &check_link($1);
  }
}
close IN;
sub check_link {
  my($link) = @_;
  if ($link =~ /^http/) {
    if (head($link)) { # this may not be good ...
      if (not $error_only) {
        print "OK:    $link\n";
      }
    } elsif ($link =~ /^mailto:/) {
      if (not $error_only) {
        print "found: $link\n";
      }
    } else {
      print "ERROR: $link\n";
    }
  } else {
    $tmplink = $link;
    $tmplink =~ s/\#.+$//;
    if (-e $dir . "\\" . $tmplink) {
      if (not $error_only) {
        print "OK:    $link\n";
      }
    } elsif ($link =~ /^mailto:/) {
      if (not $error_only) {
        print "found: $link\n";
      }
    } else {
      print "ERROR: $link\n";
    }
  }
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
