# File: CheckLinks_Perl.pl
# Date            Author        number of nodes
# 2003/6/24       Walking Lint  52
# 2003/6/10       Walking Lint  34
# 2002/11/19      Walking Lint  32
# 2002/11/19      Walking Lint  22 (ExtractLinks_Perl->CheckLinks_Perl)

=pod

=head1 NAME

CheckLinks_Perl.pl - check links from url

=head1 DESCRIPTION

ex. perl.exe CheckLinks_Perl.pl "http://member.nifty.ne.jp/WalkingLint/MyTwoCents.html"

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use LWP::Simple;
use HTML::LinkExtor;
$url = shift;
$error_only = shift;
# actually ... this is needed ...
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$ref->Close();
$refproxyoverride = $values{'ProxyOverride'};
DebugPrint("refproxyoverride = " . $refproxyoverride);
$refproxyserver = $values{'ProxyServer'};
DebugPrint("refproxyserver = " . $refproxyserver);
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = " . $proxyoverride);
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = " . $proxyserver);
$webagent = new LWP::UserAgent;
unless (($url =~ /$proxyoverride/) or (length($proxyserver) == 0)) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
}
$request = new HTTP::Request(GET => $url);
$response = $webagent->request($request);
if ($response->is_success) {
  $parser = HTML::LinkExtor->new(\&link_callback, $url);
  $parser->parse($response->content);
}
sub link_callback {
  my($tag, %links) = @_;
  if ($tag eq "a") {
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      if ($url=~ /^http/) {
        check_link($url);
      }
    }
  }
}
sub check_link {
  my($link) = @_;
  if (head($link)) { # this may not be good ...
    if (not $error_only) {
      print "OK:    $link\n";
    }
  } else {
    print "ERROR: $link\n";
  }
}
