# File: CheckWeblogs_Perl.pl
# Date            Author        number of nodes
# 2003/3/23       Walking Lint  138
# 2002/11/28      Walking Lint  137
# 2002/11/26      Walking Lint  133
# 2002/11/22      Walking Lint  120
# 2002/11/21      Walking Lint  98
# 2002/11/20      Walking Lint  89
# 2002/11/19      Walking Lint  70
# 2002/11/19      Walking Lint  31 (CheckWeblogs_Perl->NewFile)
# 2002/11/19      Walking Lint  58 (Links_Perl->CheckWeblogs_Perl)
# 2002/11/19      Walking Lint  32 (CheckLinks_Perl->Links_Perl)
# 2002/11/19      Walking Lint  22 (ExtractLinks_Perl->CheckLinks_Perl)

=pod

=head1 NAME

CheckWeblogs_Perl.pl - check if links in Link.pat are updated

=head1 DESCRIPTION

ex. perl.exe CheckWeblogs_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use LWP::Simple;
use CVTree_Perl;
use File::Copy;
# get proxy info from registry
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$ref->Close();
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = $proxyoverride");
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = $proxyserver");
my $root = {};
&initnode($root, 'root', '', '', '');
$webagent = new LWP::UserAgent;
$webagent->agent('LWP::GETHEAD');
$webagent2 = new LWP::UserAgent;
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
$link = $templatesfolder . '\Link.pat';
# from here same as CheckLinkUpdate_Perl
if (-e $link) {
  $linkbak = $link;
  $linkbak =~ s/\.pat$/.bak/;
  copy($link, $linkbak);
} else {
  DebugPrint("Cannot find $link");
  exit;
}
&gentree($root, $link);
$first = 1;
&checklinkupdate($root);
sub checklinkupdate {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      $url = $cn->{TEXT};
      if ((not $cn->{NAME} =~ /^_/)) { # and ($url =~ /\.html/)
        DebugPrint("url = $url");
        if (1 or $first) { # think later ...
          $first = 0;
          unless ($url =~ /$proxyoverride/) {
            $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
            $webagent2->proxy(['ftp', 'http'] => "http://$proxyserver");
          } else {
            $webagent->proxy(['ftp', 'http'] => "");
            $webagent2->proxy(['ftp', 'http'] => "");
          }
        }
        $request = new HTTP::Request('HEAD' => $url);
        $response = $webagent->request($request);
        $prevtype = $cn->{TYPE};
        $volatile = 0;
        if ($response->is_success) {
          $lastmodified = $response->header('Last-Modified');
          if (length($lastmodified) == 0) {
            $request2 = new HTTP::Request('GET' => $url);
            $response2 = $webagent2->request($request2);
            $lastmodified = length($response2->content); # not actually ...
            sleep 1;
            $response2 = $webagent2->request($request2);
            $lastmodified2 = length($response2->content); # not actually ...
            if ($lastmodified2 != $lastmodified) {
              $volatile = 10;
              $lastmodified = $lastmodified2;
              DebugPrint("volatile - may be changed");
            }
          }
          if (length($lastmodified) != 0) {
            $info = ' (' . $lastmodified . ')';
          } else {
            $info = '';
          }
        } else {
          $info = ' (NG)';
        }
        $quotedinfo = quotemeta $info;
        if ((length($cn->{TYPE}) == 0) or ($cn->{TYPE} =~ /^[ ]*\([^\)]*\)$/)) {
          $cn->{TYPE} = $info;
        } elsif ($cn->{TYPE} =~ /([ ]*\([^\)]*\))$/) {
          $cn->{TYPE} =~ s/$1/$info/;
        } else {
          $cn->{TYPE} .= $info;
        }
        $kind = $cn->{KIND};
        if ($info eq ' (NG)') {
          DebugPrint(" (NG)");
          if ($kind =~ / \(\) \+/) {
            # do nothing ...
          } elsif ($kind =~ / \(\) \-/) {
            $kind =~ s/ \(\) \-/ \(\) \+/;
          } elsif ($kind =~ / \(\)/) {
            $kind =~ s/ \(\)/ \(\) \+/;
          }
        } elsif ((not ($prevtype =~ /$quotedinfo/)) and (not ($info eq ' (NG)')) and (not $prevtype =~ / \(NG\)/) and (not $volatile)) {
          DebugPrint(" updated");
          if ($kind =~ / \(\) \+/) {
            $kind =~ s/ \(\) \+/ \(\) \-/;
          } elsif ($kind =~ / \(\) \-/) {
            # do nothing ...
          } elsif ($kind =~ / \(\)/) {
            $kind =~ s/ \(\)/ \(\) \-/;
          }
        } else {
          DebugPrint(" not changed");
          if ($kind =~ / \(\) \+/) {
            $kind =~ s/ \(\) \+/ \(\)/;
          } elsif ($kind =~ / \(\) \-/) {
            $kind =~ s/ \(\) \-/ \(\)/;
          }
        }
        $cn->{KIND} = $kind;
        checklinkupdate($cn); # for common links ...
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
&savetree($root, $link);
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
