# File: CompactTable_Perl.pl
# Date            Author        number of nodes
# 2005/3/2        Walking Lint  47

=pod

=head1 NAME

CompactTable_Perl.pl

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$prevlength = 0;
$prevline = '';
while (<STDIN>) {
  if ($_ =~ /^[\t\r\n]+$/) {
    next;
  }
  @items = split(/\t/, $_);
  $cnt = 0;
  $in_indent = 1;
  $indentlength = 0;
  $body = '';
  foreach $item (@items) {
    $item =~ s/[\r\n]+$//;
    if ($in_indent) {
      if (length($item) == 0) {
        $indentlength++;
      } else {
        $in_indent = 0;
        $body = $item;
      }
    } else {
      $body .= "\t" . $item;
    }
    $cnt++;
  }
  if ($prevlength <= $indentlength) {
    if (length($prevline) != 0) {
      $prevline .= "\t" x ($indentlength - $prevlength) . "\t" . $body;
    } else {
      $prevline = $body;
    }
  } else {
    print $prevline . "\n";
    $prevline = "\t" x $indentlength . $body;
  }
  $prevlength = $cnt;
}
print "$prevline\n";
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
