# File: CopyFilesFromConfigFile_Perl.pl
# Date            Author        number of nodes
# 2003/2/13       Walking Lint  61
# 2002/11/16      Walking Lint  57
# 2002/10/1       Walking Lint  57
# 2002/8/18       Walking Lint  149
# 2002/8/1        Walking Lint  136 (GenAnnotedLink_Perl->CopyFilesFromConfigFile_Perl)
# 2002/7/31       Walking Lint  446 (GenHtmlsFromConfigFile_Perl->GenAnnotedLink_Perl)
# 2002/7/30       Walking Lint  437
# 2002/7/30       Walking Lint  388 (GenHtmlsForSSG_Perl->GenHtmlsFromConfigFile_Perl)
# 2002/7/29       Walking Lint  388 (GenHtmlsForSSG->GenHtmlsForSSG_Perl)
# 2002/7/26       Walking Lint  237
# 2002/7/25       Walking Lint  150
# 2002/7/24       Walking Lint  138
# 2002/7/23       Walking Lint  136
# 2002/7/22       Walking Lint  55

=pod

=head1 NAME

CopyFilesFromConfigFile_Perl.pl - copy files of configuration file

=head1 DESCRIPTION

ex. perl.exe CopyFilesFromConfigFile_Perl.pl "D:\SSG_j\config.pat" "E:" "D:" "\\SSG_j"

=head1 AUTHOR

Walking Lint

=cut

# some configurable constants
use lib '.';
use CVTree_Perl;
use File::Copy;
use File::Basename;
$config_file = shift;
$from_drive = shift;
$to_drive = shift;
$base_to_dir = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $config_file);
&copyfiles($root, $from_drive, $to_drive);
sub copyfiles {
  my($nd, $from_dir, $to_dir) = @_;
  if (defined($nd->{CHILD})) {
    my $cnd = $nd->{CHILD};
    while (1) {
      if (($cnd->{NAME} eq '_') or ($cnd->{NAME} eq '_note') or ($cnd->{NAME} eq '_part')) {
        # do nothing ... skip comment etc.
      } else {
        &copyfilesbody($cnd, $from_dir, $to_dir);
      }
      last if not defined($cnd->{NEXT});
      $cnd = $cnd->{NEXT};
    }
  }
}
sub copyfilesbody {
  my($nd, $from_drive, $to_drive) = @_;
  my $to_file = $nd->{TEXT};
  $to_file =~ s/\//\\/g;
  my $from_file = $to_file;
  $from_file =~ s/$to_drive/$from_drive/;
  $from_file =~ s/$base_to_dir//; # this is hack ... think later ...
  unless (($from_file =~ /http:/) or ($from_file =~ /.pdf$/)) {
    my $to_dir = &mydirname($to_file);
    unless (-d $to_dir) {
      mkdir $to_dir, 0700 or die "mkdir($to_dir) failed: $!";
    }
    copy($from_file, $to_file);
    print STDERR "to_file = $to_file\n";
    print STDERR "from_file = $from_file\n";
  }
  # do something ...
  if (defined($nd->{CHILD})) {
    &copyfilesbody($nd->{CHILD}, $from_drive, $to_drive);
  }
  if (defined($nd->{NEXT})) {
    &copyfilesbody($nd->{NEXT}, $from_drive, $to_drive);
  }
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
