# File: CopyFilesToMail_Perl.pl
# Date            Author        number of nodes
# 2003/7/20       Walking Lint  69
# 2003/3/13       Walking Lint  65
# 2002/11/29      Walking Lint  62
# 2002/11/27      Walking Lint  67
# 2002/11/23      Walking Lint  67
# 2002/11/6       Walking Lint  58
# 2002/10/31      Walking Lint  58
# 2002/10/4       Walking Lint  56
# 2002/9/26       Walking Lint  46
# 2002/9/25       Walking Lint  46 (CopyFilesToMail_Perl->CopyFilesToMail_Perl)
# 2002/9/9        Walking Lint  49 (CopyFilesToMail_Perl->CopyFilesToMail_Perl)
# 2002/9/7        Walking Lint  49
# 2002/7/23       Walking Lint  9 (CheckModifiedTime_Perl->CopyFilesToMail_Perl)
# 2002/6/4        Walking Lint  6 (Time_Perl->CheckModifiedTime_Perl)
# 2002/3/3        Walking Lint  3 (Time_Perl->NewFile)
# 2002/2/19       Walking Lint  3
# 2002/2/17       Walking Lint  3

=pod

=head1 NAME

CopyFilesToMail_Perl.pl - copy files changed after previous activation of this script

=head1 DESCRIPTION

ex. perl.exe CopyFilesToMail_Perl.pl "D:\common\cv\templates" "D:\common\cv\templates\mail"

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Win32::File;
use File::Copy;
use Time::localtime;
$from_dir = $ENV{TEMPLATESFOLDER};
$from_dir =~ s/"//g;
$to_dir = $from_dir . '\mail';
# get last mailed time
$timestampfile = $from_dir . "\\" . "lastmailedtime";
  if (-e $timestampfile) {
    open IN, $timestampfile || die("Can't open $timestampfile: $!\n");
    $last_time = <IN>;
    close IN;
  } else {
    $last_time = 0; # not sure if this is OK ...
  }
DebugPrint("last_time = " . &gendate($last_time));
# clear mail dir
  if (not (-e $to_dir)) {
    mkdir $to_dir, 0700 or die("Cannot make $to_dir: $!");
  }
opendir DIR, $to_dir or die "opendir $to_dir failed: $!";
@files = readdir DIR;
closedir DIR;
  foreach $from_file (@files) {
    $from_file = $to_dir . "\\" . basename($from_file);
    unlink $from_file;
  }
# copy files modified after ftpx's last activation
opendir DIR, $from_dir or die "opendir $from_dir failed: $!";
@files = grep /\.(pat)$/i, readdir DIR;
%dates = ();
closedir DIR;
  foreach $from_file (@files) { # (sort {lc($b) cmp lc($a)} @files)
    if (($from_file =~ /^Log.pat/) or ($from_file =~ /^WebLog.pat/) or ($from_file =~ /^AutoBackup.pat/) or ($from_file =~ /^Programs.pat/)) {
      next;
    }
    $from_file = $from_dir . "\\" . basename($from_file);
    @stat = stat($from_file); # better to set this info to $to_file ... check later ...
    if ((($stat[9] > $last_time) or ($stat[10] > $last_time)) and not (basename($from_file) eq 'copyright.html') and not (basename($from_file) eq 'menu.html')) {
      $to_file = $to_dir . "\\" . basename($from_file);
      copy($from_file, $to_file);
      $dates{$to_file} = &gendate($stat[9]);
    }
  }
$first = 1;
  foreach $key (sort {$dates{$a} cmp $dates{$b}} keys %dates) {
    if ($first) {
      $first = 0;
      DebugPrint('');
    }
    DebugPrint("copied to $key - $dates{$key}");
  }
# record last activation time in timestampfile
open OUT, ">$timestampfile";
$currenttime = time();
print OUT "$currenttime\n";
close OUT;
sub gendate {
  my($time) = @_;
  $tm = localtime($time);
  $year = $tm->year + 1900;
  $month = $tm->mon + 1;
  $day = $tm->mday;
  $hour = $tm->hour;
  $min = $tm->min;
  $sec = $tm->sec;
  return sprintf("$year/%02d/%02d $hour:$min:$sec", $month, $day);
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
