# File: CopyFilesToUpdate_Perl.pl
# Date            Author        number of nodes
# 2003/7/20       Walking Lint  60
# 2002/11/29      Walking Lint  56
# 2002/11/27      Walking Lint  54
# 2002/11/6       Walking Lint  54
# 2002/10/31      Walking Lint  58 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl)
# 2002/10/4       Walking Lint  56
# 2002/9/26       Walking Lint  46
# 2002/9/25       Walking Lint  46 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl)
# 2002/9/9        Walking Lint  49 (CopyFilesToUpdate_Perl->CopyFilesToUpdate_Perl)
# 2002/9/7        Walking Lint  49
# 2002/7/23       Walking Lint  9 (CheckModifiedTime_Perl->CopyFilesToUpdate_Perl)
# 2002/6/4        Walking Lint  6 (Time_Perl->CheckModifiedTime_Perl)
# 2002/3/3        Walking Lint  3 (Time_Perl->NewFile)
# 2002/2/19       Walking Lint  3
# 2002/2/17       Walking Lint  3

=pod

=head1 NAME

CopyFilesToUpdate_Perl.pl - copy files changed after previous activation of this script

=head1 DESCRIPTION

ex. perl.exe CopyFilesToUpdate_Perl.pl "C:\memo\cv\templates" "D:\HP" "C:\memo\cv\templates\update"

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Win32::File;
use File::Copy;
use Time::localtime;
$from_dir = shift;
$update_dir = shift;
$to_dir = shift;
if (length($from_dir) == 0 or length($update_dir) == 0 or length($to_dir) == 0) {
  exit;
}
# clear to_dir (temporary)
opendir DIR, $to_dir or die "opendir $to_dir failed: $!";
@files = readdir DIR;
closedir DIR;
  foreach $file (@files) {
    $file = $to_dir . "\\" . basename($file);
    unlink $file;
  }
# copy files modified
opendir DIR, $update_dir or die "opendir $update_dir failed: $!";
@files = grep /\.(pat)$/i, readdir DIR;
%dates = ();
closedir DIR;
  foreach $file (@files) {
    $from_file = $from_dir . "\\" . basename($file);
    $update_file = $update_dir . "\\" . basename($file);
    if (not -e $from_file) {
      next;
    }
    @stat = stat($from_file); # better to set this info to $to_file ... check later ...
    @stat2 = stat($update_file); # better to set this info to $to_file ... check later ...
    if ($stat[9] > $stat2[9]) {
      $to_file = $to_dir . "\\" . basename($from_file);
      copy($from_file, $to_file);
      $dates{$to_file} = &gendate($stat[9]);
    }
  }
$first = 1;
  foreach $key (sort {$dates{$a} cmp $dates{$b}} keys %dates) {
    if ($first) {
      $first = 0;
      DebugPrint('');
    }
    DebugPrint("copied to $key - $dates{$key}");
  }
sub gendate {
  my($time) = @_;
  $tm = localtime($time);
  $year = $tm->year + 1900;
  $month = $tm->mon + 1;
  $day = $tm->mday;
  $hour = $tm->hour;
  $min = $tm->min;
  $sec = $tm->sec;
  return sprintf("$year/%02d/%02d $hour:$min:$sec", $month, $day);
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
