# File: CopyFilesWithTsvFile_Perl.pl
# Date            Author        number of nodes
# 2005/3/17       Walking Lint  44
# 2005/3/11       Walking Lint  44
# 2005/3/11       Walking Lint  61 (CopyFilesFromConfigFile_Perl->CopyFilesWithTsvFile_Perl)
# 2003/2/13       Walking Lint  61
# 2002/11/16      Walking Lint  57
# 2002/10/1       Walking Lint  57
# 2002/8/18       Walking Lint  149
# 2002/8/1        Walking Lint  136 (GenAnnotedLink_Perl->CopyFilesFromConfigFile_Perl)
# 2002/7/31       Walking Lint  446 (GenHtmlsFromConfigFile_Perl->GenAnnotedLink_Perl)
# 2002/7/30       Walking Lint  437
# 2002/7/30       Walking Lint  388 (GenHtmlsForSSG_Perl->GenHtmlsFromConfigFile_Perl)
# 2002/7/29       Walking Lint  388 (GenHtmlsForSSG->GenHtmlsForSSG_Perl)
# 2002/7/26       Walking Lint  237
# 2002/7/25       Walking Lint  150
# 2002/7/24       Walking Lint  138
# 2002/7/23       Walking Lint  136
# 2002/7/22       Walking Lint  55

=pod

=head1 NAME

CopyFilesWithTsvFile_Perl.pl - copy files according to .tsv file

=head1 DESCRIPTION

activate as program ex. CopyFilesWithTsvFile_Perl () // "D:\tmp\cv\templates\|.tsv" "" "D:\tmp\cv\templates" %% TsvFile FromFolder ToFolder

=head1 AUTHOR

Walking Lint

=cut

use File::Copy;
use File::Basename;
$tsv_file = shift;
if (length($tsv_file) == 0) {
  exit;
}
$from_dir = shift;
if (length($from_dir) == 0) {
  exit;
}
$to_dir = shift;
if (length($from_dir) == 0) {
  exit;
}
open IN, $tsv_file or die("Cannot open $tsv_file: $!\n");
$tsv = <IN>;
$tsv =~ s/[\r\n]+$//;
close IN;
@files = split(/\t/, $tsv);
foreach $file (@files) {
  $file .= '.pat';
  $from_file = $from_dir . "\\" . $file;
  $to_file = $to_dir . "\\" . $file;
  if (-e $to_file) {
    copy($from_file, $to_file);
    DebugPrint("over-written to $to_file");
  } else {
    copy($from_file, $to_file);
    DebugPrint("generated $to_file");
  }
  $from_file =~ s/\.pat/.jpg/;
  if (-e $from_file) {
    $to_file =~ s/\.pat/.jpg/;
    if (-e $to_file) {
      copy($from_file, $to_file);
      DebugPrint("over-written to $to_file");
    } else {
      copy($from_file, $to_file);
      DebugPrint("generated $to_file");
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
