# File: CountNodes_Perl.pl
# Date            Author        number of nodes
# 2004/12/21      Walking Lint  111
# 2004/10/28      Walking Lint  109
# 2004/10/27      Walking Lint  66
# 2004/10/27      Walking Lint  66 (Outline2Excel_Perl->CountNodes_Perl)
# 2004/6/28       Walking Lint  72
# 2004/6/28       Walking Lint  74 (DotWriter_Perl->Outline2Excel_Perl)
# 2003/10/20      Walking Lint  74
# 2003/10/20      Walking Lint  44 (IniWriter_Perl->DotWriter_Perl)
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

CountNodes_Perl.pl

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
$leafcount = 0;
$nodecount = 0;
$classcount = 0;
$normalcount = 0;
$vfunccount = 0;
$inoutcount = 0;
$incount = 0;
$outcount = 0;
$maxlevel = 0;
&count($root, 0);
DebugPrint("# of node\t= $nodecount");
DebugPrint("# of leaf\t= $leafcount");
$total = $nodecount + $leafcount;
DebugPrint("-----");
DebugPrint("total = $total");
DebugPrint("-----");
DebugPrint("# of class\t= $classcount");
DebugPrint("# of vfunc\t= $vfunccount");
DebugPrint("# of normal\t= $normalcount");
DebugPrint("# of inout\t= $inoutcount");
DebugPrint("# of in\t\t= $incount");
DebugPrint("# of out\t= $outcount");
$total = $classcount + $vfunccount + $normalcount + $inoutcount + $incount + $outcount;
for ($i = 0; $i <= $maxlevel; $i++) {
  if (length($classcount[$i]) == 0) {
    $classcount[$i] = 0;
  }
  if (length($vfunccount[$i]) == 0) {
    $vfunccount[$i] = 0;
  }
  if (length($normalcount[$i]) == 0) {
    $normalcount[$i] = 0;
  }
  if (length($inoutcount[$i]) == 0) {
    $inoutcount[$i] = 0;
  }
  if (length($incount[$i]) == 0) {
    $incount[$i] = 0;
  }
  if (length($outcount[$i]) == 0) {
    $outcount[$i] = 0;
  }
}
for ($i = 0; $i <= $maxlevel; $i++) {
  DebugPrint("-----");
  DebugPrint("# of class[" . $i . "]\t= $classcount[$i]"); # this is needed ...
  DebugPrint("# of vfunc[$i]\t= $vfunccount[$i]");
  DebugPrint("# of normal[$i]\t= $normalcount[$i]");
  DebugPrint("# of inout[$i]\t= $inoutcount[$i]");
  DebugPrint("# of in[$i]\t= $incount[$i]");
  DebugPrint("# of out[$i]\t= $outcount[$i]");
  DebugPrint("# of out[$i]\t= $outcount[$i]");
}
sub count {
  my($nd, $level) = @_;
  if ($nd->{NAME} =~ /^_/) { # this is needed ... think later ...
    return;
  }
  if ($level > $maxlevel) {
    $maxlevel = $level;
  }
  if ($nd->{NAME} eq 'root') {
    $level = -1;
  }
  if (defined($nd->{CHILD})) {
    if ($level == -1) { # do nothing ... for root ...
    } else {
      $nodecount++;
      &countnode($nd, $level);
    }
    my $cn = $nd->{CHILD};
    while (1) {
      count($cn, $level + 1);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  } else {
    if ($level == -1) { # do nothing ... for root ...
    } else {
      $leafcount++;
      &countnode($nd, $level);
    }
  }
}
sub countnode {
  my($nd, $level) = @_;
  if (length($nd->{NAME}) == 0) {
    return;
  }
  if ($nd->{KIND} =~ /\+/) {
    $classcount++;
    $classcount[$level]++;
  } elsif ($nd->{KIND} =~ /\-/) {
    $vfunccount++;
    $vfunccount[$level]++;
  } elsif ($nd->{KIND} =~ /inout/) {
    $inoutcount++;
    $inoutcount[$level]++;
  } elsif ($nd->{KIND} =~ /in/) {
    $incount++;
    $incount[$level]++;
  } elsif ($nd->{KIND} =~ /out/) {
    $outcount++;
    $outcount[$level]++;
  } else {
    $normalcount++;
    $normalcount[$level]++;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
