# File: CsvReader_Perl.pl
# Date            Author        number of nodes
# 2003/9/27       Walking@Lint 50
# 2003/5/17       Walking Lint  43
# 2003/3/8        Walking Lint  37
# 2003/3/8        Walking Lint  37 (XmlReader_Perl->CsvReader_Perl)
# 2003/3/8        Walking Lint  40 (CsvReader_Perl->XmlReader_Perl)
# 2002/11/10      Walking Lint  20
# 2002/11/9       Walking Lint  16
# 2002/3/10       Walking Lint  16 (CSVReader_Perl->CsvReader_Perl)

=pod

=head1 NAME

CsvReader_Perl.pl - CSV reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use Win32::Clipboard;
use File::Basename;
use Time::localtime;
$from_file = shift;
$to_file = $from_file;
@outlines = ();
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.csv';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
push @outlines, "root () /" . "/  %" . "% $file_comment\n";
$used_as_plugin = 0;
if (defined($to_file) and not ($to_file =~ /\.pat$/)) {
  $used_as_plugin = 1;
  $to_file =~ s/\..+/.pat/;
  open IN, $from_file || die("Can't open $from_file: $!\n");
  @lines = <IN>;
  close IN;
} else {
  $clipboard = Win32::Clipboard;
  $lines = $clipboard->Get();
  @lines = split(/\n/, $lines);
}
foreach $line (@lines) {
  $line =~ s/[\n\r]+$//; # this is needed ...
  @items = split(',', $line);
  push @outlines, "\t ()\n";
  foreach $item (@items) {
    $outline = "\t\t" . $item . " ()\n";
    push @outlines, $outline;
  }
}
$outlines = join('', @outlines);
if ($used_as_plugin) {
  open OUT, ">$to_file";
  print OUT $outlines;
  close OUT;
} else {
  $clipboard->Set($outlines);
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
