//
// File: DangerWafun_LSL.lsl
// Date            Author        number of nodes
// 2007/3/31       Walking Lint  76
// 2007/3/31       Walking Lint  76 (test->DangerWafun_LSL)
// 2007/3/31
//
integer activated = FALSE;
integer danger_mode = FALSE;
integer debug_mode = FALSE;
integer counter;
mySay(string str) {
    if (debug_mode == TRUE) {
        llOwnerSay(str);
    } else {
        llSay(0, str);
    }
}
showMode() {
    string debug_str;
    string danger_str;
    vector color;
    if (danger_mode) {
        danger_str = "Danger";
        color = <1.0, 0.0, 0.0>;
    } else {
        danger_str = "";
        color = <0.0, 1.0, 0.0>;
    }
    if (debug_mode) {
        debug_str = "Debug ";
        color = <1.0, 1.0, 0.0>;
    } else {
        debug_str = "";
    }
    llSetText(debug_str + danger_str, color, 0.5);
}
default {
    state_entry() {
        llSetText("", <0.0, 0.0, 0.0>, 0.5);
        danger_mode = FALSE;
        debug_mode = FALSE;
        showMode();
        llListen(0, "", llGetOwner(), "");
    }
    touch_start(integer num_detected) {
        if (danger_mode == FALSE) {
            llTriggerSound("wakyanko", 100);
        } else {
            if (activated == TRUE) {
                mySay("Self destruction sequence can not be cancelled");
            } else {
                mySay("Self destruction sequence has been initiated");
                llSleep(1.0);
                mySay("Evacuate this area in 10 second");
                llSleep(1.0);
                activated = TRUE;
                counter = 10;
                llSetTimerEvent(1.0);
            }
        }
    }
    timer() {
        mySay((string)counter + "...");
        counter--;
        if (counter == 0) {
            llTriggerSound("wakyanko", 100);
            mySay("nanchatte ^^");
            activated = FALSE;
            llSetTimerEvent(0);
        }
    }
    listen(integer channel, string name, key id, string message) {
        list parsed = llParseString2List( message, [" "], [] );
        if (llListFindList(parsed, ["wafun"]) != -1) {
            if (llListFindList(parsed, ["danger"]) != -1) {
                danger_mode = TRUE;
            }
            if (llListFindList(parsed, ["debug"]) != -1) {
                debug_mode = TRUE;
            }
            if (llListFindList(parsed, ["normal"]) != -1) {
                debug_mode = FALSE;
            }
            if (llListFindList(parsed, ["safe"]) != -1) {
                danger_mode = FALSE;
            }
        }
        llSleep(1.0);
        showMode();
    }
    on_rez(integer reset) {
        llResetScript();
    }
}
