# File: Days_Perl.pl
# Date            Author        number of nodes
# 2004/4/18       Walking Lint  112
# 2004/4/18       Walking Lint  46 (grep_Perl->Days_Perl)
# 2004/1/9        Walking Lint  43
# 2003/2/13       Walking Lint  27
# 2002/8/15       Walking Lint  21
# 2002/7/15       Walking Lint  19
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

Days_Perl.pl - grep str

=head1 DESCRIPTION

activate as filter or program

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
use Jcode;
$str = shift;
Jcode::convert(\$str, 'utf8', 'sjis', "z");
$str = quotemeta $str;
$daysfolder = $ENV{DaysFolder};
$from = $daysfolder . '\*'; # this is hack ...
if (length($from) != 0) {
  $dir = dirname($from);
  $dir2 = &mydirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  $dir = dirname($from);
  $dir2 = &mydirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  foreach $from_file (@from_files) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $pendingline = '';
    $pendingline = '';
    while (<IN>) {
      if ($_ =~ /$str/o) {
        if (length($pendingline) != 0) {
          print &date2url($from_file) . ": $.\t$pendingline";
          $pendingline = '';
        }
        Jcode::convert(\$_, 'sjis', 'utf8', "z");
        $pendingline = $_;
      } elsif ((length($pendingline) != 0) and ($_ =~ /Permalink">\(([0-9]{2}):([0-9]{2}):([0-9]{2})\)/)) {
        $h = $1;
        $m = $2;
        $s = $3;
        print &date2url2($from_file, $h, $m, $s) . ": $.\t$pendingline";
        $pendingline = '';
      }
    }
    if (length($pendingline) != 0) {
      print &date2url($from_file) . ": $.\t$pendingline";
      $pendingline = '';
    }
    close IN;
  }
} else {
  while (<STDIN>) {
    print "$_" if /$str/o;
  }
}
# customize here ...
sub date2url {
  my($date) = @_;
  $url = $date; # not actually
  $date =~ /([0-9]{4})([0-9]{2})([0-9]{2})/;
  $year = $1;
  $month = $2;
  $day = $3;
  if (20040409 <= $date) {
    $month =~ s/^0//;
    $day =~ s/^0//;
    $url = "http://ch.kitaguni.tv/u/5228/$year/$month/$day";
  } elsif ((20030924 <= $date) and ($date <= 20031204) or (20040323 <= $date) and ($date <= 20040403)) {
    $url = "http://d.hatena.ne.jp/walkinglint/$date";
  } elsif (20040113 <= $date) {
    $url = "http://www.fiberbit.net/user/mo83ed3/$year$month.html\#$day";
  } elsif (20031205 <= $date) {
    $url = "http://www.fiberbit.net/user/mo83ed2/$year$month.html\#$day";
  } elsif (20030818 <= $date) {
    $url = "http://www.fiberbit.net/user/mo83ed/$year$month.html\#$day";
  } else {
    $url = "http://homepage3.nifty.com/walkinglint/$year$month.html\#$day";
  }
  return $url;
}
# customize here ...
sub date2url2 {
  my($date, $h, $m, $s) = @_;
  $url = $date; # not actually
  $date =~ /([0-9]{4})([0-9]{2})([0-9]{2})/;
  $year = $1;
  $month = $2;
  $day = $3;
  if (20040409 <= $date) {
    $month =~ s/^0//;
    $day =~ s/^0//;
    $url = "http://ch.kitaguni.tv/u/5228/$year/$month/$day";
  } elsif ((20030924 <= $date) and ($date <= 20031204) or (20040323 <= $date) and ($date <= 20040403)) {
    $url = "http://d.hatena.ne.jp/walkinglint/$date";
  } elsif (20040113 <= $date) {
    $url = "http://www.fiberbit.net/user/mo83ed3/$year$month.html\#t$day$h$m$s";
  } elsif (20031205 <= $date) {
    $url = "http://www.fiberbit.net/user/mo83ed2/$year$month.html\#t$day$h$m$s";
  } elsif (20030818 <= $date) {
    $url = "http://www.fiberbit.net/user/mo83ed/$year$month.html\#t$day$h$m$s";
  } else {
    $url = "http://homepage3.nifty.com/walkinglint/$year$month.html\#t$day$h$m$s";
  }
  return $url;
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
