# File: DeleteCommentedOut_Perl.pl
# Date            Author        number of nodes
# 2002/12/19      Walking Lint  36
# 2002/11/10      Walking Lint  94 (Index_Perl->DeleteCommentedOut_Perl)
# 2002/11/8       Walking Lint  91
# 2002/11/6       Walking Lint  27 (Index_Perl->Index_Perl)
# 2002/11/5       Walking Lint  212 (Index_Perl->Index_Perl)
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (Index_Perl->Index_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->Index_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

DeleteCommentedOut_Perl.pl - delete commented out

=head1 DESCRIPTION

ex. perl.exe DeleteCommentedOut_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root);
&deletecommentedout($root);
&savetree($root);
sub deletecommentedout {
  my($nd) = @_;
  if (defined($nd->{CHILD})) { # this is assumed ...
    my $cn = $nd->{CHILD};
    while (1) {
      my $ncn = $cn->{NEXT};
      if (($cn->{NAME} eq '_note') and ($cn->{TYPE} =~ /^commented out /)) {
        &delnode($cn);
      } else {
        deletecommentedout($cn);
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
