# File: DeleteWidthOfTable_Perl.pl
# Date            Author        number of nodes
# 2002/7/30       Walking Lint  35
# 2002/7/30       Walking Lint  50 (ExtractImageAndMapLine_Perl->DeleteWidthOfTable_Perl)
# 2002/7/19       Walking Lint  18 (DropArchiveAndReadOnlyAttributesOfHtmlFiles_Perl->ExtractImageAndMapLine_Perl)
# 2002/7/19       Walking Lint  18 (SetFileAttr_Perl->DropArchiveAndReadOnlyAttributesOfHtmlFiles_Perl)
# 2002/7/18       Walking Lint  18 (PDFRef2ActiveXRef_Perl->SetFileAttr_Perl)
# 2001/8/15       Walking Lint  17 (Filter3_Perl->NewFile)

=pod

=head1 NAME

DeleteWidthOfTable_Perl.pl - extract image and map line

=head1 DESCRIPTION

ex. perl.exe DeleteWidthOfTable_Perl.pl D:/SSG_j/j

=head1 AUTHOR

Walking Lint

=cut

use Cwd;
use File::Find;
use File::Basename;
use Win32::File;
$dir = shift;
find(\&check_file, $dir);
sub check_file {
  $file_to_check = $_;
  if (($file_to_check =~ /.html$/) and ($file_to_check =~ /^C/)) {
    $cdir = cwd;
    if ($cdir =~ /app$/) { # this may be hack ...
      next;
    }
    $from_file = $cdir . "/$_";
    open IN, $from_file || die("Can't open $from_file: $!\n");
    @lines = <IN>;
    close IN;
    $res = '';
    $changed = 0;
    foreach $line (@lines) {
      if (($line =~ /<table/i) and ($line =~ /width/i)) { # not sure but ...
        $line =~ s/ width="[0-9]+%"//i;
        $changed = 1;
      }
      $res = $res . $line;
    }
    my $to_file = $from_file;
    if ($changed) {
      open OUT, ">$to_file";
      print OUT $res;
      close OUT;
      print STDERR "changed $to_file\n";
    }
  }
}
