# File: DistributeScripts_Perl.pl
# Date            Author        number of nodes
# 2002/12/8       Walking Lint  106
# 2002/12/7       Walking Lint  109 (Script_Perl->DistributeScripts_Perl)
# 2002/12/6       Walking Lint  94 (Perl_Perl->Script_Perl)
# 2002/11/29      Walking Lint  90
# 2002/11/28      Walking Lint  86
# 2002/11/26      Walking Lint  28
# 2002/11/21      Walking Lint  24
# 2002/11/20      Walking Lint  23
# 2002/11/18      Walking Lint  23
# 2002/8/15       Walking Lint  21 (grep_Perl->Perl_Perl)
# 2002/7/15       Walking Lint  19
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

DistributeScripts_Perl.pl - distribute scripts

=head1 DESCRIPTION

ex. perl.exe DistributeScripts_Perl.pl C:\memo\cv\templates

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
use Time::localtime;
$templatesfolder = shift;
$graph_length = 20;
%modified_time = ();
%size = ();
%elem_modified_time = ();
%elem_size = ();
%map = ();
$from = $templatesfolder . '\*_Perl.pat';
&check_dir($from);
$from = $templatesfolder . '\*_Python.pat';
&check_dir($from);
$from = $templatesfolder . '\*_Ruby.pat';
&check_dir($from);
$min_modified_time = 9999999999;
$max_modified_time = 0;
$min_size = 9999999999;
$max_size = 0;
foreach $key (sort keys %modified_time) {
  $modified_time = $modified_time{$key};
  if ($modified_time < $min_modified_time) {
    $min_modified_time = $modified_time;
    $min_modified_time_file = $key;
  }
  if ($max_modified_time < $modified_time) {
    $max_modified_time = $modified_time;
    $max_modified_time_file = $key;
  }
}
foreach $key (sort keys %size) {
  $size = $size{$key};
  if ($size < $min_size) {
    $min_size = $size;
    $min_size_file = $key;
  }
  if ($max_size < $size) {
    $max_size = $size;
    $max_size_file = $key;
  }
}
$elem_modified_time = ($max_modified_time - $min_modified_time + $graph_length - 1) / $graph_length;
$elem_size = ($max_size - $min_size + $graph_length - 1) / $graph_length;
foreach $key (keys %modified_time) {
  $elem_modified_time{$key} = int(($modified_time{$key} + 1 - $min_modified_time + $elem_modified_time - 1) / $elem_modified_time);
}
foreach $key (keys %size) {
  $elem_size{$key} = int(($size{$key} + 1 - $min_size + $elem_size - 1) / $elem_size);
}
foreach $key (keys %modified_time) {
  $x = $elem_modified_time{$key};
  $y = $elem_size{$key};
  $map{$x}{$y}++;
}
print " max_size = $max_size ($max_size_file)\n\n";
foreach $y (reverse 1..$graph_length) {
  foreach $x (1..$graph_length) {
    if (not defined($map{$x}{$y}) or $map{$x}{$y} == 0) {
      print '    ';
    } else {
      printf " %3d", $map{$x}{$y};
    }
  }
  print "\n";
}
print "\n min_size = $min_size ($min_size_file)\n\n";
$tm = localtime($min_modified_time);
$min_modified_time_str = sprintf("%04d/%02d/%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$tm = localtime($max_modified_time);
$max_modified_time_str = sprintf("%04d/%02d/%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
print <<END;
            min_modified_time = $min_modified_time_str ($min_modified_time_file)
            max_modified_time = $max_modified_time_str ($max_modified_time_file)
END
sub check_dir {
  my($from) = @_;
  $dir = dirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  foreach $from_file (@from_files) {
    $file = $dir . "\\" . $from_file;
    @stat = stat($file);
    $modified_time{$from_file} = $stat[9];
    $size{$from_file} = $stat[7];
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
