# File: Excel2Outline_Perl.pl
# Date            Author        number of nodes
# 2004/6/28       Walking Lint  224
# 2004/6/14       Walking Lint  224
# 2004/5/28       Walking Lint  186
# 2004/5/18       Walking Lint  160
# 2004/5/17       Walking Lint  114
# 2004/5/10       Walking Lint  110
# 2004/5/10       Walking Lint  114 (GeppouReader_Perl->Excel2Outline_Perl)
# 2003/12/26      Walking Lint  114
# 2003/10/3       Walking@Lint 109
# 2003/8/1        Walking Lint  101
# 2003/7/31       Walking Lint  101
# 2003/6/30       Walking Lint  101
# 2002/12/3       Walking Lint  98
# 2002/12/2       Walking Lint  93
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

Excel2Outline_Perl.pl - excel to outline

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$num_of_columns = shift;
DebugPrint("num_of_columns = $num_of_columns");
if (length($num_of_columns) > 0) {
  if (&isNum($num_of_columns)) {
    $from_file = shift;
  } else {
    $from_file = $num_of_columns;
    $num_of_columns = 10000;
  }
} else {
  $num_of_columns = 10000;
}
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.txt';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
if (length($from_file) != 0) {
  open IN, $from_file || die("Can't open $from_file: $!\n");
  $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
} else {
  $infilehandle = 'STDIN';
}
@lines = ();
$tmp_line = '';
$num_of_quote = 0;
while (1) {
  $_ = <$infilehandle>;
  if (not defined($_)) {
    last;
  }
  $quotes = $_;
  $quotes =~ s/[^\"]+//g;
  $num_of_quote += length($quotes);
  if (($num_of_quote % 2) == 1) {
    $tmp_line =~ s/[\r\n]+$//;
    $tmp_line .= ' ' . $_;
  } else {
    if (length($tmp_line)) {
      $tmp_line =~ s/[\r\n]+$//;
      $tmp_line .= ' ' . $_;
      $tmp_line =~ s/\"//g;
      push @lines, $tmp_line;
      $tmp_line = '';
    } else {
      push @lines, $_;
    }
    $num_of_quote = 0;
  }
}
if (length($tmp_line)) {
  push @lines, $tmp_line;
}
if (length($from_file) != 0) {
  close IN;
}
&gentree($root, $from_file);
if (defined($root)) {
  &treatfilekind($root);
}
&savetree($root, $to_file);
if (defined($from_file)) {
  DebugPrint("generated $to_file");
}
sub extractparams {
  my($line) = @_;
  $kind = ' () '; # somehow this is hack ... think later ...
  $type = '';
  $text = '';
  if ($line =~ /^(\t*)([^\t]+)(.*)/) {
    $level = length($1);
    DebugPrint("level = $level");
    $name = $2;
    DebugPrint("name = $name");
    if ($level + 1 == $num_of_columns) {
      $text = $3;
      $text =~ s/^[\t]+//;
      $text =~ s/[\t]+$//;
      $text =~ s/\t/ \/ /g;
      DebugPrint("text = $text");
    } elsif ($level + 1 > $num_of_columns) {
      $name = '_text';
      $text = $2 . $3;
      $text =~ s/^[\t]+//;
      $text =~ s/[\t]+$//;
      $text =~ s/\t/ \/ /g;
      DebugPrint("text = $text");
    } else {
      if (length($3) > 0) {
        $pushed = "\t" x $level;
        $pushed .= $3;
        push @lookahead, $pushed;
      }
    }
    if ($name =~ /^http/) {
      $kind = ' () / '; # somehow this is hack ... think later ...
    }
    return 0;
  } else {
    return 1;
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  @lookaheads = ();
  while (1) {
    $_ = shift @lookahead;
    if (not defined($_)) {
      $_ = shift @lines;
    }
    if (not defined($_)) {
      last;
    }
    $_ =~ s/[\n\r ]+$//;
    if ((length($_) != 0)) {
      if (&extractparams($_)) {
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        $cur = addnode($cur, $name, $kind, $type, $text);
      } else {
        until ($prevlevel <= $level) {
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevlevel = $level;
    }
  }
}
sub getfilekindfromurl {
  my($url) = @_;
  $url =~ tr/A-Z/t-z/;
  if ($url =~ /\.doc$/) {
    return ' (Word)';
  } elsif ($url =~ /\.gif$/) {
    return ' (GIF)';
  } elsif ($url =~ /\.(jpg|jpeg)$/) {
    return ' (JPG)';
  } elsif ($url =~ /\.mov$/) {
    return ' (QuickTime)';
  } elsif ($url =~ /\.pdf$/) {
    return ' (PDF)';
  } elsif ($url =~ /\.png$/) {
    return ' (PNG)';
  } elsif ($url =~ /\.ppt$/) {
    return ' (PowerPoint)';
  } elsif ($url =~ /\.svg$/) {
    return ' (SVG)';
  } elsif ($url =~ /\.swf$/) {
    return ' (Flash)';
  } elsif ($url =~ /\.wrl$/) {
    return ' (VRML)';
  } elsif ($url =~ /\.xls$/) {
    return ' (Excel)';
  } else {
    return '';
  }
}
sub isNum {
  my($num) = @_;
  return $num =~ /^[0-9]+$/;
}
sub treatfilekind {
  my($nd) = @_;
  my $cn = $nd->{CHILD};
  if (defined($cn)) {
    if (defined($cn->{NEXT}) or not ($cn->{NAME} =~ /^http/)) {
      while (1) {
        &treatfilekind($cn);
        $cn = $cn->{NEXT};
        if (not defined($cn)) {
          last;
        }
      }
    } else {
      $url = $cn->{NAME};
      $ext = &getfilekindfromurl($url);
      if (length($ext) != 0) {
        $nd->{NAME} =~ s/( |@)+$//;
        $nd->{NAME} .= $ext;
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
