# File: ExtractKeywordLinks_Perl.pl
# Date            Author        number of nodes
# 2004/3/31       Walking Lint  87
# 2004/3/31       Walking Lint  44 (ExtractLinks_Perl->ExtractKeywordLinks_Perl)
# 2004/3/31       Walking Lint  44
# 2002/11/27      Walking Lint  41
# 2002/11/22      Walking Lint  40
# 2002/11/19      Walking Lint  24

=pod

=head1 NAME

ExtractKeywordLinks_Perl.pl - extract keyword links from url

=head1 DESCRIPTION

ex. perl.exe ExtractKeywordLinks_Perl.pl http://www.fiberbit.net/user/mo83ed2/index.html D\tmp\KeywordLinks.pat

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use HTML::LinkExtor;
use CVTree_Perl;
use Jcode;
# get proxy info from registry
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$ref->Close();
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = $proxyoverride");
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = $proxyserver");
$url = shift;
$outline = shift;
$webagent = new LWP::UserAgent;
unless ($url =~ /$proxyoverride/) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
}
$request = new HTTP::Request(GET => $url);
$response = $webagent->request($request);
my $root = {};
if ($response->is_success) {
  $baseurl = $url;
  $baseurl =~ s/^([^\/]*\/)+//;
  $baseurl =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; # [[CGI-Perl̊bu(p04)!http://www.parkcity.ne.jp/~chaichan/src/perl04.htm]]
  &initnode($root, 'root', '', '', ''); # this is it ...
  $top = &addchildnode($root, $baseurl, ' () ', '', $url);
  $mask = 'keyword';
  %urls = ();
  $parser = HTML::LinkExtor->new(\&link_callback, $url);
  $parser->parse($response->content);
  foreach $key (sort keys %urls) {
    $url = $key;
    $baseurl = $url;
    $baseurl =~ s/^([^\/]*\/)+//;
    $baseurl =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; # [[CGI-Perl̊bu(p04)!http://www.parkcity.ne.jp/~chaichan/src/perl04.htm]]
    Jcode::convert(\$baseurl, 'sjis');
    &addchildnode($top, $baseurl, ' () ', '', $url);
  }
  &sortedsavetree2($root, $outline);
  DebugPrint("generated $outline");
}
sub link_callback {
  my($tag, %links) = @_;
  if ($tag eq "a") {
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      if ($url =~ /$mask/) {
        $urls{$url} = 1;
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
