# File: ExtractLinks_Perl.pl
# Date            Author        number of nodes
# 2004/3/31       Walking Lint  44
# 2002/11/27      Walking Lint  41
# 2002/11/22      Walking Lint  40
# 2002/11/19      Walking Lint  24

=pod

=head1 NAME

ExtractLinks_Perl.pl - extract links from url

=head1 DESCRIPTION

ex. perl.exe ExtractLinks_Perl.pl http://www.fiberbit.net/user/mo83ed2/index.html

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use HTML::LinkExtor;
# get proxy info from registry
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$ref->Close();
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = $proxyoverride");
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = $proxyserver");
$url = shift;
$base_url = $url;
$webagent = new LWP::UserAgent;
unless ($url =~ /$proxyoverride/) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
}
$request = new HTTP::Request(GET => $url);
$response = $webagent->request($request);
if ($response->is_success) {
  $parser = HTML::LinkExtor->new(\&link_callback, $base_url);
  $parser->parse($response->content);
}
sub link_callback {
  my($tag, %links) = @_;
  if ($tag eq "a") {
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      print "$url\n";
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
