# File: ExtractMultiLevelLinks_Perl.pl
# Date            Author        number of nodes
# 2004/3/31       Walking Lint  136
# 2004/3/31       Walking Lint  136 (Links_Perl->ExtractMultiLevelLinks_Perl)
# 2002/11/27      Walking Lint  136
# 2002/11/22      Walking Lint  135
# 2002/11/22      Walking Lint  146 (Links2Tree_Perl->Links_Perl)
# 2002/11/21      Walking Lint  146 (Link2Tree_Perl->Links2Tree_Perl)

=pod

=head1 NAME

ExtractMultiLevelLinks_Perl.pl - grep multi level links from url

=head1 DESCRIPTION

ex. perl.exe ExtractMultiLevelLinks_Perl.pl CityDesk http://member.nifty.ne.jp/WalkingLint/ 3 WalkingLint cms

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use LWP::Simple;
use HTML::LinkExtor;
use Jcode;
# get proxy info from registry
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$ref->Close();
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = $proxyoverride");
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = $proxyserver");
$str = shift;
DebugPrint("str = $str");
$url = shift;
DebugPrint("url = $url");
$maxlevel = shift;
DebugPrint("maxlevel = $maxlevel");
$mask = shift;
DebugPrint("mask = $mask");
$excludemask = shift;
DebugPrint("excludemask = $excludemask");
$separator = '\n';
$webagent = new LWP::UserAgent;
unless ($url =~ /$proxyoverride/) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
}
@urls = ();
%levels = ();
%pushed = ();
%checked = ();
push @urls, $url;
$pushed{$url} = 1;
if ($url =~ /\/$/) {
  $pushed{$url . 'index.html'} = 1;
} elsif ($url =~ /\/index\.html$/) {
  my $tmp = $url;
  $tmp =~ s/index\.html$//;
  $pushed{$tmp} = 1;
}
$url =~ /([^\/]+)\.htm/;
$levels{$url} = 1;
while (@urls != ()) {
  $url = shift @urls;
  if ((not defined $checked{$url}) and ($url =~ /(\/|\.(html|htm))$/)) {
    $checked{$url} = 1;
    if ($url =~ /\/$/) {
      $checked{$url . 'index.html'} = 1;
    } elsif ($url =~ /\/index\.html$/) {
      my $tmp = $url;
      $tmp =~ s/index\.html$//;
      $checked{$tmp} = 1;
    }
    $currentlevel = $levels{$url};
    if ((not defined($maxlevel)) or (length($maxlevel) == 0) or ($currentlevel < $maxlevel)) {
      &grep_link($url, $mask);
      next;
    } else {
      # do something for $url here getting $response->content
      my $request = new HTTP::Request('GET' => $url);
      my $response = $webagent->request($request);
      if ($response->is_success) {
        # do something for $url here using $response->content
        my $doc = $response->content;
        Jcode::convert(\$doc, 'sjis');
        if ($doc =~ /$str/i) {
          print "\n$url:\n";
          $doc =~ s/[\n\r]+/\n/g; # not sure if needed ...
          my @lines = split(/$separator/, $doc);
          my $count = 1;
          foreach $line (@lines) {
            if ($line =~ /$str/i) { # o check later ...
              $line =~ s/($str)/*$1*/g;
              printf "%5d $line\n", $count;
            }
            $count++;
          }
        }
      }
    }
  }
}
sub grep_link {
  my($url, $mask) = @_;
  my $request = new HTTP::Request('GET' => $url);
  my $response = $webagent->request($request);
  if ($response->is_success) {
    $parser = HTML::LinkExtor->new(\&link_callback, $url);
    $parser->parse($response->content);
    # do something for $url here using $response->content
    my $doc = $response->content;
    Jcode::convert(\$doc, 'sjis');
    if ($doc =~ /$str/i) {
      print "\n$url:\n";
      $doc =~ s/[\n\r]+/\n/g; # not sure if needed ...
      my @lines = split(/$separator/, $doc);
      my $count = 1;
      foreach $line (@lines) {
        if ($line =~ /$str/i) { # o check later ...
          $line =~ s/($str)/*$1*/g;
          printf "%5d $line\n", $count;
        }
        $count++;
      }
    }
  }
}
sub link_callback {
  my($tag, %links) = @_;
  $tag = lc($tag); # maybe not needed ...
  if (($tag eq 'a') or ($tag eq 'frame')) { # or ($tag eq 'option') not functioning ...
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      if (($url =~ /^http/) and ($url =~ /(\/|\.(html|htm|cgi|doc|ppt|pdf|txt|xls))$/) and (not $url =~ /\#/) and (not defined $pushed{$url})) { # think later ...
        if ((not defined($mask)) or (length($mask) == 0) or ($url =~ /$mask/)) {
          if ((not defined($excludemask)) or (length($excludemask) == 0) or (not $url =~ /$excludemask/)) {
            $pushed{$url} = 1;
            if ($url =~ /\/$/) {
              $pushed{$url . 'index.html'} = 1;
            } elsif ($url =~ /\/index\.html$/) {
              my $tmp = $url;
              $tmp =~ s/index\.html$//;
              $pushed{$tmp} = 1;
            }
            push @urls, $url;
            $levels{$url} = $currentlevel + 1;
          }
        }
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
