# File: ExtractTopic_Perl.pl
# Date            Author        number of nodes
# 2003/4/4        Walking Lint  92
# 2003/3/30       Walking Lint  92
# 2003/3/29       Walking Lint  92
# 2003/3/23       Walking Lint  93
# 2003/3/3        Walking Lint  94
# 2003/2/20       Walking Lint  83
# 2002/11/19      Walking Lint  76
# 2002/11/19      Walking Lint  74 (ExtractCategorizedText_Perl->ExtractTopic_Perl)
# 2002/10/1       Walking Lint  74
# 2002/9/30       Walking Lint  76 (ExtractCategorizedTextNew_Perl->ExtractCategorizedText_Perl)
# 2002/9/28       Walking Lint  182 (ExtractCategorizedText_Perl->ExtractCategorizedTextNew_Perl)
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

ExtractTopic_Perl - extract topic as text

=head1 DESCRIPTION

ex1. perl.exe ExtractTopic_Perl.pl "Web ֌W"

ex2. perl.exe ExtractTopic_Perl.pl "Web ֌W" ^2003[0-9]+\.pat$

ex3. perl.exe ExtractTopic_Perl.pl ".*֌W" .*\.pat$ "C:\My Documents\񍐏"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
$topic = shift;
DebugPrint("topic = " . $topic);
$mask = shift;
DebugPrint("mask = " . $mask);
$dir = shift;
if (length($dir) != 0) {
} else {
  $weblogfolder = $ENV{WEBLOGFOLDER};
  $weblogfolder =~ s/"//g;
  $dir = $weblogfolder;
}
DebugPrint("dir = $dir");
opendir DIR, $dir or die "opendir($dir) failed: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /$mask/, @files;
closedir DIR;
$to_file = $dir . "\\ExtractTopic.txt";
my $root = {};
$yearmonth = '';
foreach $file (@files) {
  &initnode($root, 'root', '', '', '');
  $from_file = $dir . "\\" . $file;
  DebugPrint("from_file = $from_file");
  &gentree($root, $from_file);
  $textlines = '';
  &extractcategorizedtext($root, 0);
}
open OUT, ">$to_file";
foreach $key (sort keys %categorizedtext) {
  DebugPrint("extracted $key");
  print OUT $categorizedtext{$key};
}
close OUT;
DebugPrint("generated $to_file");
sub extractcategorizedtext {
  my($nd, $extract) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if (($cn->{NAME} eq _note) or ($cn->{KIND} =~ /\!/)) { # actually _node is already deleted ...
        # skip
      } else {
        if ($extract) {
          $text = $cn->{TEXT};
          $text =~ s/ \CRLF /\n/g;
          $textlines .= $text;
          extractcategorizedtext($cn, 1);
        } else {
          if ((length($cn->{TYPE}) == 0) and ($cn->{NAME} =~ /$topic/i) or ($cn->{TYPE} =~ /$topic/i)) { # not sure ...
            $textlines .= "\n\n----- $yearmonth $cn->{NAME} -----\n\n";
            $text = $cn->{TEXT};
            $text =~ s/ \CRLF /\n/g;
            $textlines .= $text;
            extractcategorizedtext($cn, 1);
          } else {
            if ($cn->{NAME} =~ /^(200[0-9\/]+)/) {
              if (length($textlines) != 0) {
                $categorizedtext{$yearmonthday_key} = $textlines;
              }
              $yearmonth = $1;
              ($year, $month, $day) = split(/\//, $yearmonth);
              $yearmonthday_key = sprintf("%d%02d%02d", $year, $month, $day);
              $textlines = '';
            }
            extractcategorizedtext($cn, 0);
          }
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    if (length($textlines) != 0) { # this is needed ...
      $categorizedtext{$yearmonthday_key} = $textlines;
    }
  }
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
