# File: FTermListReader_Perl.pl
# Date            Author        number of nodes
# 2005/2/10       Walking Lint  31
# 2005/2/9        Walking Lint  27
# 2005/2/8        Walking Lint  26
# 2005/2/4        Walking Lint  22

=pod

=head1 NAME

FTermListReader_Perl.pl - F term list reader

=head1 DESCRIPTION

activate as filter

can be used to outline table like 

<a href="http://www5.ipdl.ncipi.go.jp/pmgs1/pmgs1/frame?hs=1&gb=2&dep=3&sec=5C&cls=059&scls=&mgrp=&idx=&sgrp=&sf=&bs=&dt=0&wrd=DVD&nm=5C059">PMGS/FTERM (e^[Xg)</a>

=head1 AUTHOR

Walking Lint

=cut

$fterms = <STDIN>;
@fterm = split(/[ ]+/, $fterms);
$defs = <STDIN>;
$defs =~ s/^[ ]+//;
$defs =~ s/(E|)//g;
$defs =~ s/ij//g; # try this ...
$defs =~ s/[ |@]*//g; # try this ...
@def = split(/[ ]+/, $defs);
foreach $fterm (@fterm) {
  $fterm =~ s/[\r\n]+$//;
  if (length($fterm) != 0) {
    $def = shift @def;
    print $fterm . " () // %" . "% " . $def . "\n";
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
