# File: FTermTableReader_Perl.pl
# Date            Author        number of nodes
# 2006/1/16       Walking Lint  173
# 2005/11/17      Walking Lint  162
# 2005/7/14       Walking Lint  151
# 2005/4/21       Walking Lint  150
# 2005/3/29       Walking Lint  149
# 2005/3/25       Walking Lint  132
# 2005/3/24       Walking Lint  128
# 2005/3/23       Walking Lint  109
# 2005/3/8        Walking Lint  106
# 2005/2/10       Walking Lint  62
use CVTree_Perl;
$pcnums = shift;
DebugPrint("pcnums = $pcnums");
$to_dir = shift;
DebugPrint("to_dir = $to_dir");
if ((length($to_dir) == 0) and (length($pcnums) != 0)) {
  $to_dir = $pcnums;
  undef $pcnums;
}
$list_fn = $ENV{TEMPLATESFOLDER} . "\\" . "FTermList.txt";
%list = ();
if (-e $list_fn) {
  open IN, $list_fn or die("Cannot open $list_fn: $!\n");
  while (<IN>) {
    $_ =~ s/[\r\n]+$//;
    ($name, $def) = split(/\t/, $_);
    $list{$name} = $def;
  }
  close IN;
}
if (length($pcnums) == 0) {
  &readtable('');
} else {
  @pcnums = split(/\t/, $pcnums);
  foreach $pcnum (@pcnums) {
    &readtable($pcnum);
  }
}
open OUT, ">$list_fn" or die("Cannot open $list_fn: $!\n"); # FTermList.txt is updated ...
foreach $key (sort keys %list) {
  print OUT "$key\t$list{$key}\n";
}
close OUT;
sub readtable {
  my($pcnum) = @_;
  if (length($pcnum) == 0) {
    @lines = <STDIN>;
  } else { # get table from URL
    use LWP::UserAgent;
    use Win32::Registry;
    use Win32::Clipboard;
    use Jcode;
    $HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
    $ref->GetValues(\%values);
    $refproxyoverride = $values{'ProxyOverride'};
    $refproxyserver = $values{'ProxyServer'};
    $ref->Close();
    $proxyoverride = $$refproxyoverride[2];
    $proxyoverride =~ s/\*//g;
    $proxyoverride =~ s/;?<local>//g;
    $proxyoverride =~ s/;/\|/g; # not actually ...
    $proxyoverride = quotemeta $proxyoverride;
    $proxyoverride =~ s/\\\|/\|/g; # hack ...
    $proxyoverride = '(' . $proxyoverride . ')';
    $proxyserver = $$refproxyserver[2];
    $pcnum =~ /([0-9A-Z][0-9A-Z])([0-9][0-9][0-9])/;
    $url = 'http://www5.ipdl.ncipi.go.jp/pmgs1/pmgs1/!fterm_lst?hs=1&gb=2&dep=3&sec=' . $1 . '&cls=' . $2;
    $webagent = new LWP::UserAgent;
    unless ($url =~ /$proxyoverride/) {
      $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
    }
    $request = HTTP::Request->new('GET' => $url);
    my $response = $webagent->request($request);
    if ($response->is_success) {
      $doc = $response->content;
      $doc =~ s/[\n\r]+/\n/g; # not sure if needed ...
      Jcode::convert(\$doc, 'sjis');
      @lines = split(/\n/, $doc);
    } else {
      DebugPrint("Cannot download $url");
      exit;
    }
  }
  @fterms = ();
  @ftermdefs = ();
  $foundtop = 0;
  $top = '';
  $topdef = '';
  foreach $line (@lines) {
    if (($foundtop == 0) and ($line =~ /TARGET="_top">([^<]*)<\/A>/)) {
      $top = $1;
      $foundtop = 1;
    } elsif ($line =~ /<FONT SIZE="\+1">([^<]*)<\/FONT>/) {
      $topdef = $1;
    } else {
      while ($line =~ /<FONT SIZE="-2">([^<]*)<\/FONT>/g) {
        push @fterms, $1;
      }
      while ($line =~ /<FONT SIZE="-1">([^<]*)<\/FONT>/g) {
        push @ftermdefs, $1;
      }
    }
  }
  if ((length($pcnum) != 0) and (length($top) == 0)) {
    DebugPrint("$pcnum ͂܂");
    exit;
  }
  if (length($topdef) == 0) {
    $topdef = 'Ȃ';
  }
  if (&updatelist($top, $topdef) == 0) { # not obsolete
    my $root = {};
    &initnode($root, 'root', '', '', '');
    $node = &addchildnode($root, $top, '', '', $topdef);
    &gentree($node);
    $to_file = '';
    if (length($to_dir) != 0) {
      $to_file = $to_dir . "\\" . $top . ".pat";
    }
    &savetree($root, $to_file);
    if (length($to_dir) != 0) {
      &savetree($root, ''); # hack ...
      DebugPrint("generated $to_file");
    }
  } else {
    print "$top - obsolute?\n";
    DebugPrint("$top - obsolute?");
  }
}
sub gentree {
  my($nd) = @_;
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  foreach $fterm (@fterms) {
    $name = $fterm;
    $text = shift @ftermdefs;
    if ($text =~ s/^((?:E)+)//) {
      $level = length($1) / 2;
    } else {
      $level = 0;
    }
    $text =~ s/()//g;
    $text =~ s/ij//g; # try this ...
    $text =~ s/[ |@]*//g; # try this ...
    # construct tree here ...
    if ($prevlevel < $level) {
      push @prevlevels, $prevlevel;
      $cur = addchildnode($cur, $name, $kind, $type, $text);
    } elsif ($prevlevel == $level) {
      $cur = addnode($cur, $name, $kind, $type, $text);
    } else {
      until ($prevlevel <= $level) {
        if ($cur->{PARENT} == $root) { # hack ???
          last;
        }
        $cur = $cur->{PARENT};
        $prevlevel = pop @prevlevels;
      }
      $cur = addnode($cur, $name, $kind, $type, $text);
    }
    $prevlevel = $level;
  }
}
sub updatelist {
  my($nm, $df) = @_;
  $obsolete = 0;
  if (($df eq 'Ȃ') and defined($list{$nm}) and not ($list{$nm} eq 'Ȃ')) {
    $df = $list{$nm} . ' - obsolete?';
    $obsolete = 1;
  }
  $list{$nm} = $df;
  return $obsolete;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
