# File: GanttWriter_Perl.pl
# Date            Author        number of nodes
# 2005/2/3        Walking Lint  144
# 2005/2/2        Walking Lint  116
# 2005/2/2        Walking Lint  43 (IniWriter_Perl->GanttWriter_Perl)
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

GanttWriter_Perl.pl

=head1 DESCRIPTION

activate as plug-in ex. .xml () // %% GanttWriter_Perl

<a href="http://ganttproject.sourceforge.net/">GanttProject.org - Home</a>

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::Local;
use Time::localtime;
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
my $root = {};
$basename = basename($from_file);
$basename =~ s/\.pat$//;
$id = 0;
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
open OUT, ">$to_file";
print OUT <<"END";
<?xml version="1.0" encoding="Shift_JIS" ?>
<project name="$basename" company="" webLink="http://" view-date="1/2/2005" view-zoom="2" version="1.10.3">
  <tasks color="#8cb6ce">
END
&calcduration($root);
&gentasks($root, 2);
print OUT <<"END";
  </tasks>
  <resources></resources>
  <allocations></allocations>
  <roles roleset-name="Default"/>
</project>
END
close OUT;
sub calcduration {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    my $prev_time = 0;
    my $total_duration = 0;
    while (1) {
      $name = $cn->{NAME};
      if ($text =~ /^_/) {
      } else {
        $text = $cn->{TEXT};
        if (defined($cn->{CHILD})) {
          $duration = &calcduration($cn);
          my $ctext = $cn->{CHILD}->{TEXT};
          my $note = '';
          if ($ctext =~ /^([^ ]+) /) {
            $ctext = $1;
          }
          if ($cn->{TEXT} =~ /[^\-]+\- (.+)/) { # sometimes ...
            $note = $1;
            $cn->{TEXT} = $ctext . ' - ' . $note;
          } else {
            $cn->{TEXT} = $ctext;
          }
        } else {
          if (length($text) == 0) {
            $time = 0;
          } elsif ($text =~ /(20[0-9][0-9])\/([0-9]+)\/([0-9]+)/) { # this is assumed ...
            $text = $3 . '/' . $2 . '/' . $1;
            $time = timelocal(0, 0, 0, $3, $2 - 1, $1);
          }
          if (($prev_time != 0) and ($time != 0)) {
            $duration = ($time - $prev_time) / (60 * 60 * 24);
          } else {
            $duration = 1;
          }
        }
        if ($duration < 0) {
          $duration = 0;
        }
        $cn->{TYPE} = $duration;
        $total_duration += $duration;
        $prev_time = $time;
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    return $total_duration;
  }
}
sub gentasks {
  my($nd, $level) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    my $prev_time = 0;
    my $cnt = 1;
    my $indent = '  ' x $level;
    while (1) {
      $name = $cn->{NAME};
      if ($text =~ /^_/) {
      } else {
        my $note = '';
        if ($cn->{TEXT} =~ /(20[0-9][0-9])\/([0-9]+)\/([0-9]+)/) { # this is assumed ...
          $text = $3 . '/' . $2 . '/' . $1;
          $time = timelocal(0, 0, 0, $3, $2 - 1, $1);
        }
        if ($cn->{TEXT} =~ /[^\-]+\- (.+)/) { # sometimes ...
          $note = $1;
        }
        $duration = $cn->{TYPE};
        if ($duration == 0) {
          $duration = 1;
          $cnt = 1;
        }
        if (defined($cn->{CHILD})) {
          if (length($note) == 0) {
            print OUT <<"END";
$indent<task id="$id" name="$name" color="#8cb6ce" meeting="false" start="$text" duration="$duration" complete="0" fixed-start="false" priority="1" expand="true">
END
          } else {
            print OUT <<"END";
$indent<task id="$id" name="$name" color="#8cb6ce" meeting="false" start="$text" duration="$duration" complete="0" fixed-start="false" priority="1" expand="true">
$indent  <notes>
$indent  $note
$indent  </notes>
END
          }
          $id++;
          &gentasks($cn, $level + 1);
          print OUT <<"END";
$indent</task>
END
        } else {
          if ($cnt > 1) { # this is hack ... think later ...
            $time -= ($duration - 1) * 60 * 60 * 24;
            $tm = localtime($time);
            $mday = $tm->mday;
            $mon = $tm->mon + 1;
            $year = $tm->year + 1900;
            $text = $mday . '/' . $mon . '/' . $year;
          }
          if (length($note) == 0) {
            print OUT <<"END";
$indent<task id="$id" name="$name" color="#8cb6ce" meeting="false" start="$text" duration="$duration" complete="0" fixed-start="false" priority="1" expand="true"/>
END
          } else {
            print OUT <<"END";
$indent<task id="$id" name="$name" color="#8cb6ce" meeting="false" start="$text" duration="$duration" complete="0" fixed-start="false" priority="1" expand="true">
$indent  <notes>
$indent  $note
$indent  </notes>
$indent</task>
END
          }
          $id++;
          $cnt++;
        }
        $prev_time = $time;
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
