# File: GenAnnotedLink_Perl.pl
# Date            Author        number of nodes
# 2002/11/16      Walking Lint  46
# 2002/10/1       Walking Lint  46
# 2002/8/1        Walking Lint  136
# 2002/7/31       Walking Lint  446 (GenHtmlsFromConfigFile_Perl->GenAnnotedLink_Perl)
# 2002/7/30       Walking Lint  437
# 2002/7/30       Walking Lint  388 (GenHtmlsForSSG_Perl->GenHtmlsFromConfigFile_Perl)
# 2002/7/29       Walking Lint  388 (GenHtmlsForSSG->GenHtmlsForSSG_Perl)
# 2002/7/26       Walking Lint  237
# 2002/7/25       Walking Lint  150
# 2002/7/24       Walking Lint  138
# 2002/7/23       Walking Lint  136
# 2002/7/22       Walking Lint  55

=pod

=head1 NAME

GenAnnotedLink_Perl.pl - generate AnnotedLink.html

=head1 DESCRIPTION

ex. perl.exe GenAnnotedLink_Perl.pl "D:\common\cv\templates\Link,pat" "D:\My Weblog" "index.html" "My Two Cents - Continued" "3ColumnWithStyleSheet.css"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
# some configurable constants
$link = shift;
$dir = shift;
$dir =~ s/[\/\\]+$//;
$home_url = shift;
$home_title = shift;
$css = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $link);
&printtree($root, '  ');
$ofn = $dir . "\\AnnotedLink.html";
&genannotedlink($root, $ofn);
print STDERR "generated $ofn\n";
sub  {
  sub genannotedlink {
    my($nd, $ofn) = @_;
    open OUT, ">$ofn";
    print OUT <<"END";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<html>
<head>
<title>Annoted Link</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="3ColumnWithStyleSheet.css" />
</head>
<body>
<div class="path"><a href="$home_url">$home_title</a> > Annoted Link</div>
<h3>Annoted Link</h3>
<p>
<ol>
END
    if (defined($nd->{CHILD})) {
      my $cnd = $nd->{CHILD};
      while (1) {
        if ($cnd->{NAME} eq '_note') {
          # do nothing ... skip comment
        } else {
          if (length($cnd->{TYPE}) != 0) {
            print OUT '<li><a href="' . $cnd->{TEXT} . '">' . $cnd->{NAME} . '</a> - ' . $cnd->{TYPE} . '</li>' . "\n";
          } else {
            print OUT '<li><a href="' . $cnd->{TEXT} . '">' . $cnd->{NAME} . '</a></li>' . "\n";
          }
        }
        last if not defined($cnd->{NEXT});
        $cnd = $cnd->{NEXT};
      }
    }
    print OUT <<"END";
</ol>
</p>
</body>
</html>
END
    close OUT;
  }
}
