# File: GenCategorizedLink2_Perl.pl
# Date            Author        number of nodes
# 2004/5/7        Walking Lint  390
# 2004/5/6        Walking Lint  390
# 2004/5/6        Walking Lint  382 (GenCategorizedLink_Perl->GenCategorizedLink2_Perl)
# 2004/5/6        Walking Lint  382
# 2004/2/2        Walking Lint  262
# 2003/9/1        Walking Lint  260
# 2003/7/26       Walking Lint  257
# 2003/7/21       Walking Lint  275
# 2003/7/16       Walking Lint  240
# 2003/6/20       Walking Lint  236
# 2003/5/5        Walking Lint  226
# 2003/5/4        Walking Lint  232
# 2003/4/26       Walking Lint  246
# 2003/4/8        Walking Lint  246
# 2003/4/4        Walking Lint  238
# 2003/3/23       Walking Lint  231
# 2002/12/14      Walking Lint  230
# 2002/12/10      Walking Lint  230
# 2002/11/25      Walking Lint  226
# 2002/11/20      Walking Lint  223
# 2002/11/19      Walking Lint  220
# 2002/11/19      Walking Lint  214 (GenCategorizedLink_Perl->GenCategorizedLink_Perl)
# 2002/10/11      Walking Lint  178
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkNew_Perl->GenCategorizedLink_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLink_Perl->GenCategorizedLinkNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

GenCategorizedLink2_Perl.pl - generate CategorizedLink.html

=head1 DESCRIPTION

ex1. _text () // GenCategorizedLink2_Perl [[CurrentFolder]] 0 1 0 1

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Jcode;
use Time::localtime;
use File::Basename;
$tm = localtime;
$dateandtime = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec);
$dir = shift;
DebugPrint("dir = " . $dir);
$english = shift;
DebugPrint("english = $english");
if ($english) {
  $misc_str = 'Misc.';
  $home_str = 'Home';
} else {
  $misc_str = '̑';
  $home_str = 'z[';
}
$utf = shift; # actually for generated page ...
DebugPrint("utf = $utf");
if ($utf) {
  Jcode::convert(\$home_str, 'utf8', 'sjis', "z"); # hack ...
}
$force_misc = shift; # use if needed ...
DebugPrint("force_misc = $force_misc");
$categorize_entry = shift; # added ...
DebugPrint("categorize_entry = $categorize_entry");
$sidetitleclass = shift; # needed for new style ... or actually new style is assumed now ... ^^;
DebugPrint("sidetitleclass = $sidetitleclass");
$sideclass = shift; # needed for new style
DebugPrint("sideclass = $sideclass");
$dateclass = shift; # needed for new style
DebugPrint("dateclass = $dateclass");
$bodyclass = shift; # needed for new style
DebugPrint("bodyclass = $bodyclass");
$pageindexid = shift; # needed for new style
DebugPrint("bodyclass = $bodyclass");
$ParentTitle = ''; # currently not used ...
$ParentURL = '';
$CSSTemplate = '2ColumnForSubPage.css';
DebugPrint("CSSTemplate = $CSSTemplate");
$copyright_file = $dir . '\copyright.html';
open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
@copyrights = <IN>;
close IN;
$copyright = join('', @copyrights);
DebugPrint("copyright = $copyright");
if (length($sidetitleclass) == 0) {
  $labeltag = 'h5';
  $labeltag2 = '/h5';
} else {
  $labeltag = 'div class="' . $sidetitleclass . '"';
  $labeltag2 = '/div';
}
DebugPrint("labeltag = $labeltag");
if (length($sideclass) == 0) {
  $listtag = '';
  $listtag2 = '';
} else {
  $listtag = '<div class="' . $sideclass . '"><ul>'; # hack ??
  $listtag2 = '</ul></div>';
}
$mask = '^http:';
DebugPrint("mask = $mask");
$Title = 'Categorized Links';
DebugPrint("Title = $Title");
opendir DIR, $dir or die "Cannot open $dir: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /^200[0-9]+.pat$/, @files;
closedir DIR;
$to_url = 'CategorizedLink.html';
$to_file = $dir . "\\" . $to_url;
open OUT, ">$to_file";
foreach $from_file (sort @files) {
  $from_file = $dir . "\\" . $from_file;
  DebugPrint("from_file = " . $from_file);
  open IN, $from_file || die("Can't open $from_file: $!\n");
  my $root = {};
  &initnode($root, 'root', '', '', '');
  &gentree($root, $from_file);
  $category = $misc_str;
  $foundtitle = 0;
  $foundurl = 0;
  &extractdata($root);
  close IN;
}
print OUT <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$Title</title>
END
if ($utf) {
  print OUT <<END;
<meta http-equiv="content-type" content="text/html;charset=utf-8" />
END
} else {
  print OUT <<END;
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
END
}
# customize here ...
print OUT <<END;
<meta http-equiv="content-style-type" content="text/css"></meta>
<link rel="stylesheet" type="text/css" href="2ColumnALAKitaguni.css" media="screen"></link>
</head>
<body>
END
# think later
print <<END;
<$labeltag>$Title:<$labeltag2>
END
print <<END;
$listtag
END
$sidelink = '<' . $labeltag . '>' . 'Categories' . ':<' . $labeltag2 . '>' . "\n" . $listtag . "\n";
# customize here ...
if (length($pageindexid) == 0) {
  print OUT <<END;
<div id="wrapper">
<div id="content">
<h1>$Title</h1>
<div class="body">
<div>
END
} else {
  print OUT <<END;
<div id="wrapper">
<div id="content">
<div id="pageindex">
<a href="$ParentURL">$home_str</a>
</div>
<div class="blog">
END
}
@sortedtitles = sort {lc($a) cmp lc($b)} @titles; # actually title with category and ...
$i = 1;
$prevcategory = '';
$first = 1;
$count = 1;
foreach $title (@sortedtitles) {
  ($category, $truetitle, $dummy, $dummy) = split(/_SEP_/, $title, 4); # this is hack ...
  DebugPrint("category = $category");
  if ($category eq $misc_str) {
  } else {
    unless ($category eq $prevcategory) {
      if ($first) {
        $first = 0;
      } else {
        if (length($bodyclass) == 0) {
          $line = '</ol>' . "\n";
        } else {
          $line = '</ol></div>' . "\n";
        }
        print OUT $line;
      }
      if (length($dateclass) == 0) {
        $line = '<a name="' . $count . '"></a><h3>' . $category . '</h3>' . "\n";
      } else {
        $line = '<a name="' . $count . '"></a><div class="' . $dateclass . '">' . $category . '</div>' . "\n";
      }
      if ($utf) {
        Jcode::convert(\$line, 'utf8', 'sjis', "z");
      }
      print OUT $line;
      if (length($bodyclass) == 0) {
        $line = '<ol>' . "\n";
      } else {
        $line = '<div class="' . $bodyclass . '">' . "\n" . '<ol>' . "\n";
      }
      print OUT $line;
      $line = '<div><a href="' . $to_url . '#' . $count . '">' . $category . '</a></div>' . "\n";
      print $line;
      $sidelink .= $line . "\n";
      $count++;
    }
    unless (($urls{$title} eq '')) { # or $urlcount{$url{$title}}++ %% think later ...
      ($year, $month, $day) = split('/', $dates{$title});
      if (length($day) != 0) {
        $month =~ s/^[0]*//;
        $month = sprintf("%02d", $month);
        if (length($times{$title}) == 0) {
          $ref = $year . $month . '.html' . '#' . $day;
        } else {
          $ref = $year . $month . '.html' . '#' . $times{$title};
        }
        $date_str = ' <a href="' . $ref . '">(' . $dates{$title} . ')</a>';
      } else {
        $date_str = ' (' . $dates{$title} . ')';
      }
      if ($categorize_entry) {
        $line = '<li><a href="' . $year . $month . '.html' . '#' . $urls{$title} . '">' . $truetitle . '</a>' . $date_str . '</li>' . "\n";
      } else {
        $line = '<li><a href="' . $urls{$title} . '">' . $truetitle . '</a>' . $date_str . '</li>' . "\n";
      }
      if ($utf) {
        Jcode::convert(\$line, 'utf8', 'sjis', "z");
      }
      print OUT $line;
    }
    $prevcategory = $category;
  }
}
$first = 1;
foreach $title (@sortedtitles) {
  ($category, $truetitle, $dummy, $dummy) = split(/_SEP_/, $title, 4);
  if ($category eq $misc_str) {
    if ($first) {
      $first = 0;
      if (length($bodyclass) == 0) {
        $line = '</ol>' . "\n";
      } else {
        $line = '</ol></div>' . "\n";
      }
      print OUT $line;
      if (length($dateclass) == 0) {
        $line = '<a name="' . $count . '"></a><h3>' . $category . '</h3>' . "\n";
      } else {
        $line = '<a name="' . $count . '"></a><div class="' . $dateclass . '">' . $category . '</div>' . "\n";
      }
      if ($utf) {
        Jcode::convert(\$line, 'utf8', 'sjis', "z");
      }
      print OUT $line;
      if (length($bodyclass) == 0) {
        $line = '<ol>' . "\n";
      } else {
        $line = '<div class="' . $bodyclass . '">' . "\n" . '<ol>' . "\n";
      }
      print OUT $line;
      $line = '<div><a href="' . $to_url . '#' . $count . '">' . $category . '</a></div>' . "\n";
      print $line;
      $sidelink .= $line . "\n";
    }
    unless (($urls{$title} eq '')) { # or $urlcount{$url{$title}}++ %% think later ...
      ($year, $month, $day) = split('/', $dates{$title});
      if (length($day) != 0) {
        $month =~ s/^[0]*//;
        $month = sprintf("%02d", $month);
        if (length($times{$title}) == 0) {
          $ref = $year . $month . '.html' . '#' . $day;
        } else {
          $ref = $year . $month . '.html' . '#' . $times{$title};
        }
        $date_str = ' <a href="' . $ref . '">(' . $dates{$title} . ')</a>';
      } else {
        $date_str = ' (' . $dates{$title} . ')';
      }
      if ($categorize_entry) {
        $line = '<li><a href="' . $year . $month . '.html' . '#' . $urls{$title} . '">' . $truetitle . '</a>' . $date_str . '</li>' . "\n";
      } else {
        $line = '<li><a href="' . $urls{$title} . '">' . $truetitle . '</a>' . $date_str . '</li>' . "\n";
      }
      if ($utf) {
        Jcode::convert(\$line, 'utf8', 'sjis', "z");
      }
      print OUT $line;
    }
    $prevcategory = $category;
  }
}
print <<END;
$listtag2
END
if (length($copyright)) { # else needed ? think later ...
  if ($first) {
    $first = 0;
  } else {
    if (length($bodyclass) == 0) {
      $line = '</ol>' . "\n";
    } else {
      $line = '</ol></div>' . "\n";
    }
    print OUT $line;
  }
  # customize here
  print OUT <<END;
<div class="copyright">&copy; Copyright 2004 Walking Lint<br>
Generated by CV</div>
</div>
</div>
</div>
</div>
<div id="menu">
<div id="index">
END
  # generate link to caetgory ...
  if ($utf) {
    Jcode::convert(\$sidelink, 'utf8', 'sjis', "z");
  }
  print OUT $sidelink;
  print OUT <<END;
</div>
</div>
</div>
</body>
</html>
END
}
# think later ...
close OUT;
DebugPrint("generated $to_file");
sub extractdata {
  my($nd) = @_;
  if (($nd->{NAME} =~ /^_/) and not ($nd->{NAME} =~ /^_part/)) {
    if ($nd->{NAME} eq '_copy') {
      $foundurl = 1;
      $ParentURL = $nd->{TYPE};
      DebugPrint("ParentURL = " . $ParentURL);
    }
    return;
  }
  if ($nd->{NAME} =~ /^(200[0-9\/]+)/ and defined($nd->{CHILD})) {
    $date = $1;
    my $tn = $nd->{CHILD};
    $category = '';
    while (1) {
      if ((not $tn->{NAME} =~ /^_/)) { # and ((length($tn->{TYPE}) != 0) or $force_misc) %% try now ...
        if ((length($tn->{TYPE}) != 0) and not ($tn->{NAME} =~ /(֌W|)$/)) {
          $category = $tn->{TYPE};
          DebugPrint("category1 = $category");
        } else {
          if ($force_misc) {
            $category = $misc_str;
            DebugPrint("category2 = $category");
          } else {
            $category = $tn->{NAME}; # do not comes here ... think later ...
            DebugPrint("category3 = $category");
          }
        }
        $category =~ s/֌W$//; # this is also hack ...
        $category =~ s/$//; # this is also hack ...
        $category =~ s/[ ]+$//;
        $line = $tn->{TEXT};
        if (defined($tn->{CHILD})) {
          my $tcn = $tn->{CHILD};
          while (1) {
            if (($tcn->{NAME} eq '_text') or not ($tcn->{NAME} =~ /^_/)) {
              $line .= $tcn->{TEXT};
            }
            if (not defined($tcn->{NEXT})) {
              last;
            }
            $tcn = $tcn->{NEXT};
          }
        }
        @lines = split('CRLF', $line); # this is hack ...
        if ($line =~ /\(([0-9]+):([0-9]+):([0-9]+)\)$/) {
          $timelabel = $1 . $2 . $3;
          ($y, $m, $d) = split(/\//, $date);
          if (length($d) == 1) {
            $timelabel = 't0' . $d . $timelabel;
          } else {
            $timelabel = 't' . $d . $timelabel;
          }
        } else {
          $timelabel = '';
        }
        if ($categorize_entry) {
          $tmptitle = $tn->{NAME};
          $tmpurl = $timelabel;
          unless ($categorycount2{$category}++) {
            push @categories, $category;
          }
          $titlewithcategory = $category . '_SEP_' . $tmptitle . '_SEP_' . $date . '_SEP_' . $timelabel; # try this ...
          push @titles, $titlewithcategory;
          $url{$titlewithcategory} = $tmpurl;
          $urls{$titlewithcategory} = $tmpurl;
          $dates{$titlewithcategory} = $date;
          $times{$titlewithcategory} = $timelabel;
        } else {
          foreach $line (@lines) {
            if ($line =~ /\[\[(.+?)\]\]/) { # /\[\[((?:[^\[\]]|\[[^\]]*\])+)\]\]/
              $titleandurl = $1;
              if (($titleandurl =~ /!/) and ($titleandurl =~ /^(.+)!([^!]+)$/)) {
                $tmptitle = $1;
                $tmpurl = $2;
                if (($tmpurl =~ /$mask/) and not $doublecheck{$tmptitle . '_' . $timelabel}++) {
                  unless ($categorycount2{$category}++) {
                    push @categories, $category;
                  }
                  $titlewithcategory = $category . '_SEP_' . $tmptitle . '_SEP_' . $date . '_SEP_' . $timelabel; # try this ...
                  push @titles, $titlewithcategory;
                  $url{$titlewithcategory} = $tmpurl;
                  $urls{$titlewithcategory} = $tmpurl;
                  $dates{$titlewithcategory} = $date;
                  $times{$titlewithcategory} = $timelabel;
                }
              }
            }
          }
        }
      }
      if (not defined($tn->{NEXT})) {
        last;
      }
      $tn = $tn->{NEXT};
    }
  } elsif (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &extractdata($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  } elsif ($nd->{NAME} eq 'title') {
    $foundtitle = 1;
    $ParentTitle = $nd->{TEXT};
    if ($utf) {
      Jcode::convert(\$ParentTitle, 'utf8', 'sjis', "z");
    }
    DebugPrint("ParentTitle = " . $ParentTitle);
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
