# File: GenCategorizedLinkForDevTech_Perl.pl
# Date            Author        number of nodes
# 2002/12/17      Walking Lint  227
# 2002/11/25      Walking Lint  227
# 2002/11/20      Walking Lint  227
# 2002/11/20      Walking Lint  219 (GenCategorizedLink_Perl->GenCategorizedLinkForDevTech_Perl)
# 2002/11/19      Walking Lint  220
# 2002/11/19      Walking Lint  214 (GenCategorizedLink_Perl->GenCategorizedLink_Perl)
# 2002/10/11      Walking Lint  178
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkNew_Perl->GenCategorizedLink_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLink_Perl->GenCategorizedLinkNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

GenCategorizedLinkForDevTech_Perl.pl - generate CategorizedLinkForDevTech.html

=head1 DESCRIPTION

ex. _text () // GenCategorizedLinkForDevTech_Perl

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Time::localtime;
$tm = localtime;
$dateandtime = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec);
$dir = 'F:';
DebugPrint("dir = $dir");
$ParentTitle = 'foeNMҌ';
DebugPrint("ParentTitle = $ParentTitle");
$ParentURL = 'top.htm';
DebugPrint("ParentURL = $ParentURL");
$CSSTemplate = '3ColumnWithTableForSubPage.css';
DebugPrint("CSSTemplate = $CSSTemplate");
$copyright_file = $dir . '\copyright.html';
open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
@copyrights = <IN>;
close IN;
$copyright = join('', @copyrights);
DebugPrint("copyright = $copyright");
$labeltag = 'h2';
DebugPrint("labeltag = $labeltag");
opendir DIR, $dir or die "Cannot open $dir: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /^200[0-9]+.pat$/, @files;
closedir DIR;
$to_url = 'CategorizedLink.html';
$to_file = $dir . "\\" . $to_url;
open OUT, ">$to_file";
foreach $from_file (@files) {
  $from_file = $dir . "\\" . $from_file;
  DebugPrint("from_file = $from_file");
  open IN, $from_file || die("Can't open $from_file: $!\n");
  my $root = {};
  &initnode($root, 'root', '', '', '');
  &gentree($root, $from_file);
  $category = '̑';
  &extractdata($root);
  close IN;
}
$Title = 'Categorized Links';
print OUT <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$Title</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$CSSTemplate" />
</head>
<body>
<table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table>
<h3>$Title</h3>
END
print <<END;
<$labeltag><a href="$to_url">$Title:</a></$labeltag>
END
@sortedtitles = sort {lc($a) cmp lc($b)} @titles;
$i = 1;
$prevcategory = '';
$first = 1;
$count = 1;
foreach $title (@sortedtitles) {
  ($category, @truetitles) = split(/_/, $title);
  $truetitle = join('_', @truetitles);
  if ($category eq '̑') {
  } else {
    unless ($category eq $prevcategory) {
      if ($first) {
        $first = 0;
      } else {
        print OUT <<END;
</ol>
END
      }
      print OUT <<END;
<a name="$count"></a><h4>$category</h4>
<ol>
END
      print <<END;
<div><a href="$to_url#$count">$category</a></div>
END
      $count++;
    }
    unless ($urlcount{$url{$title}}++ or ($urls{$title} eq '') or not ($urls{$title} =~ /http:/)) {
      ($year, $month, $day) = split('/', $dates{$title});
      if (length($day) != 0) {
        $month =~ s/^[0]*//;
        $month = sprintf("%02d", $month);
        $ref = $year . $month . '.html' . '#' . $day;
        $date_str = ' <a href="' . $ref . '">(' . $dates{$title} . ')</a>';
      } else {
        $date_str = ' (' . $dates{$title} . ')';
      }
      print OUT <<END;
<li><a href="$urls{$title}">$truetitle</a>$date_str</li>
END
    }
    $prevcategory = $category;
  }
}
foreach $title (@sortedtitles) {
  ($category, $truetitle) = split(/_/, $title);
  if ($category eq '̑') {
    unless ($category eq $prevcategory) {
      if ($first) {
        $first = 0;
      } else {
        print OUT <<END;
</ol>
END
      }
      print OUT <<END;
<a name="$count"></a><h4>$category</h4>
<ol>
END
      print <<END;
<div><a href="$to_url#$count">$category</a></div>
END
      $count++;
    }
    unless ($urlcount{$url{$title}}++ or ($urls{$title} eq '') or not ($urls{$title} =~ /http:/)) {
      ($year, $month, $day) = split('/', $dates{$title});
      if (length($day) != 0) {
        $month =~ s/^[0]*//;
        $month = sprintf("%02d", $month);
        $ref = $year . $month . '.html' . '#' . $day;
        $date_str = ' <a href="' . $ref . '">(' . $dates{$title} . ')</a>';
      } else {
        $date_str = ' (' . $dates{$title} . ')';
      }
      print OUT <<END;
<li><a href="$urls{$title}">$truetitle</a>$date_str</li>
END
    }
    $prevcategory = $category;
  }
}
if (length($copyright)) {
  if ($first) {
    $first = 0;
  } else {
    print OUT <<END;
</ol>
END
  }
  print OUT <<END;
$copyright
</body>
</html>
END
}
print OUT;
print <<END;
<small><div class="lastupdate">($dateandtime)</div></small>
END
close OUT;
DebugPrint("generated $to_file");
sub extractdata {
  my($nd) = @_;
  if ($nd->{NAME} =~ /^_/) {
    return;
  }
  if ($nd->{NAME} =~ /^(200[0-9\/]+)/ and defined($nd->{CHILD})) {
    $date = $1;
    my $tn = $nd->{CHILD};
    while (1) {
      $tmp_category = $tn->{NAME};
      if ($tmp_category eq '_֌W') { # this is hack ... think later ...
      } else { # if () // (($tmp_category =~ /֌W/) or ($tmp_category =~ //) or ($tmp_category =~ /̑/))
        if ((($tmp_category =~ /֌W$/) or ($tmp_category =~ /$/) or ($tmp_category =~ /̑/))) {
          $category = $tmp_category;
        } else {
          $category = '̑';
        }
        $category =~ s/֌W$//; # this is also hack ...
        $category =~ s/$//; # this is also hack ...
        $category =~ s/[ ]+$//;
        $line = $tn->{TEXT};
        if (defined($tn->{CHILD})) {
          my $tcn = $tn->{CHILD};
          while (1) {
            if (($tcn->{NAME} eq '_text') or not ($tcn->{NAME} =~ /^_/)) {
              $line .= $tcn->{TEXT};
            }
            if (not defined($tcn->{NEXT})) {
              last;
            }
            $tcn = $tcn->{NEXT};
          }
        }
        @lines = split('CRLF', $line); # this is hack ...
        foreach $line (@lines) {
          if ($line =~ /\[\[([^\]]+)!([^\]!]+)\]\]/) {
            unless ($categorycount2{$category}++) {
              push @categories, $category;
            }
            $titlewithcategory = $category . '_' . $1;
            push @titles, $titlewithcategory;
            $url{$titlewithcategory} = $2;
            $urls{$titlewithcategory} = $2;
            $dates{$titlewithcategory} = $date;
          }
        }
      }
      if (not defined($tn->{NEXT})) {
        last;
      }
      $tn = $tn->{NEXT};
    }
  } elsif (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &extractdata($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
