# File: GenCategorizedText_Perl.pl
# Date            Author        number of nodes
# 2002/7/16       Walking Lint  143
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

D:\tmp\cv\templates\GenCategorizedText_Perl.pat - generate categorized text

=head1 DESCRIPTION

JeS[ .pat t@C𐶐

=head1 AUTHOR

Walking Lint

=cut

use Time::localtime;
use File::Basename;
$dir = shift;
print STDERR "dir = $dir\n";
$ParentTitle = shift;
print STDERR "ParentTitle = $ParentTitle\n";
$ParentURL = shift;
print STDERR "ParentURL = $ParentURL\n";
$CSSTemplate = shift;
print STDERR "CSSTemplate = $CSSTemplate\n";
opendir DIR, $dir or die "opendir($dir) failed: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /^200[0-9]+.pat$/, @files;
closedir DIR;
foreach $from_file (@files) {
  $from_file = $dir . "\\" . $from_file;
  print STDERR $from_file . "\n";
  open IN, $from_file || die("Can't open $from_file: $!\n");
  $header = 1;
  while (<IN>) {
    if ($_ =~ /\t(200[0-9\/]+)/) {
      print STDERR $_;
      $date = $1;
      next;
    } elsif ((/̑/ or /֌W/ or /{IɏdvȂ/) and ($_ =~ /\t\t\t\t\t([^\t\(2]+)/) and not ($1 eq '') and not ($_ =~ /_text/) and not ($_ =~ /\t(a|div|p) /)) { # this is hack ...
      $header = 0;
      $category = $1;
      $savedcategory = $1;
      $category =~ s/[ ]*֌W//; # this is also hack ...
      $category =~ s/[ ]+$//;
      ($year, $month, $day) = split('/', $date);
      $day =~ s/^[0]*//;
      $day = sprintf("%02d", $day);
      $month =~ s/^[0]*//;
      $month = sprintf("%02d", $month);
      $titlewithcategory = $category . '_' . $year . '/' . $month . '/' . $day; # this is hack ... acutally category with date ...
      push @titles, $titlewithcategory;
      $ref = $year . $month . '.html' . '#' . $day;
      $date_str = '<a name ="' . $year . $month . $day . '"><a href="' . $ref . '">' . $date . '</a></a>';
      $_ =~ s/^([^%]*)\%\%(.*)/\t\t\t\t\t$date_str \(\) \/\/  \%\%$2/;
    } elsif ($_ =~ /\t[lL]inks: ()/) { # this may be hack ...
      last;
    } elsif (/copyright.pat/ or /copywight.pat/) {
      $header = 1;
    }
    unless ($header) {
      $_ =~ s/^/\t/;
      $text{$titlewithcategory} .= $_;
    }
  }
  close IN;
}
$gen_info = "Date            Author        number of nodes CR" . "LF ";
$tm = localtime;
$date_str = sprintf("%04d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$space_str = ' ' x (16 - length($date_str));
$author_str = "GenCategorizedText_Perl.pl";
$gen_info = $gen_info . $date_str . $space_str . $author_str;
@sortedtitles = sort {$b cmp $a} @titles;
$i = 1;
$first = 1;
$index = '';
foreach $title (@sortedtitles) {
  print STDERR $title . "\n";
  ($category, $truetitle) = split(/_/, $title);
  unless ($categorycount{$category}++) {
    unless ($first) {
      print OUT <<EOD;
			_part () // copyright.pat
	div () // id="menu"
		div () // id="index"
			div () // class="ul"$index
EOD
      close OUT; # hack ...
      $index = '';
    }
    ($year, $month, $day) = split('/', $truetitle);
    $daystr = $day;
    $daystr =~ s/^[0]*//;
    $monthstr = $month;
    $monthstr =~ s/^[0]*//;
    $index .= "\n\t\t\t\tli () \/\/ \%\% " . '<a href="#' . $year . $month . $day . '">' . $year . '/' . $monthstr . '/' . $daystr . '</a>';
    $first = 0;
    $to_file = "$dir\\$category.pat";
    open OUT, ">$to_file";
    print STDERR "Generated/Updated $to_file\n";
    print OUT "root () //  \%\% File: $category.txt CR" . "LF " . $gen_info . " CR" . "LF  CR" . "LF $category\n";
    print OUT <<EOD;
	_part () // $CSSTemplate
	div () // id="wrapper"
		div () // id="content"
			_path () //  %% <a href="$ParentURL">$ParentTitle</a>
			$category ()
				  ()
					  ()
EOD
  } else {
    ($year, $month, $day) = split('/', $truetitle);
    $daystr = $day;
    $daystr =~ s/^[0]*//;
    $monthstr = $month;
    $monthstr =~ s/^[0]*//;
    $index .= "\n\t\t\t\tli () \/\/ \%\% " . '<a href="#' . $year . $month . $day . '">' . $year . '/' . $monthstr . '/' . $daystr . '</a>';
  }
  print OUT $text{$title};
}
print OUT <<EOD;
			_part () // copyright.pat
	div () // id="menu"
		div () // id="index"
			div () // class="ul"$index
EOD
close OUT; # hack ...
