# File: GenGraph_Perl.pl
# Date            Author        number of nodes
# 2002/11/16      Walking Lint  54
# 2002/9/18       Walking Lint  144
# 2002/8/1        Walking Lint  136
# 2002/7/31       Walking Lint  446 (GenHtmlsFromConfigFile_Perl->GenGraph_Perl)
# 2002/7/30       Walking Lint  437
# 2002/7/30       Walking Lint  388 (GenHtmlsForSSG_Perl->GenHtmlsFromConfigFile_Perl)
# 2002/7/29       Walking Lint  388 (GenHtmlsForSSG->GenHtmlsForSSG_Perl)
# 2002/7/26       Walking Lint  237
# 2002/7/25       Walking Lint  150
# 2002/7/24       Walking Lint  138
# 2002/7/23       Walking Lint  136
# 2002/7/22       Walking Lint  55

=pod

=head1 NAME

GenGraph_Perl.pl - generate graph from outline

=head1 DESCRIPTION

ex. perl.exe GenGraph_Perl.pl "F:\SSG_e\config.pat"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree;
# some configurable constants
$outline = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $outline);
$ofn = $outline;
$ofn2 = $outline;
$ofn =~ s/\.pat/.dot/;
$ofn2 =~ s/\.pat/.svg/;
&gengraph($root, $ofn);
print STDERR "generated $ofn\n";
system "dot -Tsvg $ofn -o $ofn2";
sub  {
  sub gengraph {
    my($nd, $ofn) = @_;
    open OUT, ">$ofn";
    print OUT <<"END";
digraph prof {
	size="6,4"; ratio = fill;
	node [style=filled];
END
    if (defined($nd->{CHILD})) {
      my $cnd = $nd->{CHILD};
      gengraphbody($nd->{NAME}, $cnd, $ofn);
    }
    print OUT <<"END";
}
END
    close OUT;
  }
  sub gengraphbody {
    my($parentname, $nd) = @_;
    $parentname =~ s/"//g;
    while (1) {
      if ($nd->{NAME} =~ /^\t*_/) {
        # do nothing ... skip comment
      } else {
        $name = $nd->{NAME};
        $name =~ s/"//g;
        if ($parentname ne 'root') {
          print OUT <<"EOF";
"$parentname" -> "$name" [color="0.650 0.700 0.700"];
EOF
        }
        if (defined($nd->{CHILD})) {
          gengraphbody($name, $nd->{CHILD});
        }
      }
      last if not defined($nd->{NEXT});
      $nd = $nd->{NEXT};
    }
  }
}
