# File: GenHtmlsFromConfigFile_Perl.pl
# Date            Author        number of nodes
# 2005/7/27       Walking Lint  811
# 2004/4/26       Walking Lint  777
# 2004/2/17       Walking Lint  777
# 2004/2/16       Walking Lint  772
# 2004/2/6        Walking Lint  734
# 2004/2/5        Walking Lint  734
# 2004/1/13       Walking Lint  693
# 2003/7/21       Walking Lint  693
# 2003/5/14       Walking Lint  656
# 2003/3/26       Walking Lint  649
# 2003/3/25       Walking Lint  643
# 2003/3/23       Walking Lint  731
# 2003/3/18       Walking Lint  729
# 2003/2/28       Walking Lint  726
# 2003/2/27       Walking Lint  719
# 2003/2/13       Walking Lint  698
# 2003/2/6        Walking Lint  698
# 2003/1/22       Walking Lint  696
# 2003/1/10       Walking Lint  687
# 2003/1/6        Walking Lint  683
# 2002/12/15      Walking Lint  658
# 2002/11/25      Walking Lint  636
# 2002/11/16      Walking Lint  612
# 2002/10/11      Walking Lint  612
# 2002/10/10      Walking Lint  612
# 2002/10/9       Walking Lint  611
# 2002/10/8       Walking Lint  611
# 2002/10/1       Walking Lint  609
# 2002/9/29       Walking Lint  718
# 2002/9/28       Walking Lint  687
# 2002/9/27       Walking Lint  682
# 2002/9/9        Walking Lint  657
# 2002/9/4        Walking Lint  654
# 2002/9/2        Walking Lint  684
# 2002/9/1        Walking Lint  680
# 2002/8/31       Walking Lint  652
# 2002/8/30       Walking Lint  652
# 2002/8/28       Walking Lint  648
# 2002/8/27       Walking Lint  646
# 2002/8/27       Walking Lint  436 (GenHtmlsFromConfigFileForEnglish_Perl->GenHtmlsFromConfigFile_Perl)
# 2002/8/19       Walking Lint  425
# 2002/8/19       Walking Lint  414 (GenHtmlsFromConfigFile_Perl->GenHtmlsFromConfigFileForEnglish_Perl)
# 2002/8/1        Walking Lint  450
# 2002/7/31       Walking Lint  446
# 2002/7/30       Walking Lint  437
# 2002/7/30       Walking Lint  388 (GenHtmlsForSSG_Perl->GenHtmlsFromConfigFile_Perl)
# 2002/7/29       Walking Lint  388 (GenHtmlsForSSG->GenHtmlsForSSG_Perl)
# 2002/7/26       Walking Lint  237
# 2002/7/25       Walking Lint  150
# 2002/7/24       Walking Lint  138
# 2002/7/23       Walking Lint  136
# 2002/7/22       Walking Lint  55

=pod

=head1 NAME

GenHtmlsFromConfigFile_Perl.pl - generate html files from configuration file

=head1 DESCRIPTION

ex. _presave ()
    _charset () // utf-8
    _postscript () // GenHtmlsFromConfigFile_Perl "C:\memo\CV\templates\GenHtmlsFromConfigFile_Perl.pat" "" "Next" "Back" "&copy; Copyright [[Year]] Walking Lint" 1 1

# - selection of quiz

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Jcode;
use File::Basename;
use File::Copy;
# some configurable constants
$crlf = ' CR' . 'LF ';
$config_file = shift;
$config_file =~ s/\\/\//g;
DebugPrint("config_file = $config_file");
$dir = &mydirname($config_file);
$prev_path = shift;
$nextlabel = shift;
$backlabel = shift; # used only for quiz ...
$Copyright = shift;
$copyright_file = $dir . '\copyright.html';
$weblogfolder = $ENV{WEBLOGFOLDER};
$weblogfolder =~ s/"//g;
$weblog_copyright_file = $weblogfolder . '\copyright.html';
if (length($Copyright) == 0) {
  if (-e $copyright_file) {
    open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
    @copyrights = <IN>;
    close IN;
    $Copyright = join('', @copyrights);
  } elsif (-e $weblog_copyright_file) {
    open IN, $weblog_copyright_file || die("Cannot open $weblog_copyright_file: $!\n");
    @copyrights = <IN>;
    close IN;
    $Copyright = join('', @copyrights);
  } else {
    $Copyright = ' '; # hack ???
  }
} else {
  $Copyright = '<div class="copyright">' . $Copyright . '</div>';
}
DebugPrint("Copyright = $Copyright");
$usetable = shift;
$utf = shift;
if ($utf) {
  $charset = 'utf-8';
} else {
  $charset = 'Shift_JIS';
}
$perl = $ENV{PERL};
$perl =~ s/"//g;
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
$FileSeparator = "/"; # actually / is assumed now ...
$PrefixForContentFile = 'C'; # contents files are marked with this prefix
@htmlelements = ('a', 'center', 'div', 'li', 'ol', 'p', 'table', 'ul');
$config_file =~ s/\\/\//g;
$style_file =~ s/\\/\//g;
my $root = {};
%tofns = ();
&initnode($root, 'root', '', '', '');
my $style_file = '';
&gentree($root, $config_file);
&treatvoidlevel($root);
&treatlinked($root);
&treathtmlelements($root);
$first_void_file = 1;
$copied_file = '';
&treatdefaultfilename($root);
&checkduplicatedfilename($root);
&genhtmlfromtree($root);
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
%linkname = ();
sub checkduplicatedfilename {
  my($nd) = @_;
  my $fn2;
  if ($nd->{KIND} =~ /\//) {
    if (length($nd->{TYPE}) != 0) {
      $fn2 = $nd->{TYPE};
    } else {
      $fn2 = $nd->{NAME};
      $fn2 =~ s/\// /g;
      $fn2 =~ s/^[ ]+//;
      $fn2 =~ s/[ ]+$//;
    }
    if (length($PrefixForGeneratedFile) != 0) {
      $tmpPrefixForGeneratedFile = '^' . $PrefixForGeneratedFile;
      $fn2 =~ s/$tmpPrefixForGeneratedFile//;
    }
    $linkname{$fn2}++;
    if ($linkname{$fn2} > 1) {
      DebugPrint("found duplicated name $fn2");
      exit;
    }
  }
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      my $ncn = $cn->{NEXT};
      &checkduplicatedfilename($cn);
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub deletenonlinkedchild {
  my($nd) = @_;
  my $cn = $nd->{CHILD};
  while (1) {
    my $ncn = $cn->{NEXT};
    if ($cn->{KIND} =~ /\//) {
      &deletenonlinkedchild($cn);
    } elsif (not ($cn->{NAME} eq 'script')) {
      &delnode($cn);
    }
    last if not defined($ncn);
    $cn = $ncn;
  }
}
sub genhtmlfromnode {
  my($nd) = @_;
  Trace("enter genhtmlfromnode($nd->{NAME})");
  if (($nd->{NAME} eq '<p>') or ($nd->{NAME} eq 'script') or ($nd->{NAME} =~ /^_/)) { # this is hack ...
    return;
  }
  my $fn = $nd->{FILE};
  DebugPrint("fn = $fn");
  if (length($fn) == 0) { # this is also hack ...
    return;
  }
  my $filter = $nd->{TYPE};
  my $basename = basename($fn);
  my $dirname = &mydirname($fn);
  my $cfn = $dirname . '/' . $PrefixForContentFile . $basename;
  my $ofn = $dirname . '/' . $PrefixForGeneratedFile . $basename;
  if ($nd->{KIND} =~ /\?/) { # use original %% actually not used now ...
    # do nothing ...
  } else {
    $tofn = $ofn;
    $tofn =~ s/\//\\/g;
    if ($tofns{$tofn} == 1) {
      DebugPrint("same out file $tofn is found");
      exit;
    }
    $tofns{$tofn} = $tofn;
    open OUT, ">$tofn" . "_tmp"; # this is needed for PrefixForGeneratedFile == '' case
    my $title = $nd->{NAME};
    $truetitle = $title;
    $truetitle =~ s/<[^>]+>//g;
    DebugPrint("truetitle = $truetitle");
    my $outline = '';
    my $rel_stylefile = '';
    # set parameters for template(part 1)
      unless ($nd->{NAME} =~ /^<img /) {
        $path = &genpath($nd, $prev_path);
      }
$rel_stylefile = &genrelpath($ofn, $stylefile);
$outline_cur = ''; # this is set in genindex ... hack ???
      if (not $nd->{KIND} =~ /\^/) {
        $index = &genindex($nd);
        if ($usetable) {
          $outline = <<"END";
<td valign="top" class="index">
<div class="index">
$index
</td>
END
        } else {
          $outline = <<"END";
<div class="index">
$index
</div>
END
        }
      }
$refofnextlabel = '';
      if ($nd->{KIND} =~ /\#/) {
        my $pfn = &getparentfn($nd);
        if (length($pfn) != 0) {
          $rel_pfn = &genrelpath($fn, $pfn);
          $refofparentlabel = '<div class="nextlabel"><a href="' . $rel_pfn . '">' . $backlabel . '</a></div>';
        }
      } elsif (length($nextlabel) != 0) {
        my $nfn = &getnextfn($nd);
        $rel_nfn = &genrelpath($fn, $nfn);
        DebugPrint("nfn = $nfn");
        if (length($nfn) != 0) {
          $refofnextlabel = '<div class="nextlabel"><a href="' . $rel_nfn . '">' . $nextlabel . '</a></div>';
          DebugPrint("refofnextlabel = $refofnextlabel");
        }
      }
    # this is template(part 1) for this script, customize here if needed ...
    if ($utf) {
      Jcode::convert(\$path, 'utf8', 'sjis', "z");
      Jcode::convert(\$truetitle, 'utf8', 'sjis', "z");
    }
    if ($usetable) {
      print OUT <<"END";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html;charset=$charset" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$rel_stylefile" />
<title>$truetitle</title>
END
      if (defined($nd->{CHILD}) and ($nd->{CHILD}->{NAME} eq 'script') and defined($nd->{CHILD}->{CHILD}) and ($nd->{CHILD}->{CHILD}->{NAME} eq '_text')) {
        $script = $nd->{CHILD}->{CHILD}->{TEXT};
        $param = $nd->{CHILD}->{CHILD}->{TYPE};
        if (length($param) != 0) { # this is hack
          $script =~ s/\|/$param/;
        }
        $script =~ s/$crlf/\n/g;
        print OUT <<"END";
<script>
<!--
$script
//-->
</script>
END
      }
      print OUT <<"END";
</head>
<body bgcolor="#FFFFFF" topmargin="0" marginwidth="0" marginheight="0" leftmargin="0">
<table cellspacing="0" cellpadding="0">
<tr>
<td valign="top" class="body">
$path
END
    } else {
      if ($utf) {
        Jcode::convert(\$header, 'utf8', 'sjis', "z");
      }
      print OUT <<"END";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html;charset=$charset" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$rel_stylefile" />
<title>$truetitle</title>
END
      if (defined($nd->{CHILD}) and ($nd->{CHILD}->{NAME} eq 'script') and defined($nd->{CHILD}->{CHILD}) and ($nd->{CHILD}->{CHILD}->{NAME} eq '_text')) {
        $script = $nd->{CHILD}->{CHILD}->{TEXT};
        $param = $nd->{CHILD}->{CHILD}->{TYPE};
        if (length($param) != 0) { # this is hack
          $script =~ s/\|/$param/;
        }
        $script =~ s/$crlf/\n/g;
        print OUT <<"END";
<script>
<!--
$script
//-->
</script>
END
      }
      print OUT <<"END";
</head>
<body>
<div id="wrapper">
<div id="content">
$path
$header
END
    }
    if ($nd->{KIND} =~ /\#/) {
      print OUT <<"END";
$refofparentlabel 
<div class="body">
END
    } elsif (length($refofnextlabel) != 0) {
      print OUT <<"END";
$refofnextlabel
<div class="body">
END
    } else { # try this ...
      print OUT <<"END";
<br/>
<div class="body">
END
    }
    # actually output body part ...
    if (length($fn) != 0) {
      DebugPrint("from $fn");
      open IN, $fn || die("Can't open $fn $nd->{NAME}: $!\n");
      @lines = <IN>;
      close IN;
      my $inbody = 0;
      foreach $line (@lines) {
        if ($inbody) {
          if ($line =~ /<\/body>/i) {
            last;
          } else {
            print OUT $line;
          }
        } elsif ($line =~ /<div class="path"/i) { # $line =~ $line =~ /<body/i
          $inbody = 1;
        } elsif ($line =~ /^<h1>/) { # this is needed ...
          $inbody = 1;
          print OUT $line;
        }
      }
    }
    # this is actually template(part 3) for this script, customize here if needed ...
    if ($nd->{KIND} =~ /\#/) {
      print OUT <<"END";
$refofparentlabel 
<div class="body">
END
    } elsif (length($refofnextlabel) != 0) {
      print OUT <<"END";
$refofnextlabel
END
    }
    if ($nd->{KIND} =~ /\&/) { # use blank or exclude copyright - actually not used now ...
      if ($utf) {
        Jcode::convert(\$outline, 'utf8', 'sjis', "z");
      }
      print OUT <<"END";
</div>
</div>
</div>
<div id="menu">
$outline
</div>
</body>
</html>
END
    } else {
      if ($usetable) {
        if ($utf) {
          Jcode::convert(\$outline, 'utf8', 'sjis', "z");
        }
        print OUT <<"END";
$Copyright
</td>
$outline
</tr>
</table>
</body>
</html>
END
      } else {
        if ($utf) {
          Jcode::convert(\$outline, 'utf8', 'sjis', "z");
        }
        print OUT <<"END";
$Copyright
</div>
</div>
</div>
<div id="menu">
$outline
</div>
</body>
</html>
END
      }
    }
    close OUT;
    $res = unlink($tofn);
    DebugPrint("res = $res");
    if ($res == 1) {
      rename $tofn . "_tmp", $tofn;
      DebugPrint("generated $tofn");
    } else {
      copy($tofn . "_tmp", $tofn);
      DebugPrint("********** copy " . $tofn . "_tmp to $tofn manually **********");
    }
  }
}
sub genhtmlfromtree {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cnd = $nd->{CHILD};
    while (1) {
      if ($cnd->{NAME} eq '_part') {
        $stylefile = $cnd->{TYPE};
        if ($stylefile eq '.css') {
          $stylefile = $config_file;
          $stylefile =~ s/\.pat$/.css/;
        } else {
          $stylefile = &mydirname($config_file) . "\/" . $stylefile; # rel path is assumed ...
        }
        $stylefile =~ s/\\/\//g;
        DebugPrint("stylefile set here = $stylefile");
      } elsif (($cnd->{NAME} =~ '^_') or &ishtmlelement($cnd->{NAME})) {
        # do nothing ... skip comment etc.
        if ($cnd->{NAME} eq '_copy') {
          $copied_file = $cnd->{TYPE};
        }
      } else {
        $cnd->{PREV} = undef;
        $cnd->{PREV}->{CHILD} = $cnd;
        &genhtmlfromtreebody($cnd);
      }
      last if not defined($cnd->{NEXT});
      $cnd = $cnd->{NEXT};
    }
  }
}
sub genhtmlfromtreebody {
  my($nd) = @_;
  &genhtmlfromnode($nd);
  if (defined($nd->{CHILD})) {
    &genhtmlfromtreebody($nd->{CHILD});
  }
  if (defined($nd->{NEXT})) {
    &genhtmlfromtreebody($nd->{NEXT});
  }
}
sub genindent {
  my($nd) = @_;
  # return str for indent for the node
  my $level = 0;
  # count level
  my $pn = $nd->{PARENT};
  while (defined($pn)) {
    $level++;
    $pn = $pn->{PARENT};
  }
  if ($level >= 2) { # try this ...
    $level -= 2;
  }
  return '&nbsp;' x $level;
}
sub genindex {
  my($nd) = @_;
  my $fn = $nd->{FILE};
  $index_cur = &genindex_cur($nd, $fn);
  return &genindex_pre($nd, $fn) . &genindex_cur($nd, $fn) . &genindex_post($nd, $fn);
}
sub genindex_cur {
  my($nd, $fn) = @_;
  my $header = $nd->{NAME};
  my $res = '';
  unless ($nd->{PARENT}->{NAME} eq 'root') {
    $indent = &genindent($nd);
    if (($nd->{KIND} =~ /#/) or ($nd->{NAME} eq 'script') or ($nd->{NAME} eq '_text')) {
      # do nothing ...
    } elsif ($nd->{NAME} =~ /^<img /) {
      $res = '<div class="li">' . $indent . $header . '</div>' . "\n";
    } else {
      $res = '<div class="li">' . $indent . '- ' . $header . '</div>' . "\n";
    }
  }
  if (defined($nd->{CHILD})) {
    $outline_cur = ''; # actually not needed ...
    $res = $res . '<div class="ul">' . "\n";
    my $cnd = $nd->{CHILD};
    my $cfn;
    my $rurl;
    while (1) {
      if (defined($cnd->{CHILD})) {
        if (($cnd->{KIND} =~ /#/) or ($cnd->{NAME} eq 'script') or ($cnd->{NAME} eq '_text')) {
          # do nothing ...
        } elsif (length($cnd->{FILE}) != 0) {
          $cfn = $cnd->{FILE};
          unless ($cnd->{KIND} =~ /\?/) {
            $cfn = &mydirname($cfn) . '/' . $PrefixForGeneratedFile . basename($cfn);
          }
          $rurl = &genrelpath($fn, $cfn);
          $indent = &genindent($cnd);
          $outline_cur = $outline_cur . '<div class="li">' . $indent . '<a href="' . $rurl . '">+ ' . $cnd->{NAME} . '</a></div>' . "\n";
        } else {
          $outline_cur = $outline_cur . &genindex_cur($cnd, $fn);
        }
      } else {
        $indent = &genindent($cnd);
        if (($cnd->{KIND} =~ /#/) or ($cnd->{NAME} eq 'script') or ($cnd->{NAME} eq '_text')) {
          # do nothing ...
        } elsif (length($cnd->{FILE}) != 0) {
          $cfn = $cnd->{FILE};
          unless ($cnd->{KIND} =~ /\?/) {
            $cfn = &mydirname($cfn) . '/' . $PrefixForGeneratedFile . basename($cfn);
          }
          $rurl = &genrelpath($fn, $cfn);
          $outline_cur = $outline_cur . '<div class="li">' . $indent . '<a href="' . $rurl . '">- ' . $cnd->{NAME} . '</a></div>' . "\n";
        } else {
          $outline_cur = $outline_cur . '<div class="li">' . $indent . '- ' . $cnd->{NAME} . '</div>' . "\n";
        }
      }
      last if not defined($cnd->{NEXT});
      $cnd = $cnd->{NEXT};
    }
    $res = $res . $outline_cur . '</div>' . "\n";
  } else {
    # do nothing ...
  }
  return $res;
}
sub genindex_post {
  my($nd, $fn) = @_;
  my $res = '';
  if ($nd->{PARENT}->{NAME} eq 'root') {
    return $res;
  } else {
    if (defined($nd->{NEXT})) {
      my $snd = $nd->{NEXT};
      my $sfn;
      my $urul;
      while (1) {
        $indent = &genindent($snd);
        if (defined($snd->{CHILD})) {
          if (length($snd->{FILE}) != 0) {
            $sfn = $snd->{FILE};
            unless ($snd->{KIND} =~ /\?/) {
              $sfn = &mydirname($sfn) . '/' . $PrefixForGeneratedFile . basename($sfn);
            }
            $rurl = &genrelpath($fn, $sfn);
            if ($snd->{KIND} =~ /#/ or ($snd->{NAME} eq 'script') or ($snd->{NAME} eq '_text')) {
              # do nothing ...
            } elsif ($snd->{NAME} =~ /^<img /) {
              $res = $res . '<div class="li">' . $indent . '<a href="' . $rurl . '">' . $snd->{NAME} . '</a></div>' . "\n";
            } else {
              $res = $res . '<div class="li">' . $indent . '<a href="' . $rurl . '">+ ' . $snd->{NAME} . '</a></div>' . "\n";
            }
          } else {
            $res = $res . &genindex_cur($snd, $fn);
          }
        } else {
          if (length($snd->{FILE}) != 0) {
            $sfn = $snd->{FILE};
            unless ($snd->{KIND} =~ /\?/) {
              $sfn = &mydirname($sfn) . '/' . $PrefixForGeneratedFile . basename($sfn);
            }
            $rurl = &genrelpath($fn, $sfn);
            if ($snd->{KIND} =~ /#/ or ($snd->{NAME} eq 'script') or ($snd->{NAME} eq '_text')) {
              # do nothing ...
            } elsif ($snd->{NAME} =~ /^<img /) {
              $res = $res . '<div class="li">' . $indent . '<a href="' . $rurl . '">' . $snd->{NAME} . '</a></div>' . "\n";
            } else {
              $res = $res . '<div class="li">' . $indent . '<a href="' . $rurl . '">- ' . $snd->{NAME} . '</a></div>' . "\n";
            }
          } else {
            if ($snd->{KIND} =~ /#/ or ($snd->{NAME} eq 'script') or ($snd->{NAME} eq '_text')) {
              # do nothing ...
            } elsif ($snd->{NAME} =~ /^<img /) {
              $res = $res . '<div class="li">' . $indent . $snd->{NAME} . '</div>' . "\n";
            } else {
              $res = $res . '<div class="li">' . $indent . '- ' . $snd->{NAME} . '</div>' . "\n";
            }
          }
        }
        last if not defined($snd->{NEXT});
        $snd = $snd->{NEXT};
      }
    }
    my $pnd = $nd->{PARENT};
    my $foundsome = 0;
    $res = $res . '</div>' . "\n";
    while (not ($pnd->{PARENT}->{NAME} eq 'root')) {
      $foundsome = 1;
      $pnd2 = $pnd->{PARENT};
      $res = $res . &genindex_post($pnd, $fn);
      $pnd = $pnd2;
      $res = $res . '</div>' . "\n";
    }
    if ($foundsome) {
      return $res;
    } else {
      return $res . "\n" . '</div>';
    }
  }
}
sub genindex_pre {
  my($nd, $fn) = @_;
  my $res = '';
  if ($nd->{PARENT}->{NAME} eq 'root') {
    return $res;
  } else {
    if (defined($nd->{PREV})) {
      my $snd = $nd->{PREV};
      my $sfn;
      my $urul;
      while (1) {
        $indent = &genindent($snd);
        if (defined($snd->{CHILD})) {
          if (length($snd->{FILE}) != 0) {
            $sfn = $snd->{FILE};
            unless ($snd->{KIND} =~ /\?/) {
              $sfn = &mydirname($sfn) . '/' . $PrefixForGeneratedFile . basename($sfn);
            }
            $rurl = &genrelpath($fn, $sfn);
            if ($snd->{KIND} =~ /#/ or ($snd->{NAME} eq 'script') or ($snd->{NAME} eq '_text')) {
              # do nothing ...
            } elsif ($snd->{NAME} =~ /^<img /) {
              $res = '<div class="li">' . $indent . '<a href="' . $rurl . '">' . $snd->{NAME} . '</a></div>' . "\n" . $res;
            } else {
              $res = '<div class="li">' . $indent . '<a href="' . $rurl . '">+ ' . $snd->{NAME} . '</a></div>' . "\n" . $res;
            }
          } else {
            $res = &genindex_cur($snd, $fn) . $res;
          }
        } else {
          if (length($snd->{FILE}) != 0) {
            $sfn = $snd->{FILE};
            unless ($snd->{KIND} =~ /\?/) {
              $sfn = &mydirname($sfn) . '/' . $PrefixForGeneratedFile . basename($sfn);
            }
            $rurl = &genrelpath($fn, $sfn);
            if ($snd->{KIND} =~ /#/ or ($snd->{NAME} eq 'script') or ($snd->{NAME} eq '_text')) {
              # do nothing ...
            } elsif ($snd->{NAME} =~ /^<img /) {
              $res = '<div class="li">' . $indent . '<a href="' . $rurl . '">' . $snd->{NAME} . '</a></div>' . "\n" . $res;
            } else {
              $res = '<div class="li">' . $indent . '<a href="' . $rurl . '">- ' . $snd->{NAME} . '</a></div>' . "\n" . $res;
            }
          } else {
            if ($snd->{NAME} =~ /^<img /) {
              $res = '<div class="li">' . $indent . $snd->{NAME} . '</div>' . "\n" . $res;
            } else {
              $res = '<div class="li">' . $indent . '- ' . $snd->{NAME} . '</div>' . "\n" . $res;
            }
          }
        }
        last if not defined($snd->{PREV});
        $snd = $snd->{PREV};
      }
    }
    my $pnd = $nd->{PARENT};
    my $foundsome = 0;
    while (not ($pnd->{PARENT}->{NAME} eq 'root')) {
      $foundsome = 1;
      $res = '<div class="ul">' . "\n" . $res;
      $indent = &genindent($pnd);
      if (length($pnd->{FILE}) != 0) {
        $sfn = $pnd->{FILE};
        unless ($snd->{KIND} =~ /\?/) {
          $sfn = &mydirname($sfn) . '/' . $PrefixForGeneratedFile . basename($sfn);
        }
        $rurl = &genrelpath($fn, $sfn);
        if ($pnd->{KIND} =~ /#/ or ($pnd->{NAME} eq 'script') or ($pnd->{NAME} eq '_text')) {
          # do nothing ...
        } elsif ($pnd->{NAME} =~ /^<img /) {
          $res = '<div class="li">' . $indent . '<a href="' . $rurl . '">' . $pnd->{NAME} . '</a></div>' . "\n" . $res;
        } else {
          $res = '<div class="li">' . $indent . '<a href="' . $rurl . '">- ' . $pnd->{NAME} . '</a></div>' . "\n" . $res;
        }
      } else {
        if ($pnd->{KIND} =~ /#/ or ($pnd->{NAME} eq 'script') or ($pnd->{NAME} eq '_text')) {
          # do nothing ...
        } elsif ($pnd->{NAME} =~ /^<img /) {
          $res = '<div class="li">' . $indent . $pnd->{NAME} . '</div>' . "\n" . $res;
        } else {
          $res = '<div class="li">' . $indent . '- ' . $pnd->{NAME} . '</div>' . "\n" . $res;
        }
      }
      $pnd2 = $pnd->{PARENT}; # this is the place ... why ...
      $res = &genindex_pre($pnd, $fn) . $res;
      $pnd = $pnd2;
    }
    if ($foundsome) {
      return $res;
    } else {
      return '<div class="ul">' . "\n" . $res;
    }
  }
}
sub genpath {
  my($nd, $ppath) = @_;
  my $fn = $nd->{FILE};
  my $header;
  my $pfn;
  my $rel_pfn;
  my $res = $nd->{NAME};
  while (defined($nd->{PARENT}) and not ($nd->{PARENT}->{NAME} eq 'root')) {
    $nd = $nd->{PARENT};
    $header = $nd->{NAME};
    $pfn = $nd->{FILE};
    if (length($pfn) != 0) {
      unless ($nd->{KIND} =~ /\?/) {
        $pfn = &mydirname($pfn) . '/' . $PrefixForGeneratedFile . basename($pfn);
      }
      $rel_pfn = &genrelpath($fn, $pfn);
      $res = '<a href="' . $rel_pfn . '">' . $header . '</a> > ' . $res;
    } else {
      $res = $header . ' > ' . $res;
    }
  }
  $res = '<div class="path">' . $ppath . $res . '</div>';
  return $res;
}
sub genrelpath {
  my($fromfn, $tofn) = @_;
  $fromfn =~ s/\\/\//g;
  $tofn =~ s/\\/\//g;
  if (not ($tofn =~ /[A-Z]:/)) { # currently ...
    return $tofn;
  }
  @elem_of_fromfn = split(/\//, $fromfn);
  @elem_of_tofn = split(/\//, $tofn);
  my $num_of_same_elem = 0;
  while ($elem_of_fromfn[$num_of_same_elem] eq $elem_of_tofn[$num_of_same_elem]) {
    $num_of_same_elem++;
  }
  my $res = '../' x (@elem_of_fromfn - $num_of_same_elem - 1);
  my $first = 1;
  for ($i = $num_of_same_elem; $i < @elem_of_tofn; $i++) {
    if ($first) {
      $res = $res . $elem_of_tofn[$i];
      $first = 0;
    } else {
      $res = $res . '/' . $elem_of_tofn[$i];
    }
  }
  return $res;
}
sub getnextfn {
  my($nd) = @_;
  while (defined($nd->{NEXT})) {
    if ($nd->{NEXT}->{KIND} =~ /\//) {
      return $nd->{NEXT}->{FILE};
    }
    $nd = $nd->{NEXT};
  }
  while (defined($nd->{PARENT}) and not ($nd->{PARENT}->{NAME} eq 'root')) {
    my $pn = $nd->{PARENT};
    while (defined($pn->{NEXT})) {
      if ($pn->{NEXT}->{KIND} =~ /\//) {
        return $pn->{NEXT}->{FILE};
      }
      $pn = $pn->{NEXT};
    }
    $nd = $nd->{PARENT};
  }
  return '';
}
sub getparentfn {
  my($nd) = @_;
  return $nd->{PARENT}->{FILE};
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    if (($str eq $htmlelement) or ($str eq '<' . $htmlelement . '>')) {
      return 1;
    }
  }
  return 0;
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub treatdefaultfilename {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cnd = $nd->{CHILD};
    while (1) {
      if ($cnd->{NAME} =~ /^_/) {
        # do nothing ... skip comment etc.
        if ($cnd->{NAME} eq '_copy') {
          $copied_file = $cnd->{TYPE};
        }
      } else {
        &treatdefaultfilenamebody($cnd);
      }
      last if not defined($cnd->{NEXT});
      $cnd = $cnd->{NEXT};
    }
  }
}
sub treatdefaultfilenamebody {
  my($nd) = @_;
  my $fn = $nd->{TEXT};
  if (($nd->{PARENT}->{NAME} eq 'root') and not ($nd->{NAME} =~ /^_/)) {
    if ($first_void_file) {
      $first_void_file = 0;
      if (length($copied_file)) {
        $fn = dirname($config_file) . '/' . $copied_file;
      } else {
        $fn = $config_file;
        $fn =~ s/\.pat/.html/;
      }
      $nd->{FILE} = $fn;
      DebugPrint("fn in treatdefaultfilenamebody = $fn");
    }
  } elsif (($nd->{KIND} =~ /\//)) { # and (length($nd->{TYPE}) != 0)
    if (length($nd->{TYPE}) != 0) {
      $tmpfn = $nd->{TYPE};
    } else {
      $tmpfn = $nd->{NAME};
      $tmpfn =~ s/\// /g;
      $tmpfn =~ s/^[ ]+//;
      $tmpfn =~ s/[ ]+$//;
    }
    if (length($PrefixForGeneratedFile) != 0) {
      $tmpPrefixForGeneratedFile = '^' . $PrefixForGeneratedFile;
      $tmpfn =~ s/$tmpPrefixForGeneratedFile//;
    }
    if (not ($tmpfn =~ /^[a-zA-Z]:/)) {
      $fn = dirname($config_file) . '/' . $tmpfn . ".html"; # may be changed ... think later ...
    } else {
      $fn = $tmpfn. ".html"; # may be changed ... think later ...
    }
    $nd->{FILE} = $fn;
  }
  if (defined($nd->{CHILD})) {
    my $cnd = $nd->{CHILD};
    while (1) {
      &treatdefaultfilename($cnd);
      last if not defined($cnd->{NEXT});
      $cnd = $cnd->{NEXT};
    }
  }
  if (defined($nd->{CHILD})) {
    &treatdefaultfilenamebody($nd->{CHILD});
  }
  if (defined($nd->{NEXT})) {
    &treatdefaultfilenamebody($nd->{NEXT});
  }
}
sub treathtmlelements {
  my($nd) = @_;
  if (&ishtmlelement($nd->{NAME}) or ($nd->{NAME} =~ /^_/ and defined($nd->{PARENT}) and not ($nd->{PARENT}->{NAME} eq 'script') and not ($nd->{PARENT}->{NAME} eq 'root'))) { # try this ... ()
    DebugPrint("delete node = $nd->{NAME}");
    &delnode($nd);
    return;
  }
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      my $ncn = $cn->{NEXT};
      &treathtmlelements($cn);
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub treatlinked {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    if ($nd->{KIND} =~ /\//) {
      &deletenonlinkedchild($nd);
    } else {
      my $cn = $nd->{CHILD};
      while (1) {
        my $ncn = $cn->{NEXT};
        &treatlinked($cn);
        if (not defined($ncn)) {
          last;
        }
        $cn = $ncn;
      }
    }
  }
}
sub treatvoidlevel {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    if ($nd->{NAME} eq '') {
      DebugPrint("treatvoidlevel1");
      if (not defined($nd->{PREV})) {
        $nd->{PARENT}->{CHILD} = $nd->{CHILD};
      } else {
        $nd->{CHILD}->{PREV} = $nd->{PREV};
        $nd->{PREV}->{NEXT} = $nd->{CHILD};
      }
      my $cn = $nd->{CHILD};
      $lnd = $cn;
      while (1) {
        $ncn = $cn->{NEXT};
        $cn->{PARENT} = $nd->{PARENT};
        if (not defined($ncn)) {
          last;
        }
        $cn = $ncn;
        $lnd = $cn;
      }
      if (defined($nd->{NEXT})) {
        $lnd->{NEXT} = $nd->{NEXT};
        $nd->{NEXT}->{PREV} = $lnd;
      }
    }
    my $cn = $nd->{CHILD};
    while (1) {
      my $ncn = $cn->{NEXT};
      &treatvoidlevel($cn);
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
