# File: GenIndexFromPDF_Perl.pl
# Date            Author        number of nodes
# 2003/10/30      Walking@Lint 42
# 2003/10/30      Walking@Lint 47 (GenIndexFromPDF->GenIndexFromPDF_Perl)
# 2003/10/30      Walking@Lint 49

=pod

=head1 NAME

GenIndexFromPDF_Perl.pl - generate pattern from PDF

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$pattern = shift;
$foot = '^file:';
if (length($pattern) == 0) {
  # set your default pattern here ...
}
$breaklater = 0;
$page = 1;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  $line = $_;
  if (($line =~ /$foot/) and ($line =~ /200[3-9]/)) { # this is hack ...
    $page++;
  } elsif ($line =~ /$pattern/) {
    while ($line =~ /$pattern/gi) {
      $found = $1;
      if ($current{$found} != $page) {
        $tmp = $index{$found};
        if (length($tmp) != 0) {
          $tmp = $tmp . ', ' . $page;
        } else {
          $tmp = $page;
        }
        $index{$found} = $tmp;
        $current{$found} = $page;
      }
    }
  }
  if ($breaklater) {
    last;
  }
}
print <<"END";
<html>
<head>
<title>Index</title>
</head>
<body>
<table>
END
foreach $key (sort keys %index) {
  print "<tr><td>$key</td><td>$index{$key}</td></tr>\n";
}
print <<"END";
</table>
</body>
</html>
END
