# File: GenLinkTree_Perl.pl
# Date            Author        number of nodes
# 2002/11/27      Walking Lint  81
# 2002/11/22      Walking Lint  80
# 2002/11/21      Walking Lint  64
# 2002/11/20      Walking Lint  55 (LinkCheck_Perl->GenLinkTree_Perl)
# 2002/11/19      Walking Lint  58 (Links_Perl->LinkCheck_Perl)
# 2002/11/19      Walking Lint  32 (CheckLinks_Perl->Links_Perl)
# 2002/11/19      Walking Lint  22 (ExtractLinks_Perl->CheckLinks_Perl)

=pod

=head1 NAME

GenLinkList_Perl.pl - check links from url

=head1 DESCRIPTION

ex. perl.exe GenLinkList_Perl.pl http://member.nifty.ne.jp/WalkingLint/ member

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use LWP::Simple;
use HTML::LinkExtor;
use Jcode;
use CVTree_Perl;
# get proxy info from registry
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$ref->Close();
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = $proxyoverride");
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = $proxyserver");
$url = shift;
DebugPrint("url = $url");
$mask = shift;
DebugPrint("mask = $mask");
$webagent = new LWP::UserAgent;
unless ($url =~ /$proxyoverride/) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
}
my $root = {};
&initnode($root, 'root', '', '', '');
@urls = ();
%nodes = ();
%checked = ();
push @urls, $url;
$url =~ /([^\/]+)\.htm/;
$nd = &addchildnode($root, $1, '', '', $url);
$nodes{$url} = $nd;
while (@urls != ()) {
  $url = shift @urls;
  if (not defined $checked{$url}) {
    $currentnode = $nodes{$url};
    &genlinktree($url, $mask);
    $checked{$url} = 1;
  }
}
&savetree($root);
sub genlinktree {
  my($url, $mask) = @_;
  my $request = new HTTP::Request('GET' => $url);
  my $response = $webagent->request($request);
  if ($response->is_success) {
    $parser = HTML::LinkExtor->new(\&link_callback, $url);
    $parser->parse($response->content);
  } else {
    $currentnode->{KIND} = ' () - ';
  }
}
sub link_callback {
  my($tag, %links) = @_;
  if ($tag eq "a") {
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      if (($url =~ /^http/) and ($url =~ /\.htm/) and (not $url =~ /\#/)) {
        if ((not defined($mask)) or ($url =~ /$mask/)) {
          $url =~ /([^\/]+)\.htm/;
          my $nd = &addchildnode($currentnode, $1, '', '', $url);
          push @urls, $url;
          $nodes{$url} = $nd;
        }
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
