# File: GenMindMapFromHistory_Perl.pl
# Date            Author        number of nodes
# 2002/12/6       Walking Lint  75

=pod

=head1 NAME

GenMindMapFromHistory_Perl.pl - generate text from history

=head1 DESCRIPTION

ex. perl.exe GenMindMapFromHistory_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
$from_file = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
$templatesfolder = 'C:\memo\cv\templates';
$from = $templatesfolder . '\*.pat';
$dir = dirname($from);
chdir $dir;
$from = basename($from);
@from_files = eval('<' . $from . '>');
%chains = ();
%nodes = ();
foreach $from_file (@from_files) {
  open IN, $from_file or die("Cannot open $from_file: $!\n");
  $firstline = <IN>;
  @lines = split(/ \CRLF /, $firstline);
  foreach $line (@lines) {
    $from = '';
    $to = '';
    if ($line =~ /\(([^\-]+)->([^\)]+)\)/) {
      $from = $1;
      $to = $2;
    }
    if ((length($from) != 0) and (length($to) != 0)) {
      $chain = sprintf("%s->%s", $from, $to);
      $line =~ /^([0-9]+)\/([0-9]+)\/([0-9]+)/;
      $year = $1;
      $month = $2;
      $day = $3;
      if ($year != 0) {
        $date = sprintf("%04d/%02d/%02d", $year, $month, $day);
        $chains{$chain} = $date;
      }
    }
  }
  close IN;
}
foreach $key (sort {$chains{$a} cmp $chains{$b}} keys %chains) {
  $chain = $key;
  ($from, $to) = split(/->/, $chain);
  if (not defined($nodes{$from})) {
    $node = &addchildnode($root, $from);
    $nodes{$from} = $node;
    $node = &addchildnode($node, $to);
    $nodes{$to} = $node;
  } else {
    $node = $nodes{$from};
    $node = &addchildnode($node, $to);
    $nodes{$to} = $node;
  }
}
&sortedsavetree($root);
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
