# File: GenMindMap_Perl.pl
# Date            Author        number of nodes
# 2003/4/14       Walking Lint  103
# 2002/11/16      Walking Lint  103
# 2002/10/10      Walking Lint  103
# 2002/10/2       Walking Lint  154
# 2002/10/1       Walking Lint  154
# 2002/9/29       Walking Lint  245
# 2002/9/28       Walking Lint  239
# 2002/9/21       Walking Lint  228
# 2002/9/21       Walking Lint  168 (GenMindMap_Perl->GenMindMap_Perl)
# 2002/8/31       Walking Lint  156

=pod

=head1 NAME

GenMindMap_Perl.pl - generate .pat for generating xml for FreeMind (http://freemind.sourceforge.net/index.html)

=head1 DESCRIPTION

ex. perl.exe GenMindMap_Perl.pl "D:\My Weblog\CMSReport.pat"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
$from_file = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
# customize here if needed ...
$tmp_file = $from_file;
$to_file = $from_file;
$to_file =~ s/\.pat$/_Map.pat/;
$from_file_body = basename($from_file);
$from_file_body =~ s/\.pat$//;
open OUT, ">$to_file";
print OUT <<END;
root () //  %% ${from_file_body}'s Mind Map
	?xml () // version="1.0" encoding="Shift_JIS"
	_to () // .mm
	map ()
END
&genmindmap($root, 1);
close OUT;
DebugPrint("generated $to_file");
sub  {
  sub DebugPrint {
    my($str) = @_;
    print STDERR $str . "\n";
  }
  sub genmindmap {
    my($nd, $level) = @_;
    if (defined($nd->{CHILD})) {
      my $first = 1;
      my $cn = $nd->{CHILD};
      while (1) {
        if (($cn->{NAME} =~ /^_/) and not ($cn->{TEXT} =~ /title=/) or ($cn->{NAME} eq 'center') or ($cn->{NAME} eq 'l') or ($cn->{NAME} eq 'p')) { # think later ...
          # skip
        } elsif (length($cn->{NAME}) == 0) {
          genmindmap($cn, $level);
        } else {
          my $indent = "\t" x ($level + 1);
          my $name = $cn->{NAME};
          my $link = '';
          if ($name eq 'a') {
            $name = $cn->{TEXT};
            $link = $cn->{TYPE};
            $link =~ /href="([^"]*)"/;
            $link = $1;
          } elsif ($name =~ /^<a /) {
            $name =~ /<a href="([^"]*)">([^<]*)<\/a>/;
            $link = $1;
            $name = $2;
          } elsif (($name =~ /^_/) and ($cn->{TEXT} =~ /title="([^"]*)"/)) {
            $name = $1;
            $link = $cn->{TYPE};
          } else {
            if ($cn->{TEXT} =~ /^http/) {
              $link = $cn->{TEXT};
            } elsif ($cn->{KIND} =~ /\//) {
              $link = $cn->{TYPE} . '.html';
            }
          }
          $name =~ s/"/ /g;
          $name =~ s/\x8c$//g; # hack...
          $name =~ s/<[^>]+>//g;
          $name =~ s/>/\&gt;/g;
          $name =~ s/</\&lt;/g;
          $name =~ s/&/\&amp;/g; # actually not sure ...
          if (length($link) != 0) {
            $link =~ s/"/ /g;
            $link =~ s/\x8c$//g; # hack ...
            $link =~ s/&/\&amp;/g; # actually not sure ...
            $link = 'LINK="' . $link . '" ';
          }
          print OUT <<END;
${indent}node () // ${link}TEXT="${name}"
END
          genmindmap($cn, $level + 1);
        }
        if (not defined($cn->{NEXT})) {
          last;
        }
        $cn = $cn->{NEXT};
      }
    }
  }
  sub Trace {
    my($str) = @_;
    print STDERR $str . "\n";
  }
}
