# File: GenRSS_Perl.pl
# Date            Author        number of nodes
# 2004/2/7        Walking Lint  240
# 2003/8/27       Walking@Lint 239
# 2003/8/5        Walking@Lint 227
# 2003/7/1        Walking Lint  225
# 2003/6/20       Walking Lint  222
# 2003/5/5        Walking Lint  214
# 2003/5/4        Walking Lint  210
# 2003/3/10       Walking Lint  216
# 2002/11/25      Walking Lint  214
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

GenRSS_Perl.pl - generate RSS

=head1 DESCRIPTION

ex1. _text () // GenRSS_Perl "D:\tmp\cv\templates\GenRSS_Perl.pat" "D:\tmp\cv\templates\rssj.xml" "My Two Cents" "http://member.nifty.ne.jp/WalkingLint/MyTwoCents.html" "A weblog about original outliner and stuff like that."

ex2. perl.exe GenRSS_Perl "D:\HP\MyTwoCentsContinued\200308.pat" "D:\HP\MyTwoCentsContinued\rssj.xml" "My Two Cents" "http://member.nifty.ne.jp/WalkingLint/MyTwoCents.html" "A weblog about original outliner and stuff like that."

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Jcode;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = shift;
DebugPrint("to_file = $to_file");
# set parameters
$title = shift;
DebugPrint("title = $title");
$url = shift;
DebugPrint("url = $url");
$link = $url;
$link =~ s/[^\/]*$//;
$description = shift;
DebugPrint("description = $description");
$copyright = shift;
DebugPrint("copyright = $copyright");
$webmaster = shift;
DebugPrint("webmaster = $webmaster");
  if (not defined($copyright)) {
    $weblogfoler = $ENV{WEBLOGFOLDER};
    $weblogfoler =~ s/"//g;
    $copyright_file = $weblogfoler . '\copyright.html';
    open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
    $copyright = <IN>;
    chop $copyright;
    $copyright =~ />&([^<]*)<br/;
    $copyright = '&amp;' . $1;
    DebugPrint("copyright = $copyright");
    $webmaster = <IN>;
    chop $webmaster;
    $webmaster =~ /mailto:([^"]*)/;
    $webmaster = $1;
    DebugPrint("webmaster = $webmaster");
    close IN;
  }
$numberofdaystofeed = 4;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
open OUT, ">$to_file";
$lines = "<?xml version=\"1.0\"?>\n<!-- RSS generated by GenRSS_Perl.pl -->\n<rss version=\"2.0\">\n<channel>";
if (length($title) != 0) {
  $lines .= "\n" . '<title>' . $title . '</title>';
}
if (length($url) != 0) { # actually this is assumed ...
  $lines .= "\n" . '<link>' . $url . '</link>'; # this is assumed ...
}
if (length($description) != 0) {
  $lines .= "\n" . '<description>' . $description . '</description>';
}
$japanese = 1; # currently this is default ...
$lang =~ s/"//g;
$lines .= "\n" . '<language>' . $lang . '</language>';
if (length($copyright) != 0) {
  $lines .= "\n" . '<copyright>' . $copyright . '</copyright>';
}
$lines .= "\n" . '<generator>GenRSS_Perl.pl</generator>';
if (length($webmaster) != 0) {
  $lines .= "\n" . '<webMaster>' . $webmaster . '</webMaster>';
}
if ($japanese) {
  Jcode::convert(\$lines, 'utf8', 'sjis', "z");
}
print OUT $lines . "\n";
$tm = localtime;
$date = sprintf("%04d/%02d/%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
DebugPrint("date = $date");
$datefile = sprintf("%04d%02d%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
DebugPrint("datefile = $datefile");
$dir = dirname($from_file);
$dir =~ s/\\$//;
$rsslogdir = $dir . "\\RSSLog";
if (not -e $rsslogdir) {
  mkdir $rsslogdir, 0700 or die("Cannot make $rsslogdir: $!");
}
$base = basename($from_file);
$base =~ s/\.pat/.html/;
$link2 = $link . $base;
&genrss($root);
if ($numberofdaystofeed > 0) {
  $file = basename($from_file);
  opendir DIR, $dir or die "opendir() failed: $!";
  @files = grep !/^\.\.?$/, readdir DIR;
  @files = grep /^20[0-9]+.pat$/, @files;
  closedir DIR;
  $found_file = 0;
  DebugPrint("file = " . $file);
  foreach $file2 (reverse sort @files) {
    DebugPrint("file2 = $file2");
    if ($file eq $file2) {
      $found_file = 1;
    } elsif ($found_file) {
      my $root = {};
      &initnode($root, 'root', '', '', '');
      &gentree($root, $dir . "\\" . $file2);
      $base = basename($file2);
      $base =~ s/\.pat/.html/;
      $link2 = $link . $base;
      &genrss($root);
    }
    unless ($numberofdaystofeed > 0) {
      last;
    }
  }
}
$lines = <<END;
</channel>
</rss>
END
if ($japanese) {
  Jcode::convert(\$lines, 'utf8', 'sjis', "z");
}
print OUT $lines;
close OUT;
DebugPrint("generated $to_file");
sub genrss {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while ($numberofdaystofeed > 0) {
      if (not $cn->{NAME} =~ /^_/) {
        if ($cn->{NAME} =~ /20[0-9]{2}/) {
          ($year, $month, $day) = split(/[\/\(]/, $cn->{NAME});
          $datefile2 = sprintf("%04d%02d%02d", $year, $month, $day);
          $rsslogfile = $rsslogdir . "\\" . $datefile2;
          if (($datefile eq $datefile2) or (not -e $rsslogfile)) {
            &savetree($cn, $rsslogfile);
            DebugPrint("generated $rsslogfile");
          }
          $date = $cn->{NAME};
          $date =~ s/\(.+$//;
          ($year, $month, $day) = split(/\/|\(/, $date);
          $day =~ s/^0+//;
          $w3cdtf = sprintf("%04d-%02d-%02d", $year, $month, $day);
          if (&genrssbody($cn)) {
            $numberofdaystofeed--;
          }
        } else {
          &genrss($cn);
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub genrssbody {
  my($nd) = @_;
  my $generated = 0;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    $counter = 0;
    while (1) {
      if (defined($cn->{TYPE})) {
        $name = $cn->{TYPE};
        $itemtitle = $cn->{NAME};
      } else {
        $name = $cn->{NAME};
        $itemtitle = '';
      }
      if ($japanese and ($name =~ /֌W$/)) {
        $name =~ s/[ ]*֌W$//;
      }
      if ((not $cn->{NAME} =~ /^_/)) {
        $topic = $cn->{TEXT};
        @topics = (); # currently
        if (length($topic) != 0) {
          push @topics, $topic;
        } elsif (defined($cn->{CHILD})) {
          my $ccn = $cn->{CHILD};
          DebugPrint("ccname = " . $ccn->{NAME});
          while (1) {
            if (($ccn->{NAME} eq '_text') and (length($ccn->{TEXT}) != 0)) {
              push @topics, $ccn->{TEXT};
            }
            if (not defined($ccn->{NEXT})) {
              last;
            }
            $ccn = $ccn->{NEXT};
          }
        }
        $first = 1;
        foreach $line (@topics) {
          @lines = split(/ \CRLF /, $line);
          $line = join(" ", @lines);
          if ($first) {
            if (length($itemtitle) != 0) {
            } else {
              $itemtitle = $date . ' - ' . $name;
            }
            $first = 0;
          } else {
            if (($#lines >= 1) and ($lines[0] =~ /^\[\[/) and ($lines[0] =~ /\]\]$/)) {
              $itemtitle = $lines[0] . ' ' . $lines[1];
              if (($#lines > 2) or defined($cn->{CHILD})) {
                $itemtitle =~ s/\.\.\.$//;
                $itemtitle .= '...';
              }
            } elsif (($#lines >= 2) and (length($lines[0]) < 20) and ($lines[1] =~ /^\[\[/) and ($lines[1] =~ /\]\]$/)) {
              $itemtitle = $lines[0] . ' ' . $lines[1] . ' ' . $lines[2];
              if (($#lines > 3) or defined($cn->{CHILD})) {
                $itemtitle =~ s/\.\.\.$//;
                $itemtitle .= '...';
              }
            } else {
              $itemtitle = $lines[0];
              if (($#lines > 1) or defined($cn->{CHILD})) {
                $itemtitle =~ s/\.\.\.$//;
                $itemtitle .= '...';
              }
            }
            $itemtitle = $date . ' - ' . $itemtitle . ' - ' . $name;
          }
          $itemtitle =~ s/\[\[([^!]+)!([^]]+)\]\]/$1/g;
          $itemtitle =~ s/&/\&amp;/g;
          $itemtitle =~ s/<[^>]*>//g;
          $itemtitle =~ s/</\&lt;/g;
          $itemtitle =~ s/>/\&gt;/g;
          $line =~ s/&/\&amp;/g;
          $line =~ s/\[\[([^!]+)!([^]]+)\]\]/\&lt;a href=\&quot;$2\&quot;\&gt;$1\&lt;\/a&gt;/g;
          $line =~ s/</\&lt;/g;
          $line =~ s/>/\&gt;/g;
          $counter++;
          if (length($line) != 0) {
            if ($japanese) {
              Jcode::convert(\$itemtitle, 'utf8', 'sjis', "z");
              Jcode::convert(\$line, 'utf8', 'sjis', "z");
            }
            if ($line =~ /\(([0-9]+):([0-9]+):([0-9]+)\)$/) {
              $timelabel = $1 . $2 . $3;
              $label = $day;
              if (length($day) == 1) {
                $label = '0' . $day;
              }
              $label = 't' . $label . $timelabel; # currently ... change here if needed ...
            } else {
              $label = $day;
            }
            print OUT <<END;
<item>
<title>$itemtitle</title>
<link>${link2}#${label}</link>
<description>
$line
</description>
</item>
END
            $generated = 1;
          }
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
  return $generated;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
