# File: GenRSS_Ruby.rb
# Date            Author        number of nodes
# 2002/11/17      Walking Lint  180
# 2002/11/16      Walking Lint  174
# 2002/11/16      Walking Lint  212 (GenRSS_Perl->GenRSS_Ruby)
# 2002/11/15      Walking Lint  212 (GenRSS_Ruby->GenRSS_Perl)
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Ruby.GenRSS_Ruby)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Ruby.GenRSS_Ruby)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Ruby.GenCategorizedLinkLog_Ruby)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Ruby.GenCategorizedLinkLogNew_Ruby)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=begin

= NAME

GenRSS_Ruby.rb - generate RSS

= DESCRIPTION

ex. ruby.exe GenRSS_Ruby "D:\HP\200211.pat" "D:\HP\rss.xml"  "My Two Cents" "http://member.nifty.ne.jp/WalkingLint/" "A weblog about original outliner and stuff like that." "&amp;copy; Copyright 2001-2002 Walking Lint" "GDA00545@nifty.ne.jp"

= AUTHOR

Walking Lint

=end

require 'CVTree_Ruby.rb'
def genrssbody(nd, outfile)
  generated = false
  def if
    cn = nd['CHILD']
    counter = 0
    def while
      name = cn['NAME']
      def if
        name.gsub!(/[ ]*֌W$/, '')
        usetitle = false
      def else
        usetitle = true
      end
      def if    # or (''cn['NAME'] eq '_text')
        topic = cn['TEXT']
        topics = topic.split(/( C\RLF )+-----( C\RLF )+/)
        def for
          def if    # this is hack ...
            next
          end
          lines = line.split(/ C\RLF /)
          line = lines.join(" ")
          def if
            itemtitle = $date + ' ' + name
          def else
            def if
              itemtitle = lines[0] + ' ' + lines[1]
              def if
                itemtitle.gsub!(/\.\.\.$/, '')
                itemtitle += '...'
              end
            def elsif
              itemtitle = lines[0] + ' ' + lines[1] + ' ' + lines[2]
              def if
                itemtitle.gsub!(/\.\.\.$/, '')
                itemtitle += '...'
              end
            def else
              itemtitle = lines[0]
              def if
                itemtitle.gsub!(/\.\.\.$/, '')
                itemtitle += '...'
              end
            end
            itemtitle = $date + ' ' + itemtitle + ' - ' + name
          end
          itemtitle.gsub!(/\[\[([^!]+)!([^]]+)\]\]/, '$1')
          itemtitle.gsub!(/&/, '\&amp;')
          itemtitle.gsub!(/<[^>]*>/, '')
          itemtitle.gsub!(/</, '\&lt;')
          itemtitle.gsub!(/>/, '\&gt;')
          line.gsub!(/&/, '\&amp;')
          line.gsub!(/\[\[([^!]+)!([^]]+)\]\]/, '\&lt;a href=\&quot;$2\&quot;\&gt;$1\&lt;\/a&gt;')
          line.gsub!(/</, '\&lt;')
          line.gsub!(/>/, '\&gt;')
          counter += 1
          def if
            lines = <<END
<item>
<title>#{itemtitle}</title>
<link>#{$link2}##{$day}</link>
<description>
#{line}
</description>
</item>
END
            outfile.print(lines)
            generated = true
          end
        end
      end
      def if
        break
      end
      cn = cn['NEXT']
    end
  end
  return generated
end
def genrss(nd, outfile)
  def if
    cn = nd['CHILD']
    def while
      def if
        def if
          (year, month, $day) = cn['NAME'].split(/[\/\(]/)
          $datefile2 = "%04d%02d%02d" % [year, month, $day]
          rsslogfile = $rsslogdir + "/" + $datefile2
          def if
            savetree(cn, rsslogfile)
            DebugPrint("generated #{rsslogfile}")
          end
          $date = cn['NAME']
          $date.gsub!(/\(.+$/, '')
          (year, month, $day) = $date.split(/\/|\(/)
          $day.gsub!(/^0+/, '')
          w3cdtf = "%04d-%02d-%02d" % [year, month, $day]
          def if
            $numberofdaystofeed -= 1
          end
        def else
          genrss(cn, outfile)
        end
      end
      def if
        break
      end
      cn = cn['NEXT']
    end
  end
end
from_file = ARGV.shift
DebugPrint("from_file = #{from_file")
to_file = ARGV.shift
DebugPrint("to_file = #{to_file}")
title = ARGV.shift
DebugPrint("title = #{title}")
link = ARGV.shift
DebugPrint("link = #{link}")
description = ARGV.shift
DebugPrint("description = #{description}")
copyright = ARGV.shift
DebugPrint("copyright = #{copyright}")
webmaster = ARGV.shift
DebugPrint("webmaster = #{webmaster}")
$numberofdaystofeed = 7
root = {}
initnode(root, 'root', '', '', '')
gentree(root, from_file)
outfile = open(to_file, "w")
lines = "<?xml version=\"1.0\"?>\n<!-- 1 RSS generated by GenRSS_Ruby.rb -->\n<rss version=\"2.0\">\n<channel>"
def if
  lines += "\n" + '<title>' + title + '</title>'
end
def if  # actually this is assumed ...
  lines += "\n" + '<link>' + link + 'index.html' + '</link>'    # this is assumed ...
end
def if
  lines += "\n" + '<description>' + description + '</description>'
end
lines += "\n" + '<language>ja</language>'
def if
  lines += "\n" + '<copyright>' + copyright + '</copyright>'
end
lines += "\n" + '<generator>GenRSS_Ruby.rb</generator>'
def if
  lines += "\n" + '<webMaster>' + webmaster + '</webMaster>'
end
outfile.print(lines + "\n")
tm = Time.now.localtime
$date = "%04d/%02d/%02d" % [tm.year, tm.mon, tm.mday]
DebugPrint("$date = #{$date}")
$datefile = "%04d%02d%02d" % [tm.year, tm.mon, tm.mday]
DebugPrint("$datefile = #{$datefile}")
dir = File.dirname(from_file)
dir.gsub!(/\\$/, '')
$rsslogdir = dir + "/RSSLog"
def if
  Dir.mkdir($rsslogdir, 0700)
end
base = File.basename(from_file)
base.gsub!(/\.pat/, '.html')
$link2 = link + base
genrss(root, outfile)
def if
  file = File.basename(from_file)
  files = Dir.entries(dir).grep(/^20[0-9]+.pat$/)
  found_file = false
  def for
    DebugPrint("file2 = #{file2}")
    def if
      found_file = true
    def elsif
      root = {}
      initnode(root, 'root', '', '', '')
      gentree(root, dir + "/" + file2)
      base = File.basename(file2)
      base.gsub!(/\.pat/, '.html')
      $link2 = link + base
      genrss(root, outfile)
    end
    def unless
      break
    end
  end
end
lines = <<END
</channel>
</rss>
END
outfile.print(lines)
outfile.close
DebugPrint("generated #{to_file}")
