# File: GenRefRelationsFromPatents_Perl.pl
# Date            Author        number of nodes
# 2006/5/9        Walking Lint  159
# 2006/5/8        Walking Lint  154
# 2005/4/13       Walking Lint  105
# 2005/4/7        Walking Lint  94
# 2005/4/4        Walking Lint  84
# 2005/4/2        Walking Lint  51
# 2005/4/2        Walking Lint  265 (AugmentFTermWithPatent_Perl->GenRefRelationsFromPatents_Perl)
# 2005/3/31       Walking Lint  265
# 2005/3/24       Walking Lint  265
# 2005/3/23       Walking Lint  263
# 2005/3/17       Walking Lint  263
# 2005/3/16       Walking Lint  224
# 2005/3/14       Walking Lint  277
# 2005/3/11       Walking Lint  273
# 2005/3/10       Walking Lint  267
# 2005/3/9        Walking Lint  235
# 2005/3/8        Walking Lint  154
# 2005/3/7        Walking Lint  128
# 2005/3/6        Walking Lint  126
# 2005/3/6        Walking Lint  123 (PatentMapWriter_Perl->AugmentFTermWithPatent_Perl)
# 2005/3/5        Walking Lint  123
# 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl)
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85
use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$is_US = shift;
$with_PC = shift; # not used for JP currently ...
$from_file = shift;
$to_file = shift;
my $root = {};
my $root2 = {};
&initnode($root, 'root', '', '', '');
&initnode($root2, 'root', '', '', '');
&gentree($root, $from_file);
%relations = ();
%company = ();
%company2 = ();
%pc = ();
%pc2 = ();
&set_relation($root);
foreach $key (sort keys %relations) {
  ($from, $to) = split(/_/, $key);
  $tmp_from = '';
  $tmp_to = '';
  if ($with_PC == 1) {
    if (defined($pc{$from}) and not ($pc{$from} eq '.') and (length($pc{$from}) != 0)) {
      $tmp_from = '_' . $pc{$from} . '_' . $from;
    } else {
      $tmp_from = $from;
    }
    if (defined($pc{$to}) and not ($pc{$to} eq '.') and (length($pc{$to}) != 0)) {
      $tmp_to = '_' . $pc{$to} . '_' . $to;
    } elsif (defined($pc2{$to}) and not ($pc2{$to} eq '.') and (length($pc2{$to}) != 0)) {
      $tmp_to = '_' . $pc2{$to} . '_' . $to;
    } else {
      $tmp_to = $to;
    }
  } else {
    $tmp_from = $from;
    $tmp_to = $to;
  }
  if (defined($company{$from})) {
    $tmp_from = $company{$from} . $tmp_from;
  }
  if (defined($company{$to})) {
    $tmp_to = $company{$to} . $tmp_to;
  } elsif (defined($company2{$to})) {
    $tmp_to = $company2{$to} . $tmp_to;
  }
  &addchildnode($root2, $tmp_from, '', '', $tmp_to);
}
&savetree($root2, $to_file);
DebugPrint("generated $to_file");
sub set_relation {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if (($is_US == 1) and ($cn->{NAME} eq 'United States Patent')) {
        $text = $cn->{TEXT};
        ($company, $name, $patent_num, $patent_name, $file) = split(/\t/, $text);
        $file =~ s/,//g;
        if ($file =~ /[A-Z]+([0-9]+)/) { # actually US or USRE?
          $file = $1;
        }
        ($company, $tmp_company, $dummy) = split(/[^a-zA-Z\-]+/, $company); # this is hack ...
        if ($company eq 'The') {
          $company = $tmp_company;
        }
        ($tmp_name, $dummy) = split(/[^a-zA-Z\-]+/, $name); # not actually
        $company{$file} = $company . '_' . $tmp_name;
        my $ccn = $cn->{CHILD};
        while (1) {
          if ($ccn->{NAME} eq 'US REFERENCE') { # if () // $ccn->{NAME} eq 'References Cited'
            my $cccn = $ccn->{CHILD};
            $tmp_num = '';
            $tmp_name = '';
            $tmp_pc = '';
            while (1) {
              if ($cccn->{NAME} eq 'Patent') {
                $tmp_num = $cccn->{TEXT};
              } elsif ($cccn->{NAME} eq 'Name') {
                $tmp_name = $cccn->{TEXT};
              } elsif ($cccn->{NAME} eq 'US Class') {
                $tmp_pc = $cccn->{TEXT};
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
            $idx = $file . '_' . $tmp_num;
            ($mark, $tmp_name, $dummy) = split(/[^a-zA-Z\-]+/, $tmp_name);
            if (($mark eq 'A') or ($mark eq 'B') or ($mark eq 'B1') or ($mark eq 'B2')) {
              $company2{$tmp_num} = $tmp_name;
            } else {
              $company2{$tmp_num} = $mark;
            }
            $pc2{$tmp_num} = $tmp_pc;
            $relations{$idx}++;
          } elsif ($ccn->{NAME} eq 'CLASSIFICATION') {
            my $cccn = $ccn->{CHILD};
            $tmp_pc = '';
            while (1) {
              if ($cccn->{NAME} eq 'U.S. Class') {
                $tmp_pc = $cccn->{TEXT};
                last;
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
            $pc{$file} = $tmp_pc;
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
      } elsif (($is_US == 0) and ($cn->{NAME} eq 's')) {
        $text = $cn->{TEXT};
        ($company, $name, $patent_num, $patent_name, $file, $id) = split(/\t/, $text);
        $file =~ /([0-9]+)\.txt/;
        $file = $1;
        if ($file =~ /^0/) {
          $file = '20' . $file;
        } else {
          $file = '19' . $file;
        }
        my $ccn = $cn->{CHILD};
        while (1) {
          if ($ccn->{NAME} =~ /^(㗝l||ol|lĎ)/) {
            my $cccn = $ccn->{CHILD};
            while (1) {
              if ($cccn->{NAME} eq 'pieiXj') {
                my $ccccn = $cccn->{NEXT};
                while (1) {
                  if ($ccccn->{TEXT} =~ /([0-9]+)/) {
                    $idx = $file . '_' . $1;
                    $relations{$idx}++;
                  }
                  if (not defined($ccccn->{NEXT})) {
                    last;
                  }
                  $ccccn = $ccccn->{NEXT};
                }
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
