# File: GenRelatedSites_Perl.pl
# Date            Author        number of nodes
# 2002/12/14      Walking Lint  105
# 2002/12/3       Walking Lint  105
# 2002/11/25      Walking Lint  96 (GenWeblogs_Perl->GenRelatedSites_Perl)
# 2002/11/22      Walking Lint  94
# 2002/11/19      Walking Lint  94
# 2002/11/6       Walking Lint  86
# 2002/10/15      Walking Lint  81
# 2002/9/21       Walking Lint  168
# 2002/8/31       Walking Lint  156

=pod

=head1 NAME

GenRelatedSites_Perl.pl - generate RelatedSites section and RelatedSites.html

=head1 DESCRIPTION

ex. _text () // GenRelatedSites_Perl

meaning of flags in kind

! - exclude

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree;
use Time::localtime;
$tm = localtime;
$dateandtime = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec);
# set parameters
$link_file = 'C:\memo\cv\templates\Link2.pat';
DebugPrint("link_file = $link_file");
$dir = 'D:\HP';
DebugPrint("dir = $dir");
$ParentTitle = 'My Two Cents';
DebugPrint("ParentTitle = $ParentTitle");
$ParentURL = 'index.html';
DebugPrint("ParentURL = $ParentURL");
$CSSTemplate = '3ColumnWithStyleSheetForSubPage.css';
DebugPrint("CSSTemplate = $CSSTemplate");
$copyright_file = $dir . '\copyright.html';
open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
@copyrights = <IN>;
close IN;
$copyright = join('', @copyrights);
DebugPrint("copyright = $copyright");
$labeltag = 'div';
DebugPrint("labeltag = $labeltag");
$Title = 'related sites';
DebugPrint("Title = $Title");
$to_url = 'relatedsites.html';
$to_file = $dir . "\\" . $to_url;
DebugPrint("to_file = $to_file");
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $link_file);
&genlinks($root, $to_file);
print <<END;
<small><div class="lastupdate">($dateandtime)</div></small>
END
DebugPrint("generated $to_file");
sub  {
  sub DebugPrint {
    my($str) = @_;
    print STDERR $str . "\n";
  }
  sub genlinks {
    my($nd, $to_file) = @_;
    if (defined($nd->{CHILD})) {
      my $first = 1;
      $cn = $nd->{CHILD};
      while (1) {
        if (($cn->{NAME} =~ /^_/) or ($cn->{KIND} =~ /\!/)) { # actually _node is already deleted ...
          # skip
        } else {
          if ($first) {
            $first = 0;
            open OUT, ">$to_file";
            print OUT <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$Title</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$CSSTemplate" />
</head>
<body>
<table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table>
<h3>$Title</h3>
<p>
<ol>
END
            print <<END;
<$labeltag><a href="$to_url">$Title</a></$labeltag>
END
          }
          $rsslink = '';
          $type = $cn->{TYPE};
          if (length($type) != 0) {
            if ($type =~ /(http:.*)/) { # not actually ... but this is assumed ...
              $rsslink = ' <a href="' . $1 . '"><img src="tinyxml.jpg" alt="RSS link" title="RSS link"></a>';
              $type = $cn->{TYPE};
              $type =~ s/(http:.*)//;
            }
            if (length($type) != 0) {
              $type = $rsslink . ' - ' . $type;
            } else {
              $type = $rsslink;
            }
          }
          print OUT <<END;
<li> <a href="$cn->{TEXT}">$cn->{NAME}</a>$type
END
        }
        if (not defined($cn->{NEXT})) {
          last;
        }
        $cn = $cn->{NEXT};
      }
      if (not $first) {
        print OUT <<END;
</ol>
</p>
$copyright
</body>
</html>
END
        close OUT;
      }
    }
  }
  sub Trace {
    my($str) = @_;
    print STDERR $str . "\n";
  }
}
