# File: GenStyleSheetForPrint_Perl.pl
# Date            Author        number of nodes
# 2002/12/9       Walking Lint  31
# 2002/12/9       Walking Lint  30 (GenStyleSheetFromPrint_Perl->GenStyleSheetForPrint_Perl)
# 2002/12/8       Walking Lint  30 (GenStyleSheetForPrint_Perl->GenStyleSheetFromPrint_Perl)
# 2002/7/4        Walking Lint  5 (DeleteMatchedLine_Perl->GenStyleSheetForPrint_Perl)
# 2002/5/22       Walking Lint  4
# 2002/4/28       Walking Lint  4
# 2002/4/20       Walking Lint  4

=pod

=head1 NAME

GenStyleSheetForPrint_Perl.pl - gen stylesheet for print

=head1 DESCRIPTION

ex. perl.exe GenStyleSheetForPrint_Perl.pl D:\HP\3ColumnWithStyleSheet.css

=head1 AUTHOR

Walking Lint

=cut

$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$to_file =~ s/\.(css|pat)$/ForPrint.css/; # think later ...
open IN, $from_file or die("Cannot open $from_file: $!\n");
open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
$found_body = 0;
while (<IN>) {
  if ($found_body) {
    if (/^}/) {
      print OUT "  padding-left : 70px;\n"; # customize here ...
      print OUT "  padding-right : 20px;\n"; # customize here ...
      $found_body = 0;
    }
  } else {
    if (/^body {/) {
      $found_body = 1;
    }
  }
  if (/\sbackground-color : ([^;]+);/) {
    $_ =~ s/$1/white/;
  } elsif (/\scolor : ([^;]+);/) {
    $_ =~ s/$1/black/;
  }
  print OUT $_;
}
close IN;
close OUT;
DebugPrint("generated $to_file");
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
