# File: GenStyleSheetForSubPage_Perl.pl
# Date            Author        number of nodes
# 2003/4/10       Walking Lint  85
# 2003/3/20       Walking Lint  62
# 2002/12/10      Walking Lint  58
# 2002/12/9       Walking Lint  31 (GenStyleSheetForPrint_Perl->GenStyleSheetForSubPage_Perl)
# 2002/12/9       Walking Lint  30 (GenStyleSheetFromPrint_Perl->GenStyleSheetForPrint_Perl)
# 2002/12/8       Walking Lint  30 (GenStyleSheetForPrint_Perl->GenStyleSheetFromPrint_Perl)
# 2002/7/4        Walking Lint  5 (DeleteMatchedLine_Perl->GenStyleSheetForPrint_Perl)
# 2002/5/22       Walking Lint  4
# 2002/4/28       Walking Lint  4
# 2002/4/20       Walking Lint  4

=pod

=head1 NAME

GenStyleSheetForSubPage_Perl.pl - gen stylesheet for sub page

=head1 DESCRIPTION

ex. perl.exe GenStyleSheetForSubPage_Perl.pl D:\HP\3ColumnWithStyleSheet.css

=head1 AUTHOR

Walking Lint

=cut

$from_file = shift;
DebugPrint("from_file = $from_file");
$use_menu = shift;
DebugPrint("use_menu = $use_menu");
$to_file = $from_file;
$to_file =~ s/\.(css|pat)$/ForSubPage.css/; # think later ...
open IN, $from_file or die("Cannot open $from_file: $!\n");
open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
$found_body = 0;
$found_div_body = 0;
$found_h1 = 0;
$h1_existed = 0;
$found_h1_text_align = 0;
$body = '';
$h1 = '';
$background_color = '';
$color = '';
while (<IN>) {
  if ($found_body) {
    if (/^}/) {
      $found_body = 0;
    }
    $body .= $_;
    next;
  } elsif ($found_div_body) {
    if (/^}/) {
      $found_div_body = 0;
    } elsif (/\sbackground-color : ([^;]+);/) {
      $background_color = $1;
    } elsif (/\scolor : ([^;]+);/) {
      $color = $1;
    }
  } elsif ($found_h1) {
    if (/^}/) {
      $found_h1 = 0;
      if (not $found_h1_text_align) {
        $h1 .= "  text-align : center;\n";
      }
      print OUT $h1;
      print OUT $_;
    } elsif (/text-align/) {
      $_ =~ s/:.*/: center;/;
      $found_h1_text_align = 1;
    }
    $h1 .= $_;
    next;
  } else {
    if (/^body {/) {
      $found_body = 1;
      $body = $_;
      next;
    } elsif (defined($use_menu) and ($_ =~ /^div#menu {/)) {
      $found_div_body = 1;
    } elsif ((not defined($use_menu)) and ($_ =~ /^div\.body {/)) {
      $found_div_body = 1;
    } elsif (/^h1 {/) {
      $found_h1 = 1;
      $h1_existed = 1;
    }
  }
  print OUT $_;
}
# better to think of the case in which body does not exist ???
if (length($body) != 0) {
  @lines = split(/\n/, $body);
  foreach $line (@lines) {
    if (length($line) != 0) { # not sure if needed ...
      if ($line =~ /\sbackground-color : ([^;]+);/) {
        $line =~ s/$1/$background_color/;
      } elsif ($line =~ /\scolor : ([^;]+);/) {
        $line =~ s/$1/$color/;
      }
      print OUT $line . "\n";
    }
  }
}
if (not $h1_existed) {
  print OUT <<"END";
h1 {
  text-align : center;
}
END
}
close IN;
close OUT;
DebugPrint("generated $to_file");
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
