# File: GenText_Perl.pl
# Date            Author        number of nodes
# 2002/11/16      Walking Lint  154
# 2002/10/1       Walking Lint  154
# 2002/9/29       Walking Lint  245
# 2002/9/28       Walking Lint  239
# 2002/9/21       Walking Lint  228
# 2002/9/21       Walking Lint  168 (GenText_Perl->GenText_Perl)
# 2002/8/31       Walking Lint  156

=pod

=head1 NAME

GenText_Perl.pl - generate text from outline

=head1 DESCRIPTION

ex. perl.exe GenText_Perl.pl "D:\My Weblog\CMSReport.pat" "WL Corp." "Walking Lint" "2002N101" "ȏ"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Time::localtime;
$from_file = shift;
$division = shift;
$author = shift;
$date = shift;
if (length($date) == 0) { # not sure if good ...
  $tm = localtime;
  $date = sprintf("%04dN%d%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
}
$footnote = shift;
$generate_index = 1;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
# customize here if needed ...
$tmp_file = $from_file;
$tmp_file =~ s/\.pat$/.tmp/;
$to_file = $from_file;
$to_file =~ s/\.pat$/.txt/;
open OUT, ">$tmp_file";
&gentext($root, '', 0, 0);
close OUT;
# indent ref part
open IN, $tmp_file || die("Can't open $tmp_file: $!\n");
open OUT, ">$to_file";
DebugPrint("generated $to_file");
$indent = '  ';
$inref = 0;
$afteritem = 0;
  while (<IN>) {
    if ($inref) {
      if (/^ <\/div>/) {
        $inref = 0;
      } else {
        print OUT $indent . $_;
      }
    } else {
      if (/^ <div class="ref">/) {
        $inref = 1;
      } else {
        if (/^ ([-]+) /) {
          $itemlevel = length($1);
          $newitem = ' ' x ($itemlevel - 1) . '-';
          $itemindent = ' ' x $itemlevel . ' ';
          $_ =~ s/[-]+/$newitem/;
          $afteritem = 1;
        } else {
          if ($afteritem) {
            if ($_ =~ /^[ ]*$/) {
              $afteritem = 0;
            } else {
              $_ = $itemindent . $_;
            }
          }
        }
        print OUT $_;
      }
    }
  }
print OUT "\n";
print OUT <<"END";
$footnote
END
close IN;
close OUT;
sub  {
  sub DebugPrint {
    my($str) = @_;
    print STDERR $str . "\n";
  }
  sub gentext {
    my($nd, $num, $for_index, $level) = @_;
    if (defined($nd->{CHILD})) {
      my $first = 1;
      my $cn = $nd->{CHILD};
      my $cnt = 1;
      my $cnum = '';
      my $cnum2 = '';
      while (1) {
        if ($cn->{NAME} eq '_text') {
          if ($for_index) {
            # skip
          } else {
            $text = $cn->{TEXT};
            $text = &processtext($text);
            print OUT <<END;
$text
END
            print OUT "\n";
          }
        } elsif (($cn->{NAME} =~ /^_/) or ($cn->{NAME} eq 'center') or ($cn->{NAME} eq 'left') or ($cn->{NAME} eq 'p')) { # think later ...
          # skip
        } else {
          if ($nd->{NAME} eq 'root') {
            $cnum2 = '';
            print OUT "\n";
            print OUT <<END;
                                       $cn->{NAME}

                                                                  $date
                                                                  $division
                                                                  $author
END
            if ($generate_index) {
              print OUT <<END;
                                          ڎ
END
              print OUT "\n";
              gentext($cn, '', 1, 0);
              print OUT "\n";
              $num = '';
            }
          } else {
            if (length($num) == 0) {
              $cnum = $cnt . ". ";
              $cnum2 = $cnt;
            } else {
              $cnum = $num . "." . $cnt . " ";
              $cnum2 = $num . "." . $cnt;
            }
            $text = $cn->{TEXT};
            if ($for_index) {
              print OUT '  ' x $level;
              print OUT <<END;
          $cnum$cn->{NAME}
END
            } elsif (length($text) != 0) {
              $text = &processtext($text);
              print OUT <<END;
$cnum$cn->{NAME}

$text
END
              print OUT "\n";
            } else {
              print OUT <<END;
$cnum$cn->{NAME}
END
              print OUT "\n";
            }
          }
          gentext($cn, $cnum2, $for_index, $level + 1);
          $cnt++;
        }
        if (not defined($cn->{NEXT})) {
          last;
        }
        $cn = $cn->{NEXT};
      }
    }
  }
  sub processtext {
    my($text) = @_;
    $text =~ s/&gt;/>/g;
    $text =~ s/&lt;/>/g;
    $text =~ s/&amp;/\&/g;
    $text =~ s/&nbsp;/ /g;
    $text =~ s/<br>//g;
    $text =~ s/<br\/>//g;
    $text =~ s/<strong>//g;
    $text =~ s/<\/strong>//g;
    $text =~ s/\[\[([^!]+)!([^\]]+)\]\]/$1\n ($2)/g;
    $text =~ s/ \CRLF /\n /g;
    $text =~ s/^/ /g;
    return $text;
  }
  sub Trace {
    my($str) = @_;
    print STDERR $str . "\n";
  }
}
