# File: GenToDo_Perl.pl
# Date            Author        number of nodes
# 2003/3/23       Walking Lint  128
# 2002/12/13      Walking Lint  126
# 2002/11/19      Walking Lint  93
# 2002/10/16      Walking Lint  86 (GenToDoList_Perl->GenToDo_Perl)
# 2002/10/15      Walking Lint  115 (GenToDoList_Perl->GenToDoList_Perl)
# 2002/10/15      Walking Lint  81 (GenToDoList_Perl->GenToDoList_Perl)
# 2002/9/21       Walking Lint  168
# 2002/8/31       Walking Lint  156

=pod

=head1 NAME

GenToDo_Perl.pl - generate ToDo

=head1 DESCRIPTION

ex. perl.exe GenToDo_Perl.pl

meaning of flags in kind

! - exclude

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Time::localtime;
$tm = localtime;
$dateandtime = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec);
# set parameters
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
$todo_body = 'Memo.pat';
$todo_file = $templatesfolder . "\\" . $todo_body;
DebugPrint("todo_file = $todo_file");
$weblogfolder = $ENV{WEBLOGFOLDER};
$weblogfolder =~ s/"//g;
$todo = $weblogfolder . '\ToDo.html';
DebugPrint("todo = $todo");
$ParentTitle = 'Revenge of My Two Cents';
DebugPrint("ParentTitle = $ParentTitle");
$ParentURL = 'index.html';
DebugPrint("ParentURL = $ParentURL");
$link_file_body = 'link.css';
DebugPrint("link_file_body = $link_file_body");
$link_file = $todo;
$link_file =~ s/[^\\]+$/$link_file_body/;
DebugPrint("link_file = $link_file");
$src_link_file = $templatesfolder . "\\" . $link_file_body;
  if (not -e $link_file and -e $src_link_file) {
    copy($src_link_file, $link_file);
    DebugPrint("copied $src_link_file to $link_file");
  }
$copyright_file = 'E:\copyright.html';
open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
@copyrights = <IN>;
close IN;
$copyright = join('', @copyrights);
DebugPrint("copyright = $copyright");
$Title = 'items to be done';
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $todo_file);
my $first = 1;
open OUT, ">$todo";
print OUT <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$Title</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$link_file_body" />
</head>
<body>
<table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table>
<div class="lastupdate">Last update: $dateandtime</div>
END
print <<END;
<a href="ToDo.html">$Title</a><small>
<div class="lastupdate">($dateandtime)</div></small>
END
$counter = 1;
&gentodo($root, 1);
print OUT <<END;
</body>
</html>
END
close OUT;
DebugPrint("generated $todo");
sub gentodo {
  my($nd, $level) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if ($cn->{NAME} =~ /^_/) {
        if ($cn->{NAME} eq '_mheader') {
          $mail_file_body = $todo_body;
          $mail_file_body =~ s/\.pat//;
          $mail_file_body .= $counter . '.html';
          $counter++;
          $mail_file = $weblogfolder . "\\" . $mail_file_body;
          $mail_body = $cn->{TEXT};
          $mail_body =~ s/ \CRLF /\n/g;
          $mail_body =~ /(.*)/;
          $mail_head = $1;
          open OUT2, ">$mail_file" or die("Cannot open $mail_file: $!\n");
          print OUT2 '<pre>' . $mail_body . '</pre>';
          close OUT2;
          print OUT <<END;
<h$level><a href="$mail_file_body">$mail_head</a></h$level>
END
        } else {
          # skip
        }
      } else {
        $text = $cn->{TEXT};
        $text =~ s/( \CRLF )+/ /g;
        if (length($text) != 0) {
          $text = ' - ' . $text;
        } else {
          $text = '';
        }
        if ($cn->{KIND} =~ /\(\) \+/) {
          print OUT <<END;
<h$level><img src="CheckedNode.jpg"/> $cn->{NAME}$text</h$level>
END
        } else {
          print OUT <<END;
<h$level><img src="NotCheckedNode.jpg"/> $cn->{NAME}$text</h$level>
END
        }
        if (defined($cn->{CHILD})) {
          &gentodo($cn, $level + 1);
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
