# File: GenWeblogs_Perl.pl
# Date            Author        number of nodes
# 2003/8/19       Walking@Lint 138
# 2003/8/3        Walking@Lint 136
# 2003/7/21       Walking Lint  124
# 2003/5/4        Walking Lint  105
# 2003/3/10       Walking Lint  105
# 2002/12/17      Walking Lint  102
# 2002/11/21      Walking Lint  96
# 2002/11/19      Walking Lint  94
# 2002/11/6       Walking Lint  86
# 2002/10/15      Walking Lint  81
# 2002/9/21       Walking Lint  168
# 2002/8/31       Walking Lint  156

=pod

=head1 NAME

GenWeblogs_Perl.pl - generate Weblogs section and Weblogs.html

=head1 DESCRIPTION

ex. _text () //  GenWeblogs_Perl 1

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Jcode;
use Time::localtime;
$needtostop = 0;
$tm = localtime;
$dateandtime = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec);
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
if (length($templatesfolder) == 0) {
  DebugPrint("please set TEMPLATESFOLDER");
  $needtostop = 1;
}
$weblogfolder = $ENV{WEBLOGFOLDER};
$weblogfolder =~ s/"//g;
if (length($weblogfolder) == 0) {
  DebugPrint("please set WEBLOGFOLDER");
  $needtostop = 1;
}
# set parameters
$link_file = $templatesfolder . '\Link.pat';
DebugPrint("link_file = $link_file");
$weblog_file = $weblogfolder . '\Weblogs.html';
DebugPrint("weblog_file = $weblog_file");
$ParentTitle = $ENV{TITLEOFWEBLOG};
$ParentTitle =~ s/"//g;
  if (length($ParentTitle) == 0) {
    DebugPrint("please set TITLEOFWEBLOG");
    $needtostop = 1;
  }
DebugPrint("ParentTitle = $ParentTitle");
  if ($needtostop) {
    exit;
  }
$ParentURL = 'index.html';
DebugPrint("ParentURL = $ParentURL");
$CSSTemplate = '2ColumnForSubPage.css';
DebugPrint("CSSTemplate = $CSSTemplate");
$copyright_file = $weblogfolder . '\copyright.html';
open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
@copyrights = <IN>;
close IN;
$copyright = join('', @copyrights);
DebugPrint("copyright = $copyright");
$Title = 'Weblogs';
DebugPrint("Title = $Title");
$utf = shift;
DebugPrint("utf = " . $utf);
$genfile = 1; # change here if needed ...
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $link_file);
&genlinks($root, $weblog_file);
DebugPrint("generated $weblog_file");
sub  {
  sub DebugPrint {
    my($str) = @_;
    print STDERR $str . "\n";
  }
  sub genlinks {
    my($nd, $to_file) = @_;
    if (defined($nd->{CHILD})) {
      my $first = 1;
      $cn = $nd->{CHILD};
      while (1) {
        if (($cn->{NAME} =~ /^_/) or ($cn->{KIND} =~ /\!/)) { # actually _node is already deleted ...
          # skip
        } else {
          if ($first) {
            $first = 0;
            if ($genfile) {
              open OUT, ">$to_file";
              print OUT <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$Title</title>
END
              if ($utf) {
                print OUT <<END;
<meta http-equiv="content-type" content="text/html;charset=utf-8" />
END
              } else {
                print OUT <<END;
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
END
              }
              print OUT <<END;
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$CSSTemplate" />
</head>
<body>
<table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table>
<h3>$Title</h3>
<p>
<ol>
END
            }
            print <<END;
<h5><a href="Weblogs.html">Weblogs:</a></h5>
END
          }
          $rsslink = '';
          $type = $cn->{TYPE};
          if (length($type) != 0) {
            if ($type =~ /(http:[^ \(]*)/) { # not actually ... but this is assumed ...
              $rsslink = ' <a href="' . $1 . '"><img src="tinyxml.jpg" alt="RSS link" title="RSS link"></a>';
              $type = $cn->{TYPE};
              $type =~ s/(http:[^ \(]*)//;
            }
            if (length($type) != 0) {
              $type = $rsslink . ' - ' . $type;
            } else {
              $type = $rsslink;
            }
          }
          if ($genfile) {
            $line = '<li> <a href="' . $cn->{TEXT} . '">' . $cn->{NAME} . '</a>' . $type . "\n";
            if ($utf) {
              Jcode::convert(\$line, 'utf8', 'sjis', "z");
            }
            print OUT $line;
          }
          print <<END;
<div><a href="$cn->{TEXT}">$cn->{NAME}</a></div>
END
        }
        if (not defined($cn->{NEXT})) {
          last;
        }
        $cn = $cn->{NEXT};
      }
      if (not $first) {
        if ($genfile) {
          print OUT <<END;
</ol>
</p>
$copyright
</body>
</html>
END
          close OUT;
        }
        print <<END;
<div class="lastupdate">($dateandtime)</div>
END
      }
    }
  }
  sub Trace {
    my($str) = @_;
    print STDERR $str . "\n";
  }
}
