# File: GeppouReader_Perl.pl
# Date            Author        number of nodes
# 2006/7/18       Walking Lint  273
# 2005/3/14       Walking Lint  272
# 2005/2/28       Walking Lint  271
# 2005/2/16       Walking Lint  264
# 2005/2/15       Walking Lint  195
# 2003/12/26      Walking Lint  114
# 2003/10/3       Walking@Lint 109
# 2003/8/1        Walking Lint  101
# 2003/7/31       Walking Lint  101
# 2003/6/30       Walking Lint  101
# 2002/12/3       Walking Lint  98
# 2002/12/2       Walking Lint  93
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

GeppouReader_Perl.pl - txt reader (its format is assumed...)

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$from_file = shift;
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
$found_maru = 0;
my $root = {};
&initnode($root, 'root');
&gentree($root, $from_file);
&savetree($root, $to_file);
if (length($to_file) != 0) {
  DebugPrint("generated $to_file");
}
sub extractparams {
  my($line) = @_;
  $kind = ' ()  '; # somehow this is hack ... think later ...
  $type = '';
  $text = '';
  if ($line =~ /^(?:P|Q|R|S|T|U|V|W|X)(?:\x81\x7C|D)(?:P|Q|R|S|T|U|V|W|X)(?:D|j|\))(?: |@)*(.*)/) { # add more if needed ...
    $level = 2;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    $is_pending = 1;
    $savedstr = $line;
    return 0;
  } elsif ($line =~ /^(?: |@)*(?:P|Q|R|S|T|U|V|W|X|[1-9])(?:D|j|\))(?: |@)*(.*)/) { # add more if needed ...
    $level = 1;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    $is_pending = 1;
    $savedstr = $line;
    return 0;
  } elsif ($line =~ /^\[(?:P|Q|R|S|T|U|V|W|X)(?:D|j|\))(.*)\]/) { # add more if needed ...
    $level = 1;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^(?: |@)*(gsbNX|eڍ)(?: |@)*$/) { # add more if needed ...
    $level = 1;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^\[(gsbNX|T̃gsbNX)\]$/) { # add more if needed ...
    $level = 1;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    return 0;
  } elsif (($line =~ /^(?: |@)*(ȏ|ȏB)$/) or ($line =~ /^(?: |@)+(ȁ@)$/)  or ($line =~ /^ȏA/)) { # ($line =~ /^-----(\-)*/) or ... add more if needed ...
    $level = 1;
    $founditem = 0; # think later...
    return 1;
  } elsif (($line =~ /^(?: |@)*(.*)/)) {
    $level = 2;
    $name = $1;
    if ($name =~ /^NDAČF戵$/) {
      return 1;
    }
    $name =~ s/[ \t]+$//;
    $founditem = 1;
    return 0;
  } elsif (($line =~ /^(?: |@)*(.*)/)) {
    $level = 2;
    $name = $1;
    $name =~ s/[ \t]+$//;
    $founditem = 1;
    return 0;
  } elsif (($line =~ /^(?: |@)*s(.*)t/)) {
    $level = 2;
    $name = $1;
    $name =~ s/[ \t]+$//;
    $founditem = 1;
    return 0;
  } elsif (($found_maru == 0) and ($line =~ /^(?: |@)*(||)(?: |@)*(.*)/)) {
    $found_maru = 1;
    $maru_pattern = $1;
    $level = 2;
    $name = $2;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    return 0;
  } elsif (($found_maru == 1) and ($line =~ /^(?: |@)*$maru_pattern(?: |@)*(.*)/)) {
    $level = 2;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    return 0;
  } elsif (($found_maru == 0) and ($line =~ /^@(?:|)(?: |@)*(.*)/)) { # $line =~ /^@(?:||)(?: |@)*(.*)/
    $level = 2;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^(?:@)*(?:)(?: |@)*(.*)/) {
    $level = 3;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    $founditem = 1;
    return 0;
  } elsif (($found_maru == 0) and ($line =~ /^(?:@)+(?:@|A|B|C|D|E|F|G|H|I)[ @]*(.*)/)) { # this is hack ...
    $level = 3;
    $name = $1;
    $name =~ s/( |@|\t)+$//;
    return 0;
  } else {
    return 1;
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $founditem = 0; # think later...
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  $is_pending = 0;
  $pushed = 0;
  while ($pushed or ($_ = <$infilehandle>)) {
    if ($pushed) {
      $_ = $pushedstr;
      $pushed = 0;
    }
    $_ =~ s/[\r\n]+$//;
    $through = 0;
    $through2 = 0;
    if ($is_pending) {
      $is_pending = 0;
      if ($_ =~ /(\x81\x50)+/) { # P
        $through = 1;
      } else {
        $pushed = 1;
        $pushedstr = $_;
        $_ = $savedstr;
        $through2 = 1;
      }
    } elsif ($_ =~ /(\x81\x50)+/) { # P
      next;
    }
    if (($through == 1) or (length($_) != 0)) {
      if (($through == 0) and (($through2 == 1) or &extractparams($_))) {
        if ($founditem) {
          $_ =~ s/^( |@)+//;
          $_ =~ s/^-----(\-)*//;
          if (length($cur->{TEXT}) == 0) {
            $cur->{TEXT} = $_;
          } else {
            if (length($_) != 0) {
              $tmpline = " \CRLF " . $_;
            }
            $cur->{TEXT} .= $tmpline;
            $tmpline = '';
          }
          if ($_ eq "ȏ") {
            last;
          }
        }
        next;
      }
      if ($is_pending) {
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        $cur = addnode($cur, $name, $kind, $type, $text);
      } else {
        until ($prevlevel <= $level) {
          if ($cur->{PARENT} == $root) {
            last;
          }
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevlevel = $level;
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
