# File: GoogleCountForWeb_Perl.pl
# Date            Author        number of nodes
# 2003/9/22       Walking Lint  39
# 2003/9/11       Walking Lint  34
# 2003/9/9        Walking Lint  34
# 2003/8/31       Walking@Lint 32
# 2003/8/31       Walking@Lint 42 (GoogleCount_Perl->GoogleCountForWeb_Perl)
# 2003/8/31       Walking@Lint 42
# 2003/8/30       Walking@Lint 40
# 2003/8/30       Walking@Lint 40 (GetGoogleCount_Perl->GoogleCount_Perl)
# 2003/8/30       Walking@Lint 40
# 2003/8/30       Walking@Lint 39 (63_1->GetGoogleCount_Perl)
# 2003/8/23

=pod

=head1 NAME

GoogleCountForWeb_Perl.pl - get estimated total results count of Google search

=head1 DESCRIPTION

ex. _text () // GoogleCountForWeb_Perl %% mn83ed

=head1 AUTHOR

Walking Lint

=cut

my $google_key = $ENV{GoogleWebAPILicenseKey};
$google_key =~ s/"//g;
# Location of the GoogleSearch WSDL file
my $templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
my $google_wdsl = $templatesfolder . '\GoogleSearch.wsdl';
use CGI;
use Jcode;
use SOAP::Lite;
# Create a new Google SOAP request
my $google_search = SOAP::Lite->service("file:$google_wdsl");
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  } else {
    $_ =~ s/[\n\r]*$//;
  }
  $full_query = '"' . $_ . '"';
  # Query Google
  my $result = $google_search -> doGoogleSearch( $google_key, $full_query, 0, 10, "false", "",  "false", "", "latin1", "latin1" );
  # Output
  $str = $_;
  Jcode::convert(\$str, 'utf8', 'sjis', "z");
  $link = '<a href="http://www.google.com/search?sourceid=navclient&hl=ja&ie=UTF-8&oe=UTF-8&q=' . CGI::escape('"' . $str . '"') . '">' . $_ . '</a>'; # try this ...
  print "<div>" . $link . " - " . $result->{estimatedTotalResultsCount} . "</div>\n";
  if ($breaklater) {
    last;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
