#!/usr/bin/perl -w
# File: Google_Perl.pl
# Date            Author        number of nodes
# 2003/3/11       Walking Lint  26
# GoogleSearch.pl
# 11apr2002 - matt@interconnected.org http://interconnected.org/home/
# Demonstrates use of the doGoogleSearch method on the Google API.
# See http://www.google.com/apis/ to get your key and download the WSDL
# (which this script expects to find in its directory).
use strict;
use SOAP::Lite;
# Configuration
my $key = "xxxxxxxxxxxxxxxxxxxxxx"; # <-- PUT YOUR KEY HERE
# either type on the command line,
# or it defaults to 'google api'
my $query = $ARGV[0] || "google api";
# Redefine how the default deserializer handles booleans.
# Workaround because the 1999 schema implementation incorrectly doesn't
# accept "true" and "false" for boolean values.
# See http://groups.yahoo.com/group/soaplite/message/895
*SOAP::XMLSchema1999::Deserializer::as_boolean = *SOAP::XMLSchemaSOAP1_1::Deserializer::as_boolean = \&SOAP::XMLSchema2001::Deserializer::as_boolean;
# Initialise with local SOAP::Lite file
my $service = SOAP::Lite
  -> service('file:./GoogleSearch.wsdl');
$result = my $service
-> doGoogleSearch(
$key,                               # key
xml_clean($query),                  # search query
0,                                  # start results
1,                                  # max results
"false",                            # filter: boolean
"",                                 # restrict (string)
"false",                            # safeSearch: boolean
"",                                 # lr
"latin1",                           # ie
"latin1"                            # oe
);
# $result is hash of the return structure. Each result is an element in the
# array keyed by 'resultElements'. See the WSDL for more details.
if (defined($result->{resultElements})) {
  print join "\n", "Found:", $result->{resultElements}->[0]->{title}, $result->{resultElements}->[0]->{URL} . "\n";
}
# cleans up strings for XML
sub xml_clean {
  my $text = shift;
  $text =~  s/\&/\&amp;/g;
  $text =~  s/</\&lt;/g;
  $text =~  s/>/\&gt;/g;
  $text =~  s/\"/\&quot;/g;
  $text =~  s/\'/\&apos;/g;
  return $text;
}
# nb:
# - The two booleans in the search above must be "false" or "true" (not 1 or
#   0). Previously this script used 'SOAP::Data->type(boolean => "false")'
#   which came out as '0' in the SOAP message, but wasn't understood by the
#   Google interface.
# - I understand that the Schema definition workaround above isn't needed if
#   you're using SOAP::Lite 0.52 or above. I've been using 0.51.
# nb 19apr2002:
# - Chris Nandor pointed out that the query needs escaping. I've put a very
#   simplistic xml_clean sub in to do that, although you should really use
#   the xml_escape function from XML::Parser.
