# File: HistogramLogAnalyzer_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 49
# 2003/8/6        Walking@Lint 43
# 2003/2/18       Walking Lint  41
# 2003/2/13       Walking Lint  41

=pod

=head1 NAME

HistogramLogAnalyzer_Perl.pl - generate histogram from log

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

$mask = shift;
DebugPrint("mask = $mask");
$excludemask = shift;
DebugPrint("excludemask = $excludemask");
$hour = 0;
$minute = 0;
$second = 0;
$breaklater = 0;
while (<STDIN>) {
  if ($_ =~ /^__EOF__[\n\r]*$/) {
    last;
  } elsif ($_ =~ /__EOF__[\n\r]*$/) {
    $_ =~ s/__EOF__[\n\r]*$//;
    $breaklater = 1;
  }
  if (($_ =~ /$mask/) and (not defined($excludemask) or not ($_ =~ /$excludemask/))) {
    if ($_ =~ / \-[ ]*([0-9]+)h[ ]*([0-9]+)m[ ]*([0-9]+)s/) {
      $hour += $1;
      $minute += $2;
      $second += $3;
    } elsif ($_ =~ / \-[ ]*([0-9]+)m[ ]*([0-9]+)s/) {
      $minute += $1;
      $second += $2;
    } elsif ($_ =~ / \-[ ]*([0-9]+)h[ ]*([0-9]+)s/) {
      $hour += $1;
      $second += $2;
    } elsif ($_ =~ / \-[ ]*([0-9]+)h[ ]*([0-9]+)m/) {
      $hour += $1;
      $minute += $2;
    } elsif ($_ =~ / \-[ ]*([0-9]+)h/) {
      $hour += $1;
    } elsif ($_ =~ / \-[ ]*([0-9]+)m/) {
      $minute += $1;
    } elsif ($_ =~ / \-[ ]*([0-9]+)s/) {
      $second += $1;
    }
  }
  print $_; # this is needed to active as filter ...
  if ($breaklater) {
    last;
  }
}
$minute += int($second / 60);
$second = $second % 60;
$hour += int($minute / 60);
$minute = $minute % 60;
DebugPrint(sprintf("\ntotal time: %4dh%3dm%3ds", $hour, $minute, $second));
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
