# File: HistogramPatent_Perl.pl
# Date            Author        number of nodes
# 2006/7/5        Walking Lint  397
# 2006/3/27       Walking Lint  391
# 2006/3/24       Walking Lint  386
# 2006/3/23       Walking Lint  382
# 2006/3/22       Walking Lint  382
# 2006/3/20       Walking Lint  374
# 2006/2/9        Walking Lint  316
# 2006/2/8        Walking Lint  305
# 2005/12/9       Walking Lint  299
# 2005/11/22      Walking Lint  283
# 2005/11/15      Walking Lint  260
# 2005/4/28       Walking Lint  239
# 2005/4/13       Walking Lint  236
# 2005/4/6        Walking Lint  234
# 2005/4/5        Walking Lint  181
# 2005/4/4        Walking Lint  111
# 2005/4/4        Walking Lint  82 (GenRefRelationsFromPatents_Perl->HistogramPatent_Perl)
# 2005/4/4        Walking Lint  82
# 2005/4/2        Walking Lint  51
# 2005/4/2        Walking Lint  265 (AugmentFTermWithPatent_Perl->GenRefRelationsFromPatents_Perl)
# 2005/3/31       Walking Lint  265
# 2005/3/24       Walking Lint  265
# 2005/3/23       Walking Lint  263
# 2005/3/17       Walking Lint  263
# 2005/3/16       Walking Lint  224
# 2005/3/14       Walking Lint  277
# 2005/3/11       Walking Lint  273
# 2005/3/10       Walking Lint  267
# 2005/3/9        Walking Lint  235
# 2005/3/8        Walking Lint  154
# 2005/3/7        Walking Lint  128
# 2005/3/6        Walking Lint  126
# 2005/3/6        Walking Lint  123 (PatentMapWriter_Perl->AugmentFTermWithPatent_Perl)
# 2005/3/5        Walking Lint  123
# 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl)
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85
use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$is_US = shift;
$unique = shift; # 0: not unique / 1: unique / 2: both
$from_file = shift;
$fterm_to_check = shift; # 999: top level / non: co
$is_total = shift;
$with_co = shift;
$include_subclasses = shift;
$do_not_output_obsolete_subfterm = 1;
if (($fterm_to_check eq '999') or ($fterm_to_check eq '2')) {
  if ($is_US == 0) {
    $fterm_file = $ENV{TEMPLATESFOLDER} . "\\" . 'FTermList.txt';
  } else {
    $fterm_file = $ENV{TEMPLATESFOLDER} . "\\" . 'PatentClassList.txt';
  }
  unless (-e $fterm_file) {
    die "$fterm_file do not exist";
  }
} elsif ((length($fterm_to_check) != 0) and not (($fterm_to_check eq '999') or ($fterm_to_check eq '2'))) {
  $fterm_file = $from_file;
  $fterm_file =~ s/[^\\]+$//;
  $fterm_file .= $fterm_to_check . '.pat';
  unless (-e $fterm_file) {
    die "$fterm_file do not exist";
  }
}
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
&gengraph();
if ($with_co == 1) {
  $fterm_to_check = '';
  &gengraph();
}
sub gengraph {
  %years = ();
  %companies = ();
  %count = ();
  %count2 = ();
  %person = ();
  &get_year($root);
  $found_def_of_fterm = 0;
  %def = ();
  if ($fterm_to_check eq '999') {
    open IN, $fterm_file or die("Cannot open $term_file: $!\n");
    @items = <IN>;
    close IN;
    $found_def_of_fterm = 1;
    foreach $item (@items) {
      $item =~ s/[\r\n]+$//;
      ($fterm, $def) = split(/\t/, $item);
      if ($def eq 'Ȃ') {
        $def = $fterm . '(Ȃ)';
      }
      $def{$fterm} = $def;
    }
  } elsif (length($fterm_to_check) != 0) {
    if (-e $fterm_file) {
      $found_def_of_fterm = 1;
      my $root2 = {};
      &initnode($root2, 'root', '', '', '');
      &gentree($root2, $fterm_file);
      $nd = $root2->{CHILD};
      while ($nd != undef) {
        if ((not ($nd->{NAME} =~ /^<a /)) and (not ($nd->{NAME} =~ /^_/))) {
          $def{$nd->{NAME}} = $nd->{TEXT};
        }
        $nd = &getnext($nd);
      }
    }
  }
  $year_line = '';
  $first = 1;
  @sorted_years = sort keys %years;
  $min_year = $sorted_years[0];
  $max_year = $sorted_years[$#sorted_years];
  for ($year = $min_year; $year <= $max_year; $year++) {
    if ($first == 1) {
      $first = 0;
      $year_line = "\t" . $year;
    } else {
      $year_line .= "\t" . $year;
    }
  }
  if ($unique == 2) {
    &printgraph(\%count2);
  }
  DebugPrint("");
  &printgraph(\%count);
}
sub printgraph {
  my($to_count_ref) = @_;
  if ($is_total != 1) {
    DebugPrint("$year_line");
  }
  foreach $company (sort {$companies{$b} <=> $companies{$a}} keys %companies) {
    $first = 1;
    $count_line = '';
    $skip = 0;
    $total = 0;
    for ($year = $min_year; $year <= $max_year; $year++) { # foreach () // $year (sort keys %years)
      $idx = $year . '_' . $company;
      if ($first == 1) {
        $first = 0;
        if ($found_def_of_fterm == 1) {
          if (length($def{$company}) == 0) {
            unless ($do_not_output_obsolete_subfterm == 1) {
              $count_line = "(Ȃ)\t" . $$to_count_ref{$idx};
            } else {
              $skip = 1;
              last;
            }
          } else {
            if ($is_total == 1) {
              $count_line = $company . ' - ' . $def{$company};
              $total += $$to_count_ref{$idx};
            } else {
              $count_line = $company . ' - ' . $def{$company} . "\t" . $$to_count_ref{$idx};
            }
          }
        } else {
          if ($is_total == 1) {
            $count_line = $company;
            $total += $$to_count_ref{$idx};
          } else {
            $count_line = $company . "\t" . $$to_count_ref{$idx};
          }
        }
      } else {
        if ($is_total == 1) {
          $total += $$to_count_ref{$idx};
        } else {
          $count_line .= "\t" . $$to_count_ref{$idx};
        }
      }
    }
    if ($is_total == 1) {
      $count_line .= "\t" . $total;
    }
    unless ($skip == 1) {
      DebugPrint("$count_line");
    }
  }
}
sub get_year {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      $text = $cn->{TEXT};
      $year = '';
      if (($is_US == 1) and ($cn->{NAME} eq 'United States Patent')) {
        ($company, $name, $patent_num, $patent_name, $dummy, $id, $file) = split(/\t/, $text);
        my $ccn = $cn->{CHILD};
        while (1) {
          if ($ccn->{NAME} eq 'Issue Date') {
            $ccn->{TEXT} =~ /^([0-9][0-9][0-9][0-9])/;
            $year = $1;
            $years{$year}++;
            if (length($fterm_to_check) == 0) {
              $companies{$company}++;
              $idx = $year . '_' . $company;
              if ($unique == 2) {
                $count2{$idx}++;
              }
              if ($unique == 0) {
                $count{$idx}++;
              } elsif (not defined($person{$idx . $name})) {
                $person{$idx . $name}++;
                $count{$idx}++;
              }
            }
          }
          if (length($fterm_to_check) != 0) {
            if ($ccn->{NAME} eq 'CLASSIFICATION') { # this is for MicroPatentReader
              my $cccn = $ccn->{CHILD};
              while (1) {
                if (($cccn->{NAME} eq 'U.S. Class') or ($include_subclasses == 1) and (($cccn->{NAME} eq 'Cross Ref. Class') or ($cccn->{NAME} eq 'Field of Search'))) {
                  $item = $cccn->{TEXT};
                  if ($fterm_to_check eq '999') {
                    $item =~ /([0-9][0-9][0-9])([0-9][0-9][0-9])/;
                    $pc = $1;
                    $companies{$pc}++; # this is needed ...
                    $idx = $year . '_' . $pc;
                    if ($unique == 2) {
                      $count2{$idx}++;
                    }
                    if ($unique == 0) {
                      $count{$idx}++;
                    } elsif (not defined($person{$idx . $name})) {
                      $person{$idx . $name}++;
                      $count{$idx}++;
                    }
                    last;
                  } else {
                    $item =~ s/[ ]*$//;
                    $item =~ /([0-9][0-9][0-9])([0-9][0-9][0-9])([0-9A-Z]*)/;
                    $pc = $1;
                    $pc2 = $2;
                    $added_pc2 = $3;
                    $pc =~ s/^[0]+//; # this may be hack ...
                    $pc2 =~ s/^[0]+//; # this may be hack ...
                    $added_pc2 =~ s/[0]+$//; # this may be hack ...
                    if (length($added_pc2) != 0) {
                      if ($added_pc2 =~ /^[0]+([A-Z]+)$/) {
                        $pc2 .= $1;
                      } elsif ($added_pc2 =~ /[A-Z]+/) {
                        $pc2 .= $added_pc2;
                      } else {
                        $pc2 .= '.' . $added_pc2;
                      }
                    }
                    if ($pc == $fterm_to_check) {
                      $companies{$pc2}++; # not actually
                      $idx = $year . '_' . $pc2;
                      if ($unique == 2) {
                        $count2{$idx}++;
                      }
                      if ($unique == 0) {
                        $count{$idx}++;
                      } elsif (not defined($person{$idx . $name})) {
                        $person{$idx . $name}++;
                        $count{$idx}++;
                      }
                      last;
                    }
                    if ($include_subclasses != 1) {
                      last;
                    }
                  }
                }
                if (not defined($cccn->{NEXT})) {
                  last;
                }
                $cccn = $cccn->{NEXT};
              }
            }
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
      } elsif (($is_US == 0) and ($cn->{NAME} eq 's')) {
        ($company, $name, $patent_num, $patent_name, $file, $id) = split(/\t/, $text);
        my $ccn = $cn->{CHILD};
        while (1) {
          if ((($ccn->{NAME} eq 'o') or ($ccn->{NAME} eq '\'))) { # not defined($year) and (($ccn->{NAME} eq 'o') or ($ccn->{NAME} eq 'D'))
            $ccn->{TEXT} =~ /i((?:O|P|Q|R|S|T|U|V|W|X)+)/;
            $year = &zen2han($1);
            $years{$year}++;
            if (length($fterm_to_check) == 0) {
              $companies{$company}++;
              $idx = $year . '_' . $company;
              if ($unique == 2) {
                $count2{$idx}++;
              }
              if ($unique == 0) {
                $count{$idx}++;
              } elsif (not defined($person{$idx . $name})) {
                $person{$idx . $name}++;
                $count{$idx}++;
              }
            }
          }
          if (length($fterm_to_check) != 0) {
            if ($ccn->{NAME} =~ /^(|㗝l|ol||lĎ|Ql)/) {
              my $cccn = $ccn->{CHILD};
              $found_fterm = '';
              $found_fterm2 = '';
              while (1) {
                if ($cccn->{NAME} eq 'e^[iQlj') { # also see this ...
                  $found_fterm = $cccn->{TEXT};
                } elsif ($cccn->{NAME} eq 'e^[ieiXj') { # this is default ...
                  $found_fterm2 = $cccn->{TEXT};
                }
                if (not defined($cccn->{NEXT})) {
                  last;
                }
                $cccn = $cccn->{NEXT};
              }
              if (length($found_fterm2) != 0) {
                $found_fterm = $found_fterm2;
              }
              if (length($found_fterm) != 0) {
                @items = split(/\t/, $found_fterm);
                my $cnt = 0;
                $matched = 0;
                if ($fterm_to_check eq '999') {
                  %fterms = ();
                  foreach $item (@items) {
                    if ($cnt % 2 == 0) {
                      $fterms{$item}++;
                    }
                    $cnt++;
                  }
                  foreach $fterm (keys %fterms) {
                    $companies{$fterm}++;
                    $idx = $year . '_' . $fterm;
                    if ($unique == 2) {
                      $count2{$idx}++;
                    }
                    if ($unique == 0) {
                      $count{$idx}++;
                    } elsif (not defined($person{$idx . $name})) {
                      $person{$idx . $name}++;
                      $count{$idx}++;
                    }
                  }
                } else {
                  foreach $item (@items) {
                    if ($cnt % 2 == 0) {
                      if ($item =~ /^$fterm_to_check/) {
                        $matched = 1;
                      }
                    } elsif ($matched == 1) {
                      @fsubterms = split(/[ ]+/, $item);
                      foreach $fsubterm (@fsubterms) {
                        $companies{$fsubterm}++; # not actually
                        $idx = $year . '_' . $fsubterm;
                        if ($unique == 2) {
                          $count2{$idx}++;
                        }
                        if ($unique == 0) {
                          $count{$idx}++;
                        } elsif (not defined($person{$idx . $name})) {
                          $person{$idx . $name}++;
                          $count{$idx}++;
                        }
                      }
                      last;
                    }
                    $cnt++;
                  }
                }
              }
            }
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub zen2han {
  my($str) = @_;
  $str =~ s/O/0/g;
  $str =~ s/P/1/g;
  $str =~ s/Q/2/g;
  $str =~ s/R/3/g;
  $str =~ s/S/4/g;
  $str =~ s/T/5/g;
  $str =~ s/U/6/g;
  $str =~ s/V/7/g;
  $str =~ s/W/8/g;
  $str =~ s/X/9/g;
  return $str;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
