# File: HtmlReader2Outline_Perl.pl
# Date            Author        number of nodes
# 2003/10/7       Walking Lint  537
# 2003/10/7       Walking Lint  537 (HtmlReader_Perl->HtmlReader2Outline_Perl)
# 2003/10/7       Walking Lint  537
# 2003/10/3       Walking@Lint 536
# 2003/9/27       Walking@Lint 520
# 2003/9/26       Walking Lint  511
# 2003/9/10       Walking Lint  505
# 2003/8/28       Walking Lint  472
# 2003/6/9        Walking Lint  469
# 2003/5/17       Walking Lint  494
# 2003/4/15       Walking Lint  488
# 2003/4/15       Walking Lint  464 (JavaScriptReader_Perl->HtmlReader_Perl)
# 2003/3/20       Walking Lint  464
# 2003/3/19       Walking Lint  397
# 2003/3/18       Walking Lint  341
# 2003/3/14       Walking Lint  358 (JavaReader_Perl->JavaScriptReader_Perl)
# 2003/3/13       Walking Lint  353 (PerlReader_Perl->JavaReader_Perl)
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

HtmlReader2Outline_Perl.pl - html reader (suited to re-generate outline from generated html ^^)

=head1 DESCRIPTION

activate as plug-in or filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$crlf = ' CR' . 'LF ';
@langelements = ('begin', 'break', 'case', 'default', 'else', 'exit', 'for', 'if', 'import', 'next', 'switch', 'when');
$subdef = 'function';
$comment = '<!--';
$comment2 = '-->';
$comment_start = '\/\*';
$comment_end = '\*\/';
$in_comment = 0;
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.html';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
$found_div_ref = 0;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("input line = $linewithoutindent");
  if ($linewithoutindent eq $comment) {
    $name = '_';
    $indentedcomment = '';
    DebugPrint("comment");
    return 0;
  }
  $comment_part = '';
  if (not ($line =~ /!DOCTYPE/)) { # this is hack ...
    $line =~ s/($comment.*)$//; # this is hack ...
    if (defined($1)) {
      $comment_part = $1;
    }
  }
  $line =~ /^([\t ]*)(.*)/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  DebugPrint("level = $level");
  $argline = '';
  if (length($comment_part) != 0) {
    $text = $comment_part;
    $indentedcomment = $text;
    $indentedcomment =~ s/^$comment(?:$crlf|[ \t]*)//;
    $text =~ s/^$comment(?:$crlf|[ \t]*)//;
    if (length($linewithoutindentandcomment) == 0) {
      $name = '_';
      $text =~ s/($crlf|[ \t]*)(\/\/)?$comment2[ \t]*$//;
      DebugPrint("comment " . $text);
      return 0;
    }
  }
  $name =~ s/[ \t]+$//;
  $name =~ s/^[ \t]*\}[ \t]*//;
  if ($name =~ /[ \t]*{[ \t]*$/) {
    $name =~ s/[ \t]*\{[ \t]*$//;
  }
  DebugPrint("name = [" . $name . "] text = [" . $text . "]");
  if (($name eq 'end') or (length($name) == 0)) { # end or } ... } is already deleted ...
    return 1; # skip this line ... think later ...
  } elsif ($name =~ /$comment_start([^*]*)$comment_end/) { # comment started and ended
    $name = '_';
    DebugPrint("comment started and ended");
    $text = $1;
    $indentedcomment = $text; # this is key
    if (length($text) == 0) {
      return 1; # skip ...
    }
  } elsif ($name =~ /$comment_start([^*]*)/) { # comment started
    $name = '_';
    DebugPrint("comment started");
    $text = $1;
    $indentedcomment = $text; # this is key
    $in_comment = 1;
    if (length($text) == 0) {
      return 1; # skip ...
    }
  } elsif ($in_comment) { # this is hack ...
    if ($name =~ /([^*]*)$comment_end/) { # comment ended
      $name = '_';
      DebugPrint("comment ended");
      $text = $1;
      $indentedcomment = $text; # this is key
      $in_comment = 0;
      if (length($text) == 0) {
        return 1; # skip ...
      }
    } else {
      $text = $name; # hack ...
      $text =~ s/^\*\*[ \t]+//; # hack ...
      $indentedcomment = $text; # this is key
      $name = '_';
      DebugPrint("comment continued");
    }
  } elsif ($name =~ /^<!DOCTYPE[ \t]+(.*)$/) { # !DOCTYPE decl
    $name = '!DOCTYPE';
    DebugPrint("!DOCTYPE decl");
    $type = $1;
    $type =~ s/[ \t]*>[ \t]*$//;
  } elsif ($name =~ /^$comment(?:$crlf|[ \t]*)(.*)$/) { # comment
    $name = '_';
    $text = $1;
    $text =~ s/($crlf|[ \t]*)(\/\/)?$comment2[ \t]*$//;
    DebugPrint("comment2 " . $text);
  } elsif ($name =~ /^<([a-zA-Z0-9_\-]+)>(?:$crlf)?(.*)$/) { # open tag without attribute not actually ...
    $name = $1;
    $name =~ tr/A-Z/a-z/;
    DebugPrint("open tag without attribute");
    $text = $2;
    $text =~ s/[ \t]*(<\/[a-zA-Z0-9_\-]+>[ \t]*)+$//; # not actually ...
    if ($name eq 'p') {
      $name = _text;
      if (length($text) != 0) { # this is hack ... think later ...
        $text =~ s/^[ ]+//;
        $text = $crlf . $text;
      } else {
        $text = '';
      }
    } elsif (($name eq 'b') or ($name eq 'br')) {
      $name = _text;
      $text = $linewithoutindent;
    } elsif ($name eq 'h4') { # this is also hack ... think ...
      $name = $text;
      $text = '';
    }
  } elsif ($name =~ /^<([^ \t>]+)[ \t]+([^>]+)>(?:$crlf)?(.*)$/) { # open tag with attributes not actually ...
    $name = $1;
    $name =~ tr/A-Z/a-z/; # I'd like to change attribute name to lower case also ... but how ...
    DebugPrint("open tag with attributes2");
    $type = $2;
    $text = $3;
    if ($name eq 'a') {
      $name = _text;
      $text = $linewithoutindent;
    } elsif (($name eq 'div') and ($type eq 'class="ref"')) { # this is assumed for ref ...
      $name = '_text';
      $text = $linewithoutindent;
      $found_div_ref = 1;
    } else {
      $text =~ s/[ \t]*(<\/[a-zA-Z0-9_\-]+>[ \t]*)+$//; # not actually ...
    }
  } elsif ($name =~ /^$subdef[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([\t ]*(.*)[\t ]*\)$/) { # func def with arg
    $name = $1;
    DebugPrint("funcdef with arg - $name");
    $argline = $2;
  } elsif ($name =~ /^$subdef[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([\t ]*\)$/) { # func def with arg
    $name = $1;
    DebugPrint("funcdef without arg - $name");
  } elsif ($name =~ /^(var)[ \t]+((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]|,[\t ]*)+)[\t ]*=[\t ]*([^;]+);?$/) { # decl and assignment
    $name = $2;
    DebugPrint("my decl and assignment - $name");
    $kind = ' (out) ';
    $type = $1 . '  ' . $3;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>\*\:]|,[\t ]*)+)[\t ]*=[\t ]*$/) { # incomplete assignment
    $name = $1;
    DebugPrint("incomplete assignment - $name");
    $kind = ' (out) ';
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>\*\:]|,[\t ]*)+)[\t ]*=[\t ]*([^;]+);?$/) { # assignment
    $name = $1;
    DebugPrint("assignment - $name");
    $kind = ' (out) ';
    $type = '  ' . $2;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]|,[\t ]*)+)[\t ]*([\+\-\*\/\.]=)[\t ]*(.+);?$/) { # inout pattern1
    $name = $1;
    DebugPrint("inout pattern1 - $name");
    $kind = ' (inout) ';
    $type = $2 . '  ' . $3;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]|,[\t ]*)+)[\t ]*(=~)[\t ]*(.+);?$/) { # inout pattern2
    $name = $1;
    DebugPrint("inout pattern2 - $name");
    $kind = ' (inout) ';
    $type = $2 . '  ' . $3;
  } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([a-zA-Z0-9_\$\@\[\]\{\}\.\'\"\(\)]+)[\t ]*\{[\t ]*(.*);?$/)) { # block ... think later ... this is hack
    $name = $1;
    DebugPrint("block - $name");
    $kind .= '~ '; # may not be good ...
    $argline = $2;
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\..+);?$/) { # method
    $name = '->' . $1;
    DebugPrint("-> method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\..+);?$/) { # method
    $name = $1;
    DebugPrint("method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)\([\t ]*(.*)[\t ]*\);?$/) { # static func call with param
    $name = '->' . $1;
    DebugPrint("static -> func call - $name");
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)\([\t ]*(.*)[\t ]*\);?$/) { # static func call with param
    $name = $1;
    DebugPrint("static func call - $name");
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)\([\t ]*(.*)[\t ]*\)[\t ]+if[\t ]+(.*);?$/) { # static func call with if ... think later ...
    $name = $1;
    DebugPrint("static func call with if - $name");
    $type = $2 . ' if ' . $3;
  } elsif (($name =~ /^(var)[\t ]+([^;]+);?$/)) { # my decl
    $name = $2;
    DebugPrint("my decl - $name");
    $kind = ' (out) ';
    $type = $1;
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@]+)[\t ]+([^;]+);$/) and &islangelement($1)) { # control statement with param in one line ...
    $name = $1;
    DebugPrint("control statement with param in one line - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    ($cond, $stmt) = &getcondandstmt($type);
    DebugPrint("cond = $cond");
    DebugPrint("stmt = $stmt");
    $type = $cond . '  ' . $stmt;
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@]+)[\t ]+(.+)$/) and &islangelement($1)) { # control statement with param ...
    $name = $1;
    DebugPrint("control statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    $type =~ s/^\((.*)\)$/$1/;
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@\:]+)[\t ]+([^;]+);?$/)) { # and &islangelement($1) %% control statement with param (not actually ...)
    $name = $1;
    DebugPrint("statement with param - $name");
    $type = $2;
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@\-\>\:]+);?$/)) { # and &islangelement($1) %% control statement (not actually ...)
    $name = $1;
    DebugPrint("control statement - $name");
  } elsif (length($text) != 0) { # not sure but ...
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  } else {
    if ($found_div_ref and ($name eq '</div>')) {
      $text = $name;
      $name = '_text';
      $found_div_ref = 0;
    } else {
      return 1;
    }
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  # try here filtering ...
  $breaklater = 0;
  while (<$infilehandle>) {
    if ($_ =~ /^__EOF__[\n\r]*$/) {
      last;
    } elsif ($_ =~ /__EOF__[\n\r]*$/) {
      $_ =~ s/__EOF__[\n\r]*$//;
      $breaklater = 1;
    }
    push @lines, $_;
    if ($breaklater) {
      last;
    }
  }
  @processed_lines = ();
  $tmp_line = '';
  foreach $line (@lines) {
    # better to change a ref to URL ref - this is hack ...
    if ($line =~ /^<a href="([^"]*)">([^<]*)<\/a>$/) {
      $line = '[[' . $2 . '!' . $1 . ']]' . "\n";
    }
    if (not ($line =~ /^[ \t]*</)) { # concatenate this case ... think later ...
      chop $tmp_line;
      $tmp_line =~ s/[ \t]*$/ /;
      $line =~ s/^[ \t]*//;
      $tmp_line .= ' ' . $line;
    } else {
      push @processed_lines, $tmp_line;
      $tmp_line = $line;
    }
  }
  if (length($tmp_line)) {
    push @processed_lines, $tmp_line;
  }
  foreach (@processed_lines) {
    $_ =~ s/($crlf)+$//;
    $_ =~ s/[\n\t ]+$//;
    if ((length($_) != 0)) {
      if (&extractparams($_)) {
        $prevname = '';
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        DebugPrint("** 1 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        DebugPrint("** 2 prevlevel = $prevlevel level = $level cur = $cur->{NAME} name=$name prevname=$prevname");
        if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
            $previndentedcomment = '';
          }
        } elsif (($name eq '_text') and (($prevname eq '_text') or (length($prevname) == 0))) { # ($cur->{NAME} eq '_text') ... hack? ...
          $cur->{TEXT} .= " \CRLF " . $text;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      } else {
        DebugPrint("** 3 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        until ($prevlevel <= $level) {
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevname = $name;
      $previndentedcomment = $indentedcomment;
      $prevlevel = $level;
      my $argkind = " \(in\) \& ";
      if ($kind =~ /~/) {
        if ($name =~ /\(([^\)]+)\)$/) {
          $name =~ s/[\t ]*\(([^\)]+)\)$//;
          $cur->{NAME} = $name;
          $argline2 = $1;
          my @args2 = reverse split(/[\t ]*,[\t ]*/, $argline2);
          foreach $arg (@args2) {
            if ($arg =~ /=/) {
              $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
              &addchildnode($cur, $1, $argkind, '  ' . $2, '');
            } else {
              &addchildnode($cur, $arg, $argkind, '', '');
            }
          }
        }
      }
      if (length($argline) != 0) {
        if ($argline =~ /\|[\t ]*([^\|]+)\|[\t ]*(.*)/) { # this is block arg
          $argline = $1;
          $body = $2;
          $body =~ s/[\t ]*}$//;
          $argline =~ s/[\t ]*$//;
          $argkind .= '~ ';
        }
        my @args = split(/[\t ]*,[\t ]*/, $argline);
        foreach $arg (@args) {
          if ($arg =~ /=/) {
            $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
            &addchildnode($cur, $1, $argkind, '  ' . $2, '');
          } else {
            &addchildnode($cur, $arg, $argkind, '', '');
          }
        }
        if (length($body) != 0) {
          &extractparams($body);
          &addchildnode($cur, $name, $kind, $type, $text);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub getcondandstmt {
  my($str) = @_;
  @chars = split(//, $str);
  $pre = '';
  $post = '';
  $level = 0;
  foreach $char (@chars) {
    if ($char eq '(') {
      $level++;
      if ($level > 1) {
        $pre .= $char;
      }
    } elsif ($char eq ')') {
      $level--;
      if ($level == 0) {
        last;
      } else {
        $pre .= $char;
      }
    } else {
      $pre .= $char;
    }
  }
  $post = substr($str, length($pre) + 2);
  return ($pre, $post);
}
sub islangelement {
  my($str) = @_;
  foreach $langelement (@langelements) {
    if ($str eq $langelement) {
      return 1;
    }
  }
  return 0;
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      @newlines = ();
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
