# File: HtmlReader_Perl.pl
# Date            Author        number of nodes
# 2004/6/25       Walking Lint  927
# 2004/6/23       Walking Lint  910
# 2004/3/19       Walking Lint  905
# 2004/3/18       Walking Lint  887
# 2004/3/17       Walking Lint  662
# 2004/3/16       Walking Lint  642
# 2003/10/7       Walking Lint  574
# 2003/10/3       Walking@Lint 536
# 2003/9/27       Walking@Lint 520
# 2003/9/26       Walking Lint  511
# 2003/9/10       Walking Lint  505
# 2003/8/28       Walking Lint  472
# 2003/6/9        Walking Lint  469
# 2003/5/17       Walking Lint  494
# 2003/4/15       Walking Lint  488
# 2003/4/15       Walking Lint  464 (JavaScriptReader_Perl->HtmlReader_Perl)
# 2003/3/20       Walking Lint  464
# 2003/3/19       Walking Lint  397
# 2003/3/18       Walking Lint  341
# 2003/3/14       Walking Lint  358 (JavaReader_Perl->JavaScriptReader_Perl)
# 2003/3/13       Walking Lint  353 (PerlReader_Perl->JavaReader_Perl)
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

HtmlReader_Perl.pl - html reader

=head1 DESCRIPTION

activate as plug-in or filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$force2lower = shift;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$crlf = ' CR' . 'LF ';
@langelements = ('begin', 'break', 'case', 'default', 'else', 'exit', 'for', 'foreach', 'if', 'import', 'next', 'switch', 'when', 'while');
$parenpattern = '\([\t ]*((?:[^\(\)]|\((?:[^\(\)]|\([^\)]*\))*\))*)[\t ]*\)';
$parenpatternwithoutmatch = '\([\t ]*(?:(?:[^\(\)]|\((?:[^\(\)]|\([^\)]*\))*\))*)[\t ]*\)';
$bracepattern = '\{[\t ]*((?:(?:[^\{\}]|\{[^\}]*\})*|))[\t ]*\}';
$condpattern = '(?:elsif|if|for|for[ \t]+(?:my[ \t]+)?\$[a-zA-Z_0-9]+|unless|until|while|function[ \t]+[a-zA-Z_0-9]+)';
$condpattern2 = '(?:else|function[ \t]+[a-zA-Z_0-9]+)';
$lefthand = '((?:[a-zA-Z_\$\@\%\[\]\{\}\.\: \-\*\+\/\&]|,|->|[\t ]|\([\t ]*(?:(?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\))(?:[a-zA-Z0-9_\$\@\%\[\]\{\}\.\: \-\*\+\/\&]|,|->|[\t ]|\([\t ]*(?:(?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\))*|\$[\|\~|_])';
$continuationpattern = '(\|\||\&\&|,|=|\+|\*|\(|\[|\?|=>?[ \t]*\{)[ \t]*'; # end of prev line
$continuationpattern2 = '[ \t]*(\.|\|\||\&\&|->|\+[^\+]|\/[^\/\*]|\)|\]|\{|FROM |WHERE |AND |or )'; # start of next line
$subdef = '(?:function|sub)';
$comment = '<!--';
$comment2 = '-->';
$comment_start = '\/\*(?:[\* ]*)?';
$comment_end = '\*\/';
$end_of_multiline_string = 'EOL';
$in_comment = 0;
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.html';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
$found_div_ref = 0;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $separate_text = 0;
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("input line = $linewithoutindent");
  if ($linewithoutindent eq $comment) {
    $name = '_';
    $indentedcomment = '';
    DebugPrint("comment");
    return 0;
  }
  $comment_part = '';
  if (not ($line =~ /!DOCTYPE/)) { # this is hack ...
    $line =~ s/($comment.*)$//; # this is hack ...
    if (defined($1)) {
      $comment_part = $1;
    }
  }
  $line =~ /^([\t ]*)(.*)/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  DebugPrint("level = $level");
  $argline = '';
  if (length($comment_part) != 0) {
    $text = $comment_part;
    $indentedcomment = $text;
    $indentedcomment =~ s/^$comment(?:$crlf|[ \t]*)//;
    $indentedcomment =~ s/[ \t]*$comment2(?:$crlf|[ \t]*)$//;
    $text =~ s/^$comment(?:$crlf|[ \t]*)//;
    $text =~ s/[ \t]*$comment2(?:$crlf|[ \t]*)$//;
    if (length($linewithoutindentandcomment) == 0) {
      $name = '_';
      $text =~ s/($crlf|[ \t]*)(\/\/|\#)?$comment2[ \t]*$//;
      DebugPrint("comment " . $text);
      return 0;
    }
  }
  $name =~ s/[ \t]+$//;
  $name =~ s/^[ \t]*\}[ \t]*//;
  if ($name =~ /[ \t]*{[ \t]*$/) {
    $name =~ s/[ \t]*\{[ \t]*$//;
  }
  DebugPrint("name = [" . $name . "] text = [" . $text . "]");
  # process php here ... try this ...
  if ($in_php or $in_javascript) {
    if ($in_comment) { # this is hack ...
      if ($name =~ /([^*]*)$comment_end/) { # comment ended ... not actually ... think later ...
        DebugPrint("comment ended");
        $text = $1;
        $name = '_';
        $indentedcomment = $text; # this is key
        $in_comment = 0;
        if (length($text) == 0) {
          return 1; # skip ...
        }
      } else {
        DebugPrint("comment continued");
        $text = $name; # hack ...
        $name = '_';
        $text =~ s/^\**[ \t]+//; # hack ...
        $indentedcomment = $text; # this is key
      }
      return 0;
    }
    if ($name =~ /^[ \t]*\?>[ \t]*$/) {
      $in_php = 0;
      DebugPrint("in_php1");
      return 1;
    } elsif ($name =~ /<\/script>/) {
      $in_javascript = 0;
      DebugPrint("in_php2");
      return 1;
    } else {
      if ($name =~ /^[ \t]*(?:\/\/|\#)(.*)$/) { # comment
        $text = $1;
        $name = '_';
        if (($text =~ /^\/+[ \t]*$/) or ($text =~ /^\#+[ \t]*$/)) {
          DebugPrint("comment1 " . $text);
          $text = '';
        } else {
          DebugPrint("comment2 " . $text);
        }
        $indentedcomment = $text;
        return 0;
      } elsif ($name =~ /^[ \t]*$comment_start([^*]*)$comment_end[ \t]*$/) { # comment started and ended
        DebugPrint("comment started and ended 1");
        $text = $1;
        $name = '_';
        $indentedcomment = $text; # this is key
        if (length($text) == 0) {
          return 1; # skip ...
        }
        return 0;
      } elsif ($name =~ /^[ \t]*$comment_start([^*]*)/) { # comment started
        DebugPrint("comment started 1");
        $text = $1;
        $name = '_';
        $indentedcomment = $text; # this is key
        $in_comment = 1;
        if (length($text) == 0) {
          return 1; # skip ...
        }
        return 0;
      } elsif ($name =~ /(?:;|{)[ \t]*\#(.*)$/) { # comment
        $text = $1;
        $name =~ s/[ \t]*\#(.*)$//;
        DebugPrint("comment0-1 " . $text);
      } elsif ($name =~ /(?:;|{)[ \t]*\/\/(.*)$/) { # comment
        $text = $1;
        $name =~ s/[ \t]*\/\/(.*)$//;
        DebugPrint("comment0-2 " . $text);
      } elsif ($name =~ /$comment_start([^*]*)$comment_end/) { # comment started and ended
        DebugPrint("comment started and ended 2");
        $text = $1;
        $name =~ s/$comment_start([^*]*)$comment_end//;
        DebugPrint("name = $name");
      } elsif ($name =~ /$comment_start([^*]*)/) { # comment started
        DebugPrint("comment started 2");
        $text = $1;
        $name =~ s/$comment_start([^*]*)//;
        DebugPrint("name = $name");
        $in_comment = 1;
      }
      if ($name =~ /^$subdef[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([\t ]*(.*)[\t ]*\)$/i) { # func def with arg
        $name = $1;
        DebugPrint("funcdef with arg - $name");
        $argline = $2;
        DebugPrint("argline = $argline");
      } elsif ($name =~ /^$subdef[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([\t ]*\)$/i) { # func def with arg
        $name = $1;
        DebugPrint("funcdef without arg - $name");
      } elsif ($name =~ /^class[\t ]+(.+)/) { # class def
        $name = $1;
        DebugPrint("class def - $name");
        $kind = ' () + ';
        if ($name =~ /[ \t]+extends[ \t]+(.*)$/) {
          $type = '  ' . $1;
          $name =~ s/[ \t]+extends[ \t]+(.*)$//;
        }
      } elsif ($name =~ /^(var|global)[ \t]+((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]|,[\t ]*)+)[\t ]*=[\t ]*([^;]+);?$/) { # decl and assignment
        $name = $2;
        DebugPrint("my decl and assignment - $name");
        $kind = ' (out) ';
        $type = $1 . '  ' . $3;
      } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>\*\:]|,[\t ]*)+)[\t ]*=[\t ]*$/) { # incomplete assignment
        $name = $1;
        DebugPrint("incomplete assignment - $name");
        $kind = ' (out) ';
      } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]|,[\t ]*)+)[\t ]*([\+\-\*\/\.]=)[\t ]*([^;]+);?$/) { # inout pattern1
        $name = $1;
        DebugPrint("inout pattern1 - $name");
        $kind = ' (inout) ';
        $type = $2;
        DebugPrint("type = $type");
        $ini = $3;
        DebugPrint("ini = $ini");
        if ($ini =~ /^<<<(?:'|")?([^<'"]+)(?:'|")?$/) {
          $in_here_doc = 1;
          $end_of_here_doc = $1;
          DebugPrint("end_of_here_doc = " . $end_of_here_doc);
        } elsif ($ini =~ /^"((?:\\"|[^"])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $multiline_kind = '"';
        } elsif ($ini =~ /^'((?:\\'|[^'])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $multiline_kind = "'";
        } else {
          $type = $type . ' ' . $ini;
        }
      } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]|,[\t ]*)+)[\t ]*(=~)[\t ]*([^;]+);?$/) { # inout pattern2
        $name = $1;
        DebugPrint("inout pattern2 - $name");
        $kind = ' (inout) ';
        $type = $2;
        DebugPrint("type = $type");
        $ini = $3;
        DebugPrint("ini = $ini");
        if ($ini =~ /^<<<(?:'|")?([^<'"]+)(?:'|")?$/) {
          $in_here_doc = 1;
          $end_of_here_doc = $1;
          DebugPrint("end_of_here_doc = " . $end_of_here_doc);
        } elsif ($ini =~ /^"((?:\\"|[^"])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $multiline_kind = '"';
        } elsif ($ini =~ /^'((?:\\'|[^'])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $multiline_kind = "'";
        } else {
          $type = $type . '  ' . $ini;
        }
      } elsif (($name =~ /^([0-9a-zA-Z_\$\@]+)[\t ]*([^;]+);$/) and &islangelement($1)) { # control statement with param in one line ...
        $name = $1;
        DebugPrint("control statement with param in one line - $name");
        $type = $2;
        $type =~ s/[ \t]*{[ \t]*$//;
        $name =~ tr/A-Z/a-z/;
        ($cond, $stmt) = &getcondandstmt($type);
        DebugPrint("cond = $cond");
        DebugPrint("stmt = $stmt");
        $type = $cond . '  ' . $stmt;
      } elsif (($name =~ /^([0-9a-zA-Z_\$\@]+)[\t ]*([^;]+);?$/) and &islangelement($1)) { # control statement with param ...
        $name = $1;
        DebugPrint("control statement with param - $name");
        $type = $2;
        $type =~ s/[ \t]+then[ \t]*$//i;
        DebugPrint("type = $type");
        $type =~ s/[ \t]*{[ \t]*$//;
        $name =~ tr/A-Z/a-z/;
        if (($name eq 'else') and ($type =~ /^if[ \t]+/)) {
          $type =~ s/^if[ \t]+//;
          $name = 'elsif';
        } elsif ($name eq 'default') {
          $type =~ s/^[ \t]*://;
        } elsif ($name eq 'case') {
          $type =~ s/:[ \t]*$//;
        }
        $type =~ s/^\((.*)\)$/$1/;
      } elsif ($name =~ /^$lefthand[\t ]*=[\t ]*(.*);?$/) { # assignment ... try this ...
        $name = $1;
        $ini = $2;
        DebugPrint("assignment - $name");
        $kind = ' (out) ';
        $name =~ s/[ \t]+$//;
        $ini =~ s/[ \t]*;[ \t]*$//;
        DebugPrint("ini = $ini");
        if ($ini =~ /^<<<(?:'|")?([^<'"]+)(?:'|")?$/) {
          $in_here_doc = 1;
          $end_of_here_doc = $1;
          DebugPrint("end_of_here_doc = " . $end_of_here_doc);
        } elsif ($ini =~ /^"((?:\\"|[^"])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $multiline_kind = '"';
          DebugPrint("beginning of multiline string 1");
        } elsif ($ini =~ /^'((?:\\'|[^'])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $multiline_kind = "'";
          DebugPrint("beginning of multiline string 2");
        } else {
          $type = '  ' . $ini;
        }
      } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([a-zA-Z0-9_\$\@\[\]\{\}\.\'\"\(\)]+)[\t ]*\{[\t ]*([^;]+);?$/)) { # block ... think later ... this is hack
        $name = $1;
        DebugPrint("block - $name");
        $kind .= '~ '; # may not be good ...
        $argline = $2;
      } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\.[^;]+);?$/) { # method
        $name = '->' . $1;
        DebugPrint("-> method - $name");
        $kind = ' (out) ';
        $type = $2;
      } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\-\>]+)(\.[^;]+);?$/) { # method
        $name = $1;
        DebugPrint("method - $name");
        $kind = ' (out) ';
        $type = $2;
      } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([\t ]*(.*)[\t ]*\);?$/) { # static func call with param
        $name = '->' . $1;
        DebugPrint("static -> func call - $name");
        $type = $2;
      } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.\-\>]+)[ \t]*\([\t ]*(.*)[\t ]*\);?$/) { # static func call with param
        $name = $1;
        DebugPrint("static func call with param - $name");
        $type = $2;
      } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([\t ]*(.*)[\t ]*\)[\t ]+if[\t ]+([^;]+);?$/) { # static func call with if ... think later ...
        $name = $1;
        DebugPrint("static func call with if - $name");
        $type = $2 . ' if ' . $3;
      } elsif (($name =~ /^(var)[\t ]+([^;]+);?$/)) { # my decl
        $name = $2;
        DebugPrint("my decl - $name");
        $kind = ' (out) ';
        $type = $1;
      } elsif (($name =~ /^([0-9a-zA-Z_\$\@\:]+)((?:[\t ]+[^;]+|[ \t ]*['"][^;]*));?$/)) { # and &islangelement($1) %% control statement with param (not actually ...)
        $name = $1;
        $type = $2;
        $type =~ s/^[ \t]+//;
        $type =~ s/[ \t]+$//;
        if ($name =~ /end/i) {
          DebugPrint("end");
          return 1;
        }
        DebugPrint("statement with param - $name");
        DebugPrint("type = $type");
        if ($type =~ /<<<(?:'|")?([^<'"]+)(?:'|")?$/) { # this must be also for data ...
          $in_here_doc = 1;
          $end_of_here_doc = $1;
          DebugPrint("end_of_here_doc = " . $end_of_here_doc);
          $type =~ s/\<\<\<$end_of_here_doc$//;
          DebugPrint("type = " . $type);
        } elsif ($type =~ /^"((?:\\"|[^"])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $type = '';
          $multiline_kind = '"';
        } elsif ($type =~ /^'((?:\\'|[^'])*)$/) {
          $in_multiline_string = 1;
          $multiline_string = $1;
          $type = '';
          $multiline_kind = "'";
        }
      } elsif (($name =~ /^([0-9a-zA-Z_\$\@\-\>\:]+);?$/)) { # and &islangelement($1) %% control statement (not actually ...)
        $name = $1;
        DebugPrint("name = $name");
        if (&islangelement($name)) {
          $name =~ tr/A-Z/a-z/;
          DebugPrint("name = $name");
        } elsif ($name eq '-->') {
          DebugPrint("-->");
          return 1;
        }
        DebugPrint("control statement - $name");
      } elsif (length($text) != 0) { # not sure but ...
        $name = '_text';
        $text = $linewithoutindent;
        DebugPrint("not supported yet - $text");
      } else {
        DebugPrint("in_php not matched ...");
        if ($found_div_ref and ($name eq '</div>')) {
          $text = $name;
          $name = '_text';
          $found_div_ref = 0;
        } else {
          return 1;
        }
      }
      return 0;
    }
  } else {
    if ($name =~ /^<\?/) {
      $in_php = 1;
      $name = '?';
      return 0;
    } else {
      if (($name eq 'end') or (length($name) == 0)) { # end or } ... } is already deleted ...
        return 1; # skip this line ... think later ...
      } elsif ($name =~ /^<!DOCTYPE[ \t]+(.*)$/) { # !DOCTYPE decl
        $name = '!DOCTYPE';
        DebugPrint("!DOCTYPE decl");
        $type = $1;
        $type =~ s/[ \t]*>[ \t]*$//;
      } elsif ($name =~ /^$comment(?:$crlf|[ \t]*)(.*)$/) { # comment
        $name = '_';
        $text = $1;
        $text =~ s/($crlf|[ \t]*)(\/\/)?$comment2[ \t]*$//;
        DebugPrint("comment2 " . $text);
      } elsif ($name =~ /^<([a-zA-Z0-9_\-]+?)>(?:$crlf)?(.*)$/) { # open tag without attribute not actually ...
        $name = $1;
        if ($force2lower) {
          $name =~ tr/A-Z/a-z/;
        }
        DebugPrint("open tag without attribute - $name");
        if ($name eq 'script') {
          $in_javascript = 1;
        }
        $text = $2;
        DebugPrint("text = " . $text);
        $text =~ /<\/([^>]+?)>[ \t]*$/;
        $endmatch = $1;
        DebugPrint("endmatch = " . $endmatch);
        if ((length($endmatch) != 0) and ($text =~ /<$endmatch/)) {
          # do nothing ...
          DebugPrint("here2");
        } elsif ($text =~ /<\/$name>[ \t]*$/) {
          $text =~ s/[ \t]*<\/$name>[ \t]*$//; # not actually ...
          DebugPrint("here1");
        } else {
          $text =~ s/[ \t]*(<\/[a-zA-Z0-9_\-]+>[ \t]*)+$//; # not actually ...
          DebugPrint("here3");
        }
      } elsif ($name =~ /^<\/([a-zA-Z0-9_\-]+)>(?:$crlf)?(.+)$/) { # close tag with text
        $name = '_text';
        DebugPrint("close tag with text");
        $text = $2;
        $text =~ s/[ \t]*(<\/[a-zA-Z0-9_\-]+>[ \t]*)+$//; # not actually ...
        $text =~ s/^[ \t]*//; # not actually ...
        $separate_text = 1;
      } elsif ($name =~ /^<([^ \t>]+)[ \t]+([^>]+)>(?:$crlf)?(.*)$/) { # open tag with attributes not actually ...
        $name = $1;
        if ($force2lower) {
          $name =~ tr/A-Z/a-z/;
        }
        DebugPrint("open tag with attributes2");
        if ($name eq 'script') {
          $in_javascript = 1;
        }
        $type = $2;
        $text = $3;
        $text =~ /<\/([^>]+?)>[ \t]*$/;
        $endmatch = $1;
        DebugPrint("endmatch = " . $endmatch);
        if ((length($endmatch) != 0) and ($text =~ /<$endmatch/)) {
          # do nothing ...
          DebugPrint("here2");
        } elsif ($text =~ /<\/$name>[ \t]*$/) {
          $text =~ s/[ \t]*<\/$name>[ \t]*$//; # not actually ...
          DebugPrint("here1");
        } else {
          $text =~ s/[ \t]*(<\/[a-zA-Z0-9_\-]+>[ \t]*)+$//; # not actually ...
          DebugPrint("here3");
        }
      } elsif (length($text) != 0) { # not sure but ...
        $name = '_text';
        $text = $linewithoutindent;
        DebugPrint("not supported yet - $text");
      } else {
        if ($found_div_ref and ($name eq '</div>')) {
          $text = $name;
          $name = '_text';
          $found_div_ref = 0;
        } else {
          return 1;
        }
      }
      return 0;
    }
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  # try here filtering ...
  while (<$infilehandle>) {
    push @lines, $_;
  }
  @lines1 = ();
  $tmp_line = '';
  $prev_is_continuation = 0;
  foreach $line (@lines) {
    $line =~ s/[ \t\n]+$//;
    $line =~ s/\t/        /g; # try this ...
    $line2 = $line;
    $line2 =~ s/[ \t]*#[^0-9a-fA-F][^#]*$//; # try this now ...
    if (length($line) == 0) {
      next;
    }
    if (($line eq $line2) and ($line =~ /$continuationpattern$/)) { # pattern to concatenate ...
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation or ($line =~ /^$continuationpattern2/)) {
          $line =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 1;
    } elsif (not ($line eq $line2) and ($line2 =~ /$continuationpattern$/)) { # pattern to concatenate ...
      $line2 =~ s/\\[ \t]*$/ /;
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation or ($line =~ /^$continuationpattern2/)) {
          $line2 =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line2;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line2;
        }
      } else {
        $tmp_line = $line2;
      }
      $prev_is_continuation = 1;
    } elsif ($line =~ /^$continuationpattern2/) {
      if (length($tmp_line) != 0) {
        $line =~ s/^[ \t]*/ /;
        $tmp_line = $tmp_line . $line;
      } else {
        $tmp_line = $line; # should not happen ...
      }
      $prev_is_continuation = 0;
    } else {
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 0;
    }
  }
  if (length($tmp_line) != 0) {
    push @lines1, $tmp_line;
  }
  @processed_lines = ();
  $tmp_line = '';
  $in_php = 0;
  $in_javascript = 0;
  foreach $line (@lines1) {
    $line =~ s/\t/        /g; # try this ...
    if ($in_php or $in_javascript) {
      # better to treat cntinuation case ???
      if ($line =~ /^[ \t]*\?>[ \t]*$/) { # not actually think later ...
        DebugPrint("line1-1 = $line");
        $in_php = 0;
        push @processed_lines, $tmp_line;
        $tmp_line = $line;
      } elsif ($line =~ /<\/script>/) { # not actually think later ...
        DebugPrint("line1-2 = $line");
        $in_javascript = 0;
        push @processed_lines, $tmp_line;
        $tmp_line = $line;
      } else {
        push @processed_lines, $tmp_line;
        if ($line =~ /^([ \t]*)($condpattern)[ \t]*$parenpattern[ \t]*$bracepattern[ \t]*(#.*)?$/i) { # pattern for line line control statement
          DebugPrint("line1-3 = $line");
          push @processed_lines, $1 . $2 . ' (' . $3 . ')' . '{' . $5;
          $indent = $1;
          $block = $4;
          @inner_statements = split(/[ \t]*;[ \t]*/, $block);
          for ($i = 0; $i <= $#inner_statements; $i++) {
            $inner_statement = $inner_statements[$i];
            $inner_statement =~ s/^[ \t]+//;
            push @processed_lines, $indent . '  ' . $inner_statement . ';'; # better ?
          }
          $tmp_line = '';
        } elsif ($line =~ /^([ \t]*)($condpattern2)[ \t]*$bracepattern[ \t]*(#.*)?$/i) { # pattern for line line control statement
          DebugPrint("line1-4 = $line");
          push @processed_lines, $1 . $2 . '{' . $4;
          $indent = $1;
          $block = $3;
          @inner_statements = split(/[ \t]*;[ \t]*/, $block);
          for ($i = 0; $i <= $#inner_statements; $i++) {
            $inner_statement = $inner_statements[$i];
            $inner_statement =~ s/^[ \t]+//;
            $inner_statement =~ s/[ \t]+$//;
            push @processed_lines, $indent . '  ' . $inner_statement . ';'; # better ?
          }
          $tmp_line = '';
        } elsif ((not $line =~ /^([ \t]*)(if|unless|while)/) and ($line =~ /^([ \t]*)([^#]+?)[ \t]+(or)[ \t]+(.+)$/)) { # pattern for or ... not actually ... ^^;
          DebugPrint("line1-5 = $line");
          push @processed_lines, $1 . $2;
          push @processed_lines, $1 . '  ' . $3 . ' ' . $4;
          $tmp_line = '';
        } elsif ($line =~ /^([ \t]*)($condpattern)[ \t]*$parenpattern[ \t]*([^;]+;)[ \t]*$/i) { # pattern for line line control statement
          DebugPrint("line1-6 = $line");
          push @processed_lines, $1 . $2 . ' (' . $3 . ')';
          push @processed_lines, $1 . '  ' . $4;
          $tmp_line = '';
        } elsif ($line =~ /^([ \t]*)($condpattern2)[ \t]*([^;]+;)[ \t]*(#.*)?$/i) { # pattern for line line control statement
          DebugPrint("line1-7 = $line");
          push @processed_lines, $1 . $2 . '{' . $4;
          push @processed_lines, $1 . '  ' . $3;
          $tmp_line = '';
        } elsif ((not $line =~ /^[ \t]*(for)[ \t\(]/) and ($line =~ /;[^;"]+;/)) { # this is hack ...
          DebugPrint("line1-8 = $line");
          $line =~ /^([ \t]*)/;
          $indent = $1;
          @inner_statements = split(/[ \t]*;[ \t]*/, $line);
          for ($i = 0; $i <= $#inner_statements - 1; $i++) { # - 1 is needed for \n
            $inner_statement = $inner_statements[$i];
            $inner_statement =~ s/^[ \t]+//;
            push @processed_lines, $indent . $inner_statement . ';'; # better ?
          }
          $tmp_line = '';
        } else {
          DebugPrint("line1-9 = $line");
          $tmp_line = $line;
        }
      }
    } else {
      if ($line =~ /[ \t]*<\?([^\?]*)\?>/) {
        DebugPrint("line2 = $line");
        push @processed_lines, $tmp_line;
        push @processed_lines, '<?';
        $stmt_line = $1;
        @stmts = split(/;/, $stmt_line);
        foreach $stmt (@stmts) {
          push @processed_lines, $stmt;
        }
        push @processed_lines, '?>';
      } elsif ($line =~ /[ \t]*<\?/) {
        DebugPrint("line3 = $line");
        push @processed_lines, $tmp_line;
        $tmp_line = $line;
        $in_php = 1;
      } elsif ($line =~ /[ \t]*<script/) {
        DebugPrint("line4 = $line");
        push @processed_lines, $tmp_line;
        $tmp_line = $line;
        $in_javascript = 1;
      } elsif (not ($line =~ /^[ \t]*</)) { # concatenate this case ... think later ...
        DebugPrint("line5 = $line");
        $tmp_line =~ s/[\r\n]+$//;
        $tmp_line =~ s/[ \t]*$/ /;
        $line =~ s/^[ \t]*//;
        $tmp_line .= ' ' . $line;
      } else {
        DebugPrint("line6 = $line");
        push @processed_lines, $tmp_line;
        $tmp_line = $line;
      }
    }
  }
  if (length($tmp_line)) {
    push @processed_lines, $tmp_line;
  }
  $in_php = 0;
  $in_javascript = 0;
  $in_here_doc = 0;
  $here_doc = '';
  $in_multiline_string = 0;
  $multiline_string = '';
  $previsempty = 0;
  foreach (@processed_lines) {
    $_ =~ s/[\n\t ]+$//;
    $_ =~ s/($crlf)+$//;
    if ($in_here_doc) {
      if ($_ =~ /$end_of_here_doc/) { # not sure ... try this ... think later ...
        insnode($cur, '<<<' . $end_of_here_doc, ' (' . 'in) ', '', $here_doc);
        $in_here_doc = 0;
        $here_doc = '';
        DebugPrint("end of here_doc");
      } else {
        if (length($here_doc) == 0) {
          $here_doc = $_;
        } else {
          $here_doc .= ' CR' . 'LF ' . $_;
        }
        DebugPrint("here_doc = $here_doc");
      }
    } elsif ($in_multiline_string) {
      if (($multiline_kind eq '"') and ($_ =~ /([^\"]*)\"[ \t]*;[ \t]*$/)) { # not sure ... try this ... think later ...
        insnode($cur, '<<<' . $end_of_multiline_string, ' (' . 'in) ', '', $multiline_string); # this is hack ... think later ...
        $in_multiline_string = 0;
        $multiline_string = '';
        DebugPrint("end of multiline_string");
      } elsif (($multiline_kind eq "'") and ($_ =~ /([^\']*)\'[ \t]*;[ \t]*$/)) { # not sure ... try this ... think later ...
        insnode($cur, '<<<' . $end_of_multiline_string, ' (' . 'in) ', '', $multiline_string); # this is hack ... think later ...
        $in_multiline_string = 0;
        $multiline_string = '';
        DebugPrint("end of multiline_string");
      } else {
        if (length($multiline_string) == 0) {
          $multiline_string = $_;
        } else {
          $multiline_string .= ' CR' . 'LF ' . $_;
        }
        DebugPrint("multiline_string = $multiline_string");
      }
    } else {
      DebugPrint("_ = $_");
      if ((length($_) != 0)) {
        if (&extractparams($_)) {
          $prevname = '';
          next;
        }
        # construct tree here ...
        if ($prevlevel < $level) {
          DebugPrint("** 1 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
          if (($cur != $root) and ($name eq '_') and ((length($cur->{TEXT}) != 0) and not ($prevname eq '_text') or ($prevname eq '_'))) {
            $level = $prevlevel;
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          } else {
            push @prevlevels, $prevlevel;
            $cur = addchildnode($cur, $name, $kind, $type, $text);
          }
        } elsif ($prevlevel == $level) {
          if (($name eq '_') and ($prevname eq '_') and not $previsempty) { # ($cur->{NAME} eq '_')
            if (not $cur->{TEXT} =~ / \CRLF /) {
              $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
            } else {
              $cur->{TEXT} .= " \CRLF " . $indentedcomment;
              $previndentedcomment = '';
            }
            $previsempty = 0;
            DebugPrint("** 2-1 prevlevel = $prevlevel level = $level cur = $cur->{NAME} name=$name prevname=$prevname");
          } elsif (($name eq '_text') and (($prevname eq '_text') or (length($prevname) == 0)) and (not $separate_text)) { # ($cur->{NAME} eq '_text') ... hack? ...
            $cur->{TEXT} .= " \CRLF " . $text;
            $previsempty = 0;
            DebugPrint("** 2-2 prevlevel = $prevlevel level = $level cur = $cur->{NAME} name=$name prevname=$prevname");
          } elsif (($name eq '_') and not ($prevname eq '_') and (length($indentedcomment) == 0)) {
            $previsempty = 1;
            DebugPrint("** 2-3 prevlevel = $prevlevel level = $level cur = $cur->{NAME} name=$name prevname=$prevname");
          } else {
            DebugPrint("** 2-4 prevlevel = $prevlevel level = $level cur = $cur->{NAME} name=$name prevname=$prevname");
            $cur = addnode($cur, $name, $kind, $type, $text);
            $previsempty = 0;
          }
        } else {
          DebugPrint("** 3 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
          until ($prevlevel <= $level) {
            if ($cur->{PARENT} == $root) { # hack ???
              last;
            }
            $cur = $cur->{PARENT};
            $prevlevel = pop @prevlevels;
          }
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
        $prevname = $name;
        $previndentedcomment = $indentedcomment;
        $prevlevel = $level;
        my $argkind = " \(in\) \& ";
        if ($kind =~ /~/) {
          if ($name =~ /\(([^\)]+)\)$/) {
            $name =~ s/[\t ]*\(([^\)]+)\)$//;
            $cur->{NAME} = $name;
            $argline2 = $1;
            my @args2 = reverse split(/[\t ]*,[\t ]*/, $argline2);
            foreach $arg (@args2) {
              if ($arg =~ /=/) {
                $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
                &addchildnode($cur, $1, $argkind, '  ' . $2, '');
              } else {
                &addchildnode($cur, $arg, $argkind, '', '');
              }
            }
          }
        }
        if (length($argline) != 0) {
          if ($argline =~ /\|[\t ]*([^\|]+)\|[\t ]*(.*)/) { # this is block arg
            $argline = $1;
            $body = $2;
            $body =~ s/[\t ]*}$//;
            $argline =~ s/[\t ]*$//;
            $argkind .= '~ ';
          }
          my @args = split(/[\t ]*,[\t ]*/, $argline);
          foreach $arg (@args) {
            if ($arg =~ /=/) {
              $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
              &addchildnode($cur, $1, $argkind, '  ' . $2, '');
            } else {
              &addchildnode($cur, $arg, $argkind, '', '');
            }
          }
          if (length($body) != 0) {
            &extractparams($body);
            &addchildnode($cur, $name, $kind, $type, $text);
          }
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub getcondandstmt {
  my($str) = @_;
  @chars = split(//, $str);
  $pre = '';
  $post = '';
  $level = 0;
  foreach $char (@chars) {
    if ($char eq '(') {
      $level++;
      if ($level > 1) {
        $pre .= $char;
      }
    } elsif ($char eq ')') {
      $level--;
      if ($level == 0) {
        last;
      } else {
        $pre .= $char;
      }
    } else {
      $pre .= $char;
    }
  }
  $post = substr($str, length($pre) + 2);
  return ($pre, $post);
}
sub islangelement {
  my($str) = @_;
  foreach $langelement (@langelements) {
    if ($str =~ /$langelement/i) {
      return 1;
    }
  }
  return 0;
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      @newlines = ();
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
