# File: HtmlWithFoldWriter_Perl.pl
# Date            Author        number of nodes
# 2005/3/17       Walking Lint  364
# 2005/3/10       Walking Lint  362
# 2005/2/26       Walking Lint  362
# 2005/2/24       Walking Lint  362
# 2005/2/23       Walking Lint  333
# 2005/2/1        Walking Lint  324
# 2004/8/11       Walking Lint  321
# 2004/7/23       Walking Lint  319
# 2004/7/1        Walking Lint  318
# 2004/6/23       Walking Lint  317
# 2004/6/19       Walking Lint  318
# 2004/5/31       Walking Lint  277
# 2004/5/26       Walking Lint  258
# 2004/5/25       Walking Lint  252
# 2004/5/4        Walking Lint  249
# 2004/5/2        Walking Lint  189
# 2004/4/26       Walking Lint  181
# 2004/4/22       Walking Lint  134
# 2004/4/21       Walking Lint  121
# 2004/4/15       Walking Lint  115
# 2004/4/15       Walking Lint  80 (TextWithStructureWriter_Perl->HtmlWithFoldWriter_Perl)
# 2003/10/1       Walking Lint  80
# 2003/5/8        Walking Lint  74
# 2003/5/8        Walking Lint  60 (2PowerPoint_Perl->TextWithStructureWriter_Perl)
# 2003/2/12       Walking Lint  60
# 2002/11/10      Walking Lint  33 (2PowerPoint_Perl->2PowerPoint_Perl)
# 2002/11/9       Walking Lint  29
# 2002/6/4        Walking Lint  29 (CSVWriter_Perl->2PowerPoint_Perl)
# 2002/3/10       Walking Lint  20

=pod

=head1 NAME

HtmlWithFoldWriter_Perl.pl - to html with fold

=head1 DESCRIPTION

activate as plug-in (assuming certain outline structure ... think later ...)

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Jcode;
use IPC::Open2;
use File::Basename;
$target = ' target="_blank"'; # try this ...
$utf = shift;
if ($utf) {
  $charset = 'utf-8';
} else {
  $charset = 'Shift_JIS';
}
$inhibitimg = shift;
$use_default_css = shift;
$css = '';
if ($use_default_css) {
  $css = $ENV{CSS};
  if (length($css) != 0) {
    $css = '<link rel="stylesheet" href="' . $css . '" type="text/css" />';
  }
}
$use_default_footer = shift;
$footer = '';
if ($use_default_footer) {
  $footer = $ENV{FOOTER};
  if ((length($footer) != 0) and (-e $footer)) {
    open IN, $footer or die("Cannot open $footer: $!\n");
    $footer = <IN>;
    close IN;
  }
}
$use_default_header = shift;
$header = '';
if ($use_default_header) {
  $header = $ENV{HEADER};
  if ((length($header) != 0) and (-e $header)) {
    open IN, $header or die("Cannot open $header: $!\n");
    $header = <IN>;
    close IN;
  }
}
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
@htmlelements = (); # to prevent error case ... think later ...
my $root = {}; # this is needed ...
$crlf = ' CR' . 'LF ';
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if (not &check_if_only_one_valid_node_exists($root)) {
  $base_node = $root;
  $root = {}; # this is needed ...
  &initnode($root, 'root', '', '', '');
  $title = basename($to_file);
  $title =~ s/\..+//;
  $base_node->{NAME} = $title;
  $root->{CHILD} = $base_node;
}
if (length($to_file) != 0) {
  open OUT, ">$to_file";
  $outfilehandle = 'OUT';
} else {
  $outfilehandle = 'STDOUT';
}
open OUT, ">$to_file";
&genoutline($root, 1, '');
print $outfilehandle <<EOL;
<SCRIPT language=JavaScript>
fold_document();
</SCRIPT>
$footer
</BODY>
</HTML>
EOL
if (length($to_file) != 0) {
  close OUT;
  DebugPrint("generated $to_file");
}
sub check_if_only_one_valid_node_exists {
  my($nd) = @_;
  $cn = $nd->{CHILD};
  my $count = 0;
  if (defined($cn)) {
    while (1) {
      if (($cn->{NAME} =~ /^_/)) { # or ($cn->{KIND} =~ /!/) %% this is hack for ...
      } else {
        $count++;
        if ($count > 1) {
          return 0;
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
  return 1;
}
sub genhtml {
  my($nd) = @_;
  my $nm = $nd->{NAME};
  my $attr = $nd->{TYPE};
  my $txt = $nd->{TEXT};
  my $ret = '';
  if (length($attr) != 0) {
    $ret = '<' . $nm . ' ' . $attr . '>';
  } else {
    $ret = '<' . $nm . '>';
  }
  $ret .= $txt;
  my $cn = $nd->{CHILD};
  if (defined($cn)) {
    while (1) {
      if (not defined($inhibitimg) and ($cn->{NAME} =~ /_part/) and ($cn->{TYPE} =~ /\.jpg$/)) {
        $ctype = $cn->{TYPE};
        $ctext = $cn->{TEXT};
        if ($utf) {
          Jcode::convert(\$ctype, 'utf8', 'sjis', "z");
          Jcode::convert(\$ctext, 'utf8', 'sjis', "z");
        }
        if (length($ctext) != 0) {
          $ret .= "<img src=\"$ctype\" $ctext></img>";
        } else {
          $ret .= "<img src=\"$ctype\"></img>";
        }
      } elsif (($cn->{NAME} =~ /_text/) and ($cn->{TYPE} =~ /_Perl$/)) {
        $ret .= &process_script($cn);
      } elsif (&ishtmlelement($cn->{NAME})) { # currently ... think later for html element and script ...
        $ret .= &genhtml($cn);
      } else {
        # do nothing ... currently ...
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
  $ret .= '</' . $nm . '>';
  return $ret;
}
sub genoutline {
  my($nd, $level, $pnumstr) = @_;
  my $num = 0;
  $text = $nd->{TEXT};
  $text =~ s/\[\[([^!]*!.*?)\]\]/BEGQUOTE$1ENDQUOTE/g; # not actually but for simplicity ... think later ...
  $text =~ s/BEGQUOTE([^!]*?)ENDQUOTE/[[$1]]/g; # not actually but for simplicity ... think later ...
  $text =~ s/BEGQUOTE(.*?)!([^!]*)ENDQUOTE/<a href="$2"$target>$1<\/a>/g; # not actually but for simplicity ... think later ...
  $text =~ s/(<\/div>$crlf$crlf)-----/$1FIVEBAR<br \/>/g;
  $text =~ s/-----/<br \/>-----<br \/>/g;
  $text =~ s/FIVEBAR/-----/g;
  $nm = $nd->{NAME};
  if (($nm =~ /<a /) and not ($nm =~ / target=/)) {
    $nm =~ s/>/$target>/;
  }
  if ($utf) {
    Jcode::convert(\$nm, 'utf8', 'sjis', "z");
    Jcode::convert(\$text, 'utf8', 'sjis', "z");
  }
  if ($nm eq '_text') {
    $nm = '';
  }
  if (defined($nd->{CHILD}) and ($nd->{CHILD}->{KIND} =~ /\//)) {
    $link = $nd->{CHILD}->{NAME};
    $nm = '<a href="' . $link . '">' . $nm . '</a>';
  }
  if ($level == 2) {
    if (length($text) > 0) { # try this ...
      print $outfilehandle <<EOL;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META http-equiv=Content-Type content="text/html; charset=$charset">
$css
<title>$text</title>
<STYLE type=text/css>SPAN.foldopened {
  BORDER-TOP-WIDTH: 1px; PADDING-RIGHT: 0.25em; PADDING-LEFT: 0.25em; BORDER-LEFT-WIDTH: 1px; FONT-SIZE: xx-small; BACKGROUND: #e0e0e0; VISIBILITY: visible; BORDER-BOTTOM-WIDTH: 1px; PADDING-BOTTOM: 0em; CURSOR: hand; COLOR: white; PADDING-TOP: 0em; FONT-FAMILY: monospace; BORDER-RIGHT-WIDTH: 1px
}
SPAN.foldclosed {
  BORDER-TOP-WIDTH: 1px; PADDING-RIGHT: 0.25em; PADDING-LEFT: 0.25em; BORDER-LEFT-WIDTH: 1px; FONT-SIZE: xx-small; BACKGROUND: #e0e0e0; VISIBILITY: hidden; BORDER-BOTTOM-WIDTH: 1px; PADDING-BOTTOM: 0em; CURSOR: hand; COLOR: #666666; PADDING-TOP: 0em; FONT-FAMILY: monospace; BORDER-RIGHT-WIDTH: 1px
}
SPAN.foldspecial {
  BORDER-RIGHT: #cccccc 1px solid; PADDING-RIGHT: 0.1em; BORDER-TOP: #cccccc 1px; PADDING-LEFT: 0.1em; FONT-SIZE: xx-small; BACKGROUND: #e0e0e0; PADDING-BOTTOM: 0em; BORDER-LEFT: #cccccc 1px; CURSOR: hand; COLOR: #666666; PADDING-TOP: 0em; BORDER-BOTTOM: #cccccc 1px solid; FONT-FAMILY: sans-serif
}
LI {
  LIST-STYLE-TYPE: none
  /* clear :   both; */
}
SPAN.l {
	FONT-WEIGHT: bold; COLOR: red
}
body {
  line-height :   140%;
}
div.ref, pre {
  border-style :   dotted;
  border-width :   1px;
  clear :   both;
  font-size :   90%;
  line-height :   150%;
  margin-left :   40px;
  margin-right :   60px;
  margin-bottom :   10px;
  margin-top :   10px;
  padding :   10px;
}
img {
  border-width :   0px;
  float :   right;
  margin :   2px 2px 10px 10px;
  vertical-align :   top;
}
</STYLE>
<!-- ^ Position is not set to relative / absolute here because of Mozilla -->
<META content="MSHTML 6.00.2800.1400" name=GENERATOR></HEAD>
<BODY>
$header
<SCRIPT language=JavaScript>
   // Here we implement folding. It works fine with MSIE5.5, MSIE6.0 and
   // Mozilla 0.9.6.

   if (document.layers) {
      //Netscape 4 specific code
      pre = 'document.';
      post = ''; }
   if (document.getElementById) {
      //Netscape 6 specific code
      pre = 'document.getElementById("';
      post = '").style'; }
   if (document.all) {
      //IE4+ specific code
      pre = 'document.all.';
      post = '.style'; }

function layer_exists(layer) {
   try {
      eval(pre + layer + post);
      return true; }
   catch (error) {
      return false; }}

function show_layer(layer) {
   eval(pre + layer + post).position = 'relative'; 
   eval(pre + layer + post).visibility = 'visible'; }

function hide_layer(layer) {
   eval(pre + layer + post).visibility = 'hidden';
   eval(pre + layer + post).position = 'absolute'; }

function hide_folder(folder) {
    hide_folding_layer(folder)
    show_layer('show'+folder);

    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)
}

function show_folder(folder) {
    // Precondition: all subfolders are folded

    show_layer('hide'+folder);
    hide_layer('show'+folder);
    show_layer('fold'+folder);

    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)

    var i;
    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       show_layer('show'+folder+'_'+i); }
}
function show_folder_completely(folder) {
    // Precondition: all subfolders are folded

    show_layer('hide'+folder);
    hide_layer('show'+folder);
    show_layer('fold'+folder);

    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)

    var i;
    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       show_folder_completely(folder+'_'+i); }
}



function hide_folding_layer(folder) {
   var i;
   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       hide_folding_layer(folder+'_'+i); }

   hide_layer('hide'+folder);
   hide_layer('show'+folder);
   hide_layer('fold'+folder);

   scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)
}

function fold_document() {
   var i;
   var folder = '1';
   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       hide_folder(folder+'_'+i); }
}

function unfold_document() {
   var i;
   var folder = '1';
   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       show_folder_completely(folder+'_'+i); }
}

</SCRIPT>
<SPAN class=foldspecial onclick=fold_document()>All +</SPAN> <SPAN 
class=foldspecial onclick=unfold_document()>All -</SPAN>
<h2>$nm</h2>
EOL
      $text = '&nbsp;&nbsp;<small>' . $text . '</small>';
      $text =~ s/$crlf/\n/g;
    } else {
      print $outfilehandle <<EOL;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META http-equiv=Content-Type content="text/html; charset=$charset">
$css
<title>$nm</title>
<STYLE type=text/css>SPAN.foldopened {
  BORDER-TOP-WIDTH: 1px; PADDING-RIGHT: 0.25em; PADDING-LEFT: 0.25em; BORDER-LEFT-WIDTH: 1px; FONT-SIZE: xx-small; BACKGROUND: #e0e0e0; VISIBILITY: visible; BORDER-BOTTOM-WIDTH: 1px; PADDING-BOTTOM: 0em; CURSOR: hand; COLOR: white; PADDING-TOP: 0em; FONT-FAMILY: monospace; BORDER-RIGHT-WIDTH: 1px
}
SPAN.foldclosed {
  BORDER-TOP-WIDTH: 1px; PADDING-RIGHT: 0.25em; PADDING-LEFT: 0.25em; BORDER-LEFT-WIDTH: 1px; FONT-SIZE: xx-small; BACKGROUND: #e0e0e0; VISIBILITY: hidden; BORDER-BOTTOM-WIDTH: 1px; PADDING-BOTTOM: 0em; CURSOR: hand; COLOR: #666666; PADDING-TOP: 0em; FONT-FAMILY: monospace; BORDER-RIGHT-WIDTH: 1px
}
SPAN.foldspecial {
  BORDER-RIGHT: #cccccc 1px solid; PADDING-RIGHT: 0.1em; BORDER-TOP: #cccccc 1px; PADDING-LEFT: 0.1em; FONT-SIZE: xx-small; BACKGROUND: #e0e0e0; PADDING-BOTTOM: 0em; BORDER-LEFT: #cccccc 1px; CURSOR: hand; COLOR: #666666; PADDING-TOP: 0em; BORDER-BOTTOM: #cccccc 1px solid; FONT-FAMILY: sans-serif
}
LI {
  LIST-STYLE-TYPE: none
  /* clear :   both; */
}
SPAN.l {
	FONT-WEIGHT: bold; COLOR: red
}
body {
  line-height :   140%;
}
div.ref, pre {
  border-style :   dotted;
  border-width :   1px;
  clear :   both;
  font-size :   90%;
  line-height :   150%;
  margin-left :   40px;
  margin-right :   60px;
  margin-bottom :   10px;
  margin-top :   10px;
  padding :   10px;
}
img {
  border-width :   0px;
  float :   right;
  margin :   2px 2px 10px 10px;
  vertical-align :   top;
}
</STYLE>
<!-- ^ Position is not set to relative / absolute here because of Mozilla -->
<META content="MSHTML 6.00.2800.1400" name=GENERATOR></HEAD>
<BODY>
$header
<SCRIPT language=JavaScript>
   // Here we implement folding. It works fine with MSIE5.5, MSIE6.0 and
   // Mozilla 0.9.6.

   if (document.layers) {
      //Netscape 4 specific code
      pre = 'document.';
      post = ''; }
   if (document.getElementById) {
      //Netscape 6 specific code
      pre = 'document.getElementById("';
      post = '").style'; }
   if (document.all) {
      //IE4+ specific code
      pre = 'document.all.';
      post = '.style'; }

function layer_exists(layer) {
   try {
      eval(pre + layer + post);
      return true; }
   catch (error) {
      return false; }}

function show_layer(layer) {
   eval(pre + layer + post).position = 'relative'; 
   eval(pre + layer + post).visibility = 'visible'; }

function hide_layer(layer) {
   eval(pre + layer + post).visibility = 'hidden';
   eval(pre + layer + post).position = 'absolute'; }

function hide_folder(folder) {
    hide_folding_layer(folder)
    show_layer('show'+folder);

    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)
}

function show_folder(folder) {
    // Precondition: all subfolders are folded

    show_layer('hide'+folder);
    hide_layer('show'+folder);
    show_layer('fold'+folder);

    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)

    var i;
    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       show_layer('show'+folder+'_'+i); }
}
function show_folder_completely(folder) {
    // Precondition: all subfolders are folded

    show_layer('hide'+folder);
    hide_layer('show'+folder);
    show_layer('fold'+folder);

    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)

    var i;
    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       show_folder_completely(folder+'_'+i); }
}



function hide_folding_layer(folder) {
   var i;
   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       hide_folding_layer(folder+'_'+i); }

   hide_layer('hide'+folder);
   hide_layer('show'+folder);
   hide_layer('fold'+folder);

   scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)
}

function fold_document() {
   var i;
   var folder = '1';
   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       hide_folder(folder+'_'+i); }
}

function unfold_document() {
   var i;
   var folder = '1';
   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {
       show_folder_completely(folder+'_'+i); }
}

</SCRIPT>
<SPAN class=foldspecial onclick=fold_document()>All +</SPAN> <SPAN 
class=foldspecial onclick=unfold_document()>All -</SPAN>
<h2>$nm</h2>
EOL
    }
    if (length($text) > 0) {
      print $outfilehandle $text;
    }
  } elsif ($level > 2) {
    if (length($text) > 0) {
      $text = '&nbsp;&nbsp;<small>' . $text . '</small>';
    }
    $text =~ s/$crlf/\n/g;
    $nm =~ s/\[\[([^!]*!.*?)\]\]/BEGQUOTE$1ENDQUOTE/g; # not actually but for simplicity ... think later ...
    $nm =~ s/BEGQUOTE([^!]*?)ENDQUOTE/[[$1]]/g; # not actually but for simplicity ... think later ...
    $nm =~ s/BEGQUOTE(.*?)!([^!]*)ENDQUOTE/<a href="$2"$target>$1<\/a>/g; # not actually but for simplicity ... think later ...
    $nm = '<small><b>' . $nm . '</b></small>';
    if (defined($nd->{CHILD}) and not ($nd->{CHILD}->{KIND} =~ /\//)) {
      print $outfilehandle <<EOL;
<LI><SPAN class=foldclosed id=show$pnumstr style="POSITION: absolute" 
onclick="show_folder('$pnumstr')">+</SPAN> <SPAN class=foldopened 
id=hide$pnumstr onclick="hide_folder('$pnumstr')">-</SPAN> $nm
EOL
      if (length($text) > 0) {
        print $outfilehandle $text;
      }
    } else {
      print $outfilehandle <<EOL;
<LI> $nm
EOL
      print $outfilehandle $text . '</LI>';
    }
  }
  if (defined($nd->{CHILD}) and not ($nd->{CHILD}->{KIND} =~ /\//)) {
    my $cn = $nd->{CHILD};
    if ($level == 2) {
      print $outfilehandle '<UL>' . "\n";
    } elsif ($level > 2) {
      print $outfilehandle '<UL id=fold' . $pnumstr . ' style="VISIBILITY: visible; POSITION: relative">' . "\n";
    }
    while (1) {
      if (($inhibitimg == 0) and ($cn->{NAME} =~ /_part/) and ($cn->{TYPE} =~ /\.jpg$/)) {
        $ctype = $cn->{TYPE};
        $ctext = $cn->{TEXT};
        if ($utf) {
          Jcode::convert(\$ctype, 'utf8', 'sjis', "z");
          Jcode::convert(\$ctext, 'utf8', 'sjis', "z");
        }
        if (length($ctext) != 0) {
          print $outfilehandle "<img src=\"$ctype\" $ctext></img>";
        } else {
          print $outfilehandle "<img src=\"$ctype\"></img>";
        }
      } elsif (($cn->{NAME} =~ /^_/) and not ($cn->{NAME} eq '_text') or ($cn->{NAME} =~ /^ڎ/) or ($cn->{NAME} =~ /^yڎz/) or ($cn->{NAME} =~ /^@/) or ($cn->{NAME} =~ /^NXg/) or ($cn->{NAME} =~ /^_text/ and $cn->{TEXT} =~ /^ȏ[\n\r ]*/)) {
        # do nothing
      } elsif (($cn->{KIND} =~ /!/) and ($level != 1)) { # this is hack ...
        # do nothing
      } elsif (&ishtmlelement($cn->{NAME})) { # currently ... think later for html element and script ...
        print $outfilehandle &genhtml($cn);
      } elsif (($cn->{NAME} =~ /_text/) and ($cn->{TYPE} =~ /Text2Table_Perl$/)) { # currently ... think later for html element and script ...
        print $outfilehandle &process_script($cn);
      } else {
        if (defined($cn->{CHILD})) {
          $num++;
        }
        if (length($pnumstr) == 0) {
          &genoutline($cn, $level + 1, $num);
        } else {
          &genoutline($cn, $level + 1, $pnumstr . '_' . $num);
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    if ($level >= 2) {
      print $outfilehandle '</LI></UL>' . "\n";
    }
  }
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    $str =~ tr/A-Z/a-z/;
    if ($str eq $htmlelement) {
      return 1;
    }
  }
  return 0;
}
sub process_script {
  my($nd) = @_;
  @lines = split(/$crlf/, $nd->{TEXT});
  my $ret = '';
  if ($nd->{TYPE} =~ /Text2Table_Perl/) { # this is hack ... but do not function ...
    $ret .= "<small><ul>\n";
    $found_tab = 0;
    foreach $line (@lines) { # while <STDIN>
      $line =~ s/[\r\n ]+$//;
      $line =~ s/[ ]+/ \/ /g;
      if ($utf) {
        Jcode::convert(\$line, 'utf8', 'sjis', "z");
      }
      $ret .= "<li>$line</li>\n";
    }
    $ret .= "</ul></small>\n";
  }
  return $ret;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
