# File: IP2Host_Perl.pl
# Date            Author        number of nodes
# 2004/4/6        Walking Lint  67
# 2004/4/3        Walking Lint  67
# 2003/12/11      Walking Lint  52
# 2003/12/9       Walking Lint  44
# 2003/12/8       Walking Lint  12
# 2003/8/31       Walking@Lint 10
# 2003/3/14       Walking Lint  9
# 2002/8/14       Walking Lint  27 (Hx2Li_Perl->IP2Host_Perl)
# 2002/8/14       Walking Lint  3 (Hx2Li->Hx2Li_Perl)
# 2002/8/14       Walking Lint  3 (sort_Perl->Hx2Li)
# 2002/2/3        Walking Lint  3 (Sort2_Perl->sort_Perl)

=pod

=head1 NAME

IP2Host_Perl.pl - IP to host name

=head1 DESCRIPTION

activate as filter2

=head1 AUTHOR

Walking Lint

=cut

use Socket;
$ip = shift;
if (length($ip) != 0) {
  $host = gethostbyaddr(inet_aton($ip), AF_INET) or die "Cannot resolve $ip: $!\n";
  DebugPrint("ip = $ip");
  DebugPrint("host = $host");
} else {
  @lines = ();
  while (<STDIN>) {
    push @lines, $_;
    print $_;
  }
  $nextisip = 0;
  %hosts = ();
  %counts = ();
  foreach $line (@lines) {
    if (not defined($hosts{$line}) and ($line =~ /([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)/)) { # ex. for sugoi counter
      $line = $1;
      if (not ($host = gethostbyaddr(inet_aton($line), AF_INET))) {
        DebugPrint("Cannot resolve $line: $!");
      } else {
        $hosts{$line} = $host;
        $counts{$line . $host}++;
      }
    }
  }
  DebugPrint("");
  foreach $key (sort {lc($hosts{$a}) cmp lc($hosts{$b})} keys %hosts) {
    DebugPrint($hosts{$key} . '(' . $key . ')' . " " . '*' x $counts{$key . $hosts{$key}});
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
