# File: IndexFor2Column_Perl.pl
# Date            Author        number of nodes
# 2004/4/19       Walking Lint  91
# 2004/2/5        Walking Lint  75
# 2003/7/18       Walking Lint  72
# 2003/6/11       Walking Lint  72
# 2003/3/2        Walking Lint  71
# 2003/2/13       Walking Lint  72
# 2003/1/6        Walking Lint  68
# 2002/12/19      Walking Lint  68 (GenIndexFor2Column_Perl->IndexFor2Column_Perl)
# 2002/12/2       Walking Lint  68 (GenIndexFor3Column_Perl->GenIndexFor2Column_Perl)
# 2002/11/16      Walking Lint  63
# 2002/11/2       Walking Lint  64
# 2002/10/16      Walking Lint  64
# 2002/10/11      Walking Lint  178 (GenIndexFor3Column_Perl->GenIndexFor3Column_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenIndexFor3ColumnNew_Perl->GenIndexFor3Column_Perl)
# 2002/9/21       Walking Lint  109 (GenIndexFor3Column_Perl->GenIndexFor3ColumnNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

IndexFor2Column_Perl.pl - generate index for 2Column_CSSPart.pat / 2ColumnWithStyleSheet_CSSPart.pat

=head1 DESCRIPTION

ex. _text () // IndexFor2Column_Perl [[CurrentFile]]

=head1 AUTHOR

Walking Lint

=cut

use CVTree_Perl;
use File::Basename;
$PrefixToDateLabel = ''; # customize here if needed ...
$path = shift;
DebugPrint("path = $path");
$dir = &mydirname($path);
$file = basename($path);
DebugPrint("file = $file");
$file =~ /^([0-9]{4})([0-9]{2})/; # this is assumed ...
$thisyear = $1;
$thismonth = $2;
$thismonth =~ s/^[0]+//;
opendir DIR, $dir or die "Cannot open $dir: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /^200[0-9]+.pat$/, @files;
closedir DIR;
$entryerrorfound = 0;
$foundthisfile = 0;
foreach $from_file (reverse sort @files) {
  DebugPrint("from_file = $from_file");
  if ($from_file eq $file) {
    $foundthisfile = 1;
    $first = 1;
    open IN, $dir . "\\" . $from_file || die("Can't open $from_file: $!\n");
    my $root = {};
    &initnode($root, 'root', '', '', '');
    &gentree($root, $dir . "\\" . $from_file);
    &genindex($root);
    close IN;
    unless ($first) {
      print "</div>\n";
    }
  } else {
    $year = substr($from_file, 0, 4);
    $month = substr($from_file, 4, 2);
    print '<div class="li"><a href="' . "$year$month" . ".html" . '">';
    $month =~ s/^0//;
    print "+ $year/$month</a></div>\n";
  }
}
if ($foundthisfile == 0) {
  DebugPrint("this file must be named as 20YYMM as 200404");
}
sub genindex {
  my($nd) = @_;
  if ($nd->{NAME} =~ /^_/) {
    return;
  }
  if ($nd->{NAME} =~ /^200[0-9\/]+/) { # and defined($nd->{CHILD}) %% better ???
    $date = $nd->{NAME};
    ($year, $month, $day, $weekday) = split(/[\/\(\)]/, $date); # this is assumed ... customize here if needed ...
    if ($first) {
      $first = 0;
      print '<div class="li">- ' . "$year/$month</div>\n";
      print '<div class="ul">' . "\n";
    }
    if (length($weekday) != 0) {
      $weekday = ' (' . $weekday . ')';
    }
    if ($month == $thismonth) { # hack ??? this may not be good ... think later ...
      print '<div class="li">&nbsp;<a href="#' . $PrefixToDateLabel . $day . '">- ' . $day . $weekday . '</a></div>' . "\n";
    } elsif ($entryerrorfound == 0) {
      $entryerrorfound = 1;
      $monthstr = $month;
      if ($month < 10) {
        $monthstr = '0' . $month;
      }
      DebugPrint("this file must be named as $year" . $monthstr);
    }
  } elsif (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      &genindex($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub mydirname {
  my($fn) = @_;
  my $res = &dirname($fn);
  $res =~ s/[\/\\]+$//;
  return $res;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
