# File: Index_Perl.pl
# Date            Author        number of nodes
# 2002/11/10      Walking Lint  94
# 2002/11/8       Walking Lint  91
# 2002/11/6       Walking Lint  27 (Index_Perl->Index_Perl)
# 2002/11/5       Walking Lint  212 (Index_Perl->Index_Perl)
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (Index_Perl->Index_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->Index_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

Index_Perl.pl - gen/update item number and make/update index

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root);
@htmlelements = ('a', 'center', 'div', 'li', 'ol', 'p', 'table', 'ul');
if (defined($root->{CHILD})) {
  $indexnode = &getindexnode($root);
  $indexnode->{TEXT} = '';
  &genitemnumber($root, '');
}
&savetree($root);
sub genitemnumber {
  my($nd, $previtemnumber) = @_;
  my $res = '';
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    my $itemnumber = 1;
    my $first = 1;
    my $found = 0;
    while (1) {
      if (($cn->{NAME} =~ /^_/) or &ishtmlelement($cn->{NAME}) or ($cn->{NAME} =~ /^\[/)) { # customize here if needed ...
        # do nothing
      } else {
        if (length($previtemnumber) == 0) {
          $itemnumberstr = $itemnumber;
        } else {
          $itemnumberstr = $previtemnumber . '.' . $itemnumber;
        }
        my $tmpstr = $itemnumberstr;
        $tmpstr =~ s/\./_/g;
        $tmpstr = '<a name="' . $tmpstr . '"></a>' . $itemnumberstr;
        $cn->{NAME} =~ s/^(<a name="[0-9_]+"><\/a>[0-9\. ]*|[0-9\. ]*)/$tmpstr /; # think ...
        if ($first) {
          $first = 0;
          $found = 1;
          $indexnode->{TEXT} .= "<div class=\"ul\"> \CRLF ";
        }
        $tmpstr = $cn->{NAME};
        $tmpstr =~ s/^<a name="([0-9_]+)"><\/a>/<a href="#$1">/;
        $tmpstr =~ s/$/<\/a>/;
        $indexnode->{TEXT} .= "<div class=\"li\">" . $tmpstr . "</div> \CRLF "; # may need to escape something ...
        genitemnumber($cn, $itemnumberstr);
        $itemnumber++;
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    if ($found) {
      $indexnode->{TEXT} .= "</div> \CRLF ";
    }
  }
}
sub getindexnode {
  my($nd) = @_;
  if (defined($nd->{CHILD})) { # this is assumed ...
    my $cn = $nd->{CHILD};
    while (1) {
      if (($cn->{NAME} eq 'div') and ($cn->{TYPE} eq 'id="index"')) {
        return $cn;
      } elsif (($cn->{NAME} =~ /^_/) or &ishtmlelement($cn->{NAME}) or ($cn->{NAME} =~ /^\[/)) { # customize here if needed ...
        # do nothing
      } else {
        return &insnode($cn, 'div', '', 'id="index"', '');
      }
      $lastnode = $cn;
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    return &addnode($lastnode, 'div', '', 'id="index"', '');
  }
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    if ($str eq $htmlelement) {
      return 1;
    }
  }
  return 0;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
