# File: IniReader_Perl.pl
# Date            Author        number of nodes
# 2005/1/15       Walking Lint  87
# 2005/1/14       Walking Lint  89
# 2003/9/2        Walking Lint  100
# 2003/9/2        Walking Lint  96 (GeppouReader_Perl->IniReader_Perl)
# 2003/8/1        Walking Lint  101
# 2003/7/31       Walking Lint  101
# 2003/6/30       Walking Lint  101
# 2002/12/3       Walking Lint  98
# 2002/12/2       Walking Lint  93
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

IniReader_Perl.pl - .ini reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
my $root = {};
&initnode($root, 'root');
&gentree($root, $from_file);
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' ()  '; # somehow this is hack ... think later ...
  $type = '';
  $text = '';
  DebugPrint("linewithoutindent = $linewithoutindent");
  if ($line =~ /^\[([^]]*)\]/) {
    $level = 0;
    $name = $1;
    return 0;
  } elsif ($line =~ /^([^=]*)=(.*)/) {
    $kind = ' (out)  '; # somehow this is hack ... think later ...
    $level = 1;
    $name = $1;
    $type = $2; # better to be '  ' . $2 ???
    return 0;
  } else {
    return 1;
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $founditem = 0;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    $_ =~ s/[\n\r]*$//;
    if ((length($_) != 0)) {
      if (&extractparams($_)) {
        if ($founditem) { # not used now ...
          $_ =~ s/^[ @]*//;
          if (length($cur->{TEXT}) == 0) {
            $cur->{TEXT} = $_;
          } else {
            $tmpline = " \CRLF  \CRLF " . $_;
            $cur->{TEXT} .= $tmpline;
          }
        }
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        $cur = addnode($cur, $name, $kind, $type, $text);
      } else {
        until ($prevlevel <= $level) {
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevlevel = $level;
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
