# File: IniWriter_Perl.pl
# Date            Author        number of nodes
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

IniWriter_Perl.pl - .ini writer

=head1 DESCRIPTION

activate as plug-in ex. .ini () // IniReader_Perl %% IniWriter_Perl

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
open OUT, ">$to_file";
&genini($root);
close OUT;
sub genini {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      print OUT '[' . $cn->{NAME} . ']' . "\n";
      if (defined($cn->{CHILD})) {
        my $ccn = $cn->{CHILD};
        while (1) {
          print OUT $ccn->{NAME} . '=' . $ccn->{TYPE} . "\n";
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
      }
      print OUT "\n";
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
