# File: JavaReader_Perl.pl
# Date            Author        number of nodes
# 2005/7/17       Walking Lint  696
# 2003/12/11      Walking Lint  697
# 2003/10/3       Walking@Lint 657
# 2003/9/27       Walking@Lint 641
# 2003/6/25       Walking Lint  628
# 2003/6/19       Walking Lint  626
# 2003/6/18       Walking Lint  626
# 2003/6/17       Walking Lint  606
# 2003/6/16       Walking Lint  603
# 2003/6/15       Walking Lint  597
# 2003/6/14       Walking Lint  578
# 2003/6/9        Walking Lint  571
# 2003/6/8        Walking Lint  579
# 2003/6/7        Walking Lint  575
# 2003/6/6        Walking Lint  569
# 2003/6/5        Walking Lint  568
# 2003/6/4        Walking Lint  543
# 2003/6/3        Walking Lint  542
# 2003/5/27       Walking Lint  509
# 2003/5/23       Walking Lint  483
# 2003/5/22       Walking Lint  482
# 2003/5/18       Walking Lint  451
# 2003/5/17       Walking Lint  436
# 2003/5/16       Walking Lint  400
# 2003/3/14       Walking Lint  358
# 2003/3/13       Walking Lint  353 (PerlReader_Perl->JavaReader_Perl)
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

JavaReader_Perl.pl - Java/JavaScript reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
@langelements = ('begin', 'break', 'case', 'catch', 'default', 'else', 'exit', 'for', 'if', 'import', 'next', 'return', 'switch', 'throw', 'while');
$parenpattern = '\([\t ]*((?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\)';
$continuationpattern = '(\|\||\&\&|,|=|implements|new)[ \t]*'; # end of prev line
$continuationpattern2 = '[ \t]*(,|"|\|\||\&\&|\-[^\-]|\+[^\+]|\/[^\/\*]|\%|=|extends|implements)'; # start of next line
$typepattern = '(?:Button|boolean|double|final|float|int|interface|long|Point|private|protected|public|static|String|var|void)(?:[ \t]*\[[ \t]*\])*[ \t]+'; # var is for JavaScript
$subdef = 'function'; # for JavaScript
$comment = '(//|/\*+)';
$comment_begin = '/\*+';
$comment_end = '\*/';
$to_file =~ s/\.[^\.]+$/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
$from_as = 0;
if (length($from_file) != 0) {
  $basename = basename($from_file);
  if ($basename =~ /\.as$/) {
    $basename =~ s/\.as$/.js/; # this is hack ...
    $from_as = 1;
  }
} else {
  $basename = 'NewFile.java';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
if ($from_as == 1) {
  &addchildnode($root, '_copy', ' () ', '.as', '');
}
$is_javascript = 0;
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&treatwhiles($root); # treat do while pattern ...
if ($is_javascript) {
  $file_comment =~ s/java/js/; # this is hack ...
  $root->{TEXT} = $file_comment;
}
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("linewithoutindent = $linewithoutindent");
  if ($linewithoutindent eq $comment) {
    $name = '_';
    $indentedcomment = '';
    DebugPrint("comment1");
    return 0;
  }
  if ($in_comment) {
    $linewithoutindent =~ s/$comment_end[.\n]*$//;
    if ($line =~ /$comment_end/) {
      $in_comment = 0;
      if (length($linewithoutindent) == 0) {
        DebugPrint("null end comment");
        return 1;
      }
    }
    $text = $linewithoutindent;
    $text =~ s/^\*[ \t]*//; # this may not be good ... but try
    $name = '_';
    $indentedcomment = $text;
    DebugPrint("comment2");
    return 0;
  } elsif (($line =~ /$comment_begin/) and not ($line =~ /$comment_end/)) {
    $in_comment = 1;
    if ($linewithoutindent =~ /^$comment_begin[ \t\n]*$/) {
      $indentedcomment = '';
      $line =~ /^([\t ]*)/; # try this ...
      $level = length($1);
      DebugPrint("null begin comment");
      return 1;
    }
  }
  $line =~ s/($comment.*)$//; # this is hack ...
  if (defined($1)) {
    $comment_part = $1;
    $comment_part =~ s/$comment_end$//;
  } else {
    $comment_part = '';
  }
  $line =~ /^([\t ]*)((?:[^#]|#{)*)/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  DebugPrint("level = $level");
  $argline = '';
  if (defined($comment_part)) {
    $text = $comment_part;
    $indentedcomment = $text;
    $indentedcomment =~ s/^$comment( )?//;
    $text =~ s/^$comment[\t ]*//;
    if (length($linewithoutindentandcomment) == 0) {
      $name = '_';
      DebugPrint("comment3");
      return 0;
    }
  }
  $name =~ s/[ \t]+$//;
  $name =~ s/^[ \t]*\}[ \t]*//;
  $found_paren = 0;
  if ($name =~ /[ ]*{[ ]*}?[ ]*$/) {
    $name =~ s/[ ]*\{[ ]*}?[ ]*$//;
    $found_paren = 1;
  }
  DebugPrint("name = [" . $name . "] text = [" . $text . "]");
  if (($name eq 'end') or (length($name) == 0)) { # end or } ... } is already deleted ...
    return 1; # skip this line ... think later ...
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.]|,|[\t ]+|[\+\-\*\/][^=])+)[\t ]*((?:[\+\-\*\/]|<<|>>)=)[\t ]*([^;]+);?$/) { # inout pattern1
    $name = $1;
    $type = $2; # actually not
    $init_value = $3; # actually not
    $name =~ s/[ \t]+$//;
    DebugPrint("inout pattern1 - $name");
    $kind = ' (inout) ';
    $type =~ s/[ \t]+/ /g;
    $init_value =~ s/[ \t]+/ /g;
    $type = $type . ' ' . $init_value;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\: \-\*\+]|,|[\t ])+)[\t ]*=[\t ]*([^;]+);?$/) { # assignment
    $name = $1;
    $init_value = $2;
    $name =~ s/[ \t]+$//;
    $type = '';
    DebugPrint("assignment - $name");
    if ((not $name =~ /(\]|\))$/) and $name =~ /([ \t]+[^ \t]+)$/) { # hack???
      $type = $name;
      $name = $1;
      $type =~ s/$name$//;
      DebugPrint("type = $type");
      $name =~ s/^[ \t]+//;
      DebugPrint("name = $name");
    }
    $kind = ' (out) ';
    $type =~ s/[ \t]+/ /g;
    if (($type eq 'var') and ($name =~ /([^:]+):(.+)/)) { # this may be hack ...
      $type .= ' ' . $2;
      $name = $1;
    } elsif (($name =~ /:.+/) and ($type =~ /(static |private |public |)var[ ]+(.*)/)) { # this may be hack ...
      $scope = $1;
      $nm = $2;
      $name =~ s/^://;
      $type = var . ' ' . $name;
      $name = $nm;
      if ($scope eq 'static ') {
        $kind = ' (out) / ';
      } elsif ($scope eq 'public ') {
        $kind = ' (out) $ ';
      } elsif ($scope eq 'private ') {
        $kind = ' (out) ` ';
      }
    }
    $init_value =~ s/[ \t]+/ /g;
    $type .= '  ' . $init_value;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\: \-\*\+]|,|[\t ])+)[\t ]*(\+\+|\-\-);$/) { # increment/decriment
    $name = $1;
    $type = $2; # actually not
    $name =~ s/[ \t]+$//;
    DebugPrint("increment/decriment - $name");
    $kind = ' (inout) ';
  } elsif ($name =~ /^(\+\+|\-\-)[\t ]*((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\: \-\*\+]|,|[\t ])+);$/) { # increment/decriment right???
    $name = $2;
    $type = $1; # actually not
    $name =~ s/[ \t]+$//;
    DebugPrint("increment/decriment - $name");
    $kind = ' (inout) ';
  } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([a-zA-Z0-9_\$\@\[\]\{\}\.\'\"\(\)]+)[\t ]*\{[\t ]*([^;]*);?$/)) { # block ... think later ... this is hack
    $name = $1;
    DebugPrint("block - $name");
    $kind .= '~ '; # may not be good ...
    $argline = $2;
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\.[^;]+);?$/) { # method
    $name = '->' . $1;
    DebugPrint("-> method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\.[^;]);?$/) { # method
    $name = $1;
    DebugPrint("method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif (($name =~ /^(for)[\t ]+(.+)$/)) { # for statement with param ...
    $name = $1;
    DebugPrint("for statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    $type =~ s/^\((.*)\)$/$1/;
  } elsif (($name =~ /^(else[ \t]+if)[\t ]+(.+)$/)) { # else if statement with param ...
    $name = $1;
    $type = $2;
    $name =~ s/[ \t]+//;
    DebugPrint("else if statement with param - $name");
    $type =~ s/[ \t]*{[ \t]*$//;
    $type =~ s/^\((.*)\)$/$1/;
    $type =~ s/;$//; # this is hack ...
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@\:]+)[\t ]*([^;]+);?$/) and &islangelement($1)) { # control statement with param ...
    $name = $1;
    DebugPrint("control statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{?[ \t]*$//;
    $type =~ s/^\([ \t]*(.*)\)([ ]*\{[ ]*\})?$/$1/;
    $type =~ s/[ \t]*$//;
    if ($name eq 'case') {
      $type =~ s/[ \t]*:$//;
    }
  } elsif (($name =~ /^([^\(]+)[ \t]+([^( \t]+)[\t ]*\(([^\)]+)\)[ \t]*throws[ \t]+(.*)$/)) {
    $name = $2;
    DebugPrint("func decl with param and throws - $name");
    $type = $1 . '  throws ' . $4;
    $argline = $3;
    $isfuncorclassdecl = 1;
  } elsif (($name =~ /^(for|foreach)[\t ]*$parenpattern$/)) { # for/foreach statement with param - not sure ...
    $name = $1;
    DebugPrint("for/foreach statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    unless ($name eq 'foreach') {
      $type =~ s/^\((.*)\)$/$1/;
    }
    $type =~ s/;$//; # this is hack ...
  } elsif (($name =~ /^([^\(]+)[ \t]+([^( \t]+)[\t ]*\(([^\)]+)\)([ ]*:[ ]*([^;]+))?;?$/)) {
    $name = $2;
    DebugPrint("func decl with param - $name");
    if ($1 eq 'function') {
      $is_javascript = 1;
      if (defined($5)) {
        $type = $5;
      }
    } else {
      $type = $1;
    }
    if ($name =~ /^on/i) {
      $is_javascript = 1;
      if (defined($5)) {
        $type = $5;
      }
    }
    $argline = $3;
    $isfuncorclassdecl = 1;
  } elsif (($name =~ /^([^\(]+)[ \t]+([^( \t]+)[\t ]*\([ \t]*\)[ \t]*throws[ \t]+(.*)$/)) {
    $name = $2;
    DebugPrint("func decl without param and with throws - $name");
    $type = $1 . '  throws ' . $3;
    $isfuncorclassdecl = 1;
  } elsif (($name =~ /^([^\(]+)[ \t]+([^( \t]+)[\t ]*\(([ \t]*)\)([ ]*:[ ]*(.+))?$/)) {
    $name = $2;
    DebugPrint("func decl without param - $name");
    if (($1 eq 'function') or ($1 eq 'static function') or ($1 eq 'public function')) { # not actually ...
      $is_javascript = 1;
      if (defined($5)) {
        $type = $5;
      }
      if ($1 eq 'static function') {
        $kind = ' () / ';
      } elsif ($1 eq 'public function') {
        $kind = ' () $ ';
      }
    } else {
      $type = $1;
    }
    if ($name =~ /^on/i) {
      $is_javascript = 1;
    }
    $isfuncorclassdecl = 1;
  } elsif (($name =~ /^(.*)[\t ]*class[ \t]+([^ \t]+)[ \t]+(extends|implements)[ \t]+(.*)$/)) { # class def with extends
    $name = $2;
    DebugPrint("class def with extends - $name");
    $type = $1 . '  ' . $3 . ' ' . $4; # change CV to accept this ...
    $kind = ' () + ';
    $isfuncorclassdecl = 1;
  } elsif (($name =~ /^(.*)[\t ]*class[ \t]+(.*)$/)) { # class def without extends
    $name = $2;
    DebugPrint("class def without extends - $name");
    $type = $1;
    $kind = ' () + ';
    $isfuncorclassdecl = 1;
  } elsif (($name =~ /\)[ ]*;?$/) and ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*\([ \t]*(.*)$/)) { # static func call with param
    $org_name = $name;
    $name = $1;
    if ($found_paren) {
      $argline = $2;
      $argline =~ s/\)([ ]*:[ ]*([^;]+))?;?$//;
      DebugPrint("func decl without type ... - $name");
      if ($name =~ /^on/i) {
        $is_javascript = 1;
        if (defined($2)) {
          $type = $2;
        }
      }
    } else {
      $type = $2;
      if ($type =~ /\(((?:[^\(\)]|\([^)]*\))*)\)[ ]*;?$/) {
        $type = $1;
        $name = $org_name;
        $name =~ s/[ \t]*\(([^\(\)]|\([^)]*\))*\)[ ]*;?$//;
      } else {
        $type =~ s/\)[ ]*;?$//;
      }
      DebugPrint("static func call with param - $name");
    }
  } elsif (($name =~ /^((?:$typepattern)+)([^;]+);?$/)) { # decl statement without init
    $type = $1;
    $name = $2;
    $type =~ s/[ \t]+$//;
    if ($name =~ /^[ ]*([^ :]+)[ ]*:[ ]*([^ ]+)[ ]*$/) { # think later ...
      $type .= ' ' . $2;
      $name = $1;
    } elsif ($name =~ /^([a-zA-Z0-9]+)[ ]+([a-zA-Z].*)/) { # this is hack ... treat class name
      $type .= ' ' . $1;
      $name = $2;
    }
    DebugPrint("decl statement without init - $name");
    if ($type =~ /interface/) {
      $kind = ' () ';
    } else {
      $kind = ' (out) ';
    }
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@\-\>\:]+);?$/)) { # and &islangelement($1) %% control statement (not actually ...)
    $name = $1;
    DebugPrint("control statement - $name");
    if ($name =~ /^default[ \t]*:$/) {
      $name =~ s/[ \t]*:$//;
    }
  } elsif (($name =~ /^(break|continue|return|throw)[ \t]+([^;]*);?$/)) { # break or continue
    $name = $1;
    DebugPrint("break or continue - $name");
    $type = $2;
  } elsif (($name =~ /^(.+)[ \t]+([^ \t;]+);?$/)) { # decl using defined class
    $name = $2;
    DebugPrint("decl using defined class - $name");
    $kind = ' (out) ';
    $type = $1;
  } elsif (length($text) != 0) { # not sure but ...
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  } else {
    return 1;
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  $in_comment = 0;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    push @lines, $_;
  }
  @lines1 = ();
  $tmp_line = '';
  $prev_is_continuation = 0;
  foreach $line (@lines) {
    $line =~ s/[ \t\n]+$//;
    $line =~ s/\t/        /g; # try this ...
    if (length($line) == 0) {
      next;
    }
    if ($line =~ /$continuationpattern$/) { # pattern to concatenate ...
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 1;
    } elsif ($line =~ /^$continuationpattern2/) {
      if (length($tmp_line) != 0) {
        $line =~ s/^[ \t]*/ /;
        $tmp_line = $tmp_line . $line;
      } else {
        $tmp_line = $line; # should not happen ...
      }
      $prev_is_continuation = 0;
    } else {
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 0;
    }
  }
  if (length($tmp_line) != 0) {
    push @lines1, $tmp_line;
  }
  @lines2 = ();
  &process_multi_statement(\@lines1, \@lines2);
  @processed_lines = ();
  &process_multi_statement(\@lines2, \@processed_lines);
  foreach (@processed_lines) {
    $_ =~ s/[\n\t ]+$//;
    if ((length($_) != 0)) {
      $isfuncorclassdecl = 0;
      if (&extractparams($_)) {
        $prevname = '';
        next;
      }
      if ($type eq 'function') { # for JavaScript
        $function = '';
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
        } elsif (($prevname eq '_') and $isfuncorclassdecl) { # not &islangelement($name) and (($kind eq ' ' . '() ') or ($kind eq ' ' . '+ ')  or ($kind eq ' ' . '- '))
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
          $cur->{NAME} = $name;
          $cur->{KIND} = $kind;
          $cur->{TYPE} = $type;
        } elsif (($name eq '_text') and ($prevname eq '_text')) { # ($cur->{NAME} eq '_text')
          $cur->{TEXT} .= " \CRLF " . $text;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      } else {
        until ($prevlevel <= $level) {
          if ($cur->{PARENT} == $root) { # hack ???
            last;
          }
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevname = $name;
      $previndentedcomment = $indentedcomment;
      $prevlevel = $level;
      my $argkind = " \(in\) \& ";
      $argline =~ s/^[ \t]+//;
      $argline =~ s/[ \t]+$//;
      if (length($argline) != 0) {
        my @args = split(/[\t ]*,[\t ]*/, $argline);
        foreach $arg (@args) {
          if ($arg =~ /^((?:[a-zA-Z0-9_\$\@\[\]\{\}\.\-\>\*\: ]|,[\t ]*)+)[\t ]*=[\t ]*(.+)$/) { # assignment
            my $name = $1;
            my $init_value = $2;
            my $type = '';
            DebugPrint("arg - assignment - $arg");
            if ($name =~ /([ \t]+[^ \t]+)$/) {
              $type = $name;
              $name = $1;
              $type =~ s/[ \t]+[^ \t]+$//;
              $name =~ s/^[ \t]+//;
            }
            $type .= '  ' . $init_value;
            &addchildnode($cur, $name, $argkind, $type, '');
          } elsif ($arg =~ /:/) {
            $arg =~ s/^[ ]*([^ :]+)[ ]*:[ ]*([^ ]+)[ ]*$//;
            $type = $2;
            $name = $1;
            &addchildnode($cur, $name, $argkind, $type, '');
          } elsif ($arg =~ /([ \t]+[^ \t]+)$/) {
            $type = $arg;
            $name = $1;
            $type =~ s/[ \t]+[^ \t]+$//;
            $name =~ s/^[ \t]+//;
            &addchildnode($cur, $name, $argkind, $type, '');
          } else {
            DebugPrint("arg - default - $arg");
            &addchildnode($cur, $arg, $argkind, '', '');
          }
        }
        if (length($body) != 0) {
          &extractparams($body);
          &addchildnode($cur, $name, $kind, $type, $text);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub islangelement {
  my($str) = @_;
  foreach $langelement (@langelements) {
    if ($str eq $langelement) {
      return 1;
    }
  }
  return 0;
}
sub process_multi_statement {
  my($from_array_ref, $to_array_ref) = @_;
  foreach $line (@$from_array_ref) {
    if ($line =~ /^([ \t]*)(try)[ \t]*\{([^\}]+)\}[ \t]*(catch)[ ]*([^\/\*]+)(\/[\/\*].+)?$/) { # pattern for try ...
      $indent = $1;
      $try = $2;
      $block = $3;
      $catch = $4 . ' ' . $5;
      $com = $6;
      push @$to_array_ref, $indent . $try . $com;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
      push @$to_array_ref, $indent . $catch;
    } elsif ($line =~ /^([ \t]*)(if|for|while)[ \t]*(\([^\)]+\))[ \t]*\{([^\}]+)\}[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' ' . $3 . $5;
      $indent = $1;
      $block = $4;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif ($line =~ /^([ \t]*)([a-zA-Z_0-9]+)[ \t]*:[ \t]*(.+)$/) { # pattern for label with statement ... case default ???
      push @$to_array_ref, $1 . $2 . ':';
      push @$to_array_ref, $1 . $3;
    } elsif ($line =~ /^([ \t]*)((?:$typepattern)+)([^\{]+)[ \t]*\{([^\}]+)\}[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      $indent = $1;
      $decl_type = $2;
      $decl_items = $3;
      $block = $4;
      $com = $5;
      $decl_type =~ s/[ \t]+$//;
      push @$to_array_ref, $indent . $decl_type . ' ' . $decl_items . ' {' . $com;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif (($line =~ /^[^\(\{]+,/) and ($line =~ /^([ \t]*)((?:$typepattern)+)([^;]+);[ \t]*(\/[\/\*].+)?$/)) { # pattern for decl ... hack...
      $indent = $1;
      $decl_type = $2;
      $decl_items = $3;
      $com = $4;
      $decl_type =~ s/[ \t]+$//;
      @inner_statements = split(/[ \t]*,[ \t]*/, $decl_items);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . $decl_type . ' ' . $inner_statement . ';' . $com; # better ?
        $com = '';
      }
    } elsif ($line =~ /^([ \t]*)(else[ \t]+if|if|for|while)[ \t]*(\((?:[^\(\)]|\([^\)]*\))+\))[ \t]*([^;]+;)[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' ' . $3 . $5;
      push @$to_array_ref, $1 . '  ' . $4;
    } elsif ($line =~ /^([ \t]*)(else|try)[ \t]*\{([^\}]+)\}[ \t]*(\/[\/\*].+)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . $4;
      $indent = $1;
      $block = $3;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif ($line =~ /^([ \t]*)\}?[ \t]*(else|try)[ \t]*([^;]+;)[ \t]*(.*)$/) { # pattern for line line control statement
      $indent = $1;
      $name = $2;
      $block = $3;
      $com = $4;
      push @$to_array_ref, $indent . $name . $com;
      push @$to_array_ref, $indent . '  ' . $block;
    } elsif ((not $line =~ /^[ \t]*for[ \t\(]/) and ($line =~ /;[^;\}]+;[ \t]*(\/[\/\*].+)?$/)) { # hack ...
      $line =~ /^([ \t]*)/;
      $indent = $1;
      @inner_statements = split(/[ \t]*;[ \t]*/, $line);
      for ($i = 0; $i <= $#inner_statements; $i++) { # - 1 is needed for \n ?
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . $inner_statement . ';'; # better ?
      }
    } else {
      push @$to_array_ref, $line;
    }
  }
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
  if (defined($nd->{CHILD})) {
    # for case - when / else
    my $cn = $nd->{CHILD};
    $foundcase = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'case') {
        $foundcase = 1;
        $casenode = $cn;
      } elsif ($foundcase) {
        if (($cn->{NAME} eq 'else') or ($cn->{NAME} eq 'when')) {
          &delnode($cn);
          &addchildnode2($casenode, $cn);
        }
      } else {
        $foundcase = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
    # for begin - rescue / ensure
    my $cn = $nd->{CHILD};
    $foundbegin = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'begin') {
        $foundbegin = 1;
        $beginnode = $cn;
      } elsif ($foundbegin) {
        if (($cn->{NAME} eq 'ensure') or ($cn->{NAME} eq 'rescue')) {
          &delnode($cn);
          &addchildnode2($beginnode, $cn);
        }
      } else {
        $foundbegin = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub treatwhiles {
  my($nd) = @_;
  &treatwhilesbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatwhiles($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatwhilesbody {
  my($nd) = @_;
  if (($nd->{NAME} eq 'do') and defined($nd->{NEXT}) and ($nd->{NEXT}->{NAME} eq 'while') and not defined($nd->{NEXT}->{CHILD})) { # ok?
    $nd->{TYPE} = $nd->{NEXT}->{TYPE};
    delnode($nd->{NEXT});
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
