# File: JoinDiaryItems2_Perl.pl
# Date            Author        number of nodes
# 2004/4/22       Walking Lint  178
# 2004/4/22       Walking Lint  88 (JoinDiaryItems_Perl->JoinDiaryItems2_Perl)
# 2004/3/4        Walking Lint  88
# 2003/9/1        Walking@Lint 81
# 2003/6/1        Walking Lint  81
# 2003/4/8        Walking Lint  78
# 2002/9/26       Walking Lint  78
# 2002/9/20       Walking Lint  71
# 2002/9/20       Walking Lint  35 (GetFromZope_Perl->JoinDiaryItems_Perl)
# 2002/9/10       Walking Lint  21
# 2002/9/7        Walking Lint  4 (GetWebPage2_Perl->NewFile)
# 2002/4/21       Walking Lint  4 (GetWeb_Perl->GetWebPage2_Perl)

=pod

=head1 NAME

JoinDiaryItems2_Perl.pl - join diary items

=head1 DESCRIPTION

ex. perl.exe JoinDiaryItems_Perl.pl "D:\HP" "D:\HP\work"

=head1 AUTHOR

Walking Lint

=cut

use LWP::Simple;
use Net::FTP;
use File::Basename;
use File::Copy;
$dir = shift;
$exportdir = shift;
$upload = shift;
$DeleteSideInEntryPage = 0;
if ($upload) { # not actually
  $hostname = $ENV{FtpHostName};
  DebugPrint("hostname = $hostname");
  $username = $ENV{FtpUserName};
  $password = $ENV{FtpPassWord};
  $remotedir = $ENV{FtpRemoteDir};
  $ftp = Net::FTP->new($hostname);
  $ftp->login($username, $password);
  $ftp->cwd($remotedir);
}
$found_arg = 0;
unless ($found_arg) {
  opendir DIR, $dir or die "opendir($dir) failed: $!";
  @files = grep !/^\.\.?$/, readdir DIR;
  @files = grep /^20[0-9]+/, @files;
  closedir DIR;
}
$first = 1;
foreach $file (reverse sort @files) {
  $from_file = $exportdir . "\\" . $file;
  if ($from_file =~ /\\([0-9]{4})([0-9]{2})\.html$/) {
    $year = $1;
    $month = $2;
    $month =~ s/^0//;
    $to_file = $dir . "\\" . $file;
    open OUT, ">$to_file";
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $in_dtml_in = 0;
    $line = '';
    while (<IN>) {
      if ($in_dtml_in) {
        if (/<dtml-if[^']+'([^']+)'">/) {
          $yearmonth = $1;
        } elsif (/<\/dtml-in>/) {
          $in_dtml_in = 0;
        } elsif (/<dtml-var sequence-item>/) {
          opendir DIR2, $dir2 or die "opendir($dir2) failed: $!";
          @files2 = grep !/^\.\.?$/, readdir DIR2;
          @files2 = grep /^$yearmonth/, @files2;
          closedir DIR2;
          if ($first) { # sometimes it is not needed ...
            foreach $file2 (reverse sort @files2) {
              $from_file2 = $dir2 . "\\" . $file2;
              if ($from_file2 =~ /\\[0-9]{8}$/) {
                open IN2, $from_file2 || die("Can't open $from_file2: $!\n");
                print OUT <IN2>;
                close IN2;
              }
            }
          } else {
            foreach $file2 (sort @files2) {
              $from_file2 = $dir2 . "\\" . $file2;
              if ($from_file2 =~ /\\[0-9]{8}$/) {
                open IN2, $from_file2 || die("Can't open $from_file2: $!\n");
                print OUT <IN2>;
                close IN2;
              }
            }
          }
          $pre = $line;
          $line = '';
        }
      } else {
        if (/<dtml-in expr="([^\.]+)\.objectValues\(\)">/) {
          $in_dtml_in = 1;
          $1 $fn;
          $dir2 = $exportdir . "\\" . $fn;
        } elsif (/<dtml-var ([^>]+)>/) {
          $from_file2 = $exportdir . "\\" . $fn;
          open IN2, $from_file2 || die("Can't open $from_file2: $!\n");
          @in2 = <IN2>;
          $in2 = join('', @in2);
          print OUT $in2;
          close IN2;
          if (not ($DeleteSideInEntryPage and ($fn =~ /(Index|Weblogs)/))) {
            $line .= $in2;
          } elsif ($DeleteSideInEntryPage and ($fn =~ /Weblogs/)) {
            $line .= "</div>\n";
          }
        } else {
          print OUT $_;
          $line .= $_;
        }
      }
    }
    close IN;
    close OUT;
    $post = $line;
    if ($first) {
      copy($to_file, $dir . "\\index.html");
    }
    $dir2 = $exportdir . "\\Articles"; # try this ...
    opendir DIR2, $dir2 or die "opendir($dir2) failed: $!";
    @files2 = grep !/^\.\.?$/, readdir DIR2;
    @files2 = grep /^$yearmonth/, @files2;
    closedir DIR2;
    foreach $file2 (reverse sort @files2) {
      $from_file2 = $dir2 . "\\" . $file2;
      if ((not $from_file2 =~ /\\[0-9]{8}$/) and (not $from_file2 =~ /d/)) {
        $to_file = $dir . "\\" . $file2 . '.html';
        open OUT, ">$to_file";
        open IN2, $from_file2 || die("Can't open $from_file2: $!\n");
        @entry = <IN2>;
        $entry = join('', @entry);
        $entry =~ /<h3[^>]*>(.*)<a/;
        $title = $1;
        $title =~ s/<span class="entrysubtitle".*<\/span>//; # try this ...
        $pre2 = $pre;
        $pre2 =~ s/<title>(.*)<\/title>/<title>$title - $1<\/title>/;
        print OUT $pre2;
        $datefile = $from_file2;
        $datefile =~ s/[0-9]{6}$/d/;
        open IN2, $datefile || die("Can't open $datefile: $!\n");
        print OUT <IN2>;
        print OUT $entry;
        $post2 = $post;
        $post2 =~ s/href="\#/href=$file\#/g;
        $post2 =~ s/>- $year/><a href="${file2}.html">- $year/;
        $post2 =~ s/\/$month<\/div>/\/$month<\/a><\/div>/;
        print OUT $post2;
        close OUT;
      }
    }
    if ($upload) {
      $ftp->put($to_file, basename($to_file));
    }
    $first = 0; # do nothing
  }
}
if ($upload) {
  $ftp->quit();
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
