# File: JoinDiaryItems_Perl.pl
# Date            Author        number of nodes
# 2004/4/22       Walking Lint  89
# 2004/3/4        Walking Lint  88
# 2003/9/1        Walking@Lint 81
# 2003/6/1        Walking Lint  81
# 2003/4/8        Walking Lint  78
# 2002/9/26       Walking Lint  78
# 2002/9/20       Walking Lint  71
# 2002/9/20       Walking Lint  35 (GetFromZope_Perl->JoinDiaryItems_Perl)
# 2002/9/10       Walking Lint  21
# 2002/9/7        Walking Lint  4 (GetWebPage2_Perl->NewFile)
# 2002/4/21       Walking Lint  4 (GetWeb_Perl->GetWebPage2_Perl)

=pod

=head1 NAME

JoinDiaryItems_Perl.pl - join diary items

=head1 DESCRIPTION

ex. perl.exe JoinDiaryItems_Perl.pl "D:\HP" "D:\HP\work"

=head1 AUTHOR

Walking Lint

=cut

use LWP::Simple;
use Net::FTP;
use File::Basename;
$dir = shift;
$exportdir = shift;
$upload = shift;
if ($upload) {
  $hostname = $ENV{FtpHostName};
  DebugPrint("hostname = $hostname");
  $username = $ENV{FtpUserName};
  $password = $ENV{FtpPassWord};
  $remotedir = $ENV{FtpRemoteDir};
  $ftp = Net::FTP->new($hostname);
  $ftp->login($username, $password);
  $ftp->cwd($remotedir);
}
$found_arg = 0;
unless ($found_arg) {
  opendir DIR, $dir or die "opendir($dir) failed: $!";
  @files = grep !/^\.\.?$/, readdir DIR;
  @files = grep /^20[0-9]+.html$/, @files;
  closedir DIR;
}
$first = 1;
foreach $file (reverse sort @files) {
  $from_file = $exportdir . "\\" . $file;
  if ($from_file =~ /\\[0-9]{6}\.html$/) {
    if ($first and not $found_arg) {
      $first = 0; # do nothing
    } else {
      $to_file = $dir . "\\" . $file;
      DebugPrint("to_file = $to_file");
      open OUT, ">$to_file";
      open IN, $from_file || die("Can't open $from_file: $!\n");
      $in_dtml_in = 0;
      while (<IN>) {
        if ($in_dtml_in) {
          if (/<dtml-if[^']+'([^']+)'">/) {
            $yearmonth = $1;
          } elsif (/<\/dtml-in>/) {
            $in_dtml_in = 0;
          } elsif (/<dtml-var sequence-item>/) {
            opendir DIR2, $dir2 or die "opendir($dir2) failed: $!";
            @files2 = grep !/^\.\.?$/, readdir DIR2;
            @files2 = grep /^$yearmonth/, @files2;
            closedir DIR2;
            if ($found_arg) {
              foreach $file2 (reverse sort @files2) {
                $from_file2 = $dir2 . "\\" . $file2;
                open IN2, $from_file2 || die("Can't open $from_file2: $!\n");
                print OUT <IN2>;
                close IN2;
              }
            } else {
              foreach $file2 (sort @files2) {
                $from_file2 = $dir2 . "\\" . $file2;
                open IN2, $from_file2 || die("Can't open $from_file2: $!\n");
                print OUT <IN2>;
                close IN2;
              }
            }
          }
        } else {
          if (/<dtml-in expr="([^\.]+)\.objectValues\(\)">/) {
            $in_dtml_in = 1;
            $dir2 = $exportdir . "\\" . $1;
          } elsif (/<dtml-var ([^>]+)>/) {
            $from_file2 = $exportdir . "\\" . $1;
            open IN2, $from_file2 || die("Can't open $from_file2: $!\n");
            print OUT <IN2>;
            close IN2;
          } else {
            print OUT $_;
          }
        }
      }
      close IN;
      close OUT;
      if ($upload) {
        $ftp->put($to_file, basename($to_file));
        DebugPrint("transfered $to_file");
      }
    }
  }
}
if ($upload) {
  $ftp->quit();
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
