# File: LinkCheck_Perl.pl
# Date            Author        number of nodes
# 2002/11/27      Walking Lint  71
# 2002/11/22      Walking Lint  70
# 2002/11/20      Walking Lint  53
# 2002/11/19      Walking Lint  58 (Links_Perl->LinkCheck_Perl)
# 2002/11/19      Walking Lint  32 (CheckLinks_Perl->Links_Perl)
# 2002/11/19      Walking Lint  22 (ExtractLinks_Perl->CheckLinks_Perl)

=pod

=head1 NAME

LinkCheck_Perl.pl - check links from url

=head1 DESCRIPTION

ex. perl.exe LinkCheck_Perl.pl http://member.nifty.ne.jp/WalkingLint/ member

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use LWP::Simple;
use HTML::LinkExtor;
use Jcode;
# get proxy info from registry
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$ref->Close();
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = $proxyoverride");
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = $proxyserver");
$url = shift;
DebugPrint("url = $url");
$mask = shift;
DebugPrint("mask = $mask");
$webagent = new LWP::UserAgent;
$webagent2 = new LWP::UserAgent;
$webagent2->agent('LWP::GETHEAD');
unless ($url =~ /$proxyoverride/) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
  $webagent2->proxy(['ftp', 'http'] => "http://$proxyserver");
}
$request = new HTTP::Request('GET' => $url);
$response = $webagent->request($request);
$count = 0;
if ($response->is_success) {
  $parser = HTML::LinkExtor->new(\&link_callback, $url);
  $parser->parse($response->content);
}
if ($count > 1) {
  print "\nfound $count broken links\n";
} else {
  print "\nfound $count broken link\n";
}
sub link_callback {
  my($tag, %links) = @_;
  if ($tag eq "a") {
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      if (($url =~ /^http/) and ($url =~ /\.htm/) and (not $url =~ /\#/)) {
        if ((not defined($mask)) or ($url =~ /$mask/)) {
          check_link($url);
        }
      }
    }
  }
}
sub check_link {
  my($link) = @_;
  $request2 = new HTTP::Request('HEAD' => $link);
  $response2 = $webagent2->request($request2);
  if ($response2->is_success) {
    print "OK - $link\n";
  } else {
    print "NG - $link\n";
    $count++;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
