# File: LinkList_Perl.pl
# Date            Author        number of nodes
# 2003/1/6        Walking Lint  76
# 2002/11/16      Walking Lint  76 (GenLinkList_Perl->LinkList_Perl)
# 2002/10/17      Walking Lint  76
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenLinkList_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

LinkList_Perl.pl - generate Link List

=head1 DESCRIPTION

ex. perl.exe LinkList_Perl "D:\My Weblog\AboutCMS.pat"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$from_file = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if (defined($root->{CHILD})) {
  my $nd = $root->{CHILD};
  while (1) {
    if ((not $nd->{NAME} =~ /^_/) and defined($nd->{CHILD})) {
      &genlinklist($nd);
      last;
    }
    if (not defined($nd->{NEXT})) {
      last;
    }
    $nd = $nd->{NEXT};
  }
}
sub genlinklist {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    print <<END;
<ol>
END
    my $cn = $nd->{CHILD};
    while (1) {
      if (not $cn->{NAME} =~ /^_/) {
        %links = ();
        %urls = ();
        my $first = 1;
        &genlinklistbody($cn);
        foreach $key (sort {lc($a) . $urls{$a} cmp lc($b) . $urls{$b}} keys %urls) {
          if ($first) {
            $first = 0;
            print <<END;
<li>$cn->{NAME}</li>
<ol>
END
          }
          print <<END;
<li><a href=$urls{$key}>$key</a></li>
END
        }
        if (not $first) {
          print <<END;
</ol>
END
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    print <<END;
</ol>
END
  }
}
sub genlinklistbody {
  my($nd) = @_;
  @lines = split('CRLF', $nd->{TEXT});
  foreach $line (@lines) {
    if ($line =~ /\[\[([^!]+)!([^\]!]+)\]\]/) {
      unless ($links{$2}++) {
        $urls{$1} = $2;
      }
    }
  }
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if ((not $cn->{NAME} =~ /^_/) or ($cn->{NAME} eq '_text')) {
        &genlinklistbody($cn);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
