# File: ListPatentWithFterm_Perl.pl
# Date            Author        number of nodes
# 2006/7/19       Walking Lint  108
# 2006/7/19       Walking Lint  397 (HistogramPatent_Perl->ListPatentWithFterm_Perl)
# 2006/7/5        Walking Lint  397
# 2006/3/27       Walking Lint  391
# 2006/3/24       Walking Lint  386
# 2006/3/23       Walking Lint  382
# 2006/3/22       Walking Lint  382
# 2006/3/20       Walking Lint  374
# 2006/2/9        Walking Lint  316
# 2006/2/8        Walking Lint  305
# 2005/12/9       Walking Lint  299
# 2005/11/22      Walking Lint  283
# 2005/11/15      Walking Lint  260
# 2005/4/28       Walking Lint  239
# 2005/4/13       Walking Lint  236
# 2005/4/6        Walking Lint  234
# 2005/4/5        Walking Lint  181
# 2005/4/4        Walking Lint  111
# 2005/4/4        Walking Lint  82 (GenRefRelationsFromPatents_Perl->HistogramPatent_Perl)
# 2005/4/4        Walking Lint  82
# 2005/4/2        Walking Lint  51
# 2005/4/2        Walking Lint  265 (AugmentFTermWithPatent_Perl->GenRefRelationsFromPatents_Perl)
# 2005/3/31       Walking Lint  265
# 2005/3/24       Walking Lint  265
# 2005/3/23       Walking Lint  263
# 2005/3/17       Walking Lint  263
# 2005/3/16       Walking Lint  224
# 2005/3/14       Walking Lint  277
# 2005/3/11       Walking Lint  273
# 2005/3/10       Walking Lint  267
# 2005/3/9        Walking Lint  235
# 2005/3/8        Walking Lint  154
# 2005/3/7        Walking Lint  128
# 2005/3/6        Walking Lint  126
# 2005/3/6        Walking Lint  123 (PatentMapWriter_Perl->AugmentFTermWithPatent_Perl)
# 2005/3/5        Walking Lint  123
# 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl)
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85
use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$is_US = shift;
$from_file = shift;
$fterm_to_check = shift;
if ($is_US == 0) { # is japan
  $fterm_to_check =~ /(.....)(....)/;
  $fterm_to_check = $1;
  DebugPrint("fterm_to_check = $fterm_to_check");
  $subfterm_to_check = $2;
  DebugPrint("subfterm_to_check = $subfterm_to_check");
}
$include_subclasses = 1; # this is default ...
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
@list = ();
&listfterm($root);
foreach $list (@list) {
  $list =~ s/@/ /g;
  $list =~ s/  / /g;
  $list =~ s/\t/ /g;
  $list =~ s/^/-- [[/;
  $list =~ s/ j/!j/;
  $list =~ s/txt$/htm]]/;
  $list =~ s/txt -$/htm]] -/;
  DebugPrint("$list");
}
sub listfterm {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      $text = $cn->{TEXT};
      $year = '';
      if (($is_US == 1) and ($cn->{NAME} eq 'United States Patent')) {
        my $ccn = $cn->{CHILD};
        while (1) {
          if ($ccn->{NAME} eq 'CLASSIFICATION') { # this is for MicroPatentReader
            my $cccn = $ccn->{CHILD};
            $is_primary = 1;
            while (1) {
              if (($cccn->{NAME} eq 'U.S. Class') or ($include_subclasses == 1) and (($cccn->{NAME} eq 'Cross Ref. Class') or ($cccn->{NAME} eq 'Field of Search'))) {
                $item = $cccn->{TEXT};
                $item =~ s/[ ]*$//;
                if ($item eq $fterm_to_check) {
                  if ($is_primary) {
                    push @list, $text;
                  } else {
                    push @list, $text . ' -'; # this is hack
                  }
                  last;
                }
                $is_primary = 0;
                if ($include_subclasses != 1) {
                  last;
                }
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
      } elsif (($is_US == 0) and ($cn->{NAME} eq 's')) {
        my $ccn = $cn->{CHILD};
        while (1) {
          if ($ccn->{NAME} =~ /^(|㗝l|ol||lĎ|Ql)/) {
            my $cccn = $ccn->{CHILD};
            $found_fterm = '';
            $found_fterm2 = '';
            while (1) {
              if ($cccn->{NAME} eq 'e^[iQlj') { # also see this ...
                $found_fterm = $cccn->{TEXT};
              } elsif ($cccn->{NAME} eq 'e^[ieiXj') { # this is default ...
                $found_fterm2 = $cccn->{TEXT};
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
            if (length($found_fterm2) != 0) {
              $found_fterm = $found_fterm2;
            }
            if (length($found_fterm) != 0) {
              @items = split(/\t/, $found_fterm);
              my $cnt = 0;
              $matched = 0;
              foreach $item (@items) {
                if ($cnt % 2 == 0) {
                  if ($item =~ /^$fterm_to_check/) {
                    $matched = 1;
                  }
                } elsif ($matched == 1) {
                  @fsubterms = split(/[ ]+/, $item);
                  foreach $fsubterm (@fsubterms) {
                    if ($fsubterm eq $subfterm_to_check) {
                      push @list, $text;
                    }
                  }
                  last;
                }
                $cnt++;
              }
            }
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
