# File: Memo2Outlook_Perl.pl
# Date            Author        number of nodes
# 2005/8/29       Walking Lint  72
# 2004/6/4        Walking Lint  65
# 2004/5/31       Walking Lint  58
# 2004/5/28       Walking Lint  53
# 2004/5/28       Walking Lint  74 (DotWriter_Perl->Memo2Outlook_Perl)
# 2003/10/20      Walking Lint  74
# 2003/10/20      Walking Lint  44 (IniWriter_Perl->DotWriter_Perl)
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

Memo2Outlook_Perl.pl - Memo.pat to Outlook (import as csv)

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if (length($to_file) != 0) {
  open OUT, ">$to_file";
  $outhandle = 'OUT';
} else {
  $outhandle = 'STDOUT';
}
print $outhandle "\tJn\te\n";
&gencsv($root, 0);
if (length($to_file) != 0) {
  close OUT;
  DebugPrint("generated $to_file");
} else {
  DebugPrint("generated to clipboard");
}
sub gencsv {
  my($nd, $level) = @_;
  if (($nd->{NAME} =~ /^_/) or ($nd->{KIND} =~ /!/)) { # this is needed ... think later ...
    return;
  }
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      gencsv($cn, $level + 1);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  } else {
    if ($level == -1) { # do nothing ... for root ...
    } else {
      $content = '';
      $kenmei = $nd->{NAME};
      $kaishibi = $nd->{TEXT};
      if ($kenmei =~ /\(([0-9]+)\)$/) {
        $content = $1;
        $kenmei =~ s/[ ]*\($content\)$//;
      }
      if ($kaishibi=~ /^([0-9\/]+)[^ ]+ - (.*)/) {
        $kenmei .= ' ' . $2;
        $kaishibi = $1;
      } elsif ($kaishibi=~ /^([0-9\/]+)/) {
        $kaishibi = $1;
      }
      $line = $kenmei . "\t" . $kaishibi . "\t" . $content . "\n";
      print $outhandle $line;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
