# File: Memo2_Perl.pl
# Date            Author        number of nodes
# 2005/2/3        Walking Lint  683
# 2005/2/3        Walking Lint  683 (Memo_Perl->Memo2_Perl)
# 2004/11/22      Walking Lint  683
# 2004/6/23       Walking Lint  676
# 2004/6/1        Walking Lint  666
# 2004/3/26       Walking Lint  666
# 2004/1/21       Walking Lint  666
# 2003/11/25      Walking Lint  652
# 2003/11/21      Walking Lint  646
# 2003/10/14      Walking Lint  645
# 2003/10/9       Walking Lint  619
# 2003/9/26       Walking Lint  619
# 2003/9/18       Walking Lint  619
# 2003/7/8        Walking Lint  619
# 2003/6/25       Walking Lint  619
# 2003/6/11       Walking Lint  616
# 2003/5/9        Walking Lint  616
# 2003/3/2        Walking Lint  614
# 2003/2/25       Walking Lint  749
# 2003/1/29       Walking Lint  514
# 2003/1/28       Walking Lint  512
# 2003/1/21       Walking Lint  512
# 2002/12/27      Walking Lint  508
# 2002/12/26      Walking Lint  500
# 2002/12/25      Walking Lint  492
# 2002/12/13      Walking Lint  479
# 2002/12/11      Walking Lint  479
# 2002/12/4       Walking Lint  253
# 2002/12/2       Walking Lint  249
# 2002/11/26      Walking Lint  200
# 2002/11/25      Walking Lint  177
# 2002/11/25      Walking Lint  177 (AddToMemo_Perl->Memo_Perl)
# 2002/11/21      Walking Lint  167
# 2002/11/21      Walking Lint  119 (AddToMeno_Perl->AddToMemo_Perl)
# 2002/11/16      Walking Lint  92
# 2002/10/25      Walking Lint  92
# 2002/10/23      Walking Lint  92
# 2002/10/22      Walking Lint  138 (AddToMemo_Perl->AddToMeno_Perl)
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (AddToMemo_Perl->AddToMemo_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->AddToMemo_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

Memo2_Perl.pl - add todo item to Memo2.pat

=head1 DESCRIPTION

ex. perl.exe Memo2_Perl.pl "T" ""

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Time::localtime;
@yobi = ('', '', '', '', '', '', 'y');
$use_clipboard = 1;
if ($use_clipboard) {
  use Win32::Clipboard;
}
$date = shift;
$orgdate = $date;
$item = shift;
$itemdesc = shift;
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
$perl = $ENV{PERL};
$perl =~ s/"//g;
$from_file = $templatesfolder . '\Memo2.pat';
# set parameters
$date = &getdatestr($date);
$is_date = 1;
if (length($date) == 0) {
  $date = $orgdate;
  $is_date = 0;
  $from_file = $templatesfolder . '\Memo2.pat'; # this is hack ...
}
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
&addmemo($root, $item, $date);
&savetree($root, $from_file); # better to be incorporated in CVTree
sub addmemo {
  my($nd, $item, $date) = @_;
  $tm = localtime;
  $regdate = sprintf("(%04d%02d%02d%02d%02d)", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min);
  $item .= ' ' . $regdate;
  if ($is_date == 0) {
    $prevnode = &getprevnode2($nd, $date);
    if (length($itemdesc) != 0) {
      $item .= ' - ' . $itemdesc;
    }
    if ($prevnode == -1) {
      if (defined($root->{CHILD})) {
        &insnode($root->{CHILD}, $date, " \(\) - ", '', $item);
      } else {
        &addchildnode($root, $date, " \(\) - ", '', $item);
      }
    } else {
      &addnode($prevnode, $date, " \(\) - ", '', $item);
    }
    if ($use_clipboard) {
      Win32::Clipboard->new($date . " \(\) - //  %" . '% ' . $item);
    }
  } else {
    if (not $date =~ / \- /) {
      ($year, $month, $day) = split(/[\/ \(]/, $date);
      $date .= '(' . $yobi[&day_of_week($year, $month, $day)] . ')';
    } else {
      ($date, $date2) = split(/ \- /, $date);
      ($year, $month, $day) = split(/[\/ \(]/, $date);
      ($year2, $month2, $day2) = split(/[\/ \(]/, $date2);
      $date .= '(' . $yobi[&day_of_week($year, $month, $day)] . ')';
      $date2 .= '(' . $yobi[&day_of_week($year2, $month2, $day2)] . ')';
      $date .= ' - ' . $date2;
    }
    $prevnode = &getprevnode($nd, $year, $month, $day);
    if (length($itemdesc) != 0) {
      $date .= ' - ' . $itemdesc;
    }
    if ($prevnode == -1) {
      if (defined($root->{CHILD})) {
        &insnode($root->{CHILD}, $item, " \(\) - ", '', $date);
      } else {
        &addchildnode($root, $item, " \(\) - ", '', $date);
      }
    } else {
      &addnode($prevnode, $item, " \(\) - ", '', $date);
    }
    if ($use_clipboard) {
      Win32::Clipboard->new($item . " \(\) - //  %" . '% ' . $date);
    }
  }
}
# [[Re: Getting Day of Week for a specific date!http://granite.unh.edu/pasnews/msg00674.html]]
sub day_of_week {
  my($y, $m, $d) = @_;
  @t = (0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4);
  $y -= ($m < 3);
  return ($y + int($y / 4) - int($y / 100) + int($y / 400) +$t[$m - 1] + $d) % 7;
}
sub getdatestr {
  my($str) = @_;
  $res = '';
  if ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Yesterday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Today_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\Tomorrow_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\DayAfterTomorrow_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextTuesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextWednesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextThursday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextFriday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^Ty/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSaturday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSunday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^T/) or ($str =~ /^T/)) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextFriday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^T/ or $str =~ /^T/)) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\MondayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\TuesdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\WednesdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThursdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^T/ or $str =~ /^T/)) { # may not be true ...
    open IN, '"' . $perl . '" "' . $templatesfolder . '\FridayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^Ty/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SaturdayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SundayInNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^ėT/ or $str =~ /^ėT/)) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\MondayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\TuesdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\WednesdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThursdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif (($str =~ /^ėT/ or $str =~ /^ėT/)) { # may not be true ...
    open IN, '"' . $perl . '" "' . $templatesfolder . '\FridayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėTy/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SaturdayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\SundayInNextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^T/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ėT/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextNextWeek_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^挎/) {
    if ($str =~ /^挎([0-9]+)()?/) {
      $tmpday = $1;
      open IN, '"' . $perl . '" "' . $templatesfolder . '\PrevMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
      $res =~ s/[0-9]+$/$tmpday/;
    } else {
      $res = '挎'; # currently not right ... think later ...
    }
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisMonth_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    if ($str =~ /^([0-9]+)()?/) {
      $tm = localtime;
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $tm->mon + 1, $1);
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\StartOfNextMonth_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    if ($str =~ /^([0-9]+)()?/) {
      $tmpday = $1;
      open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
      $res =~ s/[0-9]+$/$tmpday/;
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonth_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisQuarter_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\StartOfNextQuarter_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextQuarter_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^N/) {
    if ($str =~ /^N([0-9]+)\/([0-9]+)/) {
      $tm = localtime;
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $1, $2);
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\ThisYear_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^N/) {
    if ($str =~ /^N([0-9]+)\/([0-9]+)/) {
      $tm = localtime;
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900 + 1, $1, $2);
    } else {
      open IN, '"' . $perl . '" "' . $templatesfolder . '\NextYear_Perl.pl" |' or die "cannot execute script";
      $res = <IN>;
      close IN;
    }
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextMonday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^Ηj/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextTuesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextWednesday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^ؗj/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextThursday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextFriday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^yj/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSaturday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^j/) {
    open IN, '"' . $perl . '" "' . $templatesfolder . '\NextSunday_Perl.pl" |' or die "cannot execute script";
    $res = <IN>;
    close IN;
  } elsif ($str =~ /^([0-9]+)(\/|N)[ @]*([0-9]+)(\/|)[ @]*([0-9]+)/) {
    $res = sprintf("%04d/%02d/%02d" , $1, $3, $5);
  } elsif ($str =~ /^([0-9]+)N[ @]*([0-9]+)/) {
    $res = sprintf("%04dN%02d" , $1, $2);
  } elsif ($str =~ /^([0-9]+)(\/|)[ @]*([0-9]+)/) {
    $tm = localtime;
    if ($1 < $tm->mon + 1) { # better ?
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900 + 1, $1, $3);
    } else {
      $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $1, $3);
    }
  } elsif ($str =~ /^([0-9]+)(\x8C\x8E|\x96\x96)/) { # | is not functioning? or OK? ^^
    $tm = localtime;
    $mn = $1;
    if ($mn < $tm->mon + 1) { # better ?
      $yr = $tm->year + 1900 + 1;
    } else {
      $yr = $tm->year + 1900;
    }
    $dt = &GetLastDayOfMonth($yr, $mn);
    $res = sprintf("%04d/%02d/%02d" , $yr, $mn, $dt);
  } elsif ($str =~ /^([0-9]+)/) {
    $tm = localtime;
    $mn = $1;
    if ($mn < $tm->mon + 1) { # better ?
      $yr = $tm->year + 1900 + 1;
    } else {
      $yr = $tm->year + 1900;
    }
    $dt = 15;
    $res = sprintf("%04d/%02d/%02d" , $yr, $mn, $dt);
  } elsif (($str =~ /^([0-9]+)/) and $1 < 32) { # this is hack ...
    $tm = localtime;
    $res = sprintf("%04d/%02d/%02d" , $tm->year + 1900, $tm->mon + 1, $1);
  }
  return $res;
}
# [[Penguin Club-Perl!http://penguinclub.net/linux/perl/learn/page3.html]]
sub GetLastDayOfMonth {
  my($year, $month) = @_;
  @month_days = (0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
  if (($year % 4) == 0 and ($year % 100) != 0 or ($year % 400) == 0) {
    $month_days[2] = 29;
  }
  $last_date = $month_days[$month];
  return $last_date;
}
# not actually ...
sub getprevnode {
  my($nd, $year, $month, $day) = @_;
  my $prevnode = -1;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if (not $cn->{NAME} =~ /^_/) {
        if (length($cn->{TEXT}) != 0) {
          $curdate = $cn->{TEXT};
        } elsif (defined($cn->{CHILD}) and length($cn->{CHILD}->{TEXT}) != 0) {
          $curdate = $cn->{CHILD}->{TEXT};
        } else {
          return $prevnode;
        }
        ($curyear, $curmonth, $curday) = split(/[\/ \(]/, $curdate);
        if ((not defined($curday)) and (length($curyear) != 4)) { # may not be good ... actually ...
          $curday = $curmonth;
          $curmonth = $curyear;
          $curyear = $year;
        }
        if (($curyear < $year) or ($curyear == $year) and ($curmonth < $month) or ($curyear == $year) and ($curmonth == $month) and ($curday <= $day)) {
          $prevnode = $cn;
        } else {
          last;
        }
      } else {
        $prevnode = $cn;
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
  return $prevnode;
}
sub getprevnode2 {
  my($nd, $date) = @_;
  my $prevnode = -1;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      $curdate = $cn->{NAME};
      if (not $curdate =~ /^_/) {
        if ($curdate < $date) {
          $prevnode = $cn;
        } else {
          last;
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
  return $prevnode;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
