# File: MicroPatentReader_Perl.pl
# Date            Author        number of nodes
# 2006/3/28       Walking Lint  166
# 2006/3/27       Walking Lint  166
# 2006/3/22       Walking Lint  166
# 2006/3/20       Walking Lint  142
# 2006/3/20       Walking Lint  216 (PatentReader_Perl->MicroPatentReader_Perl)
# 2005/4/5        Walking Lint  216
# 2005/3/28       Walking Lint  214
# 2005/3/7        Walking Lint  203
# 2005/3/2        Walking Lint  190
# 2005/2/28       Walking Lint  188
# 2005/2/25       Walking Lint  188
# 2005/2/24       Walking Lint  188
# 2005/2/23       Walking Lint  158
# 2005/2/22       Walking Lint  135
# 2005/2/14       Walking Lint  131
# 2005/2/1        Walking Lint  122
# 2005/1/26       Walking Lint  113
# 2005/1/18       Walking Lint  110
# 2005/1/17       Walking Lint  107
# 2005/1/15       Walking Lint  92
# 2005/1/15       Walking Lint  87 (IniReader_Perl->PatentReader_Perl)
# 2005/1/15       Walking Lint  87
# 2005/1/14       Walking Lint  89
# 2003/9/2        Walking Lint  100
# 2003/9/2        Walking Lint  96 (GeppouReader_Perl->IniReader_Perl)
# 2003/8/1        Walking Lint  101
# 2003/7/31       Walking Lint  101
# 2003/6/30       Walking Lint  101
# 2002/12/3       Walking Lint  98
# 2002/12/2       Walking Lint  93
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

MicroPatentReader_Perl.pl - patent reader (JP-NET)

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
$assignee = '';
$inventor = '';
$patent_num = '';
$title = '';
my $root = {};
&initnode($root, 'root');
$is_first_line = 1;
$is_firsts_attr = 1;
$found_abstract = 0;
$found_assignee = 0;
$found_inventor = 0;
$is_first_inventor = 1;
$prev_is_number = 0;
&gentree($root, $from_file);
if (defined($root->{CHILD})) {
  if (length($assignee) == 0) { # this is hack ...
    $assignee = $inventor;
  }
  $root->{CHILD}->{TEXT} = $assignee . "\t" . $inventor . "\t" . $patent_num . "\t" . $title . "\t" . $from_file;
}
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' ()  '; # somehow this is hack ... think later ...
  $type = '';
  $text = '';
  $founditem = 0;
  if ($is_first_line == 1) {
    $is_first_line = 0;
    $level = 0;
    $name = $line;
    $prev_is_number = 0;
    return 0;
  } elsif (not ($line =~ /^\[([0-9]+)\] (.*)/) and ($line =~ /^\[([^]]*)\]/)) {
    $is_firsts_attr = 0;
    $level = 1;
    $name = $1;
    if ($name eq 'ABSTRACT') {
      $found_abstract = 1;
    } elsif ($name eq 'ASSIGNEE') {
      $found_assignee = 1;
    } elsif ($is_first_inventor and ($name eq 'INVENTOR')) {
      $found_inventor = 1;
      $is_first_inventor = 0;
    }
    $prev_is_number = 0;
    return 0;
  } elsif (($found_abstract == 0) and ($line =~ /^([^:]*):[ \t]*(.*)/)) {
    if ($is_firsts_attr == 1) {
      $level = 1;
    } else {
      $level = 2;
    }
    $name = $1;
    $text = $2; # better to be '  ' . $2 ???
    if ($name eq 'Name') {
      if ($found_assignee == 1) {
        $found_assignee = 0;
        $assignee = $text;
      } elsif (($found_inventor == 1) and not (($text eq 'INF') or ($text eq 'MUC') or ($text eq 'PA') or ($text eq 'PR') or ($text eq 'RDA'))) {
        $found_inventor = 0;
        $inventor = $text;
      }
    } elsif ($name eq 'City') { # try this ...
      if ($found_inventor == 1) {
        $found_inventor = 0;
        $inventor = $text;
      }
    } elsif ($name eq 'Patent Number') {
      $patent_num = $text;
    } elsif ($name eq 'Title') {
      $title = $text;
    }
    $prev_is_number = 0;
    return 0;
  } elsif ($line =~ /^[ ]*((?:BACKGROUND(?:S|)|FIELD|SUMMARY|TECHNICAL FIELD) OF THE INVENTION)/) {
    $level = 2;
    $name = $1;
    $prev_is_number = 0;
    return 0;
  } elsif ($line =~ /^[ ]*((?:BRIEF|DETAILED) DESCRIPTION OF THE DRAWINGS)/) {
    $level = 2;
    $name = $1;
    $prev_is_number = 0;
    return 0;
  } elsif ($line =~ /^[ ]*(DETAILED DESCRIPTION OF (?:A PREFERRED EMBODIMENT|THE INVENTION|THE PREFERRED EMBODIMENT))/) {
    $level = 2;
    $name = $1;
    $prev_is_number = 0;
    return 0;
  } elsif ($line =~ /^[ ]*(DESCRIPTION OF (?:THE PREFERRED EMBODIMENT(?:S|)|THE RELATED ART))/) {
    $level = 2;
    $name = $1;
    $prev_is_number = 0;
    return 0;
  } elsif ($line =~ /^([0-9]+\.) (.*)/) { # for claim
    if ($prev_is_number == 0) {
      $level++;
    }
    $name = $1;
    $text = $2;
    $prev_is_number = 1;
    return 0;
  } elsif ($line =~ /^\[([0-9]+)\] (.*)/) { # for statements
    if ($prev_is_number == 0) {
      $level++;
    }
    $name = $1;
    $text = $2;
    $prev_is_number = 1;
    return 0;
  } else {
    $founditem = 1;
    return 1;
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $founditem = 0;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    $_ =~ s/[\n\r]*$//;
    if ((length($_) != 0)) {
      if (&extractparams($_)) {
        if ($founditem) { # not used now ...
          $_ =~ s/^[ @]*//;
          if (length($cur->{TEXT}) == 0) {
            $cur->{TEXT} = $_;
          } else {
            $tmpline = " \CRLF " . $_;
            $cur->{TEXT} .= $tmpline;
          }
        }
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        $cur = addnode($cur, $name, $kind, $type, $text);
      } else {
        until ($prevlevel <= $level) {
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevlevel = $level;
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
