# File: NKGraph_Perl.pl
# Date            Author        number of nodes
# 2005/4/28       Walking Lint  50
# 2005/4/28       Walking Lint  30 (Chasen_Perl->NKGraph_Perl)
# 2005/4/28       Walking Lint  30
# 2005/4/27       Walking Lint  28
# 2005/4/27       Walking Lint  25 (SaHenSetuzokuMeishi_Perl->Chasen_Perl)
# 2005/4/27       Walking Lint  25
# 2005/4/27       Walking Lint  25 (KoyuuMeishi_Perl->SaHenSetuzokuMeishi_Perl)
# 2005/4/27       Walking Lint  25
# 2005/4/27       Walking Lint  25 (IppanMeishi_Perl->KoyuuMeishi_Perl)
# 2005/4/27       Walking Lint  5
# 2005/4/27       Walking Lint  5 (IP2Host_Perl->IppanMeishi_Perl)
# 2004/4/6        Walking Lint  67
# 2004/4/3        Walking Lint  67
# 2003/12/11      Walking Lint  52
# 2003/12/9       Walking Lint  44
# 2003/12/8       Walking Lint  12
# 2003/8/31       Walking@Lint 10
# 2003/3/14       Walking Lint  9
# 2002/8/14       Walking Lint  27 (Hx2Li_Perl->IP2Host_Perl)
# 2002/8/14       Walking Lint  3 (Hx2Li->Hx2Li_Perl)
# 2002/8/14       Walking Lint  3 (sort_Perl->Hx2Li)
# 2002/2/3        Walking Lint  3 (Sort2_Perl->sort_Perl)

=pod

=head1 NAME

NKGraph_Perl.pl - Nanchatte KeyGraph

=head1 DESCRIPTION

ref. <a href="http://www.carc.aist.go.jp/~y.matsuo/homepage/papers/jsai01a.pdf">̋N̓vɊẪL[[hoASY (PDF)</a>

=head1 AUTHOR

Walking Lint

=cut

$from_file = shift;
$max_num_of_elem = shift;
if (length($max_num_of_elem) == 0) {
  $max_num_of_elem = 999;
}
if (length($from_file) == 0) {
  $from_file = $ENV{TEMPLATESFOLDER} . '\\' . 'chasen.tmp';
  open OUT, ">$from_file" or die("Cannot open $from_file: $!\n");
  while (<STDIN>) {
    print OUT $_;
  }
  close OUT;
}
$to_file = $ENV{TEMPLATESFOLDER} . '\\' . 'chasen.out';
$chasen = $ENV{CHASEN};
if (not -e $to_file) {
  open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
  close OUT;
}
system '"' . $chasen . '" "' . $from_file . '" > "' . $to_file . '"';
open IN, $to_file or die("Cannot open $to_file: $!\n");
%keys = ();
%kinds = ();
$prev = '';
while (<IN>) {
  $_ =~ s/[\r\n]*$//;
  if ($_ eq 'EOS') {
    $prev = '';
  } elsif ($_ =~ /(`e|-(ŗL||Tϐڑ))/) { # $_ =~ /(`e|-(ŗL||Tϐڑ)|-|m)/
    ($key, $dummy, $dummy, $kind) = split(/\t/, $_);
    $kinds{$key} = $kind;
    if (length($prev) != 0) {
      $idx = $prev . "\t" . $key;
      $keys{$idx}++;
    }
    $prev = $key;
  }
}
close IN;
$cnt = 0;
@sorted_keys = sort {$keys{$b} <=> $keys{$a}} keys %keys;
$max_freq = $keys{$sorted_keys[0]};
foreach $key (@sorted_keys) { # (sort {$keys{$b} <=> $keys{$a}} keys %keys)
  $cnt++;
  if ($cnt <= $max_num_of_elem) {
    ($prev, $post) = split(/\t/, $key);
    print "$prev\t$post\n"; # "$prev\t$post\t$keys{$key}\t$kinds{$prev} - $kinds{$post}\n"
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
