# File: OpmlReader_Perl.pl
# Date            Author        number of nodes
# 2003/9/27       Walking@Lint 56
# 2003/5/17       Walking Lint  49
# 2003/3/6        Walking Lint  39
# 2003/3/6        Walking Lint  46 (OPML_Perl->OpmlReader_Perl)

=pod

=head1 NAME

OpmlReader_Perl.pl - OPML reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use strict;
use XML::Simple;
use Data::Dumper;
use File::Basename;
use Time::localtime;
my $from_file = shift;
my $to_file = $from_file;
$to_file =~ s/\..+/.pat/;
open IN, $from_file || die("Can't open $from_file: $!\n");
open IN, $from_file or die("Cannot open $from_file: $!\n");
my @lines = <IN>;
my $xml = join('', @lines);
close IN;
open OUT, ">$to_file";
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.opml'; # not sure ...
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
print OUT "root () /" . "/  %" . "% $file_comment\n";
my $info = XML::Simple::XMLin($xml);
my $data = $info->{body}->{outline};
&print_outline($data, "\t");
close OUT;
sub print_outline {
  my($data, $indent) = @_;
  my @list = @$data;
  foreach my $item (@list) {
    my $text = $item->{text};
    my $data2 = $item->{outline};
    if (length($text) >= 250) {
      print OUT $indent . "_text () \/\/  \%\% " . $text . "\n";
    } else {
      print OUT $indent . $text . " ()\n";
    }
    if (defined($data2)) { # think later ...
      &print_outline($data2, $indent . "\t");
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
