# File: Outline2Excel_Perl.pl
# Date            Author        number of nodes
# 2004/6/28       Walking Lint  72
# 2004/6/28       Walking Lint  74 (DotWriter_Perl->Outline2Excel_Perl)
# 2003/10/20      Walking Lint  74
# 2003/10/20      Walking Lint  44 (IniWriter_Perl->DotWriter_Perl)
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

Outline2Excel_Perl.pl

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$crlf = ' CR' . 'LF ';
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if (length($to_file) != 0) {
  open IN, $to_file || die("Can't open $to_file: $!\n");
  open OUT, ">$to_file";
  $outfilehandle = 'OUT';
} else {
  $outfilehandle = 'STDOUT';
}
&gencsv($root, 0);
if (length($to_file) != 0) {
  close $outfilehandle;
}
sub gencsv {
  my($nd, $level) = @_;
  my $indent = ''; # currently ...
  if ($nd->{NAME} =~ /^_/) { # this is needed ... think later ...
    return;
  } elsif ($nd->{NAME} eq 'root') {
    $level = -1;
  }
  if (defined($nd->{CHILD})) {
    if ($level == -1) { # do nothing ... for root ...
    } else {
      print $outfilehandle $indent . $nd->{NAME} . &gencsvfortext($nd->{TEXT}) . "\n";
    }
    my $cn = $nd->{CHILD};
    while (1) {
      gencsv($cn, $level + 1);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  } else {
    if ($level == -1) { # do nothing ... for root ...
    } else {
      print $outfilehandle $indent . $nd->{NAME} . &gencsvfortext($nd->{TEXT}) . "\n";
    }
  }
}
sub gencsvfortext {
  my($text) = @_;
  @cells = split(/ \/ /, $text);
  my $ret = '';
  my $first = 1;
  foreach $cell (@cells) {
    if ($cell =~ /$crlf/) {
      $cell =~ s/$crlf/\r\n/g;
      $cell =~ s/"//g;
      $cell = '"' . $cell . '"';
    }
    if ($first) {
      $first = 0;
      $ret = $cell;
    } else {
      $ret = $ret . "\t" . $cell;
    }
  }
  if (length($text) != 0) {
    $ret = "\t" . $ret;
  }
  return $ret;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
