# File: PatentClassReaderWithTsvFile_Perl.pl
# Date            Author        number of nodes
# 2005/3/17       Walking Lint  29
# 2005/3/17       Walking Lint  44 (CopyFilesWithTsvFile_Perl->PatentClassReaderWithTsvFile_Perl)
# 2005/3/17       Walking Lint  44
# 2005/3/11       Walking Lint  44
# 2005/3/11       Walking Lint  61 (CopyFilesFromConfigFile_Perl->CopyFilesWithTsvFile_Perl)
# 2003/2/13       Walking Lint  61
# 2002/11/16      Walking Lint  57
# 2002/10/1       Walking Lint  57
# 2002/8/18       Walking Lint  149
# 2002/8/1        Walking Lint  136 (GenAnnotedLink_Perl->CopyFilesFromConfigFile_Perl)
# 2002/7/31       Walking Lint  446 (GenHtmlsFromConfigFile_Perl->GenAnnotedLink_Perl)
# 2002/7/30       Walking Lint  437
# 2002/7/30       Walking Lint  388 (GenHtmlsForSSG_Perl->GenHtmlsFromConfigFile_Perl)
# 2002/7/29       Walking Lint  388 (GenHtmlsForSSG->GenHtmlsForSSG_Perl)
# 2002/7/26       Walking Lint  237
# 2002/7/25       Walking Lint  150
# 2002/7/24       Walking Lint  138
# 2002/7/23       Walking Lint  136
# 2002/7/22       Walking Lint  55

=pod

=head1 NAME

PatentClassReaderWithTsvFile_Perl.pl - copy files according to .tsv file

=head1 DESCRIPTION

activate as program ex. CopyFilesWithTsvFile_Perl () // "D:\tmp\cv\templates\|.tsv" "" "D:\tmp\cv\templates" %% TsvFile FromFolder ToFolder

=head1 AUTHOR

Walking Lint

=cut

use File::Copy;
use File::Basename;
$tsv_file = shift;
DebugPrint("tsv_file = $tsv_file");
if (length($tsv_file) == 0) {
  exit;
}
$to_dir = shift;
DebugPrint("to_dir = $to_dir");
if (length($to_dir) == 0) {
  exit;
}
open IN, $tsv_file or die("Cannot open $tsv_file: $!\n");
$tsv = <IN>;
$tsv =~ s/[\r\n]+$//;
close IN;
$perl = $ENV{PERL};
$templatesfolder = $ENV{TEMPLATESFOLDER};
@patentclasses = split(/\t/, $tsv);
foreach $patentclass (@patentclasses) {
  DebugPrint("patentclass = $patentclass");
  $file = $patentclass . '.pat';
  $to_file = $to_dir . "\\" . $file;
  system '"' . $perl . '" "' . $templatesfolder . '\PatentClassReader_Perl.pl" ' . $patentclass . ' "' . $to_file . '"';
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
