# File: PatentMapWriter_Perl.pl
# Date            Author        number of nodes
# 2006/3/24       Walking Lint  217
# 2006/3/20       Walking Lint  216
# 2005/3/24       Walking Lint  194
# 2005/3/23       Walking Lint  194
# 2005/3/18       Walking Lint  193
# 2005/3/15       Walking Lint  194
# 2005/3/11       Walking Lint  192
# 2005/3/10       Walking Lint  188
# 2005/3/8        Walking Lint  165
# 2005/3/7        Walking Lint  132
# 2005/3/5        Walking Lint  123
# 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl)
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

PatentMapWriter_Perl.pl - patent map writer

=head1 DESCRIPTION

activate as plug-in ex. .tsv () // %% PatentMapWriter_Perl

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$with_co = shift;
$is_US = shift;
$to_file = shift;
$from_file = $to_file;
$from_file =~ s/\..+/.pat/;
if ($is_US == 1) {
  $FTermList = $ENV{TEMPLATESFOLDER} . "\\PatentClassList.txt";
} else {
  $FTermList = $ENV{TEMPLATESFOLDER} . "\\FTermList.txt";
}
if (-e $FTermList) {
  $FTermListExisted = 1;
  open IN, $FTermList or die("Cannot open $FTermList $!\n");
  @pairs = <IN>;
  foreach $pair (@pairs) {
    $pair =~ s/[\r\n]+$//;
    ($code, $def) = split(/\t/, $pair);
    $ftermdef{$code} = $def;
  }
  close IN;
}
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
if (length($to_file) != 0) {
  open OUT, ">$to_file";
  $outfilehandle = 'OUT';
} else {
  $outfilehandle = 'STDOUT';
}
&setmap($root);
&genpatmap($root);
if (length($to_file) != 0) {
  close OUT;
  DebugPrint("generated $to_file");
}
sub setmap {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if (($is_US == 0) and ($cn->{NAME} eq 's') or ($is_US == 1) and ($cn->{NAME} =~ /^Patent\/Publication Number/)) { # for MicroPatentReader
        $text = $cn->{TEXT};
        ($company, $name, $dummy, $dummy, $file, $dummy) = split(/\t/, $text);
        if ($cn->{KIND} =~ /!/) {
          $cn->{TEXT} =~ s/$company/$company */; # this is hack ...
        }
        $file =~ s/\.txt$//;
        my $ccn = $cn->{CHILD};
        $found_fterm = '';
        $found_fterm2 = '';
        while (1) {
          if (($is_US == 0) and ($ccn->{NAME} =~ /^(|㗝l|ol||lĎ|Ql)/)) {
            my $cccn = $ccn->{CHILD};
            while (1) {
              if ($cccn->{NAME} eq 'e^[iQlj') { # try this ...
                $found_fterm = $cccn->{TEXT};
              } elsif ($cccn->{NAME} eq 'e^[ieiXj') {
                $found_fterm2 = $cccn->{TEXT};
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
          } elsif (($is_US == 1) and ($ccn->{NAME} eq 'CLASSIFICATION')) { # for MicroPatentReader
            my $cccn = $ccn->{CHILD};
            while (1) {
              if (($cccn->{NAME} eq 'U.S. Class') or ($cccn->{NAME} eq 'US Class')) {
                $item = $cccn->{TEXT};
                $item =~ /([0-9][0-9][0-9])([0-9][0-9][0-9])/;
                $pc = $1;
                $pc =~ s/^[0]+//;
                $fterms{$pc}++;
                $index = $pc . '_' . $file;
                $map{$index}++;
                last;
              }
              if (not defined($cccn->{NEXT})) {
                last;
              }
              $cccn = $cccn->{NEXT};
            }
          }
          if (not defined($ccn->{NEXT})) {
            last;
          }
          $ccn = $ccn->{NEXT};
        }
        if (length($found_fterm2) != 0) {
          $found_fterm = $found_fterm2;
        }
        if (length($found_fterm) != 0) {
          @items = split(/\t/, $found_fterm);
          %found_pcs = ();
          my $cnt = 0;
          foreach $item (@items) {
            if ($cnt % 2 == 0) {
              $found_pcs{$item}++;
            }
            $cnt++;
          }
          foreach $pc (keys %found_pcs) {
            $fterms{$pc}++;
            $index = $pc . '_' . $file;
            $map{$index}++;
          }
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub genpatmap {
  my($nd) = @_;
  print $outfilehandle "\t";
  if ($with_co) {
    print $outfilehandle "\t";
  }
  foreach $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms) {
    print $outfilehandle "\t" . $fterm;
    $index = $fterm . '_' . $file;
  }
  print $outfilehandle "\n";
  if ($FTermListExisted) {
    if ($with_co) {
      print $outfilehandle "\t";
    }
    print $outfilehandle "\t";
    foreach $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms) {
      print $outfilehandle "\t" . $ftermdef{$fterm};
    }
    print $outfilehandle "\n";
  }
  if ($with_co) {
    if ($is_US == 0) {
      print $outfilehandle "Ж\t";
    } else {
      print $outfilehandle "Corp.\t";
    }
  }
  if ($is_US == 0) {
    print $outfilehandle "\t";
  } else {
    print $outfilehandle "Name\t";
  }
  foreach $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms) {
    if ($is_US == 0) {
      print $outfilehandle "\t" . $fterms{$fterm} . '';
    } else {
      print $outfilehandle "\t" . $fterms{$fterm};
    }
    $index = $fterm . '_' . $file;
  }
  print $outfilehandle "\n";
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if (($is_US == 0) and ($cn->{NAME} eq 's') or ($is_US == 1) and ($cn->{NAME} =~ /^Patent\/Publication Number/)) { # for MicroPatentReader
        $text = $cn->{TEXT};
        ($company, $name, $dummy, $dummy, $file, $dummy) = split(/\t/, $text);
        $file =~ s/\.txt$//;
        if (($is_US == 0) or ($file =~ /^[0-9,A-Z\(\)]+$/)) { # actually not sure ...
          if ($with_co) {
            print $outfilehandle $company, "\t";
          }
          print $outfilehandle $name . "\t" . $file;
          foreach $fterm (sort {$fterms{$b} <=> $fterms{$a}} keys %fterms) {
            print $outfilehandle "\t";
            $index = $fterm . '_' . $file;
            if (defined($map{$index})) {
              if ($is_US == 0) {
                print $outfilehandle "";
              } else {
                print $outfilehandle "1";
              }
            }
          }
          print $outfilehandle "\n";
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
