# File: PatentReaderUS2_Perl.pl
# Date            Author        number of nodes
# 2005/4/4        Walking Lint  358
# 2005/3/28       Walking Lint  342
# 2005/3/25       Walking Lint  336
# 2005/3/24       Walking Lint  335
# 2005/3/23       Walking Lint  333
# 2005/3/18       Walking Lint  307
# 2005/3/17       Walking Lint  305
# 2005/3/16       Walking Lint  298
# 2005/3/15       Walking Lint  273
# 2005/3/15       Walking Lint  280 (PatentReaderUS_Perl->PatentReaderUS2_Perl)
# 2005/3/15       Walking Lint  280
# 2005/3/9        Walking Lint  280
# 2005/2/24       Walking Lint  278
# 2005/2/22       Walking Lint  266
# 2005/2/18       Walking Lint  265
# 2005/2/17       Walking Lint  265
# 2005/2/17       Walking Lint  119 (PatentReader_Perl->PatentReaderUS_Perl)
# 2005/2/14       Walking Lint  131
# 2005/2/1        Walking Lint  122
# 2005/1/26       Walking Lint  113
# 2005/1/18       Walking Lint  110
# 2005/1/17       Walking Lint  107
# 2005/1/15       Walking Lint  92
# 2005/1/15       Walking Lint  87 (IniReader_Perl->PatentReader_Perl)
# 2005/1/15       Walking Lint  87
# 2005/1/14       Walking Lint  89
# 2003/9/2        Walking Lint  100
# 2003/9/2        Walking Lint  96 (GeppouReader_Perl->IniReader_Perl)
# 2003/8/1        Walking Lint  101
# 2003/7/31       Walking Lint  101
# 2003/6/30       Walking Lint  101
# 2002/12/3       Walking Lint  98
# 2002/12/2       Walking Lint  93
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

PatentReaderUS2_Perl.pl - US patent reader 2 for Patent Web

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$from_file = shift;
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
$assignee = '';
$inventor = '';
my $root = {};
&initnode($root, 'root');
$in_normal = 1;
$in_kokoku = 0;
$first = 1;
$found_claim = 0;
$before_background_and_summary = 1;
$found_background_of_the_invention = 0;
$found_us_reference = 0;
$prev_non_text_level = 3; # not sure ...
$title = '';
&gentree($root, $from_file);
if (defined($root->{CHILD})) {
  $root->{CHILD}->{TEXT} = $assignee . "\t" . $inventor . "\t" . "\t" . $title . "\t" . "\t" . "\t" . $root->{CHILD}->{TEXT};
}
&savetree($root, $to_file);
if (length($to_file) > 0) {
  DebugPrint("generated $to_file");
}
sub extractparams {
  my($line) = @_;
  $found_issuedate = 0;
  $kind = ' ()  '; # somehow this is hack ... think later ...
  $type = '';
  $text = '';
  $name = '';
  if (($first == 1) and ($line =~ /<\/FONT><\/B><B><FONT SIZE=\+1>([^<]*)<\/FONT>.*<\/FONT>/)) {
    $name = 'United States Patent';
    $text = $1;
    $text =~ s/^[ \t]*//; # this may be overwritten ...
    $level = 0;
    $founditem = 1;
    $first = 0;
    return 0;
  } elsif ($line =~ /^<!--\[APDATE/) {
    $line =~ /-->(.*)$/;
    $name = 'Filed';
    $text = $1;
    $text =~ s/<\/B><B>//g;
    $text =~ s/<\/B><BR>//;
    $text =~ s/<B>//g;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<!--\[ISDATE/) {
    $line =~ /<FONT SIZE=\+1>(.*)<HR>(.*)/;
    $line2 = $2;
    $name = 'Issue Date';
    $text = $1;
    $text =~ s/<\/FONT><\/B><B><FONT SIZE=\+1>//g;
    $text =~ s/<\/FONT><\/B><BR>//g;
    $found_issuedate = 1;
    $line2 =~ /([^>]*)$/;
    $title = $1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<!--\[US REFERENCE/) {
    $name = 'U.S. Patent Documents';
    $level = 2;
    $found_us_reference = 1;
    return 0;
  } elsif (($line =~ /^<!--/) or ($line =~ /Application Date/) or ($line =~ /Primary Examiner/) or ($line =~ /\* \* \* \* \*/)) { # think later ...
    $found_us_reference = 0;
    $founditem = 0; # think later...
    return 1;
  } elsif ((($before_background_and_summary == 1) or ($found_claim > 0)) and ($line =~ /<H3>([^<]*)/i)) { # ($line =~ /<H3>([^<]*)<\/H3>/i)
    $founditem = 0; # think later...
    return 1;
  } elsif ($line =~ /<B>ABSTRACT/) { # think later ...
    $name = 'Abstract';
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>Assignee/) {
    $line =~ /([^>]*)$/;
    $name = 'Assignee';
    $text = $1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>BACKGROUND AND SUMMARY/) {
    $before_background_and_summary = 0;
    $name = 'Description';
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>CLAIMS/) {
    $name = 'Claims';
    $found_claim = 1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ((($found_claim == 1) or ($found_claim == 2)) and ($line =~ /^ ([0-9]+)\. ([^ ].*)$/)) { # hack ???
    $found_claim = 2;
    $name = $1;
    $text = $2;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif ((($found_claim == 1) or ($found_claim == 3)) and ($line =~ /^ <b>([0-9]+)<\/b>\. (.*)$/i)) {
    $found_claim = 3;
    $name = $1;
    $text = $2;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>Field of Search/) {
    $line =~ /([^>]*)$/;
    $name = 'Field of Search';
    $text = $1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>Int\. Cl\./) {
    $line =~ /([^>]*)$/;
    $name = 'Intern\'l Class';
    $text = $1;
    $text =~ s/(.*)([0-9][0-9][0-9])([0-9][0-9])/$1 $2\/$3/; # think later ...
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>Inventor/) {
    $line =~ /([^>]*)$/;
    $name = 'Inventors';
    $text = $1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>Priority/) {
    $line =~ /([^>]*)$/;
    $name = 'Foreign Application Priority Data';
    $text = $1;
    $text =~ s/&nbsp;//g;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<B>References Cited/) {
    $name = 'References Cited';
    $level = 1;
    return 0;
  } elsif ($line =~ /<B>US Class/) {
    $line =~ /: (.*)$/;
    $name = 'Current U.S. Class';
    $text = $1;
    $text =~ s/(&nbsp;|<B>|<\/B>)//g;
    $text =~ s/[ ]+;/;/g;
    $text =~ s/([0-9][0-9][0-9])([0-9][0-9][0-9])([0-9][0-9])/$1\/$2.$3/g; # actually not perfect ... may not be used ...
    $text =~ s/([0-9][0-9][0-9])([0-9][0-9][0-9])([0-9])/$1\/$2.$3/g;
    $text =~ s/([0-9][0-9][0-9])([0-9][0-9][0-9])/$1\/$2/g;
    $text =~ s/0([0-9][0-9])\/([0-9][0-9][0-9])/$1\/$2/g; # try this ...
    $text =~ s/_//g; # try this ...
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /Application Number/) {
    $line =~ /<B>([0-9\/]+)<\/B><BR>$/;
    $name = 'Appl. No.';
    $text = $1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /Attorney, Agent, or Firm/) {
    $line =~ /([^>]*)$/;
    $name = 'Attorney, Agent or Firm';
    $text = $1;
    $text =~ s/&#0038;/&/g;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /(BACKGROUND OF THE INVENTION)/) {
    $found_background_of_the_invention = 1;
    $name = $1;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif (($line =~ /^([A-Z ]+)$/) and (length($line) > 10)) { # this is hack ...
    $found_background_of_the_invention = 0;
    $name = $1;
    $name =~ s/^[ ]+//;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<H3>([^<]*)<\/H3>/i) {
    $found_background_of_the_invention = 0;
    $name = $1;
    $name =~ s/( )*$//;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif ((($found_background_of_the_invention == 1) or ($found_background_of_the_invention == 2)) and ($line =~ /^(?:\[[0-9]+\]| )*[0-9]+\. ([^<]*)/)) {
    $found_background_of_the_invention = 2;
    $name = $1;
    $level = 3;
    $founditem = 1;
    return 0;
  } elsif (($founditem == 1) and ($line =~ /^(?: )*(?:\[[0-9]+\])([^<]*)/) and (length($1) != 0)) {
    if ($found_background_of_the_invention == 1) {
      $found_background_of_the_invention = 3;
    }
    $name = '_text';
    $text = $1;
    $level = $prev_non_text_level + 1;
    return 0;
  }
  if (($found_us_reference == 1) and ($line =~ /&nbsp;&nbsp;&nbsp;&nbsp;([0-9]+)/)) {
    $name = $1;
    $level = 4;
    return 0;
  } else {
    if ($found_background_of_the_invention != 2) { # try this ...
      $found_background_of_the_invention = 0;
    }
    return 1;
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $founditem = 0; # think later...
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    $_ =~ s/[\n\r ]*$//;
    if ($_ =~ /^(( )*<TABLE WIDTH="[0-9]+%">|( )*<\/TABLE>|<p>|( )*<TD ALIGN="RIGHT" VALIGN="TOP" WIDTH="60%">|<BR><BR><PRE>|<\/PRE>)$/) {
      next;
    }
    if ($found_claim == 0) {
      $_ =~ s/^(<\/B><BR><\/P><P>| )(<p>\[[0-9]+\]|<p>)/[0000]/; # this is hack ...
    }
    $_ =~ s/<P>//ig;
    $_ =~ s/<\/P>//ig;
    if ($_ =~ /^( |<H[1-6]>)*((What|Waht) is claimed is|(I|We) claim)(:| |<\/H[1-6]>)*$/i) { # not used now ...
      next;
    }
    if (length($_) != 0) {
      $_ =~ s/(<in-[ ]*line-[ ]*formula>|<\/in-[ ]*line-[ ]*formula>)//ig;
      $_ =~ s/(<in-[ ]*line-[ ]*|<\/in-[ ]*line-[ ]*)$//ig;
      $_ =~ s/(<in-|<\/in-)$//i;
      $_ =~ s/^( line-[ ]*formula>)//i;
      $_ =~ s/^( formula>)//i;
      if (&extractparams($_)) {
        $_ = &strip_html($_);
        if ($founditem and ($found_us_reference == 0)) {
          if (length($cur->{TEXT}) == 0) {
            $cur->{TEXT} = $_;
          } else {
            $tmpline = $_;
            $cur->{TEXT} .= ' ' . $tmpline;
            $cur->{TEXT} =~ s/ ,/,/g; # this is hack ...
            $cur->{TEXT} =~ s/( )+/ /g; # this is hack ...
          }
          if ((length($assignee) == 0) and ($cur->{NAME} =~ /^Assignee$/)) {
            $assignee = $cur->{TEXT};
          } elsif ((length($inventor) == 0) and ($cur->{NAME}  =~ /^Inventors$/)) {
            $inventor = $cur->{TEXT};
          }
          next;
        }
      }
      if ($founditem and (length($name) > 0)) {
        if (not ($name eq '_text')) {
          $prev_non_text_level = $level;
        }
        $text =~ s/^( )+//; # not functioning ???
        $text =~ s/( )+/ /; # not functioning ???
        $text = &strip_html($text);
        # construct tree here ...
        if ($prevlevel < $level) {
          if ($cur->{NAME} eq 'Title') {
            $cur->{TEXT} .= ' ' . $name; # this is hack ...
            $title = $cur->{TEXT};
            next;
          } else {
            push @prevlevels, $prevlevel;
            $cur = addchildnode($cur, $name, $kind, $type, $text);
            if ($found_issuedate) { # this is hack ...
              $cur = addnode($cur, 'Title', $kind, $type, $title);
            }
          }
        } elsif ($prevlevel == $level) {
          $cur = addnode($cur, $name, $kind, $type, $text);
        } else {
          until ($prevlevel <= $level) {
            if ($cur->{PARENT} == $root) { # hack ???
              last;
            }
            $cur = $cur->{PARENT};
            $prevlevel = pop @prevlevels;
          }
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
        $prevlevel = $level;
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub strip_html {
  my($str) = @_;
  $str =~ s/<BR>//ig;
  $str =~ s/^( )*<TR><TD WIDTH=10%><\/TD><TD>//ig;
  $str =~ s/^( )*<TD VALIGN=TOP ALIGN="RIGHT" WIDTH="60%">//ig;
  $str =~ s/<\/TD><\/TR>$//ig;
  $str =~ s/<\/TD><TD>/ /ig;
  $str =~ s/(<B>|<\/B>)//ig;
  $str =~ s/(<H[1-6]>|<\/H[1-6]>)//ig;
  $str =~ s/(<I>|<\/I>)//ig;
  $str =~ s/(<PRE>|<\/PRE>)//ig;
  $str =~ s/(<sb>|<\/sb>)//ig;
  $str =~ s/  <TD ALIGN=LEFT><br>//ig;
  $str =~ s/&nbsp;//ig;
  return $str;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
