# File: PatentReaderUS_Perl.pl
# Date            Author        number of nodes
# 2005/3/23       Walking Lint  283
# 2005/3/17       Walking Lint  281
# 2005/3/15       Walking Lint  280
# 2005/3/9        Walking Lint  280
# 2005/2/24       Walking Lint  278
# 2005/2/22       Walking Lint  266
# 2005/2/18       Walking Lint  265
# 2005/2/17       Walking Lint  265
# 2005/2/17       Walking Lint  119 (PatentReader_Perl->PatentReaderUS_Perl)
# 2005/2/14       Walking Lint  131
# 2005/2/1        Walking Lint  122
# 2005/1/26       Walking Lint  113
# 2005/1/18       Walking Lint  110
# 2005/1/17       Walking Lint  107
# 2005/1/15       Walking Lint  92
# 2005/1/15       Walking Lint  87 (IniReader_Perl->PatentReader_Perl)
# 2005/1/15       Walking Lint  87
# 2005/1/14       Walking Lint  89
# 2003/9/2        Walking Lint  100
# 2003/9/2        Walking Lint  96 (GeppouReader_Perl->IniReader_Perl)
# 2003/8/1        Walking Lint  101
# 2003/7/31       Walking Lint  101
# 2003/6/30       Walking Lint  101
# 2002/12/3       Walking Lint  98
# 2002/12/2       Walking Lint  93
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

PatentReaderUS_Perl.pl - US patent reader

=head1 DESCRIPTION

activate as plug-in %% currently PatentReaderUS2_Perl is better ... ^^;

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
$assignee = '';
$inventor = '';
my $root = {};
&initnode($root, 'root');
$in_normal = 1;
$in_kokoku = 0;
$title = '';
&gentree($root, $from_file);
if (defined($root->{CHILD})) {
  $root->{CHILD}->{TEXT} = $assignee . "\t" . $inventor . "\t" . "\t" . $title . "\t" . "\t" . "\t" . $root->{CHILD}->{TEXT};
}
&savetree($root, $to_file);
sub extractparams {
  my($line) = @_;
  $kind = ' ()  '; # somehow this is hack ... think later ...
  $type = '';
  $text = '';
  if ($line =~ /^(?: |\t)*<TD ALIGN="RIGHT" WIDTH="50%"><B>(?: |\t)*(.*)$/) { # this is patentnumber ...
    $name = 'United States Patent';
    $text = $1;
    $text =~ s/(<B>|<\/B>|<I>|<\/I>)//g;
    $level = 0;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<font size="\+1">(?: |\t)*(.*)$/) {
    $name = 'Title';
    $text = $1;
    $text =~ s/(<B>|<\/B>|<I>|<\/I>)//g;
    $title = $text;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<\/TD><TD ALIGN="RIGHT" WIDTH="50%"> <B>$/) {
    $name = 'Issue Date';
    $text = $1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^(?: )+<TR><TD VALIGN="TOP" ALIGN="LEFT" WIDTH="10%">(.*)$/) {
    $name = $1;
    $name =~ s/^( |\t)+//;
    $name =~ s/:$//;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<TR><TD VALIGN="TOP" ALIGN="LEFT" WIDTH="10%" NOWRAP>(.*)$/) {
    $name = $1;
    $name =~ s/^( |\t)+//;
    $name =~ s/:$//;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^(?: )+<I>(.*)<\/I>(.*)$/) {
    $name = $1;
    $text = $2;
    $name =~ s/^( |\t)+//;
    $name =~ s/:$//;
    $text =~ s/^( |\t)+//;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /<HR><CENTER><B>(References Cited).*$/) {
    $name = $1;
    $level = 1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<CENTER><b>(U.S. Patent Documents)<\/b><\/CENTER>$/) {
    $level = 2;
    $name = $1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<TR><TD COLSPAN="4" ALIGN="CENTER"><B>(Foreign Patent Documents)<\/B><\/TD><\/TR>$/) {
    $level = 2;
    $name = $1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^  <CENTER><B>(Foreign Application Priority Data|Other References)<\/B><\/CENTER>$/) {
    $level = 1;
    $name = $1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^  <TR><TD VALIGN=TOP ALIGN="LEFT" WIDTH="40%"><B>([^<]+)<\/B><\/TD>$/) {
    $level = 1;
    $name = $1;
    $name =~ s/:( |\t)*$//;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<TABLE WIDTH="100%"><TR><TD WIDTH="25%">(.*)$/) {
    $level = 3;
    $ref = $1;
    $ref =~ s/<a [^>]+>//g;
    $ref =~ s/<\/a>//g;
    DebugPrint("ref1 = $ref");
    if ($ref =~ /^([^<]+)<\/TD><TD WIDTH="25%">([^<]+)<\/TD><TD WIDTH="25%" ALIGN="LEFT">([^<]+)<\/TD><TD WIDTH="25%" ALIGN="RIGHT">(.*)$/) {
      $name = $1 . ' ' . $2 . ' ' . $3 . ' ' . $4;
    } elsif ($ref =~ /^([^<]+)<\/TD><TD WIDTH="25%">([^<]+)<\/TD><TD WIDTH="25%" ALIGN="LEFT">(.*)$/) {
      $name = $1 . ' ' . $2 . ' ' . $3;
    }
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<TR><TD WIDTH="25%">(.*)$/) {
    $level = 3;
    $ref = $1;
    $ref =~ s/<a [^>]+>//g;
    $ref =~ s/<\/a>//g;
    DebugPrint("ref2 = $ref");
    if ($ref =~ /^([^<]+)<\/TD><TD WIDTH="25%">([^<]+)<\/TD><TD WIDTH="25%" ALIGN="LEFT">([^<]+)<\/TD><TD WIDTH="25%" ALIGN="RIGHT">(.*)$/) {
      $name = $1 . ' ' . $2 . ' ' . $3 . ' ' . $4;
    } elsif ($ref =~ /^([^<]+)<\/TD><TD WIDTH="25%">([^<]+)<\/TD><TD WIDTH="25%" ALIGN="LEFT">(.*)$/) {
      $name = $1 . ' ' . $2 . ' ' . $3;
    }
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<TR><TD WIDTH="25%">(.*)$/) {
    $level = 3;
    $ref = $1;
    $name = $1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^(( )*<HR[^>]*>|<\/B><\/TD>|<\/font><BR>|<\/TABLE>|<\/TD><TD WIDTH="25%" ALIGN="RIGHT"><\/TD><\/TR>| <\/TD><\/TABLE>)$/) {
    $founditem = 0; # think later...
    return 1;
  } elsif ($line =~ /^<BR><CENTER><B>(.*)<\/B><\/CENTER>$/) {
    $level = 1;
    $name = $1;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<CENTER><B><I>(.*)<\/B><\/I><\/CENTER>$/) { # Claims / Description
    $level = 1;
    $name = $1;
    $name =~ s/^( |\t)+//;
    $founditem = 1;
    return 0;
  } elsif (($line =~ /^<BR><BR>(?:1\.|\(a\)) (Field of the Invention)(?: )*(.*)$/) or ($line =~ /^<BR><BR>(?:2\.|\(b\)) ((?:Description|Discussion) of (?:the |)(?:Prior|Related) Art)(?: )*(.*)$/i)) {
    $name = $1;
    $text = $2;
    $level = 3;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<BR><BR>([0-9]+)\.[0-9a-z]/) { # this is hack ...
    return 1;
  } elsif ($line =~ /^<BR><BR>([0-9]+)\.(?: |\t)*(.*)$/) {
    $name = $1;
    $text = $2;
    $level = 3;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<BR><BR>((?:BACKGROUND|BACKGROUNDS|FIELD|(?:BRIEF |)SUMMARY|DETAILED DESCRIPTION) OF THE INVENTION)$/i) {
    $name = $1;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<BR><BR>((?:(?:DETAILED |BRIEF |)DESCRIPTION OF (?:THE |)|)(?:PREFERRED |PRIOR |RELATED |)(?:ART|DRAWING|EMBODIMENT)(?:S|)(?: OF THE INVENTION|))$/) {
    $name = $1;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<BR><BR>((?:First|Second|Third|Fourth) (?:Prior Method|Embodiment))$/) {
    $name = $1;
    $level = 3;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<BR><BR>(DESCRIPTION OF THE RELATED ART)$/) {
    $name = $1;
    $level = 2;
    $founditem = 1;
    return 0;
  } elsif ($line =~ /^<BR><BR><CENTER><B>\* \* \* \* \*<\/B><\/CENTER>$/) {
    $founditem = 0; # think later...
    return 1;
  } elsif ($line =~ /^<BR><BR>(.*)$/) {
    $name = '_text';
    $text = $1;
    $level = 4; # this is hack ...
    $founditem = 1;
    return 0;
  } else {
    return 1;
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $founditem = 0; # think later...
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    $_ =~ s/[\n\r ]*$//;
    if ($_ =~ /^(( )*<BR>|( )*<\/TD><\/TR>|<BR><BR>((What|Waht) is claimed is|(I|We) claim)(:|)|( )*<\/TD><TD ALIGN="LEFT" WIDTH="90%">)$/) {
      next;
    }
    if ($_ =~ /^(( )*<TABLE WIDTH="[0-9]+%">|( )*<\/TABLE>|<p>|( )*<TD ALIGN="RIGHT" VALIGN="TOP" WIDTH="60%">|<BR><BR><PRE>|<\/PRE>)$/) {
      next;
    }
    $_ =~ s/^<P>//;
    $_ =~ s/^<\/P>$//;
    if (length($_) != 0) {
      if (&extractparams($_)) {
        $_ =~ s/^<BR><BR>//;
        $_ =~ s/^<br>//;
        $_ =~ s/^( )*<TR><TD WIDTH=10%><\/TD><TD>//;
        $_ =~ s/^( )*<TD VALIGN=TOP ALIGN="RIGHT" WIDTH="60%">//;
        $_ =~ s/<\/TD><\/TR>$//;
        $_ =~ s/<\/TD><TD>/ /g;
        $_ =~ s/(<B>|<\/B>)//g;
        $_ =~ s/(<P>|<\/P>)//g;
        $_ =~ s/(<PRE>|<\/PRE>)//g;
        $_ =~ s/  <TD ALIGN=LEFT><br>//g;
        $_ =~ s/^( )+//;
        if ($founditem) {
          if (length($cur->{TEXT}) == 0) {
            $cur->{TEXT} = $_;
            if ((length($assignee) == 0) and ($cur->{NAME} =~ /^Assignee$/)) {
              $assignee = $_;
              DebugPrint("assignee = $assignee");
            } elsif ((length($inventor) == 0) and ($cur->{NAME}  =~ /^Inventors$/)) {
              $inventor = $_;
              DebugPrint("inventor = $inventor");
            }
          } else {
            $tmpline = $_;
            $cur->{TEXT} .= ' ' . $tmpline;
          }
          next;
        }
      }
      if ($founditem) {
        # construct tree here ...
        if ($prevlevel < $level) {
          push @prevlevels, $prevlevel;
          $cur = addchildnode($cur, $name, $kind, $type, $text);
        } elsif ($prevlevel == $level) {
          $cur = addnode($cur, $name, $kind, $type, $text);
        } else {
          until ($prevlevel <= $level) {
            if ($cur->{PARENT} == $root) { # hack ???
              last;
            }
            $cur = $cur->{PARENT};
            $prevlevel = pop @prevlevels;
          }
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
        $prevlevel = $level;
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
