# File: PatentReader_Perl.pl
# Date            Author        number of nodes
# 2005/4/5        Walking Lint  216
# 2005/3/28       Walking Lint  214
# 2005/3/7        Walking Lint  203
# 2005/3/2        Walking Lint  190
# 2005/2/28       Walking Lint  188
# 2005/2/25       Walking Lint  188
# 2005/2/24       Walking Lint  188
# 2005/2/23       Walking Lint  158
# 2005/2/22       Walking Lint  135
# 2005/2/14       Walking Lint  131
# 2005/2/1        Walking Lint  122
# 2005/1/26       Walking Lint  113
# 2005/1/18       Walking Lint  110
# 2005/1/17       Walking Lint  107
# 2005/1/15       Walking Lint  92
# 2005/1/15       Walking Lint  87 (IniReader_Perl->PatentReader_Perl)
# 2005/1/15       Walking Lint  87
# 2005/1/14       Walking Lint  89
# 2003/9/2        Walking Lint  100
# 2003/9/2        Walking Lint  96 (GeppouReader_Perl->IniReader_Perl)
# 2003/8/1        Walking Lint  101
# 2003/7/31       Walking Lint  101
# 2003/6/30       Walking Lint  101
# 2002/12/3       Walking Lint  98
# 2002/12/2       Walking Lint  93
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

PatentReader_Perl.pl - patent reader (JP-NET)

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
$is_youyaku = 0;
if (($from_file =~ /j(.*).txt/) and ($1 =~ /j/)) { # hack ...
  $is_youyaku = 1;
}
my $root = {};
&initnode($root, 'root');
$in_normal = 1;
$in_kokoku = 0;
$in_tokkyo_seikyuu = 0;
$shutugannin = '';
$hatumeisha = '';
$number = '';
$meishou = '';
$seiribangou = '';
&gentree($root, $from_file);
if (defined($root->{CHILD})) {
  if (length($seiribangou) > 0) {
    $root->{CHILD}->{TEXT} = $shutugannin . "\t" . $hatumeisha . "\t" . $number . "\t" . $meishou . "\t" . basename($from_file) . "\t" . $seiribangou;
  } elsif (length($from_file) != 0) {
    $root->{CHILD}->{TEXT} = $shutugannin . "\t" . $hatumeisha . "\t" . $number . "\t" . $meishou . "\t" . basename($from_file);
  } else {
    $root->{CHILD}->{TEXT} = $shutugannin . "\t" . $hatumeisha . "\t" . $number . "\t" . $meishou . "\t";
  }
}
&savetree($root, $to_file);
sub extractparams {
  my($line) = @_;
  $kind = ' ()  '; # somehow this is hack ... think later ...
  $type = '';
  $text = '';
  if (($is_youyaku != 1) and ($line =~ /^(?:k|m)(.+)(?:l|n)( |@)*(.*)/)) { # try this ...
    $level = 2;
    $name = $1;
    $text = $3;
    return 0;
  } elsif (($in_tokkyo_seikyuu == 1) and ($line =~ /^((?:O|P|Q|R|S|T|U|V|W|X)+D)[ ]+(.*)/)) {
    $level = 2;
    $name = $1;
    $text = $2;
    return 0;
  } elsif ($line =~ /^\([0-9]+\)y(.+)z( |@)*(.*)/) {
    $level = 1;
    $name = $1;
    $text = $3;
    if ($name eq 's') {
      $level = 0;
      $in_normal = 1;
      $in_kokoku = 0;
    }
    return 0;
  } elsif ($line =~ /^y(.+)z( |@)*(.*)/) {
    $name = $1;
    $text = $3;
    if ($name eq 's') {
      $level = 0;
      $in_normal = 0;
      $in_kokoku = 1;
    } elsif (($name eq 'ޖ') and ($text eq '')) {
      $level = 0;
      $in_normal = 0;
      $in_kokoku = 0;
    } elsif ($is_youyaku) {
      $level = 2;
      if (($name =~ /^J/) or ($name =~ /^/) or ($name =~ /^/) or ($name =~ /^R/)) {
        $level = 1;
      } elsif (($name =~ /^o/) or ($name =~ /^v/)) {
        $level = 1;
      }
    } elsif ($in_normal) {
      $level = 2;
      if (($name =~ /^(|l|]|}|||YƏ)/) or ($name =~ /^(|l)/) or ($name =~ /^(|ۑ|_)/) or ($name =~ /␳/) or ($name =~ /͈$/)) {
        $level = 1;
      } elsif (($name =~ /^(P|Q|R|S|T|U|V|W|X)/) or ($name =~ /^\x95\x5C(P|Q|R|S|T|U|V|W|X)/)) { # or ($name =~ /^\(P|Q|R|S|T|U|V|W|X)/)
        $level = 1;
      } elsif (($name =~ /^(p|{)/)) { # ($name =~ /^({)$/)
        $level = 1;
      }
    } else {
      $level = 1;
      if (($name =~ /^/)) {
        $level = 2;
      }
    }
    if ($name eq '͈̔') { # this is hack ...
      $in_tokkyo_seikyuu = 1;
    } else {
      $in_tokkyo_seikyuu = 0;
    }
    return 0;
  } elsif ($line =~ /^(@| )+y(.+)z( |@)*(.*)/) { # $in_normal == 0 is assumed actually not ... try this ...
    $level = 2;
    $name = $2;
    if (($name =~ /^(l|]|YƏ)/) or ($name =~ /^(l)/) or ($name =~ /^(ۑ)/) or ($name =~ /␳/)) {
      $level = 1;
    } elsif (($name =~ /^(p|{)/)) { # ($name =~ /^(p|{)$/)
      $level = 1;
    }
    $text = $4;
    return 0;
  } elsif ($cur->{NAME}) {
  } else {
    return 1;
  }
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    $_ =~ s/[\n\r]*$//;
    if ((length($_) != 0) and not ($_ =~ /^ԍ/)) {
      if (&extractparams($_)) {
        $_ =~ s/^(@| )+//; # try this...
        $separator = '';
        if ($cur->{NAME} =~ /^(eh|\x83\x65\x81\x5B\x83\x7D\x83\x52\x81\x5B\x83\x68|R\x83\x74\x83\x8A\x81\x5B\x83\x8F\x81\x5B\x83\x68)/) { # e[}R[h t[[h
          $separator = "\t";
        } elsif ($cur->{NAME} =~ /^(e\x83\x5E\x81\x5B\x83\x80)/) { # ^[
          $separator = "\t";
          $_ =~ s/ /\t/; # this is hack ...
          $_ =~ s/( )+$//; # this is needed ...
        }
        if ($is_youyaku and ($cur->{NAME} eq 'v')) {
          @youyakus = split(/k/, $_);
          foreach $youyaku (@youyakus) {
            if (length($youyaku) != 0) {
              ($ttl, $cntnt) = split(/l/, $youyaku);
              addchildnode($cur, $ttl, '', '', $cntnt);
            }
          }
        } else {
          if (length($cur->{TEXT}) == 0) {
            $cur->{TEXT} = $_;
          } else {
            $tmpline = $_;
            $cur->{TEXT} .= $separator . $tmpline;
          }
        }
        next;
      }
      if ((length($shutugannin) == 0) and ($name =~ /^͖$/) and (($cur->{PARENT}->{NAME} =~ /^(ol||pVČ)$/) or ($cur->{NAME} =~ /^(ol||pVČ)$/) )) {
        $shutugannin = $text;
      } elsif ((length($hatumeisha) == 0) and ($name =~ /^$/) and (($cur->{PARENT}->{NAME} =~ /^(|lĎ)$/) or ($cur->{NAME} =~ /^(|lĎ)$/))) {
        $hatumeisha = $text;
      } elsif ($name =~ /^(|l)̖$/) {
        $meishou = $text;
      } elsif ($name =~ /^oԍ$/) {
        $number = $text;
      } elsif ($name =~ /ԍ$/) {
        $seiribangou = &zen2han($text);
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        $cur = addnode($cur, $name, $kind, $type, $text);
      } else {
        until ($prevlevel <= $level) {
          if ($cur->{PARENT} == $root) { # hack ???
            last;
          }
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      if ($level > $prevlevel + 1) {
        $level = $prevlevel + 1;
      }
      $prevlevel = $level;
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub zen2han {
  my($str) = @_;
  $str =~ s/O/0/g;
  $str =~ s/P/1/g;
  $str =~ s/Q/2/g;
  $str =~ s/R/3/g;
  $str =~ s/S/4/g;
  $str =~ s/T/5/g;
  $str =~ s/U/6/g;
  $str =~ s/V/7/g;
  $str =~ s/W/8/g;
  $str =~ s/X/9/g;
  return $str;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
