# File: PerlReader_Perl.pl
# Date            Author        number of nodes
# 2004/6/25       Walking Lint  600
# 2004/5/1        Walking Lint  599
# 2004/3/18       Walking Lint  612
# 2004/3/16       Walking Lint  609
# 2004/1/20       Walking Lint  609
# 2003/12/5       Walking Lint  679
# 2003/12/2       Walking Lint  650
# 2003/12/1       Walking Lint  647
# 2003/10/29      Walking Lint  640
# 2003/10/14      Walking Lint  638
# 2003/10/3       Walking@Lint 630
# 2003/9/27       Walking@Lint 614
# 2003/8/25       Walking@Lint 606
# 2003/8/23       Walking@Lint 606
# 2003/7/15       Walking Lint  602
# 2003/7/14       Walking Lint  559
# 2003/6/19       Walking Lint  514
# 2003/6/6        Walking Lint  466
# 2003/5/27       Walking Lint  420
# 2003/5/26       Walking Lint  395
# 2003/5/17       Walking Lint  360
# 2003/4/8        Walking Lint  354
# 2003/3/14       Walking Lint  353
# 2003/3/13       Walking Lint  353
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

PerlReader_Perl.pl - Perl reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
@langelements = ('begin', 'break', 'case', 'default', 'else', 'elsif', 'exit', 'for', 'foreach', 'if', 'loop', 'next', 'return', 'use', 'unless', 'until', 'when', 'while');
$parenpattern = '\([\t ]*((?:[^\(\)]|\((?:[^\(\)]|\([^\)]*\))*\))*)[\t ]*\)';
$parenpatternwithoutmatch = '\([\t ]*(?:(?:[^\(\)]|\((?:[^\(\)]|\([^\)]*\))*\))*)[\t ]*\)';
$bracepattern = '\{[\t ]*((?:(?:[^\{\}]|\{[^\}]*\})*|))[\t ]*\}';
$condpattern = '(?:elsif|if|for|for[ \t]+(?:my[ \t]+)?\$[a-zA-Z_0-9]+|unless|until|while|sub [a-zA-Z_0-9]+)';
$condpattern2 = '(?:else|BEGIN|END|sub [a-zA-Z_0-9]+)';
$lefthand = '((?:[a-zA-Z_\$\@\%\[\]\{\}\.\: \-\*\+\/\&]|,|->|[\t ]|\([\t ]*(?:(?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\))(?:[a-zA-Z0-9_\$\@\%\[\]\{\}\.\: \-\*\+\/\&]|,|->|[\t ]|\([\t ]*(?:(?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\))*|\$[\|\~|_])';
$continuationpattern = '(\|\||\&\&|->|,|=|\-|\+|\*|\/|\(|\[|\?|=>?[ \t]*\{)[ \t]*'; # end of prev line
$continuationpattern2 = '[ \t]*(\|\||\&\&|->|\+[^\+]|\/[^\/\*]|\)|\]|\?|\{)'; # start of next line
$subdef = 'sub';
$comment = '#';
$to_file =~ s/\.pl/.pat/; # this is needed ...
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.pl';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
$in_pod = 0;
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&treatargs($root); # treat args
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  if ($linewithoutindent eq $comment) {
    $name = '_';
    $indentedcomment = '';
    DebugPrint("comment");
    return 0;
  }
  $line =~ /^([\t ]*)((?:#{|'#|"#|[^#])*)(#[^{].*)?/; # this is hack ... sequence is important ...
  $linewithoutindentandcomment = $2;
  DebugPrint("linewithoutindentandcomment = $linewithoutindentandcomment");
  $name = $2;
  $level = length($1);
  $argline = '';
  if (defined($3)) { # may be better to treat "#####" case ... think later ...
    $text = $3;
    if ($line =~ /^#!/) {
      $name = '_text';
      DebugPrint("comment to activate interpreter $line");
      return 0;
    }
    $indentedcomment = $text;
    $indentedcomment =~ s/^#( )?//;
    $text =~ s/^#[\t ]*//;
    if (length($linewithoutindentandcomment) == 0) {
      $name = '_';
      DebugPrint("comment");
      return 0;
    }
  }
  $name =~ s/[ \t]+$//;
  $name =~ s/^[ \t]*\}[ \t]*//;
  if ($in_pod) {
    if ($name eq '=cut') { # pod
      $in_pod = 0;
      return 1; # skip this line ... think later ...
    } elsif ($name =~ /^=head[0-9][ \t]+(.+)/) { # not actually ...
      $name = $1; # arg should be treated later ...
      DebugPrint("=head1 $name");
    } else { # not supported yet
      $name = '_text';
      $text = $linewithoutindent;
      DebugPrint("text in pod - $text");
    }
    return 0;
  }
  if ($name =~ /[ \t]*{[ \t]*$/) {
    $name =~ s/[ \t]*\{[ \t]*$//;
  }
  if ($name eq '=pod') { # pod
    $in_pod = 1;
    $name = '_doc';
    DebugPrint("starting pod");
    return 0; # skip this line ... think later ...
  } elsif (($name eq '}') or ($name eq $subdef)) { # end
    return 1; # skip this line ... think later ...
  } elsif ($name =~ /^$subdef[\t ]+([a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*$parenpattern$/) { # func def with arg
    $name = $1;
    DebugPrint("funcdef with arg - $name");
    if (length($2) > 2) {
      $argline = $2;
      $argline =~ s/^\(//;
      $argline =~ s/\)$//;
    }
  } elsif ($name =~ /^$subdef[\t ]+(.+)/) { # func def without arg
    $name = $1; # arg should be treated later ...
    DebugPrint("func def without arg $name");
  } elsif (($name =~ /^(for|foreach)[\t ]+(.+)$/)) { # for/foreach statement with param
    $name = $1;
    DebugPrint("for/foreach statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    unless ($name eq 'foreach') {
      $type =~ s/^\((.*)\)$/$1/;
    }
    $type =~ s/;$//; # this is hack ...
  } elsif (($name =~ /^([0-9a-zA-Z_\$\@]+)[\t ]*([^;]+);?$/) and &islangelement($1)) { # control statement with param ...
    $name = $1;
    DebugPrint("control statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*{[ \t]*$//;
    $type =~ s/^\((.*)\)$/$1/;
  } elsif ($name =~ /^((?:[a-zA-Z0-9_\$\%\@\[\]\{\}\.\-\>]|,[\t ]*)+)[\t ]*([\+\-\*\/\.]=)[\t ]*([^;]+);?$/) { # inout pattern1
    $name = $1;
    DebugPrint("inout pattern1 - $name");
    $kind = ' (inout) ';
    $type = $2 . '  ' . $3;
  } elsif ($name =~ /^((?:(?:[a-zA-Z0-9_\$\%\@\[\]\{\}\.\-\>]|,[\t ]*)+|$parenpatternwithoutmatch))[\t ]*(=~)[\t ]*([^;]+);?$/) { # inout pattern2
    $name = $1;
    DebugPrint("inout pattern2 - $name");
    $kind = ' (inout) ';
    $type = $2 . '  ' . $3;
  } elsif ($name =~ /^(local|my)[ \t]+$lefthand[\t ]*=[\t ]*([^>;][^;]*);?$/) { # my decl and assignment
    $name = $2;
    DebugPrint("my decl and assignment - $name");
    $kind = ' (out) ';
    $type = $1 . '  ' . $3;
    $name =~ s/[ \t]+$//;
    if ($name =~ /^\([ \t]*([^\)]+)[ \t]*\)$/) {
      $name = $1;
    }
  } elsif ($name =~ /^(local|my)[ \t]+$lefthand$/) { # my decl with space
    $name = $2;
    DebugPrint("my decl with space - $name");
    $kind = ' (out) ';
    $type = $1;
    $name =~ s/[ \t]+$//;
  } elsif ($name =~ /^(local|my)$parenpattern$/) { # my decl
    $name = '(' . $2 . ')';
    DebugPrint("my decl - $name");
    $kind = ' (out) ';
    $type = $1;
    $name =~ s/[ \t]+$//;
  } elsif ($name =~ /^$lefthand[\t ]*=[\t ]*([^;>][^;]*);?$/) { # assignment - may be needed to use here_doc and may include ; ... see. PHP
    $name = $1;
    $init_value = $2;
    $name =~ s/[ \t]+$//;
    $init_value =~ s/[ \t]+$//g;
    $type = '';
    DebugPrint("assignment - $name");
    $kind = ' (out) ';
    $type =~ s/[ \t]+/ /g;
    if ($type eq 'format') {
      $found_format = 1;
    } else {
      $type .= '  ' . $init_value;
    }
  } elsif ($name =~ /^(eval)[\t ]*$bracepattern;?$/) { # ex. eval pattern ...
    $name = $1;
    DebugPrint("eval pettern - $name");
    $type = '{ ' . $2 . ' }';
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}]+)(\.[^;]+);?$/) { # method
    $name = '->' . $1;
    DebugPrint("-> method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\-\>]+)(\.[^;]+);?$/) { # method
    $name = $1;
    DebugPrint("method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^->[ \t]*([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)$parenpattern[ \t]*(;[ \t]*)?$/) { # static func call with param
    $name = '->' . $1;
    DebugPrint("static -> func call - $name");
    $type = $2;
  } elsif (($name =~ /^(local|my)[\t ]+$lefthand;?$/)) { # my decl
    $name = $2;
    DebugPrint("my decl - $name");
    $kind = ' (out) ';
    $type = $1;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.+\-\>\:]+)[ \t]*$parenpattern[ \t]*(;[ \t]*)?$/) { # static func call with param
    $name = $1;
    DebugPrint("static func call - $name");
    $type = $2;
  } elsif ($name =~ /^([\&a-zA-Z0-9_\$\@\[\]\{\}\.]+)[ \t]*$parenpattern[\t ]+if[\t ]+([^;]*);?$/) { # static func call with if ... think later ...
    $name = $1;
    DebugPrint("static func call with if - $name");
    $type = $2 . ' if ' . $3;
  } elsif (($name =~ /^([a-zA-Z_\$\@\:][0-9a-zA-Z_\$\@\:]*)[\t ]+([^;]+);?$/)) { # statement with param (not actually ...)
    $name = $1;
    DebugPrint("statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]+$//;
    if ($type =~ /<<(?:'|")?([^<'"]+)(?:'|")?$/) {
      $in_here_doc = 1;
      $end_of_here_doc = $1;
      DebugPrint("end_of_here_doc = " . $end_of_here_doc);
      DebugPrint("type = " . $type);
      $type =~ s/\<\<$end_of_here_doc$//;
      DebugPrint("type = " . $type);
    }
  } elsif (not ($name =~ /^(\+\+|\-\-)/) and not ($name =~ /(\+\+|\-\-);?$/) and ($name =~ /^$lefthand;?$/)) { # and &islangelement($1) %% control statement (not actually ...)
    $name = $1;
    if ($name =~ /([^\(\)]+)[ ]+(if|unless)[ ]+(.+)$/) {
      $name = $1 . ' ' . $2;
      $type = $3;
      if ($type =~ /^$parenpattern$/) {
        $type = $1;
      }
    }
    DebugPrint("control statement - $name");
  } elsif (length($text) != 0) { # not sure but ...
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
    if ($text =~ /^[} ]*#[ ]*(.)*$/) { # this is hack ...
      $name = '_';
      $text = $1;
    }
  } elsif (length($name) != 0) { # not sure but ...
    if ($name =~ /(\+\+|--);?$/) {
      $type = $1;
      $kind = ' (inout) ';
      $name =~ s/(\+\+|--);?$//;
    } elsif (($name =~ /^$lefthand[\t ]*([^=]+)=[\t ]*([^;>][^;]*);?$/)) { # assignment with ->
      my $tmp = $1;
      my $tmp2 = $2;
      my $tmp3 = $3;
      if (($tmp =~ /-$/) and ($tmp2 =~ /^>/)) { # assignment with -> ()
        $name = $tmp;
        $name =~ s/-$//;
        $type = $tmp2;
        $type =~ s/^>/->/;
        $type =~ s/[ \t]+$//;
        $init_value = $tmp3;
        $name =~ s/[ \t]+$//;
        $init_value =~ s/[ \t]+$//g;
        DebugPrint("assignment with -> - $name");
        $kind = ' (out) ';
        $type =~ s/[ \t]+/ /g;
        if ($type eq 'format') {
          $found_format = 1;
        } else {
          $type .= '  ' . $init_value;
        }
      } else {
        $text = $name;
        $name = '_text';
      }
    } else {
      $text = $name;
      $name = '_text';
    }
  } else {
    return 1;
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    push @lines, $_;
  }
  @lines1 = ();
  $tmp_line = '';
  $prev_is_continuation = 0;
  foreach $line (@lines) {
    $line =~ s/[ \t\n]+$//;
    $line =~ s/\t/        /g; # try this ...
    $line2 = $line;
    $line2 =~ s/[ \t]*#[^0-9a-fA-F][^#]*$//; # try this now ...
    if (length($line) == 0) {
      next;
    }
    if (($line eq $line2) and ($line =~ /$continuationpattern$/)) { # pattern to concatenate ...
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation or ($line =~ /^$continuationpattern2/)) {
          $line =~ s/^[ \t]+/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 1;
    } elsif (not ($line eq $line2) and ($line2 =~ /$continuationpattern$/)) { # pattern to concatenate ...
      $line2 =~ s/[ ]*\\[ \t]*$//;
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation or ($line =~ /^$continuationpattern2/)) {
          $line2 =~ s/^[ \t]+/ /;
          $tmp_line = $tmp_line . $line2;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line2;
        }
      } else {
        $tmp_line = $line2;
      }
      $prev_is_continuation = 1;
    } elsif ($line =~ /^$continuationpattern2/) {
      if (length($tmp_line) != 0) {
        $line =~ s/^[ \t]+/ /;
        $tmp_line = $tmp_line . $line;
      } else {
        $tmp_line = $line; # should not happen ...
      }
      $prev_is_continuation = 0;
    } else {
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]+/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 0;
    }
  }
  if (length($tmp_line) != 0) {
    push @lines1, $tmp_line;
  }
  @lines2 = ();
  &process_multi_statement(\@lines1, \@lines2);
  @processed_lines = ();
  &process_multi_statement(\@lines2, \@processed_lines);
  $in_here_doc = 0;
  $here_doc = '';
  $found_format = 0;
  $in_format = 0;
  foreach (@processed_lines) {
    if ($in_here_doc) {
      if ($_ eq $end_of_here_doc) {
        insnode($cur, '<<' . $end_of_here_doc, ' (' . 'in) ', '', $here_doc);
        $in_here_doc = 0;
        $here_doc = '';
      } else {
        if (length($here_doc) == 0) {
          $here_doc = $_;
        } else {
          $here_doc .= ' CR' . 'LF ' . $_;
        }
      }
    } elsif ($in_format) {
      if ($_ eq '.') {
        $in_format = 0;
      } else {
        $format_body->{TEXT} .= " \CRLF " . $_;
      }
    } else {
      $_ =~ s/[\n\t ]+$//;
      if ((length($_) != 0)) {
        if (&extractparams($_)) {
          $prevname = '';
          next;
        }
        # construct tree here ...
        if ($prevlevel < $level) {
          if (($cur != $root) and ($name eq '_') and ((length($cur->{TEXT}) != 0) and not ($prevname eq '_text') or ($prevname eq '_'))) {
            $level = $prevlevel;
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          } else {
            push @prevlevels, $prevlevel;
            $cur = addchildnode($cur, $name, $kind, $type, $text);
          }
        } elsif ($prevlevel == $level) {
          if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
            if (not $cur->{TEXT} =~ / \CRLF /) {
              $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
            } else {
              $cur->{TEXT} .= " \CRLF " . $indentedcomment;
            }
          } else {
            $cur = addnode($cur, $name, $kind, $type, $text);
          }
        } else {
          until ($prevlevel <= $level) {
            if ($cur->{PARENT} == $root) { # hack ???
              last;
            }
            $cur = $cur->{PARENT};
            $prevlevel = pop @prevlevels;
          }
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
        $prevname = $name;
        $previndentedcomment = $indentedcomment;
        $prevlevel = $level;
        my $argkind = " \(in\) \& ";
        if (length($argline) != 0) {
          if ($argline =~ /\|[\t ]*([^\|]+)\|[\t ]*(.*)/) { # this is block arg
            $argline = $1;
            $body = $2;
            $body =~ s/[\t ]*}$//;
            $argline =~ s/[\t ]*$//;
            $argkind .= '~ ';
          }
          my @args = reverse split(/[\t ]*,[\t ]*/, $argline);
          foreach $arg (@args) {
            if ($arg =~ /=/) {
              $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
              &addchildnode($cur, $1, $argkind, '  ' . $2, '');
            } else {
              &addchildnode($cur, $arg, $argkind, '', '');
            }
          }
          if (length($body) != 0) {
            &extractparams($body);
            &addchildnode($cur, $name, $kind, $type, $text);
          }
        }
        if ($found_format) {
          $found_format = 0;
          $in_format = 1;
          $format_body = addchildnode($cur, '_text', ' () ', '', $init_value);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub islangelement {
  my($str) = @_;
  foreach $langelement (@langelements) {
    if ($str eq $langelement) {
      return 1;
    }
  }
  return 0;
}
sub process_multi_statement {
  my($from_array_ref, $to_array_ref) = @_;
  foreach $line (@$from_array_ref) {
    if ($line =~ /^([ \t]*)($condpattern)[ \t]*$parenpattern[ \t]*$bracepattern[ \t]*(#.*)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' (' . $3 . ')' . '{' . $5;
      $indent = $1;
      $block = $4;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif ($line =~ /^([ \t]*)($condpattern2)[ \t]*$bracepattern[ \t]*(#.*)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . '{' . $4;
      $indent = $1;
      $block = $3;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        $inner_statement =~ s/[ \t]+$//;
        push @$to_array_ref, $indent . '  ' . $inner_statement . ';'; # better ?
      }
    } elsif ($line =~ /^([ \t]*)($condpattern)[ \t]*$parenpattern[ \t]*([^;]+;)[ \t]*$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' (' . $3 . ')';
      push @$to_array_ref, $1 . '  ' . $4;
    } elsif ($line =~ /^([ \t]*)($condpattern2)[ \t]*([^;]+;)[ \t]*(#.*)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . '{' . $4;
      push @$to_array_ref, $1 . '  ' . $3;
    } elsif ((not $line =~ /^[ \t]*(for)[ \t\(]/) and ($line =~ /;[^;]+;/)) {
      $line =~ /^([ \t]*)/;
      $indent = $1;
      @inner_statements = split(/[ \t]*;[ \t]*/, $line);
      for ($i = 0; $i <= $#inner_statements - 1; $i++) { # - 1 is needed for \n
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . $inner_statement . ';'; # better ?
      }
    } else {
      push @$to_array_ref, $line;
    }
  }
}
sub treatargs {
  my($nd) = @_;
  &treatargsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatargs($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatargsbody {
  my($nd) = @_;
  if ($nd->{TYPE} =~ /^my[ ]+\@_$/) {
    Trace("enter treatargsbody($nd->{NAME})");
    if (not defined($nd->{PREV}) and $nd->{KIND} eq ' (' . 'out) ') {
      Trace("enter treatargsbody($nd->{NAME})");
      $args = $nd->{NAME};
      if ($args =~ /^\((.*)\)[ \t]*$/) {
        $args = $1;
      }
      @args = split(/[ ]*,[ ]*/, $args);
      $first = 1;
      foreach $arg (@args) {
        if ($first) {
          $nd->{NAME} = $arg;
          $nd->{KIND} = ' (' . 'in) & ';
          $nd->{TYPE} = '';
          $first = 0;
        } else {
          $nd = addnode($nd, $arg, ' (' . 'in) & ', '', '');
        }
      }
    }
  }
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
