# File: PodReader_Perl.pl
# Date            Author        number of nodes
# 2003/5/17       Walking Lint  39
# 2002/11/10      Walking Lint  33
# 2002/11/10      Walking Lint  20 (CsvReader_Perl->PodReader_Perl)
# 2002/11/9       Walking Lint  16
# 2002/3/10       Walking Lint  16 (CSVReader_Perl->CsvReader_Perl)

=pod

=head1 NAME

PodReader_Perl.pl - POD reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Time::localtime;
$from_file = shift;
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
open IN, $from_file || die("Can't open $from_file: $!\n");
open OUT, ">$to_file";
$tm = localtime;
$file_comment = 'File: ' . basename($from_file) . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
print OUT "root () /" . "/  %" . "% $file_comment\n";
$name = '';
while (<IN>) {
  chop;
  if (/^=/) {
    if (length($name) != 0) {
      if (length($text) != 0) {
        print OUT "\t" . $name . " () \/\/  \%\% $text\n";
      } else {
        print OUT "\t" . $name . " ()\n";
      }
    }
    $name = $_;
    $text = '';
  } else {
    if (length($text) == 0) {
      $text = $_;
    } else {
      $text .= " \CRLF " . $_;
    }
  }
}
if (length($name) != 0) {
  if (length($text) != 0) {
    print OUT "\t" . $name . " () \/\/  \%\% $text\n";
  } else {
    print OUT "\t" . $name . " ()\n";
  }
}
close IN;
close OUT;
