//
// File: PresetPose_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   75
// 2007/9/29       walkinglint   75 (PresetPose->PresetPose_LSL)
// 2007/8/7        walkinglint   75
// 2007/8/7        walkinglint   47 (animation->PresetPose)
// 2007/8/3        Walking Lint  25
//
// http://oitake.jugem.jp/?eid=115
//
// ================================ 
// Play Default Animations (C) 20070310 oitake
// ================================ 
// ================================ 
// Animations
// ================================ 
//
list animations=["aim_L_bow", "aim_R_bazooka", "aim_R_handgun", "aim_R_rifle", "angry_fingerwag", "angry_tantrum", "away", "backflip", "blowkiss", "bow", "brush", "clap", "courtbow", "crouch", "crouchwalk", "dance1", "dance2", "dance3", "dance4", "dance5", "dance6", "dance7", "dance8", "dead", "drink", "express_afraid", "express_anger", "express_bored", "express_cry", "express_embarrased", "express_laugh", "express_repulsed", "express_sad", "express_shrug", "express_surprise", "express_wink", "express_worry", "falldown", "female_walk", "fist_pump", "fly", "flyslow", "hello", "hold_R_bazooka", "hold_R_handgun", "hold_R_rifle", "hold_throw_R", "hover", "hover_down", "hover_up", "impatient", "jump", "jumpforjoy", "kick_roundhouse_R", "kissmybutt", "land", "laugh_short", "motorcycle_sit", "musclebeach", "no_head", "no_unhappy", "nyanya", "peace", "point_me", "point_you", "prejump", "punch_L", "punch_onetwo", "punch_R", "RPS_countdown", "RPS_paper", "RPS_rock", "RPS_scissors"];
list animations_added=["run", "salute", "shoot_L_bow", "shout", "sit", "sit_female", "sit_ground", "sit_to_stand", "sleep", "smoke_idle", "smoke_inhale", "smoke_throw_down", "snapshot", "soft_land", "stand", "standup", "stand_1", "stand_2", "stand_3", "stand_4", "stretch", "stride", "surf", "sword_strike_R", "talk", "throw_R", "tryon_shirt", "turnback_180", "turnleft", "turnright", "turn_180", "type", "walk", "whisper", "whistle", "wink_hollywood", "yes_happy", "yes_head", "yoga_float"];
list partial_animations;
string prev_str = "< Prev";
string next_str = "Next >";
list prev_list = ["< Prev"];
list next_list = ["Next >"];
integer seq_num = 0;
string pose = "";
key av;
integer found_av = FALSE;
//
// ================================ 
// Animations that can not start
// ================================ 
// "cross_arms","curtsy","hold_R_bow","kneel_left","kneel_right","slowwalk","uphillwalk","yell"
// ================================ 
// Main
// ================================ 
//
DebugPrint(string str) {
    llOwnerSay(str);
}
SetDialog() {
    partial_animations = llList2List(animations, seq_num * 10, seq_num * 10 + 9);
    if (0 < seq_num) {
        partial_animations = prev_list + partial_animations;
    }
    if (10 * seq_num + 9 < llGetListLength(animations)) {
        partial_animations += next_list;
    }
    if (found_av == FALSE) {
        av = llDetectedKey(0);
        found_av = TRUE;
    }
    llDialog(av, "Select pose", partial_animations, 123);
}
default {
    state_entry() {
        llRequestPermissions(llGetOwner(), PERMISSION_TRIGGER_ANIMATION);
        llListen(123, "", "", "");
        animations += animations_added;
    }
    touch(integer total_number) {
        SetDialog();
    }
    listen(integer channel, string name, key id, string message) {
        if (pose != "") {
            llStopAnimation(pose);
        }
        llListen(123, "", "", "");
        if (message == prev_str) {
            seq_num--;
            SetDialog();
        } else if (message == next_str) {
            seq_num++;
            SetDialog();
        } else {
            DebugPrint(message);
            pose = message;
            llStartAnimation(pose);
        }
    }
}
