# File: PythonReader_Perl.pl
# Date            Author        number of nodes
# 2004/5/1        Walking Lint  487
# 2003/10/3       Walking@Lint 490
# 2003/9/27       Walking@Lint 474
# 2003/7/14       Walking Lint  458
# 2003/7/13       Walking Lint  434
# 2003/7/12       Walking Lint  399
# 2003/5/27       Walking Lint  422
# 2003/5/26       Walking Lint  322
# 2003/5/17       Walking Lint  321
# 2002/12/1       Walking Lint  315
# 2002/11/24      Walking Lint  315
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

PythonReader_Perl.pl - Python reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
@langelements = ('break', 'case', 'default', 'else', 'elif', 'except', 'exit', 'for', 'from', 'if', 'loop', 'next', 'import', 'raise', 'rescue', 'try', 'until', 'when');
$indexpattern = '\[[^\]]*\]';
$parenpattern = '\([\t ]*((?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\)';
$parenpatternwithoutmatch = '\([\t ]*(?:(?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\)';
$stringpattern = '(?:\'[^\']*\'|\"[^\"]*\")';
$namepattern = 'a-zA-Z0-9_\$\@\[\]\'\"\#\{\}\.\!\?\:';
$condpattern = '(?:elif|if|for|until|while)';
$condpattern2 = '(?:else)';
$namewithoutdotpattern = 'a-zA-Z0-9_\$\@\[\]\'\"\#\{\}\!\?\:';
$lefthand = '((?:[a-zA-Z_\$\@\%\[\]\{\}\.\: \-\*\+\/\&]|,|->|[\t ]|\([\t ]*(?:(?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\))(?:[a-zA-Z0-9_\$\@\%\[\]\{\}\.\: \-\*\+\/\&]|,|->|[\t ]|\([\t ]*(?:(?:(?:[^\(\)]|\([^\)]*\))*|))[\t ]*\))*|\$[\|\~|_])';
$continuationpattern = '(%|,|\\\\|\[|\{)[ \t]*'; # end of prev line
$continuationpattern2 = '[ \t]*(%|\]|\})'; # start of next line
$subdef = 'def';
$comment_begin = '"""';
$comment_end = '"""';
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.py';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $argline = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("linewithoutindent = $linewithoutindent");
  if ($in_comment) {
    if ($linewithoutindent eq '"""') { # not actually ... think later ...
      $in_comment = 0;
      return 1;
    } elsif ($linewithoutindent =~ /"""$/) {
      $in_comment = 0;
    }
    $name = '_';
    $text = $linewithoutindent;
    $indentedcomment = $text;
    $indentedcomment =~ s/^\* //;
    $line =~ /^([\t ]*)/;
    $level = length($1);
    return 0;
  } elsif ($in_text) {
    if ($linewithoutindent =~ /"""$/) {
      $in_text = 0;
    }
    $name = '_text';
    $text = $linewithoutindent;
    $indentedcomment = $text;
    $indentedcomment =~ s/^\* //;
    $line =~ /^([\t ]*)/;
    $level = length($1);
    return 0;
  }
  if ($linewithoutindent eq '#') {
    $name = '_';
    $indentedcomment = '';
    DebugPrint("comment");
    return 0;
  } elsif ($linewithoutindent eq '"""') {
    $in_comment = 1;
    return 1;
  } elsif ($linewithoutindent =~ /^"""/) {
    if ($linewithoutindent =~ /"""$/) {
    } else {
      $in_comment = 1;
    }
    $name = '_text';
    $text = $linewithoutindent;
    $indentedcomment = $text;
    $line =~ /^([\t ]*)/;
    $level = length($1);
    return 0;
  } elsif ($linewithoutindent =~ /^[$namepattern]+[ \t]*=[ \t]*"""/) {
    if ($linewithoutindent =~ /"""$/) {
      $linewithoutindent =~ s/[ \t]*"""$//;
    } else {
      $in_text = 1;
    }
    $name = '_text';
    $text = $linewithoutindent;
    $indentedcomment = $text;
    $line =~ /^([\t ]*)/;
    $level = length($1);
    return 0;
  }
  $line =~ /^([\t ]*)((?:[^#]|#{)*)(#[^{].*)?/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  if (defined($3)) {
    $text = $3;
    if ($line =~ /^#!/) {
      $name = '_text';
      DebugPrint("comment to activate interpreter");
      return 0;
    }
    $indentedcomment = $text;
    $indentedcomment =~ s/^#( )?//;
    $text =~ s/^#[\t ]*//;
    if (length($linewithoutindentandcomment) == 0) {
      $name = '_';
      DebugPrint("comment");
      return 0;
    }
  }
  $name =~ s/[\t ]+$//;
  if ($name =~ /[\t ]+do$/) {
    $name =~ s/[\t ]+do$//;
    $kind .= '~ ';
  }
  if ($name =~ /^"[^"]+"$/) {
    $text = $name;
    $name = '_text';
  } elsif ($name =~ /^$subdef[\t ]+([$namepattern]+)\([\t ]*(.*)[\t ]*\)[ \t]*(:[ \t]*)?$/) { # func def with arg
    $name = $1;
    DebugPrint("funcdef with arg - $name");
    $argline = $2;
  } elsif ($name =~ /^$subdef[\t ]+(.+)/) { # func def without arg
    $name = $1; # arg should be treated later ...
    DebugPrint("func def without arg $name");
  } elsif ($name =~ /^class[ \t]+([$namepattern]+)[ \t]*$parenpattern[ \t]*(:[\t]*)?$/) { # class def with super class
    $name = $1;
    DebugPrint("class def with super class - $name");
    $type = '  ' . $2;
    $kind = ' () + ';
  } elsif ($name =~ /^class[\t ]+(.+)/) { # class def
    $name = $1;
    DebugPrint("class def - $name");
    $kind = ' () + ';
  } elsif ($name =~ /^module[\t ]+(.+)/) { # module def
    $name = $1;
    DebugPrint("module def (currently not supported) - $name");
    $kind = ' () + ';
  } elsif ($name =~ /^$lefthand[\t ]*=[\t ]*(.*)$/) { # assignment
    $name = $1;
    $init_value = $2;
    $name =~ s/[ \t]+$//;
    $init_value =~ s/[ \t]+$//g;
    DebugPrint("assignment - $name");
    $kind = ' (out) ';
    $type = '  ' . $init_value;
  } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([$namepattern\'\"\(\)]+)[\t ]*\{[\t ]*(.*)$/)) { # block ... think later ... this is hack
    $name = $1;
    DebugPrint("block - $name");
    $kind .= '~ '; # may not be good ...
    $argline = $2;
  } elsif ($name =~ /^((?:[$namewithoutdotpattern]|$parenpatternwithoutmatch)+)(\..+)/) { # method (try this ... now ...)
    $name = $1;
    DebugPrint("method - $name");
    $kind = ' (out) ';
    $type = $2;
  } elsif ($name =~ /^([$namepattern]+)\([\t ]*(.*)[\t ]*\)$/) { # static func call with param
    $name = $1;
    DebugPrint("static func call - $name");
    $type = $2;
    if (length($type) == 0) {
      $name .= '()'; # this is hack ...
    }
  } elsif ($name =~ /^([$namepattern]+)\([\t ]*(.*)[\t ]*\)[\t ]+if[\t ]+(.*)$/) { # static func call with if ... think later ...
    $name = $1;
    DebugPrint("static func call with if - $name");
    $type = $2 . ' if ' . $3;
  } elsif (($name =~ /^([$namepattern]+)[\t ]+(.+)$/)) { # and &islangelement($1) %% control statement with param (not actually ...)
    $name = $1;
    DebugPrint("statement with param - $name");
    $type = $2;
    $type =~ s/[ \t]*:$//;
  } elsif (($name =~ /^([$namepattern]+)$/)) { # and &islangelement($1) %% control statement (not actually ...)
    $name = $1;
    $name =~ s/[ \t]*:$//;
    DebugPrint("control statement - $name");
  } else { # not supported yet
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  $in_comment = 0;
  $in_text = 0;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  while (<$infilehandle>) {
    push @lines, $_;
  }
  @lines1 = ();
  $tmp_line = '';
  $prev_is_continuation = 0;
  foreach $line (@lines) {
    $line =~ s/[ \t\n]+$//;
    $line =~ s/\t/        /g; # try this ...
    $line2 = $line;
    $line2 =~ s/[ \t]*#[^#]+$//; # try this now ...
    if (length($line) == 0) {
      next;
    }
    if (($line eq $line2) and ($line =~ /$continuationpattern$/)) { # and not ($line =~ /print/) %% pattern to concatenate ...
      $line =~ s/[ ]*\\[ \t]*$//; # actually not sure ... indent in next line is assumed ...
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]+/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 1;
    } elsif (not ($line eq $line2) and ($line2 =~ /$continuationpattern$/)) { # and not ($line2 =~ /print/) %% pattern to concatenate ...
      $line2 =~ s/[ ]*\\[ \t]*$//;
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line2 =~ s/^[ \t]+/ /;
          $tmp_line = $tmp_line . $line2;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line2;
        }
      } else {
        $tmp_line = $line2;
      }
      $prev_is_continuation = 1;
    } elsif ($line =~ /^$continuationpattern2/) {
      if (length($tmp_line) != 0) {
        $line =~ s/^[ \t]+/ /;
        $tmp_line = $tmp_line . $line;
      } else {
        $tmp_line = $line; # should not happen ...
      }
      $prev_is_continuation = 0;
    } else {
      if (length($tmp_line) != 0) {
        if ($prev_is_continuation) {
          $line =~ s/^[ \t]+/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          push @lines1, $tmp_line;
          $tmp_line = $line;
        }
      } else {
        $tmp_line = $line;
      }
      $prev_is_continuation = 0;
    }
  }
  if (length($tmp_line) != 0) {
    push @lines1, $tmp_line;
  }
  @lines2 = ();
  &process_multi_statement(\@lines1, \@lines2);
  @processed_lines = ();
  &process_multi_statement(\@lines2, \@processed_lines);
  foreach (@processed_lines) {
    $_ =~ s/[:\n\t ]+$//; # deleted :
    if (length($_) != 0) {
      if (&extractparams($_)) {
        $prevname = '';
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        if (($cur != $root) and ($name eq '_') and ((length($cur->{TEXT}) != 0) and not ($prevname eq '_text') or ($prevname eq '_'))) {
          $level = $prevlevel;
          $cur->{TEXT} .= " \CRLF " . $indentedcomment;
        } elsif (($cur != $root) and ($name eq '_text') and ($prevname eq '_text')) { # try this ...
          $level = $prevlevel;
          $cur->{TEXT} .= " \CRLF " . $indentedcomment;
        } else {
          push @prevlevels, $prevlevel;
          $cur = addchildnode($cur, $name, $kind, $type, $text);
        }
      } elsif ($prevlevel == $level) {
        if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
        } elsif (($name eq '_text') and ($prevname eq '_text')) { # ($cur->{NAME} eq '_text')
          $cur->{TEXT} .= " \CRLF " . $text;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      } else {
        until ($prevlevel <= $level) {
          if ($cur->{PARENT} == $root) { # hack ???
            last;
          }
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevname = $name;
      $previndentedcomment = $indentedcomment;
      $prevlevel = $level;
      my $argkind = " \(in\) \& ";
      if ($kind =~ /~/) {
        if ($name =~ /\(([^\)]+)\)$/) {
          $name =~ s/[\t ]*\(([^\)]+)\)$//;
          $cur->{NAME} = $name;
          $argline2 = $1;
          my @args2 = split(/[\t ]*,[\t ]*/, $argline2);
          foreach $arg (@args2) {
            if ($arg =~ /=/) {
              $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
              &addchildnode($cur, $1, $argkind, '  ' . $2, '');
            } else {
              &addchildnode($cur, $arg, $argkind, '', '');
            }
          }
        }
      }
      if (length($argline) != 0) {
        if ($argline =~ /\|[\t ]*([^\|]+)\|[\t ]*(.*)/) { # this is block arg
          $argline = $1;
          $body = $2;
          $body =~ s/[\t ]*}$//;
          $argline =~ s/[\t ]*$//;
          $argkind .= '~ ';
        }
        my @args = split(/[\t ]*,[\t ]*/, $argline);
        foreach $arg (@args) {
          if ($arg =~ /=/) {
            $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
            &addchildnode($cur, $1, $argkind, '  ' . $2, '');
          } else {
            &addchildnode($cur, $arg, $argkind, '', '');
          }
        }
        if (length($body) != 0) {
          &extractparams($body);
          &addchildnode($cur, $name, $kind, $type, $text);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub islangelement {
  my($str) = @_;
  foreach $langelement (@langelements) {
    if ($str eq $langelement) {
      return 1;
    }
  }
  return 0;
}
sub process_multi_statement {
  my($from_array_ref, $to_array_ref) = @_;
  foreach $line (@$from_array_ref) {
    if ($line =~ /^([ \t]*)(class|def|$condpattern)[ \t]+((?:$indexpattern|[^:\[\]])+):([^:]+)$/) { # pattern for multi statement
      $indent = $1;
      $type = $2;
      $name = $3;
      $statement = $4;
      $statement =~ s/^[ \t]+//;
      $name =~ s/[ \t]+$//;
      push @$to_array_ref, $indent . $type . ' ' . $name;
      push @$to_array_ref, $indent . '  ' . $statement;
    } elsif ($line =~ /^([ \t]*)($condpattern2)[ \t]*:([^:]+)$/) { # pattern for multi statement
      $indent = $1;
      $name = $2;
      $statement = $3;
      $statement =~ s/^[ \t]+//;
      $name =~ s/[ \t]+$//;
      push @$to_array_ref, $indent . $name;
      push @$to_array_ref, $indent . '  ' . $statement;
    } elsif ($line =~ /^([ \t]*)($parenpattern|$stringpattern|[^;\"\'\(\)])+;/) { # hack ...
      $line =~ /^([ \t]*)/;
      $indent = $1;
      @inner_statements = split(/[ \t]*;[ \t]*/, $line);
      for ($i = 0; $i <= $#inner_statements; $i++) { # - 1 is needed for \n ?
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . $inner_statement; # better ?
      }
    } else {
      push @$to_array_ref, $line;
    }
  }
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
  if (defined($nd->{CHILD})) {
    # for case - when / else
    my $cn = $nd->{CHILD};
    $foundcase = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'case') {
        $foundcase = 1;
        $casenode = $cn;
      } elsif ($foundcase) {
        if (($cn->{NAME} eq 'else') or ($cn->{NAME} eq 'when')) {
          &delnode($cn);
          &addchildnode2($casenode, $cn);
        }
      } else {
        $foundcase = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
