# File: RGBEdit_Perl.pl
# Date            Author        number of nodes
# 2005/7/30       Walking Lint  40
# 2003/8/31       Walking@Lint 40
# 2002/12/14      Walking Lint  39
# 2002/9/6        Walking Lint  31
# 2002/7/9        Walking Lint  26
# 2002/3/26       Walking Lint  16
@color_list = ('red', 'green', 'blue');
$color = <STDIN>;
$color =~ s/[\n\r]*$//;
if (length($color) != 0) {
  $color =~ s/^#//;
  $color =~ /(..)(..)(..)/;
  @color_code = (hex($1), hex($2), hex($3));
} else {
  @color_code = (0, 0, 0);
}
use Tk;
$mw = MainWindow->new();
$mw->title("RGB Edit");
$mw->minsize(200, 200);
$color_display = $mw->Button
  ->pack(-fill => 'both', -expand => 'yes');
for ($i = 0; $i < 3; $i++) {
  $sca[$i] = $mw->Scale (-from => 0, -to => 255, -orient => 'horizontal', -command => [\&ChangeColor, $i])
    ->pack(-fill => 'both', -expand => 'yes');
  $sca[$i]->set($color_code[$i]);
}
MainLoop();
sub ChangeColor {
  $color_code[$_[0]] = $_[1];
  &set_color();
}
sub set_color {
  $r = $color_code[0];
  $g = $color_code[1];
  $b = $color_code[2];
  $rgb_text = sprintf "#%2.2x%2.2x%2.2x (%1.2f %1.2f %1.2f)", ($r, $g, $b, $r/255, $g/255, $b/255);
  $rgb_number = sprintf "#%2.2x%2.2x%2.2x", ($r, $g, $b);
  $ir = 255 -$r;
  $ig = 255 -$g;
  $ib = 255 -$b;
  $txt_number = sprintf "#%2.2x%2.2x%2.2x", ($ir, $ig, $ib);
  $color_display->configure(-text => $rgb_text, -background => $rgb_number, -foreground => $txt_number, -activebackground => $rgb_number, -activeforeground => $txt_number);
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
