# File: ReCalc_Perl.pl
# Date            Author        number of nodes
# 2002/12/7       Walking Lint  48
# 2002/12/5       Walking Lint  48
# 2002/12/1       Walking Lint  48
# 2002/11/29      Walking Lint  93 (GeppouReader_Perl->ReCalc_Perl)
# 2002/11/24      Walking Lint  315 (PythonReader_Perl->GeppouReader_Perl)
# 2002/11/24      Walking Lint  287 (RubyReader_Perl->PythonReader_Perl)
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

ReCalc_Perl.pl - re-calc sum

=head1 DESCRIPTION

ex. perl.exe ReCalc_Perl.pl C:\memo\cv\templates\samplecalc.pat

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
my $root = {};
&initnode($root, 'root');
&gentree($root, $from_file);
&recalc($root);
&savetree($root, $to_file);
DebugPrint("modified $to_file");
sub recalc {
  my($nd) = @_;
  my $val = 0;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      if (not $cn->{NAME} =~ /^_/) {
        $val += &recalc($cn);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    if (not ($nd->{NAME} eq 'root')) {
      $nd->{TEXT} = $val;
    }
    if (defined($nd->{TYPE})) {
      $val = $cn->{TYPE};
      $val =~ s/^[ ]*//;
    }
  } else {
    $val = $nd->{TYPE};
    $val =~ s/^[ ]*//;
  }
  return $val;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
