# File: RubyReader_Perl.pl
# Date            Author        number of nodes
# 2004/4/7        Walking Lint  595
# 2003/10/3       Walking@Lint 579
# 2003/9/27       Walking@Lint 563
# 2003/7/8        Walking Lint  550
# 2003/7/7        Walking Lint  484
# 2003/7/6        Walking Lint  521
# 2003/7/5        Walking Lint  469
# 2003/5/27       Walking Lint  394
# 2003/5/26       Walking Lint  294
# 2003/5/17       Walking Lint  293
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

RubyReader_Perl.pl - Ruby reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
@langelements = ('begin', 'break', 'case', 'default', 'else', 'elsif', 'exit', 'if', 'loop', 'next', 'require', 'rescue', 'until', 'when');
$parenpattern = '\((?:[^\(\)]|\((?:[^\(\)]|\((?:[^\(\)]|\([^\)]*\))*\))*\))*\)';
$thenpattern = '(?:[ \t]*\{|[ \t]+then[ \t]+)';
$endpattern = '(?:\}|[ \t]+end)';
$namepattern = 'a-zA-Z0-9_\$\@\[\]\'\"\#\{\}\.\!\?\:';
$condpattern = '(?:elsif|if|for|unless|until|while)';
$compattern = '\#';
$continuationpattern = '([^\x81](,|=|\+|\-|\%|\[|\()|\|\||\&\&| or| and)[ \t]*'; # end of prev line
$continuationpattern2 = '[ \t]*(\|\||\&\&|\-[^\-]|\+[^\+]|\/[^\/\*]|\%|or |and |\]|\)|\|[^\|]+\|$)'; # start of next line ... hack ???
$subdef = 'def';
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.rb';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("linewithoutindent = $linewithoutindent");
  if ($linewithoutindent eq '#') {
    $name = '_';
    $indentedcomment = '';
    DebugPrint("comment");
    return 0;
  }
  $line =~ s/\%\%/\\%\\%/g; # actually not sure but ...
  $line =~ /^([\t ]*)((?:[^#"']|#\{|"[^"]*"|'[^']*'|"|')*)(#[^{].*)?/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  $argline = '';
  $argline2 = '';
  $isblock = 0;
  if (defined($3)) {
    $text = $3;
    if ($line =~ /^#!/) {
      $name = '_text';
      DebugPrint("comment to activate interpreter");
      return 0;
    }
    $indentedcomment = $text;
    $indentedcomment =~ s/^#( )?//;
    $text =~ s/^#[\t ]*//;
    if (length($linewithoutindentandcomment) == 0) {
      $name = '_';
      DebugPrint("comment");
      return 0;
    }
  }
  $name =~ s/[\t ]+$//;
  $found_do = 0;
  if ($name =~ /[\t ]+do$/) {
    $found_do = 1;
    $isblock = 1;
    $name =~ s/[\t ]+do$//;
    $kind .= '~ ';
  }
  if ($name =~ /[ \t]+do[ \t]*(\|[^\|]+\|)$/) {
    $isblock = 1;
    $argline2 = $1; # try this ...
    $name =~ s/[ \t]+do[ \t]*(\|[^\|]+\|)$//;
    $kind .= '~ ';
    DebugPrint("found do with block argline2 $argline2");
  }
  if (($name eq 'end') or ($name eq '}')) { # end
    return 1; # skip this line ... think later ...
  } elsif ($name =~ /^$subdef[\t ]+([$namepattern\=\<\>\+\-\/\*\`]+)\([\t ]*(.*)[\t ]*\)$/) { # func def with arg
    $name = $1;
    DebugPrint("funcdef with arg - $name");
    $argline = $2;
  } elsif ($name =~ /^$subdef[\t ]+(.+)/) { # func def without arg
    $name = $1; # arg should be treated later ...
    DebugPrint("func def without arg $name");
  } elsif ($name =~ /^class[\t ]+(.+)/) { # class def
    $name = $1;
    DebugPrint("class def - $name");
    if ($name =~ /;[ \t]*end[ \t]*$/) {
      $text = $name;
      $name = '_text';
    } else {
      if ($name =~ /^([^\<]*)\<+(.*)$/) {
        $type = '  ' . $2;
        $name = $1;
        $name =~ s/[ \t]+$//;
      }
      $kind = ' () + ';
    }
  } elsif ($name =~ /^module[\t ]+(.+)/) { # module def
    $name = $1;
    DebugPrint("module def (currently not supported) - $name");
    $kind = ' () + ^ ';
  } elsif ($name =~ /^(rescue)[ \t]*(=>)[ \t]*(.*)$/) { # rescue
    DebugPrint("rescue - $name");
    $name = $1;
    $type = $2 . ' ' . $3;
  } elsif (($name =~ /^([$namepattern]+)[\t ]+([^<>=\+\-\*\{].*)/) and &islangelement($1)) { # control statement with param (this is hack ...)
    $name = $1;
    $type = $2;
    if ($name eq '{') { # this is hack ...
      $text = $name . ' ' . $type;
      $name = '_text';
      $type = '';
    } else {
      DebugPrint("statement with param - $name");
      $type =~ s/([ \t]+then|;)[ \t]*$//;
      if ($type =~ /<<([^<]+)$/) {
        $in_here_doc = 1;
        $end_of_here_doc = $1;
        DebugPrint("type = " . $type);
        $type =~ s/\<\<$end_of_here_doc$//;
        DebugPrint("type = " . $type);
      }
    }
  } elsif ($name =~ /^((?:[$namepattern]|,|[\t ]+|[\+\-\*\/][^=])+)[\t ]*((?:[\+\-\*\/\|\&]|<<|>>|\|\||\&\&)=|<<-|<<|>>|=~)[\t ]*(.+)$/) { # inout pattern1
    $name = $1;
    $type = $2; # actually op
    $init_value = $3; # actually not
    $name =~ s/[ \t]+$//;
    DebugPrint("inout pattern1 - $name");
    $kind = ' (inout) ';
    $type =~ s/[ \t]+/ /g;
    $init_value =~ s/[ \t]+/ /g;
    if ($type eq '<<-') {
      $type = $type . $init_value;
    } else {
      $type = $type . ' ' . $init_value;
    }
  } elsif ($name =~ /^((?:[$namepattern]|,[\t ]*)+)[\t ]*([\+\-\*\/]?=)[\t ]*(.+)/) { # assignment
    if ($found_do) {
      DebugPrint("assignment and block - $name");
    } else {
      DebugPrint("assignment - $name");
      $name = $1;
      $asgop = $2;
      $value = $3;
      if ($value =~ /\{[ \t]*$/) { # this is hack ...
        $value =~ s/[ \t]*\{[ \t]*$//;
        $name = $name . ' ' . $asgop . ' ' . $value;
        $kind = ' () ~ ';
      } else {
        $kind = ' (out) ';
        if ($value=~ /^<<([^<]+)$/) { # actually not true ...
          $in_here_doc = 1;
          $end_of_here_doc = $1;
          DebugPrint("type = " . $type);
          $type =~ s/\<\<$end_of_here_doc$//;
          DebugPrint("type = " . $type);
        } else {
          $type = '  ' . $value;
        }
      }
    }
  } elsif ($name =~ /^([$namepattern]+)[ ]*($parenpattern)$/) { # static func call with param
    $name = $1;
    if ($isblock) {
      DebugPrint("block with do |...| - $name");
      $argline = $2;
      $argline =~ s/^\(//;
      $argline =~ s/\)$//;
    } else {
      DebugPrint("static func call - $name");
      $type = $2;
      $type =~ s/^\(//;
      $type =~ s/\)$//;
    }
  } elsif ($name =~ /^([$namepattern]+)\([\t ]*(.*)[\t ]*\)[\t ]+if[\t ]+(.*)$/) { # static func call with if ... think later ...
    $name = $1;
    DebugPrint("static func call with if - $name");
    $type = $2 . ' if ' . $3;
  } elsif (($name =~ /^([$namepattern]+)[\t ]+([^<>=\+\-\*\{].*)/)) { # and &islangelement($1) %% control statement with param (not actually ...)
    $name = $1;
    $type = $2;
    if ($name eq '{') { # this is hack ...
      $text = $name . ' ' . $type;
      $name = '_text';
      $type = '';
    } else {
      DebugPrint("statement with param - $name");
      $type =~ s/([ \t]+then|;)[ \t]*$//;
      if ($type =~ /<<([^<]+)$/) {
        $in_here_doc = 1;
        $end_of_here_doc = $1;
        DebugPrint("type = " . $type);
        $type =~ s/\<\<$end_of_here_doc$//;
        DebugPrint("type = " . $type);
      }
    }
  } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([$namepattern]+)[ ]*($parenpattern)[\t ]*\{[\t ]*(.*)$/)) { # block ... think later ... this is hack
    $isblock = 1;
    $name = $1;
    DebugPrint("block - $name");
    $kind .= '~ '; # may not be good ...
    $argline = $2;
    $argline2 = $3;
    $argline =~ s/^\(//;
    $argline =~ s/\)$//;
    if ($argline2 =~ /\}[ \t]*(if[ \t]+.*)$/) {
      $type = '  ' . $1;
      $argline2 =~ s/\}[ \t]*(if[ \t]+.*)$//;
    } elsif ($argline2 =~ /\}[ \t]*$/) {
      $type = '  ' . $1;
      $argline2 =~ s/\}[ \t]*$//;
    }
  } elsif ((not $name =~ /\([\t ]*{/) and ($name =~ /^([$namepattern]+)[\t ]*\{[\t ]*(.*)$/)) { # block ... think later ... this is hack
    $isblock = 1;
    $name = $1;
    DebugPrint("block - $name");
    $kind .= '~ '; # may not be good ...
    $argline = '';
    $argline2 = $2;
    if ($argline2 =~ /\}[ \t]*(if[ \t]+.*)$/) {
      $type = '  ' . $1;
      $argline2 =~ s/\}[ \t]*(if[ \t]+.*)$//;
    } elsif ($argline2 =~ /\}[ \t]*$/) {
      $type = '  ' . $1;
      $argline2 =~ s/\}[ \t]*$//;
    }
  } elsif (($name =~ /^([$namepattern]+)$/)) { # and &islangelement($1) %% control statement (not actually ...)
    $name = $1;
    DebugPrint("control statement - $name");
  } else { # not supported yet
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  $breaklater = 0;
  while (<$infilehandle>) {
    if ($_ =~ /^__EOF__[\n\r]*$/) {
      last;
    } elsif ($_ =~ /__EOF__[\n\r]*$/) {
      $_ =~ s/__EOF__[\n\r]*$//;
      $breaklater = 1;
    }
    push @lines, $_;
    if ($breaklater) {
      last;
    }
  }
  @lines1 = ();
  $tmp_line = '';
  $prev_is_continuation = 0;
  $in_here_doc = 0;
  foreach $line (@lines) {
    $line =~ s/[ \t\n]+$//;
    $line =~ s/\t/        /g; # try this ...
    if ($in_here_doc) {
      if ($line eq $end_of_here_doc) {
        $in_here_doc = 0;
      }
    } else {
      if ($line =~ /<<([A-Z]+)$/) { # actually not true ...
        $in_here_doc = 1;
        $end_of_here_doc = $1;
      }
    }
    if ($in_here_doc) {
      push @lines1, $tmp_line; # try this ...
      $tmp_line = $line;
    } else {
      if (length($line) == 0) {
        next;
      }
      if ($line =~ /$continuationpattern$/) { # pattern to concatenate ...
        if (length($tmp_line) != 0) {
          if ($prev_is_continuation) {
            $line =~ s/^[ \t]*/ /;
            $tmp_line = $tmp_line . $line;
          } else {
            push @lines1, $tmp_line;
            $tmp_line = $line;
          }
        } else {
          $tmp_line = $line;
        }
        $prev_is_continuation = 1;
      } elsif ($line =~ /^$continuationpattern2/) {
        if (length($tmp_line) != 0) {
          $line =~ s/^[ \t]*/ /;
          $tmp_line = $tmp_line . $line;
        } else {
          $tmp_line = $line; # should not happen ...
        }
        $prev_is_continuation = 0;
      } else {
        if (length($tmp_line) != 0) {
          if ($prev_is_continuation) {
            $line =~ s/^[ \t]*/ /;
            $tmp_line = $tmp_line . $line;
          } else {
            push @lines1, $tmp_line;
            $tmp_line = $line;
          }
        } else {
          $tmp_line = $line;
        }
        $prev_is_continuation = 0;
      }
    }
  }
  if (length($tmp_line) != 0) {
    push @lines1, $tmp_line;
    DebugPrint('converted to ' . $tmp_line . '(3)');
  }
  @lines2 = ();
  &process_multi_statement(\@lines1, \@lines2);
  @processed_lines = ();
  &process_multi_statement(\@lines2, \@processed_lines);
  $in_here_doc = 0;
  $after_end = 0;
  $here_doc = '';
  foreach (@processed_lines) {
    if ($after_end) {
      if ($first_after_end) {
        $first_after_end = 0;
        $cur = addnode($cur, '_text', ' () ', '', $_);
      } else {
        $cur->{TEXT} .= ' CR' . 'LF ' . $_;
      }
    } else {
      if ($_ eq '__END__') {
        $after_end = 1;
        $first_after_end = 1;
      }
      if ($in_here_doc) {
        if ($_ eq $end_of_here_doc) {
          insnode($cur, '<<' . $end_of_here_doc, ' (' . 'in) ', '', $here_doc);
          $in_here_doc = 0;
          $here_doc = '';
        } else {
          if (length($here_doc) == 0) {
            $here_doc = $_;
          } else {
            $here_doc .= ' CR' . 'LF ' . $_;
          }
        }
      } else {
        $_ =~ s/[\n\t ]+$//;
        if ((length($_) != 0)) {
          if (&extractparams($_)) {
            $prevname = '';
            next;
          }
          # construct tree here ...
          if ($prevlevel < $level) {
            if (($cur != $root) and ($name eq '_') and ((length($cur->{TEXT}) != 0) and not ($prevname eq '_text') or ($prevname eq '_'))) {
              $level = $prevlevel;
              $cur->{TEXT} .= " \CRLF " . $indentedcomment;
            } else {
              push @prevlevels, $prevlevel;
              $cur = addchildnode($cur, $name, $kind, $type, $text);
            }
          } elsif ($prevlevel == $level) {
            if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
              if (not $cur->{TEXT} =~ / \CRLF /) {
                $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
              } else {
                $cur->{TEXT} .= " \CRLF " . $indentedcomment;
              }
            } elsif (($name eq '_text') and ($prevname eq '_text')) { # ($cur->{NAME} eq '_text')
              $cur->{TEXT} .= " \CRLF " . $text;
            } else {
              $cur = addnode($cur, $name, $kind, $type, $text);
            }
          } else {
            until ($prevlevel <= $level) {
              if ($cur->{PARENT} == $root) { # hack ???
                last;
              }
              $cur = $cur->{PARENT};
              $prevlevel = pop @prevlevels;
            }
            if ($name eq 'end') {
              if (length($cur->{TYPE}) == 0) {
                $cur->{TYPE} = '  ' . $type;
              } else { # not actually
                $cur->{TYPE} .= '  ' . $type;
              }
            } else {
              $cur = addnode($cur, $name, $kind, $type, $text);
            }
          }
          $prevname = $name;
          $previndentedcomment = $indentedcomment;
          $prevlevel = $level;
          my $argkind = " \(in\) \& ";
          if ((length($argline) != 0) or (length($argline2) != 0)) {
            $body = '';
            if ($isblock) {
              my @args = split(/[\t ]*,[\t ]*/, $argline);
              foreach $arg (@args) {
                if ($arg =~ /=/) {
                  $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
                  &addchildnode($cur, $1, $argkind, '  ' . $2, '');
                } else {
                  &addchildnode($cur, $arg, $argkind, '', '');
                }
              }
              if ($argline2 =~ /\|[\t ]*([^\|]+)\|[\t ]*(.*)/) { # this is block arg
                $argline = $1;
                $body = $2;
                $body =~ s/[\t ]*}$//;
                $argline =~ s/[\t ]*$//;
                $argkind .= '~ ';
                my @args = split(/[\t ]*,[\t ]*/, $argline);
                foreach $arg (@args) {
                  if ($arg =~ /=/) {
                    $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
                    &addchildnode($cur, $1, $argkind, '  ' . $2, '');
                  } else {
                    &addchildnode($cur, $arg, $argkind, '', '');
                  }
                }
              } else {
                $body = $argline2;
              }
              if (length($body) != 0) {
                &extractparams($body);
                &addchildnode($cur, $name, $kind, $type, $text);
              }
            } else {
              my @args = split(/[\t ]*,[\t ]*/, $argline);
              foreach $arg (@args) {
                if ($arg =~ /=/) {
                  $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
                  &addchildnode($cur, $1, $argkind, '  ' . $2, '');
                } else {
                  &addchildnode($cur, $arg, $argkind, '', '');
                }
              }
            }
          }
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub islangelement {
  my($str) = @_;
  foreach $langelement (@langelements) {
    if ($str eq $langelement) {
      return 1;
    }
  }
  return 0;
}
sub process_multi_statement {
  my($from_array_ref, $to_array_ref) = @_;
  foreach $line (@$from_array_ref) {
    $found_endpattern = 0;
    $found_block = 0;
    $saved_line = $line;
    if ($line =~ /$endpattern[ \t]*($compattern.+)?$/) {
      $found_endpattern = 1;
      $com = $1;
      $line =~ s/$endpattern[ \t]*($compattern.+)?$//;
      if (not ($line =~ /\#$thenpattern(.*)$/) and ($line =~ /$thenpattern(.*)$/)) { # hack ???
        $found_block = 1;
        $block = $1;
        $line =~ s/$thenpattern(.*)$//;
      }
    }
    if ($found_block and ($line =~ /^([ \t]*)($condpattern)[ \t]*(.*)$/)) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' ' . $3 . $com;
      $indent = $1;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement;
      }
    } elsif ($found_block and ($line =~ /^([ \t]*)(else|try)[ \t]*$/)) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . $com;
      $indent = $1;
      @inner_statements = split(/[ \t]*;[ \t]*/, $block);
      for ($i = 0; $i <= $#inner_statements; $i++) {
        $inner_statement = $inner_statements[$i];
        $inner_statement =~ s/^[ \t]+//;
        push @$to_array_ref, $indent . '  ' . $inner_statement; # better ?
      }
    } else {
      $line = $saved_line;
      push @$to_array_ref, $line;
    }
  }
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
  if (defined($nd->{CHILD})) {
    # for case - when / else
    my $cn = $nd->{CHILD};
    $foundcase = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'case') {
        $foundcase = 1;
        $casenode = $cn;
      } elsif ($foundcase) {
        if (($cn->{NAME} eq 'else') or ($cn->{NAME} eq 'when')) {
          &delnode($cn);
          &addchildnode2($casenode, $cn);
        }
      } else {
        $foundcase = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
