# File: Script_Perl.pl
# Date            Author        number of nodes
# 2003/3/19       Walking Lint  111
# 2002/12/25      Walking Lint  109
# 2002/12/8       Walking Lint  109
# 2002/12/7       Walking Lint  109
# 2002/12/6       Walking Lint  94 (Perl_Perl->Script_Perl)
# 2002/11/29      Walking Lint  90
# 2002/11/28      Walking Lint  86
# 2002/11/26      Walking Lint  28
# 2002/11/21      Walking Lint  24
# 2002/11/20      Walking Lint  23
# 2002/11/18      Walking Lint  23
# 2002/8/15       Walking Lint  21 (grep_Perl->Perl_Perl)
# 2002/7/15       Walking Lint  19
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

Script_Perl.pl - search *_(Perl|Python|Ruby).pat

=head1 DESCRIPTION

ex. perl.exe C:\memo\cv\templates Script_Perl.pl Perl system

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
$templatesfolder = shift;
$lang = shift;
if ($lang =~ /perl/i) {
  $lang = '_Perl';
} elsif ($lang =~ /python/i) {
  $lang = '_Python';
} elsif ($lang =~ /ruby/i) {
  $lang = '_Ruby';
} elsif (length($lang) != 0) {
  $lang = '_' . $lang;
} else {
  $lang = '';
}
$word = shift;
$checkheader = shift;
$from = $templatesfolder . '\*' . $lang . '.pat';
$dir = dirname($from);
chdir $dir;
$from = basename($from);
@from_files = eval('<' . $from . '>');
foreach $from_file (@from_files) {
  open IN, $from_file or die("Cannot open $from_file: $!\n");
  if (defined($checkheader)) {
    $first = 0;
  } else {
    $first = 1;
  }
  while (<IN>) {
    if ($first) { # skip root
      $first = 0;
      next;
    }
    $_ =~ /^(\t*)([^\(]+)/;
    $level = length($1);
    $name = $2;
    $name =~ s/( )+$//;
    $path{$level} = $name;
    if (/$word/i) {
      ($category, @groups) = split(/( \(\) \- \/\/[ ]+\%\% | \(\) \/\/[ ]+\%\% | \CRLF  \CRLF )/, $_);
      $category =~ s/^\t+//;
      $category =~ s/($word)/*$1*/ig;
      $foundcommentout = 0;
      foreach $i (1..$level - 1) {
        $path = $path{$i};
        if (($path =~ /^_note$/) or ($path =~ /^_doc$/)) { # not sure if better ...
          $foundcommentout = 1;
          last;
        }
      }
      if ($foundcommentout) {
        next;
      }
      $firstpath = 1;
      foreach $i (1..$level - 1) {
        $path = $path{$i};
        if ($firstpath) {
          $firstpath = 0;
          if (length($from_file) > 39) {
            printf "%s %s > ", $from_file, $path;
          } else {
            printf "%s %s > ", $from_file . ' ' x (40 - length($from_file)), $path;
          }
          $from_file = '';
        } else {
          print "$path > ";
        }
      }
      $foundsome = 0;
      foreach $group (@groups) {
        if ($group =~ /$word/i) {
          $group =~ s/ \CRLF /\n\t/g;
          $group =~ s/($word)/*$1*/ig;
          $group =~ s/[\n]+$//;
          $group .= "\n"; # think later ...
          if (not $foundsome) {
            $foundsome = 1;
            if ($firstpath) {
              $firstpath = 0;
              if (length($from_file) > 39) {
                printf "%s %s\n", $from_file, $category;
              } else {
                printf "%s %s\n", $from_file . ' ' x (40 - length($from_file)), $category;
              }
              $from_file = '';
            } else {
              print $category;
            }
          }
          print "\t$group";
        }
      }
      if (not $foundsome) {
        if ($firstpath) {
          $firstpath = 0;
          if (length($from_file) > 39) {
            printf "%s %s\n", $from_file, $category;
          } else {
            printf "%s %s\n", $from_file . ' ' x (40 - length($from_file)), $category;
          }
          $from_file = '';
        } else {
          print $category . "\n";
        }
        # do nothing ...
      } else {
        print "\n";
      }
    }
  }
  close IN;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
