#!/usr/local/bin/perl
# File: SearchWithGoogle_Perl.pl
# Date            Author        number of nodes
# 2003/8/17       Walking@Lint 30
# 2003/8/17       Walking@Lint 30 (50_1->SearchWithGoogle_Perl)
# 2003/8/17       Walking@Lint 30
# 2003/8/17
# googly.pl
# A typical Google Web API Perl script
# Usage: perl googly.pl <query>
# Your Google API developer's key
my $google_key = $ENV{GoogleWebAPILicenceKey};
$google_key =~ s/"//g;
DebugPrint("google_key = " . $google_key);
# Location of the GoogleSearch WSDL file
my $google_wdsl = '.\GoogleSearch.wsdl';
use strict;
# Use the SOAP::Lite Perl module
use SOAP::Lite;
# Take the query from the command-line
my $query = shift @ARGV
  or die "Usage: perl googly.pl <query>\n";
# Create a new SOAP::Lite instance, feeding it GoogleSearch.wsdl
my $google_search = SOAP::Lite->service("file:$google_wdsl");
# Query Google
my $results = $google_search ->doGoogleSearch($google_key, $query, 0, 10, "false", "",  "false", "", "latin1", "latin1");
# No results?
@{$results->{resultElements}} or exit;
# Loop through the results
foreach my $result (@{$results->{resultElements}}) {
  # Print out the main bits of each result
  print join("\n", $result->{title} || "no title", $result->{URL}, $result->{snippet} || 'no snippet', "\n");
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
