# File: SnapShot_Perl.pl
# Date            Author        number of nodes
# 2003/6/24       Walking Lint  104
# 2002/11/23      Walking Lint  28
# 2002/7/4        Walking Lint  20 (GenSnapShot_Perl->SnapShot_Perl)
# 2002/4/26       Walking Lint  19
# 2002/4/25       Walking Lint  13 (MakeSnapShot_Perl->GenSnapShot_Perl)
# 2002/4/4        Walking Lint  12
# 2002/3/20       Walking Lint  11

=pod

=head1 NAME

SnapShot_Perl.pl - fBNg or N ̃XibvVbg

=head1 DESCRIPTION

ex. perl.exe SnapShot_Perl.pl "D:\common\cv\templates"

=head1 AUTHOR

Walking Lint

=cut

use File::Copy;
use Time::localtime;
$basedir = shift;
if ($basedir =~ /http:/) {
  use LWP::UserAgent;
  use LWP::Simple;
  use HTML::LinkExtor;
  $url = $basedir;
  DebugPrint("url = " . $url);
  $basedir = shift;
  DebugPrint("basedir = " . $basedir);
  $mask = shift;
  DebugPrint("mask = " . $mask);
  $tm = localtime;
  $dir = sprintf("Snap%04d%02d%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
  $to_dir = $basedir . "\\" . $dir;
  DebugPrint("to_dir = " . $to_dir);
  unless (-d $to_dir) {
    mkdir $to_dir, 0700 or die "mkdir($to_dir) failed: $!";
    DebugPrint("generated $to_dir");
  }
  # actually ... this is needed ...
  use Win32::Registry;
  $HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
  $ref->GetValues(\%values);
  $ref->Close();
  $refproxyoverride = $values{'ProxyOverride'};
  DebugPrint("refproxyoverride = " . $refproxyoverride);
  $refproxyserver = $values{'ProxyServer'};
  DebugPrint("refproxyserver = " . $refproxyserver);
  $proxyoverride = $$refproxyoverride[2];
  $proxyoverride =~ s/\*//g;
  $proxyoverride =~ s/;?<local>//g;
  $proxyoverride =~ s/;/\|/g; # not actually ...
  $proxyoverride = quotemeta $proxyoverride;
  $proxyoverride =~ s/\\\|/\|/g; # hack ...
  $proxyoverride = '(' . $proxyoverride . ')';
  DebugPrint("proxyoverride = " . $proxyoverride);
  $proxyserver = $$refproxyserver[2];
  DebugPrint("proxyserver = " . $proxyserver);
  $webagent = new LWP::UserAgent;
  $webagent2 = new LWP::UserAgent;
  unless (($url =~ /$proxyoverride/) or (length($proxyserver) == 0)) {
    $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
    $webagent2->proxy(['ftp', 'http'] => "http://$proxyserver");
  }
  $request = new HTTP::Request(GET => $url);
  $response = $webagent->request($request);
  if ($response->is_success) {
    $parser = HTML::LinkExtor->new(\&link_callback, $url);
    $parser->parse($response->content);
  }
} else {
  DebugPrint("basedir = $basedir");
  $basedir =~ s/\\$//;
  $tm = localtime;
  $dir = sprintf("Snap%04d%02d%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
  $to_dir = $basedir . "\\" . $dir;
  unless (-d $to_dir) {
    mkdir $to_dir, 0700 or die "mkdir($to_dir) failed: $!";
    DebugPrint("generated $to_dir");
  }
  opendir DIR, $basedir or die "opendir() failed: $!";
  @files = grep !/^\.\.?$/, readdir DIR;
  closedir DIR;
  foreach $sfile (@files) {
    $dfile = $dir . '\\' . $sfile;
    copy($basedir . "\\" . $sfile, $basedir . "\\" . $dfile);
  }
}
sub link_callback {
  my($tag, %links) = @_;
  if ($tag eq "a") {
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      if (($url=~ /^http/) and (not defined($mask) or ($url =~ /$mask/))) { # customize here ...
        check_link($url);
      }
    }
  }
}
sub check_link {
  my($link) = @_;
  $request2 = new HTTP::Request(GET => $link);
  $response2 = $webagent2->request($request2);
  $content = $response2->content;
  if ($link =~ /([^\/]*)$/) {
    $to_file = $to_dir . '\\' . $1;
    DebugPrint("to_file = " . $to_file);
    open OUT, ">$to_file" or die("Cannot open $to_file: $!\n");
    print OUT $content;
    close OUT;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
