# File: SortItems_Perl.pl
# Date            Author        number of nodes
# 2003/8/6        Walking@Lint 27
# 2002/11/6       Walking Lint  27
# 2002/11/5       Walking Lint  212 (SortItems_Perl->SortItems_Perl)
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (SortItems_Perl->SortItems_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->SortItems_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

SortItems_Perl.pl - sort items of tree nodes

=head1 DESCRIPTION

activate as filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root);
if (defined($root->{CHILD})) {
  $cn = $root->{CHILD};
  while (1) {
    $text = $cn->{TEXT};
    @items = split(/ \CRLF /, $text);
    DebugPrint("items = $items[0]");
    @sorteditems = sort {lc($a) cmp lc($b)} @items;
    DebugPrint("sorteditems = $sorteditems[0]");
    $cn->{TEXT} = join(" \CRLF ", @sorteditems);
    if (not defined($cn->{NEXT})) {
      last;
    }
    $cn = $cn->{NEXT};
  }
}
&savetree($root);
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
