# File: SplitAtFirstLevel_Perl.pl
# Date            Author        number of nodes
# 2005/3/16       Walking Lint  61
# 2005/3/14       Walking Lint  61
# 2005/3/10       Walking Lint  58
# 2005/3/8        Walking Lint  54
# 2005/3/7        Walking Lint  44
# 2005/3/7        Walking Lint  44 (SeparateAtFirstLevel_Perl->SplitAtFirstLevel_Perl)
# 2005/3/6        Walking Lint  44
# 2005/3/6        Walking Lint  123 (PatentMapWriter_Perl->SeparateAtFirstLevel_Perl)
# 2005/3/5        Walking Lint  123
# 2005/3/5        Walking Lint  42 (IniWriter_Perl->PatentMapWriter_Perl)
# 2005/2/2        Walking Lint  42
# 2003/10/20      Walking Lint  42
# 2003/9/2        Walking Lint  44
# 2003/3/6        Walking Lint  126
# 2003/3/3        Walking Lint  120
# 2003/2/13       Walking Lint  219 (GenRSS_Perl->IniWriter_Perl)
# 2002/11/25      Walking Lint  215
# 2002/11/25      Walking Lint  212 (GenRSS_Perl->NewFile)
# 2002/11/18      Walking Lint  212
# 2002/11/15      Walking Lint  212
# 2002/11/5       Walking Lint  212
# 2002/11/1       Walking Lint  205
# 2002/10/31      Walking Lint  184
# 2002/10/28      Walking Lint  161
# 2002/10/22      Walking Lint  138
# 2002/10/18      Walking Lint  136
# 2002/10/17      Walking Lint  76 (GenRSS_Perl->GenRSS_Perl)
# 2002/10/11      Walking Lint  178 (GenCategorizedLinkLog_Perl->GenRSS_Perl)
# 2002/10/10      Walking Lint  178
# 2002/10/10      Walking Lint  172 (GenCategorizedLinkLogNew_Perl->GenCategorizedLinkLog_Perl)
# 2002/9/21       Walking Lint  109 (GenCategorizedLinkLog_Perl->GenCategorizedLinkLogNew_Perl)
# 2002/9/3        Walking Lint  149
# 2002/7/4        Walking Lint  141
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

SplitAtFirstLevel_Perl.pl

=head1 DESCRIPTION

activate as program ex. SplitAtFirstLevel_Perl () // "[[CurrentFile]]"

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
unless (-e $from_file) {
  DebugPrint("$from_file do not exist");
  exit;
}
$pos = shift;
my $root = {};
my $dummy_root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
&genfilefromfirstlevel($root);
sub genfilefromfirstlevel {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      $is_last = 0;
      if (not defined($cn->{NEXT})) {
        $is_last = 1;
      } else {
        $cn2 = $cn->{NEXT};
        $cn->{NEXT} = undef;
      }
      if (not ($cn->{NAME} =~ /^_/)) {
        @elements = split(/\t/, $cn->{TEXT});
        if ((not defined($pos)) or defined($elements[$pos - 1])) {
          if (not defined($pos)) {
            $fn = dirname($from_file) . "\\" . $cn->{NAME} . '.pat';
          } else {
            $fn = dirname($from_file) . "\\" . $elements[$pos - 1];
            if ($fn =~ /\.txt$/) { # try this ...
              $fn =~ s/\.txt$/.pat/;
            } else {
              $fn .= '.pat';
            }
          }
          &initnode($dummy_root, 'root', '', '', '');
          $dummy_root->{CHILD} = $cn;
          &savetree($dummy_root, $fn);
          DebugPrint("generated $fn");
        }
      }
      if ($is_last) {
        last;
      }
      $cn = $cn2;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
