# File: SplitDiaryItems_Perl.pl
# Date            Author        number of nodes
# 2004/8/1        Walking Lint  279
# 2004/4/22       Walking Lint  275
# 2004/4/17       Walking Lint  274
# 2004/4/16       Walking Lint  259
# 2003/9/1        Walking Lint  278
# 2003/9/1        Walking@Lint 260
# 2003/6/1        Walking Lint  260
# 2003/4/16       Walking Lint  243
# 2003/4/15       Walking Lint  226
# 2003/4/8        Walking Lint  223
# 2002/12/19      Walking Lint  223
# 2002/12/11      Walking Lint  199
# 2002/12/3       Walking Lint  189
# 2002/10/16      Walking Lint  184
# 2002/10/11      Walking Lint  179
# 2002/10/11      Walking Lint  193 (SplitDiaryItemsForTable_Perl->SplitDiaryItems_Perl)
# 2002/10/10      Walking Lint  158
# 2002/9/25       Walking Lint  149 (SplitDiaryItems_Perl->SplitDiaryItemsForTable_Perl)
# 2002/9/24       Walking Lint  146
# 2002/9/20       Walking Lint  140
# 2002/9/20       Walking Lint  129 (SplitDiaryItems2_Perl->SplitDiaryItems_Perl)
# 2002/9/10       Walking Lint  123
# 2002/9/9        Walking Lint  52 (SplitDiaryItems_Perl->SplitDiaryItems2_Perl)

=pod

=head1 NAME

SplitDiaryItems_Perl.pl - split diary items

=head1 DESCRIPTION

ex. perl.exe SplitDiaryItems_Perl.pl "D:\HP\MyTwoCentsContinued" "D:\HP\MyTwoCentsContinued\work"

=head1 AUTHOR

Walking Lint

=cut

use File::Copy;
$dir = shift;
$exportdir = shift;
$folder = 'Articles';
$tmp_folder = $exportdir . "\\" . $folder;
DebugPrint("tmp_folder = " . $tmp_folder);
unless (-e $exportdir) {
  mkdir $exportdir, 0700 or die "Cannot make $exportdir: $!";
}
unless (-e $tmp_folder) {
  mkdir $tmp_folder, 0700 or die "Cannot make $tmp_folder: $!";
} else { # needed not to use old data ...
  opendir DIR, $tmp_folder or die "Cannot open $tmp_folder: $!";
  @files = grep !/^\.\.?$/, readdir DIR;
  foreach $file (@files) {
    unlink $tmp_folder . "\\" . $file;
  }
  closedir DIR;
}
$found_arg = 0;
while (length($tmp = shift) != 0) {
  unless ($tmp =~ /\.html$/) {
    $tmp = $tmp . ".html";
  }
  push @files, $tmp;
  $found_arg = 1;
}
unless ($found_arg) {
  opendir DIR, $dir or die "Cannot open $dir: $!";
  @files = grep !/^\.\.?$/, readdir DIR;
  @files = grep /^20[0-9]+.html$/, @files;
  closedir DIR;
}
$first = 1;
$preindex = '';
$defaultwidth = 130;
$preindexfortable = <<END;
<td valign="top" class="menu" width="$defaultwidth">
<div class="index">
END
$istableform = 0;
foreach $file (reverse sort @files) {
  # set variables to process contents
$incopyright = 0;
$indiary = 0;
$indiv = 0; # this is hack ...
$inindex = 0;
$inweblogs = 0;
$body = '';
$year_month = '';
$year = '';
$month = '';
  $from_file = $dir . "\\" . $file;
  DebugPrint("file = $file");
  if ($from_file =~ /\\[0-9]{6}\.html$/) {
    $file =~ /^([0-9]{4})([0-9]{2})/; # this is assumed ...
    $year_month = $1 . $2;
    DebugPrint("year_month = " . $year_month);
    $year = $1;
    DebugPrint("year = " . $year);
    $month = $2;
    $month =~ s/^0+//;
    DebugPrint("month = " . $month);
    open IN, $from_file || die("Can't open $from_file: $!\n");
    DebugPrint("from_file = $from_file");
    $foundemptydiv = 0;
    $firstdivend = 1;
    $indiv = 0;
    while (<IN>) {
      if ($incopyright) {
        if (($_ =~ /^<\/body>/)) {
          $istableform = 1;
          $incopyright = 0;
          DebugPrint("out copyright(table) from $_");
          if ($first) {
            $copyrightfile = "copyright.html";
            $to_file = $exportdir . "\\" . $copyrightfile;
            open OUT, ">$to_file";
            print OUT $line;
            close OUT;
          }
          $body = $body . <<"End";
<dtml-var $copyrightfile>
</body>
End
        } elsif (not ($_ =~ /<div /) and ($_ =~ /<\/div>$/)) {
          $istableform = 0;
          $incopyright = 0;
          DebugPrint("out copyright(non table) from $_");
          if ($first) {
            $copyrightfile = "copyright.html";
            $to_file = $exportdir . "\\" . $copyrightfile;
            open OUT, ">$to_file";
            $_ =~ s/<\/div>$//;
            $line = $line . $_;
            print OUT $line;
            close OUT;
          }
          $body = $body . <<"End";
<dtml-var $copyrightfile>
</div>
End
        } else {
          DebugPrint("in copyright = $_");
          $line = $line . $_;
        }
      } elsif ($indiary) {
        $tmp_line = $_;
        if (($tmp_line =~ /<div /) and not ($tmp_line =~ /<div class="copyright">/) and not ($tmp_line =~ /<div class="navi">/) and not ($tmp_line =~ /div>$/)) { # this is hack ...
          $indiv = 1;
          $line = $line . $tmp_line;
          DebugPrint("in div from $tmp_line");
        } elsif ($tmp_line =~ /^<h[^>]+>(20[0-9]+)\/([0-9]+)\/([0-9]+)\(/) { # this is hack ...
          open OUT, ">$to_file";
          print OUT $line;
          close OUT;
          $to_file = $exportdir . "\\" . $folder . "\\" . sprintf("%d%02d%02d", $1, $2, $3);
          $line = $tmp_line;
          DebugPrint("found Diary Item $tmp_line");
        } elsif (($tmp_line =~ /^<div class="copyright">/) or ($tmp_line =~ /^<div class="navi">/)) {
          open OUT, ">$to_file";
          if ($foundemptydiv) { # may be this is it ...
            $line =~ s/<\/div>\n//;
          }
          $body = $body . <<"End";
<dtml-in expr="$folder.objectValues()">
  <dtml-let num=id>
    <dtml-if expr="num[0:6] == '$year_month'"> 
      <dtml-var sequence-item>
    </dtml-if>   
  </dtml-let>
</dtml-in>
End
          print OUT $line;
          close OUT;
          $indiary = 0;
          $incopyright = 1;
          DebugPrint("out diary and in copyright with $tmp_line");
          $line = $tmp_line;
        } else {
          $line = $line . $tmp_line;
        }
      } elsif ($inindex) {
        if (($_ =~ /^<h/) or ($_ =~ /^<div class="sidetitle"/)) { # this is assumed
          $indexfile = "Index" . $year_month;
          $to_file = $exportdir . "\\" . $indexfile;
          open OUT, ">$to_file";
          print OUT $line;
          close OUT;
          $body = $body . <<"End";
<dtml-var $indexfile>
End
          $inindex = 0;
          $inweblogs = 1;
          $indiv = 0;
          DebugPrint("out index and in weblogs from $_");
          $line = $_;
        } else {
          if ($inpreindex) {
            if (/<div class="li">-/) {
              $inpreindex = 0;
              if ($istableform) {
                $line = $line . $preindexfortable . $_;
              } else {
                $line = $line . $preindex . $_;
              }
            } elsif (/<div class="ul">/) {
              $line = $line . $_;
            } else {
              $tmp_line = $_;
              if ($istableform and ($_ =~ /class="menu"/)) { # actually this is assumed ... ? think later ...
                $tmp_line =~ /width="([0-9]+)"/;
                $new_width = $1;
                DebugPrint("new_width = " . $new_width);
                if ((length($new_width) != 0) and ($new_width != $defaultwidth)) {
                  $preindexfortable =~ s/width="$defaultwidth"/width="$new_width"/;
                }
              }
            }
          } else {
            $line = $line . $_;
          }
        }
      } elsif ($inweblogs) {
        $line = $line . $_;
        if ($istableform and ($_ =~ /<\/table>/) or (not $istableform) and ($indiv == 0) and ($_ =~ /^<\/div>/) or ($_ =~ /<td width="0"><\/td>/)) {
          $inweblogs = 0;
          DebugPrint("out weblogs from $_");
          if ($first) {
            $webogsfile = "Weblogs";
            $to_file = $exportdir . "\\" . $webogsfile;
            open OUT, ">$to_file";
            print OUT $line;
            close OUT;
          }
          $body = $body . <<"End";
<dtml-var $webogsfile>
End
        } elsif (($_ =~ /^<div /) and not ($_ =~ /<\/div>$/)) {
          $indiv++;
        } elsif ($_ =~ /^<\/div>$/) {
          $indiv--;
        }
      } else {
        if (/^<h[^>]+>(20[0-9]+)\/([0-9]+)\/([0-9]+)\(/) { # this is hack ...
          $to_file = $exportdir . "\\" . $folder . "\\" . sprintf("%d%02d%02d", $1, $2, $3);
          $indiary = 1;
          DebugPrint("in diary from $_");
          $line = $_;
        } elsif (($_ =~ /^<td width="[0-9]+"><\/td>/) or ($_ =~ /<td valign="top" class="menu"/)) {
          $istableform = 1;
          $inindex = 1;
          $inpreindex = 1;
          DebugPrint("in index (table) from $_");
          if (/<td valign="top" class="menu"/) {
            $_ =~ /width="([0-9]+)"/;
            $new_width = $1;
            DebugPrint("new_width = " . $new_width);
            if ((length($new_width) != 0) and ($new_width != $defaultwidth)) {
              $preindexfortable =~ s/width="$defaultwidth"/width="$new_width"/;
            }
            $line = ''; # needed ??
          } else {
            $line = $_;
          }
        } elsif (/^<div id="index">/) {
          $istableform = 0;
          $inindex = 1;
          $inpreindex = 1;
          DebugPrint("in diary (non table) from $_");
          $line = $_;
        } elsif (/^<div>/) { # this is hack ...
          $foundemptydiv = 1;
        } else {
          $body = $body . $_;
        }
      }
    }
    $to_file = $exportdir . "\\" . $year_month . ".html";
    $preindex = $preindex . <<"END";
<div class="li"><a href="$year_month.html">+ $year/$month</a></div>
END
    $preindexfortable = $preindexfortable . <<"END";
<div class="li"><a href="$year_month.html">+ $year/$month</a></div>
END
    open OUT, ">$to_file";
    print OUT $body;
    close OUT;
    close IN;
    $first = 0;
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
