# File: Src2Html_Perl.pl
# Date            Author        number of nodes
# 2003/8/6        Walking@Lint 39
# 2002/7/19       Walking Lint  39
# 2002/7/16       Walking Lint  33
# 2002/7/15       Walking Lint  30
# 2002/4/21       Walking Lint  8 (strings_Perl->Src2Html_Perl)
# 2002/4/21       Walking Lint  6 (WordCount_Perl->strings_Perl)

=pod

=head1 NAME

Src2Html_Perl.pl - Src2Html

=head1 DESCRIPTION

convert src file to html file

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
$from_file = shift;
$to_file = $from_file;
$to_file =~ s/\.[a-zA-Z0-9]+$/.html/;
open OUT, ">$to_file";
$basename = basename($from_file);
print OUT <<END;
<html>
<head>
<title>$basename</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="PROGRAM.css" />
</head>
<body>
<pre>
END
open IN, $from_file || die("Can't open $from_file: $!\n");
$indoc = 0;
while (<IN>) {
  if (/\[\[([^!]*)![^]]*\]\]/) {
    $_ =~ s/\[\[([^!]*)!([^]]*)\]\]/<a href="$2">$1<\/a>/g;
  } elsif (/^=pod/ or /^=begin/) {
    $indoc = 1;
    $_ = "<hr/>\n";
  } elsif (/^=cut/ or /^=end/) {
    $indoc = 0;
    $_ = "<hr/>\n";
  } elsif (/^=head[1-6][ ]+(.*)/) {
    $_ =~ s/^=head([1-6])[ ]+(.*)/<h$1>$2<\/h$1>/g;
  } elsif (/^(=+)[ ]+(.*)/) {
    $num = length($1);
    $_ =~ s/^(=+)[ ]+(.*)/<h$num>$2<\/h$num>/g;
  } elsif (not $indoc) {
    $_ =~ s/&/\&amp;/g;
    $_ =~ s/</\&lt;/g;
    $_ =~ s/>/\&gt;/g;
  }
  print OUT $_;
}
print OUT "</pre>\n";
print STDERR "\ngenerated $to_file\n";
