# File: StartOfNextQuota_Perl.pl
# Date            Author        number of nodes
# 2002/12/27      Walking Lint  41
# 2002/12/27      Walking Lint  44 (NextQuota_Perl->StartOfNextQuota_Perl)
# 2002/12/26      Walking Lint  53
# 2002/11/21      Walking Lint  46
# 2002/11/21      Walking Lint  37 (ThisQuarter_Perl->NextQuota_Perl)
# 2002/10/18      Walking Lint  29 (ThisQuarter_Perl->ThisQuarter_Perl)
# 2002/10/16      Walking Lint  19 (ThisQuarter_Perl->ThisQuarter_Perl)
# 2002/10/16      Walking Lint  19 (ThisQuarter_Perl->ThisQuarter_Perl)
# 2002/10/8       Walking Lint  7 (NextWeek_Perl->ThisQuarter_Perl)
# 2002/10/8       Walking Lint  7 (ThisQuarter_Perl->NextWeek_Perl)
# 2002/10/8       Walking Lint  7 (ThisQuarter_Perl->ThisQuarter_Perl)
# 2002/10/2       Walking Lint  7 (ThisQuarter_Perl->ThisQuarter_Perl)
# 2002/10/2       Walking Lint  39 (RefFromClipboard_Perl->ThisQuarter_Perl)
# 2002/9/29       Walking Lint  28 (SplitLine_Perl->RefFromClipboard_Perl)
# 2002/7/4        Walking Lint  13 (EncloseLinesWithTag_Perl->SplitLine_Perl)
# 2002/7/4        Walking Lint  7 (DeleteNotMatchedLine_Perl->EncloseLinesWithTag_Perl)
# 2002/6/14       Walking Lint  6
# 2002/4/24       Walking Lint  4
# 2002/4/20       Walking Lint  4 (DeleteMatchedLine_Perl->DeleteNotMatchedLine_Perl)

=pod

=head1 NAME

StartOfNextQuarter_Perl.pl - get first date of next quater

=head1 DESCRIPTION

ex. perl.exe StartOfNextQuarter_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use Time::localtime;
$time = time;
$thismonth = &month($time);
if ($thismonth <= 3) {
  $targetmonth = 4;
} elsif ($thismonth <= 6) {
  $targetmonth = 7;
} elsif ($thismonth <= 9) {
  $targetmonth = 10;
} else {
  $targetmonth = 1;
}
while (1) {
  $yobi = &yobi($time);
  if (($month == $targetmonth) and ($yobi != 6) and ($yobi != 0)) {
    $possiblelastday = $day;
    $possiblelastmonth = $month;
    $possiblelastyear = $year;
    last;
  }
  $time += 60 * 60 * 24;
}
printf "%04d/%02d/%02d", $possiblelastyear, $possiblelastmonth, $possiblelastday;
# [[Re: Getting Day of Week for a specific date!http://granite.unh.edu/pasnews/msg00674.html]]
sub day_of_week {
  my($y, $m, $d) = @_;
  @t = (0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4);
  $y -= ($m < 3);
  return ($y + int($y / 4) - int($y / 100) + int($y / 400) +$t[$m - 1] + $d) % 7;
}
sub yobi {
  my($time) = @_;
  my $tm = localtime($time);
  $year = $tm->year + 1900;
  $month = $tm->mon + 1;
  $day = $tm->mday;
  return &day_of_week($year, $month, $day);
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
