# File: StyleSheetReader_Perl.pl
# Date            Author        number of nodes
# 2004/4/13       Walking Lint  367
# 2003/10/3       Walking@Lint 362
# 2003/10/1       Walking Lint  346
# 2003/5/27       Walking Lint  299
# 2003/5/17       Walking Lint  311
# 2003/4/15       Walking Lint  305
# 2003/4/15       Walking Lint  488 (HtmlReader_Perl->StyleSheetReader_Perl)
# 2003/4/15       Walking Lint  488
# 2003/4/15       Walking Lint  464 (JavaScriptReader_Perl->HtmlReader_Perl)
# 2003/3/20       Walking Lint  464
# 2003/3/19       Walking Lint  397
# 2003/3/18       Walking Lint  341
# 2003/3/14       Walking Lint  358 (JavaReader_Perl->JavaScriptReader_Perl)
# 2003/3/13       Walking Lint  353 (PerlReader_Perl->JavaReader_Perl)
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

StyleSheetReader_Perl.pl - html reader

=head1 DESCRIPTION

activate as plug-in or filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$comment_start = '\/\*';
$comment_end = '\*\/';
$in_comment = 0;
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.css';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&rescuetree($root);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("input line = $linewithoutindent");
  $line =~ /^([\t ]*)(.*)/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  DebugPrint("level = $level");
  $argline = '';
  $name =~ s/[ \t]+$//;
  $name =~ s/^[ \t]*\}[ \t]*//;
  DebugPrint("name = [" . $name . "] text = [" . $text . "]");
  if (length($name) == 0) {
    return 1; # skip this line ... think later ...
  } elsif ($name =~ /$comment_start([^*]*)$comment_end[ ]*([^{]+){[ \t]*$/) { # comment started and ended and open tag ...
    $tmp = $name;
    $tmp =~ /$comment_end([^\/]+){[ \t]*$/;
    $name = $1;
    DebugPrint("name = " . $name);
    $text = $tmp;
    $text =~ s/$comment_end([^\/]+){[ \t]*$//;
    $text =~ s/^$comment_start//;
    DebugPrint("text = " . $text);
    $indentedcomment = $text; # this is key
    $name =~ s/[ \t]*$//;
    $name =~ s/^[ \t]*//;
    $name =~ tr/A-Z/a-z/;
    DebugPrint("comment started and ended and open tag");
  } elsif ($name =~ /$comment_start([^*]*)$comment_end/) { # comment started and ended
    $name = '_';
    DebugPrint("comment started and ended");
    $text = $1;
    $indentedcomment = $text; # this is key
    if (length($text) == 0) {
      return 1; # skip ...
    }
  } elsif ($name =~ /$comment_start([^*]*)/) { # comment started
    $name = '_';
    DebugPrint("comment started");
    $text = $1;
    $indentedcomment = $text; # this is key
    $in_comment = 1;
    if (length($text) == 0) {
      return 1; # skip ...
    }
  } elsif ($in_comment) { # this is hack ...
    if ($name =~ /([^*]*)$comment_end/) { # comment ended
      $name = '_';
      DebugPrint("comment ended");
      $text = $1;
      $indentedcomment = $text; # this is key
      $in_comment = 0;
      if (length($text) == 0) {
        return 1; # skip ...
      }
    } else {
      $text = $name; # hack ...
      $text =~ s/^\*\*[ \t]+//; # hack ...
      $indentedcomment = $text; # this is key
      $name = '_';
      DebugPrint("comment continued");
    }
  } elsif ($name =~ /^([^{]+){[ \t]*$/) { # open tag
    $name = $1;
    $name =~ s/[ \t]*$//;
    $name =~ tr/A-Z/a-z/;
    DebugPrint("open tag");
  } elsif ($name =~ /^([^: \t]+)[\t ]*:[\t ]*([^;}]+)(;|})?$/) { # assignment
    $name = $1;
    $name =~ tr/A-Z/a-z/;
    DebugPrint("assignment - $name");
    $kind = ' (out) ';
    $type = $2;
    if ($type =~ /^\#[0-9a-fA-F]+$/) { # try this now ...
      $type =~ tr/A-Z/a-z/;
    }
    $type = '  ' . $type;
  } elsif (length($text) != 0) { # not sure but ...
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  } else {
    return 1;
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  # try here filtering ...
  $breaklater = 0;
  while (<$infilehandle>) {
    if ($_ =~ /^__EOF__[\n\r]*$/) {
      last;
    } elsif ($_ =~ /__EOF__[\n\r]*$/) {
      $_ =~ s/__EOF__[\n\r]*$//;
      $breaklater = 1;
    }
    push @lines, $_;
    if ($breaklater) {
      last;
    }
  }
  $line = join(' ', @lines);
  $line =~ s/[ \n]+/ /g;
  $line =~ s/[\t]+/        /g; # try this ... hack ...
  $line =~ s/}[ ]*/}\n/g; # difference between indent of this and those of next lines is needed ...
  $line =~ s/{[ ]*/{\n  /g;
  $line =~ s/;[ ]*/;\n  /g;
  $line =~ s/\*\/[ ]*\/\*/\*\/\n\/\*/g; # must be here ... after \n are converted ...
  @processed_lines2 = split(/\n/, $line);
  @processed_lines3 = ();
  $prev_line = '';
  foreach $line (@processed_lines2) {
    if (length($prev_line) != 0) {
      $line =~ s/^[ ]+//;
      $line = $prev_line . $line;
      $prev_line = '';
    }
    if (($line =~ /^\/\*/) and not ($line =~ /\*\//)) {
      $prev_line = $line;
    } else {
      push @processed_lines3, $line;
    }
  }
  foreach (@processed_lines3) {
    $_ =~ s/[\n\t ]+$//;
    if ((length($_) != 0)) {
      if (&extractparams($_)) {
        $prevname = '';
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        DebugPrint("** 1 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        if (($cur != $root) and ($name eq '_') and ((length($cur->{TEXT}) != 0) and not ($prevname eq '_text') or ($prevname eq '_'))) {
          $level = $prevlevel;
          $cur->{TEXT} .= " \CRLF " . $indentedcomment;
        } else {
          push @prevlevels, $prevlevel;
          $cur = addchildnode($cur, $name, $kind, $type, $text);
        }
      } elsif ($prevlevel == $level) {
        DebugPrint("** 2 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
        } elsif (($name eq '_text') and ($prevname eq '_text')) { # ($cur->{NAME} eq '_text')
          $cur->{TEXT} .= " \CRLF " . $text;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      } else {
        DebugPrint("** 3 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        until ($prevlevel <= $level) {
          if ($cur->{PARENT} == $root) { # hack ???
            last;
          }
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        $cur = addnode($cur, $name, $kind, $type, $text);
      }
      $prevname = $name;
      $previndentedcomment = $indentedcomment;
      $prevlevel = $level;
      my $argkind = " \(in\) \& ";
      if ($kind =~ /~/) {
        if ($name =~ /\(([^\)]+)\)$/) {
          $name =~ s/[\t ]*\(([^\)]+)\)$//;
          $cur->{NAME} = $name;
          $argline2 = $1;
          my @args2 = reverse split(/[\t ]*,[\t ]*/, $argline2);
          foreach $arg (@args2) {
            if ($arg =~ /=/) {
              $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
              &addchildnode($cur, $1, $argkind, '  ' . $2, '');
            } else {
              &addchildnode($cur, $arg, $argkind, '', '');
            }
          }
        }
      }
      if (length($argline) != 0) {
        if ($argline =~ /\|[\t ]*([^\|]+)\|[\t ]*(.*)/) { # this is block arg
          $argline = $1;
          $body = $2;
          $body =~ s/[\t ]*}$//;
          $argline =~ s/[\t ]*$//;
          $argkind .= '~ ';
        }
        my @args = split(/[\t ]*,[\t ]*/, $argline);
        foreach $arg (@args) {
          if ($arg =~ /=/) {
            $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
            &addchildnode($cur, $1, $argkind, '  ' . $2, '');
          } else {
            &addchildnode($cur, $arg, $argkind, '', '');
          }
        }
        if (length($body) != 0) {
          &extractparams($body);
          &addchildnode($cur, $name, $kind, $type, $text);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub getcondandstmt {
  my($str) = @_;
  @chars = split(//, $str);
  $pre = '';
  $post = '';
  $level = 0;
  foreach $char (@chars) {
    if ($char eq '(') {
      $level++;
      if ($level > 1) {
        $pre .= $char;
      }
    } elsif ($char eq ')') {
      $level--;
      if ($level == 0) {
        last;
      } else {
        $pre .= $char;
      }
    } else {
      $pre .= $char;
    }
  }
  $post = substr($str, length($pre) + 2);
  return ($pre, $post);
}
sub rescuetree {
  my($nd) = @_;
  if (not defined($nd->{NEXT})) {
    return;
  }
  $cn = $nd->{NEXT};
  while (1) {
    if (defined($cn->{NEXT})) {
      $ncn = $cn->{NEXT};
      $found_next = 1;
    } else {
      $found_next = 0;
    }
    &delnode($cn);
    &addchildnode2($nd, $cn);
    if (not $found_next) {
      last;
    }
    $cn = $ncn;
  }
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if ($nd->{NAME} eq '_') { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
  if (defined($nd->{CHILD})) {
    # for case - when / else
    my $cn = $nd->{CHILD};
    $foundcase = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'case') {
        $foundcase = 1;
        $casenode = $cn;
      } elsif ($foundcase) {
        if (($cn->{NAME} eq 'else') or ($cn->{NAME} eq 'when')) {
          &delnode($cn);
          &addchildnode2($casenode, $cn);
        }
      } else {
        $foundcase = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
    # for begin - rescue / ensure
    my $cn = $nd->{CHILD};
    $foundbegin = 0;
    while (1) {
      $ncn = $cn->{NEXT};
      if ($cn->{NAME} eq 'begin') {
        $foundbegin = 1;
        $beginnode = $cn;
      } elsif ($foundbegin) {
        if (($cn->{NAME} eq 'ensure') or ($cn->{NAME} eq 'rescue')) {
          &delnode($cn);
          &addchildnode2($beginnode, $cn);
        }
      } else {
        $foundbegin = 0;
      }
      if (not defined($ncn)) {
        last;
      }
      $cn = $ncn;
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
