# File: TextWithHierarchyWriter_Perl.pl
# Date            Author        number of nodes
# 2004/7/21       Walking Lint  85
# 2003/11/21      Walking Lint  85
# 2003/7/2        Walking Lint  84
# 2003/5/9        Walking Lint  77
# 2003/5/8        Walking Lint  74
# 2003/5/8        Walking Lint  74 (TextWithStructureWriter_Perl->TextWithHierarchyWriter_Perl)
# 2003/5/8        Walking Lint  74
# 2003/5/8        Walking Lint  60 (2PowerPoint_Perl->TextWithStructureWriter_Perl)
# 2003/2/12       Walking Lint  60
# 2002/11/10      Walking Lint  33 (2PowerPoint_Perl->2PowerPoint_Perl)
# 2002/11/9       Walking Lint  29
# 2002/6/4        Walking Lint  29 (CSVWriter_Perl->2PowerPoint_Perl)
# 2002/3/10       Walking Lint  20

=pod

=head1 NAME

TextWithHierarchyWriter_Perl.pl - text with hierarchy writer

=head1 DESCRIPTION

activate as plug-in or filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
$to_file = shift;
if ($to_file =~ /\.pat/) { # activated as filter ...
  $from_file = $to_file;
  $to_file =~ s/\..+/.txt/;
} else {
  $from_file = $to_file;
  $from_file =~ s/\..+/.pat/;
}
DebugPrint("from_file = $from_file");
@htmlelements = ('!doctype', 'a', 'center', 'div', 'head', 'li', 'link', 'meta', 'ol', 'p', 'table', 'title', 'ul');
my $root = {}; # this is needed ...
$crlf = ' CR' . 'LF ';
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
open OUT, ">$to_file";
&genoutline($root, 1);
close OUT;
DebugPrint("generated $to_file");
sub genoutline {
  my($nd, $level) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      $name = $cn->{NAME};
      if (($name =~ /^_/) and not ($name eq '_text')) {
        # do nothing
      } elsif (not &ishtmlelement($name)) {
        if (not ($name eq '_text')) {
          print OUT "." x $level . $name . "\n";
        }
        $text = $cn->{TEXT};
        if (length($text) > 0) {
          $text =~ s/^\./ ./; # this is hack ...
          $text =~ s/$crlf\./\n ./g; # this is hack ...
          $text =~ s/$crlf/\n/g;
          $text =~ s/ CRLF$//; # this is hack ... think later ...
          $text =~ s/\[\[([^!]*)!(.*)\]\]/<a href="$2">$1<\/a>/g; # convert URL ref pattern
          print OUT $text . "\n";
        }
        &genoutline($cn, $level + 1);
      } else {
        &genoutline($cn, $level);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    $str =~ tr/A-Z/a-z/;
    if ($str eq $htmlelement) {
      return 1;
    }
  }
  return 0;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
sub Trace {
  my($str) = @_;
  print STDERR "$str\n";
}
