# File: ToDo_Perl.pl
# Date            Author        number of nodes
# 2003/3/30       Walking Lint  110
# 2003/3/29       Walking Lint  108
# 2003/3/8        Walking Lint  104
# 2003/3/7        Walking Lint  104
# 2003/3/5        Walking Lint  112
# 2002/12/13      Walking Lint  126 (GenToDo_Perl->ToDo_Perl)
# 2002/11/19      Walking Lint  93
# 2002/10/16      Walking Lint  86 (GenToDoList_Perl->GenToDo_Perl)
# 2002/10/15      Walking Lint  115 (GenToDoList_Perl->GenToDoList_Perl)
# 2002/10/15      Walking Lint  81 (GenToDoList_Perl->GenToDoList_Perl)
# 2002/9/21       Walking Lint  168
# 2002/8/31       Walking Lint  156

=pod

=head1 NAME

ToDo_Perl.pl - generate ToDo

=head1 DESCRIPTION

ex. perl.exe ToDo_Perl.pl

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use Time::localtime;
use File::Copy;
use Win32::File;
$templatesfolder = $ENV{TEMPLATESFOLDER};
$templatesfolder =~ s/"//g;
$todo_body = 'Memo2.pat';
$todo_file = $templatesfolder . "\\" . $todo_body;
$tofile = $todo_file;
$tofile =~ s/\.pat$/.html/;
DebugPrint("todo_file = $todo_file");
$weblogfolder = $ENV{WEBLOGFOLDER};
$weblogfolder =~ s/"//g;
$todo = $weblogfolder . '\ToDo.html';
DebugPrint("todo = $todo");
$Title = 'items to be done';
$skip_generating_file = shift;
if (defined($skip_generating_file) and not ($skip_generating_file =~ /\.pat$/)) { # generate file if activated from file menu
  if (-e $todo) {
    @stat = stat($todo);
    $tm = localtime($stat[9]);
    $dateandtime = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec);
    print <<END;
<a href="ToDo.html">$Title</a><small>
<div class="lastupdate">($dateandtime)</div></small>
END
  } else {
    print <<END;
<a href="ToDo.html">$Title</a>
END
  }
  exit;
}
# set other parameters
$ParentTitle = 'Revenge of My Two Cents';
DebugPrint("ParentTitle = $ParentTitle");
$ParentURL = 'index.html';
DebugPrint("ParentURL = $ParentURL");
$link_file_body = '2ColumnForSubPage.css';
$copyright_file = $weblogfolder . '\copyright.html';
open IN, $copyright_file || die("Cannot open $copyright_file: $!\n");
@copyrights = <IN>;
close IN;
$copyright = join('', @copyrights);
DebugPrint("copyright = $copyright");
$tm = localtime;
$dateandtime = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $tm->year + 1900, $tm->mon + 1, $tm->mday, $tm->hour, $tm->min, $tm->sec);
print <<END;
<a href="ToDo.html">$Title</a><small>
<div class="lastupdate">($dateandtime)</div></small>
END
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $todo_file);
my $first = 1;
open OUT, ">$todo";
print OUT <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
<title>$Title</title>
<meta http-equiv="content-type" content="text/html;charset=Shift_JIS" />
<meta http-equiv="content-style-type" content="text/css" />
<link rel="stylesheet" type="text/css" href="$link_file_body" />
</head>
<body>
<table class="navi"><tr><td class="path"><a href="$ParentURL">$ParentTitle</a> > $Title</td></tr></table>
<h3>items to be done</h3>
END
$counter = 1;
&gentodo($root, 1);
print OUT <<END;
$copyright
</body>
</html>
END
close OUT;
copy($todo, $tofile);
DebugPrint("generated $todo");
DebugPrint("generated $tofile");
sub gentodo {
  my($nd, $level) = @_;
  if (defined($nd->{CHILD})) {
    print OUT <<END;
<ol>
END
    my $cn = $nd->{CHILD};
    while (1) {
      if (($cn->{NAME} eq '_note') or ($cn->{NAME} eq '_presave') or ($cn->{NAME} eq '_script')) {
      } else {
        $text = $cn->{TEXT};
        $text =~ s/( \CRLF )+/ /g;
        if (length($text) != 0) {
          $text = ' - ' . $text;
        } else {
          $text = '';
        }
        $text =~s/&/&amp;/g;
        $text =~s/</&lt;/g;
        $text =~s/>/&gt;/g;
        if ($cn->{KIND} =~ /\(\) \+/) {
          print OUT <<END;
<li><strike>$cn->{NAME}$text</strike></li>
END
        } else {
          print OUT <<END;
<li>$cn->{NAME}$text</li>
END
        }
        if (defined($cn->{CHILD})) {
          &gentodo($cn, $level + 1);
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    print OUT <<END;
</ol>
END
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
