# File: TotalOfColumns_Perl.pl
# Date            Author        number of nodes
# 2004/11/3       Walking Lint  31

=pod

=head1 NAME

TotalOfColumns_Perl.pl - total of columns

=head1 DESCRIPTION

activate as filter2

=head1 AUTHOR

Walking Lint

=cut

@columns = ();
@total_of_columns = ();
while (<STDIN>) {
  $_ =~ s/[\r\n]+$//;
  @columns = split(/[ \t]+/, $_);
  $count = 0;
  foreach $column (@columns) {
    if (not ($column =~ /^[0-9]+$/)) {
      $total_of_columns[$count] = "NAN";
    } elsif ($total_of_columns[$count] eq "NAN") {
      # do nothing
    } else {
      if (length($total_of_columns[$count]) == 0) {
        $total_of_columns[$count] = $column;
      } else {
        $total_of_columns[$count] += $column;
      }
    }
    $count++;
  }
}
foreach $total_of_column (@total_of_columns) {
  if ($total_of_column eq "NAN") {
    print STDERR "NAN ";
  } else {
    print STDERR $total_of_column . " ";
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
