# File: TotalOfTreeColumns_Perl.pl
# Date            Author        number of nodes
# 2005/8/20       Walking Lint  61
# 2005/8/20       Walking Lint  44 (SumColumns_Perl->TotalOfTreeColumns_Perl)
# 2005/8/20       Walking Lint  81
# 2005/8/20       Walking Lint  81 (GenMindMap_Perl->SumColumns_Perl)
# 2003/4/14       Walking Lint  103
# 2002/11/16      Walking Lint  103
# 2002/10/10      Walking Lint  103
# 2002/10/2       Walking Lint  154
# 2002/10/1       Walking Lint  154
# 2002/9/29       Walking Lint  245
# 2002/9/28       Walking Lint  239
# 2002/9/21       Walking Lint  228
# 2002/9/21       Walking Lint  168 (GenMindMap_Perl->GenMindMap_Perl)
# 2002/8/31       Walking Lint  156
use CVTree_Perl;
$from_file = shift;
my $root = {};
&initnode($root, 'root', '', '', '');
&gentree($root, $from_file);
&sumcolumns($root);
&savetree($root, $from_file);
sub sumcolumns {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $first = 1;
    my $cn = $nd->{CHILD};
    while (1) {
      if (($cn->{NAME} =~ /^_/) and not ($cn->{TEXT} =~ /title=/) or ($cn->{NAME} eq 'center') or ($cn->{NAME} eq 'l') or ($cn->{NAME} eq 'p')) { # think later ...
        # skip
      } else {
        if (defined($cn->{CHILD})) {
          &sumcolumns($cn);
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    my @total_of_columns = ();
    my @columns = ();
    my $text = '';
    $cn = $nd->{CHILD};
    while (1) {
      if ($cn->{NAME} =~ /^_/) { # may be commented out
        # skip
      } else {
        $text = $cn->{TEXT};
        $text =~ s/(|,)//g;
        @columns = split(/[ \t\/\-]+/, $text);
        my $count = 0;
        foreach $column (@columns) {
          if (not ($column =~ /^[0-9]*$/)) {
            # do nothing
          } else {
            if (length($total_of_columns[$count]) == 0) {
              $total_of_columns[$count] = $column;
            } else {
              $total_of_columns[$count] += $column;
            }
          }
          $count++;
        }
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
    $nd->{TEXT} = join(" - ", @total_of_columns);
    if (($#total_of_columns == 1) and ($nd == $root)) {
      my $profit = $total_of_columns[0] - $total_of_columns[1];
      $nd->{TEXT} .= ' = ' . $profit;
      DebugPrint("$nd->{NAME} = $nd->{TEXT}");
    } else {
      DebugPrint("$nd->{NAME} = $nd->{TEXT}");
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
