# File: TxtReader_Perl.pl
# Date            Author        number of nodes
# 2002/11/29      Walking Lint  46
# 2002/11/10      Walking Lint  33 (PodReader_Perl->TxtReader_Perl)
# 2002/11/10      Walking Lint  20 (CsvReader_Perl->PodReader_Perl)
# 2002/11/9       Walking Lint  16
# 2002/3/10       Walking Lint  16 (CSVReader_Perl->CsvReader_Perl)

=pod

=head1 NAME

TxtReader_Perl.pl - txt reader

=head1 DESCRIPTION

activate as plug-in

=head1 AUTHOR

Walking Lint

=cut

$from_file = shift;
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
open IN, $from_file || die("Can't open $from_file: $!\n");
open OUT, ">$to_file";
$name = '';
$previtemnumber = '';
while (<IN>) {
  chop;
  if (/^[ \t]*([0-9]+(\.[0-9]+)*)( )[^ ]/) { # this is assumed ...
    # better to indent? think later ...
    $itemnumber = $1;
    if (length($name) != 0) {
      $previtemnumber =~ s/[0-9]+//g;
      $indent = "\t" x (length($previtemnumber) + 1);
      print OUT $indent . $name . " ()\n";
      if (length($text) != 0) {
        print OUT $indent . "\t_text () ^ \/\/  \%\% $text\n";
      }
    } else {
      print OUT "root ()\n";
      if (length($text) != 0) {
        print OUT "\t_text () ^ \/\/  \%\% $text\n";
      }
    }
    $previtemnumber = $itemnumber;
    $name = $_;
    $name =~ s/^[ \t]+//;
    $text = '';
  } else {
    if (length($text) == 0) {
      $text = $_;
    } else {
      $text .= " \CRLF " . $_;
    }
  }
}
if (length($name) != 0) {
  $indent = "\t";
  print OUT "\t" . $name . " ()\n";
  if (length($text) != 0) {
    print OUT $indent . "\t_text () ^ \/\/  \%\% $text\n";
  }
} else {
  print OUT "root ()\n";
  if (length($text) != 0) {
    print OUT "\t_text () ^ \/\/  \%\% $text\n";
  }
}
close IN;
close OUT;
