# File: URL2LinkInfo_Perl.pl
# Date            Author        number of nodes
# 2002/11/27      Walking Lint  53
# 2002/11/22      Walking Lint  52
# 2002/11/22      Walking Lint  111 (UpdateStatusOfLinks_Perl->URL2LinkInfo_Perl)
# 2002/11/22      Walking Lint  97 (CheckLinkUpdate_Perl->UpdateStatusOfLinks_Perl)
# 2002/11/21      Walking Lint  97
# 2002/11/21      Walking Lint  94 (CheckWeblogs_Perl->CheckLinkUpdate_Perl)
# 2002/11/20      Walking Lint  89
# 2002/11/19      Walking Lint  70
# 2002/11/19      Walking Lint  31 (CheckWeblogs_Perl->NewFile)
# 2002/11/19      Walking Lint  58 (Links_Perl->CheckWeblogs_Perl)
# 2002/11/19      Walking Lint  32 (CheckLinks_Perl->Links_Perl)
# 2002/11/19      Walking Lint  22 (ExtractLinks_Perl->CheckLinks_Perl)

=pod

=head1 NAME

URL2LinkInfo_Perl.pl - update status of links

=head1 DESCRIPTION

ex. perl.exe URL2LinkInfo_Perl.pl http://member.nifty.ne.jp/WalkingLint/

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
use LWP::Simple;
use CVTree_Perl;
# get proxy info from registry
use Win32::Registry;
$HKEY_CURRENT_USER->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", $ref) or die "cannot open registry: $!";
$ref->GetValues(\%values);
$refproxyoverride = $values{'ProxyOverride'};
$refproxyserver = $values{'ProxyServer'};
$ref->Close();
$proxyoverride = $$refproxyoverride[2];
$proxyoverride =~ s/\*//g;
$proxyoverride =~ s/;?<local>//g;
$proxyoverride =~ s/;/\|/g; # not actually ...
$proxyoverride = quotemeta $proxyoverride;
$proxyoverride =~ s/\\\|/\|/g; # hack ...
$proxyoverride = '(' . $proxyoverride . ')';
DebugPrint("proxyoverride = $proxyoverride");
$proxyserver = $$refproxyserver[2];
DebugPrint("proxyserver = $proxyserver");
$url = shift;
DebugPrint("url = $url");
$webagent = new LWP::UserAgent;
$webagent->agent('LWP::GETHEAD');
$webagent2 = new LWP::UserAgent;
unless ($url =~ /$proxyoverride/) {
  $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
  $webagent2->proxy(['ftp', 'http'] => "http://$proxyserver");
}
$request = new HTTP::Request('HEAD' => $url);
$response = $webagent->request($request);
if ($response->is_success) {
  $lastmodified = $response->header('Last-Modified');
  if (length($lastmodified) == 0) {
    $request2 = new HTTP::Request('GET' => $url);
    $response2 = $webagent2->request($request2);
    $lastmodified = length($response2->content); # not actually ...
  }
  if (length($lastmodified) != 0) {
    $info = ' (' . $lastmodified . ')';
  } else {
    $info = '';
  }
  $name = $url;
  $name =~ s/(\/|\.(html|htm))$//;
  $line = $url . ' () // ' . $info . ' %' . '% ' . $url . "\n";
  print $line;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
