# File: UpdateStatusOfLinks_Perl.pl
# Date            Author        number of nodes
# 2006/1/19       Walking Lint  348
# 2004/11/22      Walking Lint  353
# 2004/11/21      Walking Lint  354
# 2003/12/22      Walking Lint  353
# 2003/9/5        Walking Lint  351
# 2003/9/4        Walking Lint  351
# 2003/9/3        Walking Lint  345
# 2003/8/28       Walking Lint  345
# 2003/5/6        Walking Lint  343
# 2003/5/5        Walking Lint  343
# 2003/3/23       Walking Lint  337
# 2003/2/7        Walking Lint  339
# 2003/1/24       Walking Lint  336
# 2003/1/16       Walking Lint  336
# 2003/1/15       Walking Lint  286
# 2003/1/14       Walking Lint  241
# 2003/1/9        Walking Lint  231
# 2002/12/27      Walking Lint  228
# 2002/12/20      Walking Lint  228
# 2002/12/19      Walking Lint  228
# 2002/12/18      Walking Lint  224
# 2002/12/17      Walking Lint  213
# 2002/12/12      Walking Lint  212
# 2002/12/11      Walking Lint  204
# 2002/12/7       Walking Lint  204
# 2002/11/27      Walking Lint  132
# 2002/11/26      Walking Lint  129
# 2002/11/22      Walking Lint  111
# 2002/11/22      Walking Lint  97 (CheckLinkUpdate_Perl->UpdateStatusOfLinks_Perl)
# 2002/11/21      Walking Lint  97
# 2002/11/21      Walking Lint  94 (CheckWeblogs_Perl->CheckLinkUpdate_Perl)
# 2002/11/20      Walking Lint  89
# 2002/11/19      Walking Lint  70
# 2002/11/19      Walking Lint  31 (CheckWeblogs_Perl->NewFile)
# 2002/11/19      Walking Lint  58 (Links_Perl->CheckWeblogs_Perl)
# 2002/11/19      Walking Lint  32 (CheckLinks_Perl->Links_Perl)
# 2002/11/19      Walking Lint  22 (ExtractLinks_Perl->CheckLinks_Perl)

=pod

=head1 NAME

UpdateStatusOfLinks_Perl.pl - update status of links

=head1 DESCRIPTION

ex1. perl.exe UpdateStatusOfLinks_Perl.pl "C:\memo\CV\templates\Link.pat" "" ""

? - check if link is added ...

see. <a href="http://member.nifty.ne.jp/hippo2000/perltips/LWP/RobotUA.html">LWP::RobotUA - Web{bĝ߂̃NX</a>
     <a href="http://www.oreilly.com/openbook/webclient/ch06.html">Web Client Programming with Perl: Chapter 6: Example LWP Programs</a>

=head1 AUTHOR

Walking Lint

=cut

use LWP::UserAgent;
$use_robot = 1; # use 1 if you can ... in one circumstance I couldn't so ...
if ($use_robot) {
  use LWP::RobotUA;
} else {
  use LWP::Simple;
}
use HTML::LinkExtor;
use CVTree_Perl;
use File::Copy;
# get proxy info from registry
use Win32::Registry;
my $root = {};
&initnode($root, 'root', '', '', '');
if ($use_robot) {
  $webagent = new LWP::RobotUA 'UpdateStatusOfLinks/0.1', 'Walking Lint';
  $webagent->delay(0.05); # actually this can't be changed ...
  $webagent->timeout(30);
  $webagent2 = new LWP::RobotUA 'UpdateStatusOfLinks/0.1', 'Walking Lint';
  $webagent2->delay(0.05); # actually this can't be changed ...
  $webagent2->timeout(30);
} else {
  $webagent = new LWP::UserAgent;
  $webagent->agent('LWP::GETHEAD');
  $webagent2 = new LWP::UserAgent;
}
$link = shift;
$mask = shift;
$excludemask = shift;
$uselog = shift;
if ($uselog) {
  $log_file = $link;
  $log_file =~ s/\.pat$/.log/;
  open LOG, ">$log_file" or die("Cannot open $log_file: $!\n");
  select LOG;
  $| = 1; # no buffering ...
}
DebugPrint("link = $link");
DebugPrint("mask = $mask");
DebugPrint("excludemask = $excludemask");
if (-e $link) {
  $linkbak = $link;
  $linkbak =~ s/\.pat$/.bak/;
  copy($link, $linkbak);
} else {
  DebugPrint("Cannot find $link");
  exit;
}
&gentree($root, $link);
$first = 1;
$foundchecknode = 0;
if (not $foundchecknode) { # this is hack ... think later ...
  $foundchecknode = 1;
  &addurlstopushed($root);
}
&checklinkupdate($root);
&sortedsavetree2($root, $link);
if ($uselog) {
  close LOG;
}
sub addtodeleted {
  my($url, $kind) = @_;
  DebugPrint("deleted $url");
  $deleted{$url} = 1;
  if ($url =~ /\/$/) {
    $deleted{$url . 'index.html'} = 1;
  } elsif ($url =~ /\/index\.html$/) {
    my $tmp = $url;
    $tmp =~ s/index\.html$//;
    $deleted{$tmp} = 1;
  }
  if ($kind =~ /\?/) {
    DebugPrint("was generative");
    $isgenerative{$url} = 1;
    if ($url =~ /\/$/) {
      $isgenerative{$url . 'index.html'} = 1;
    } elsif ($url =~ /\/index\.html$/) {
      my $tmp = $url;
      $tmp =~ s/index\.html$//;
      $isgenerative{$tmp} = 1;
    }
  }
}
sub addtopushed {
  my($url) = @_;
  $pushed{$url} = 1;
  if ($url =~ /\/$/) {
    $pushed{$url . 'index.html'} = 1;
  } elsif ($url =~ /\/index\.html$/) {
    my $tmp = $url;
    $tmp =~ s/index\.html$//;
    $pushed{$tmp} = 1;
  }
}
sub addurlstodeleted {
  my($nd) = @_;
  my $url = $nd->{TEXT};
  my $kind = $nd->{KIND};
  &addtodeleted($url, $kind);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      my $url = $cn->{TEXT};
      if ((not $cn->{NAME} =~ /^_/)) { # and ($url =~ /\.html/)
        addurlstodeleted($cn);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
# also drop down new!! - think later ...
sub addurlstopushed {
  my($nd) = @_;
  my $kind = $nd->{KIND};
  $kind =~ s/ !//;
  $nd->{KIND} = $kind;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      my $url = $cn->{TEXT};
      if ((not $cn->{NAME} =~ /^_/)) { # and ($url =~ /\.html/)
        &addtopushed($url);
        addurlstopushed($cn);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub checklinkupdate {
  my($nd) = @_;
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      my $url = $cn->{TEXT};
      if ((not $cn->{NAME} =~ /^_/)) { # and ($url =~ /\.html/)
        DebugPrint("url = $url");
        if ($first) { # not sure if this needed ...
          $first = 0;
          unless (($url =~ /$proxyoverride/) or (length($proxyserver) == 0)) {
            $webagent->proxy(['ftp', 'http'] => "http://$proxyserver");
            $webagent2->proxy(['ftp', 'http'] => "http://$proxyserver");
          }
        }
        $request = new HTTP::Request('HEAD' => $url);
        $response = $webagent->request($request);
        $prevtype = $cn->{TYPE};
        $volatile = 0;
        if ($response->is_success) {
          $lastmodified = $response->header('Last-Modified');
          $content = '';
          if (length($lastmodified) == 0) {
            $request2 = new HTTP::Request('GET' => $url);
            $response2 = $webagent2->request($request2);
            $content = $response2->content;
            $lastmodified = length($content); # not actually ...
            sleep 10;
            $response2 = $webagent2->request($request2);
            $lastmodified2 = length($response2->content); # not actually ...
            if ($lastmodified2 != $lastmodified) {
              $volatile = 1;
              $lastmodified = $lastmodified2;
              DebugPrint("volatile - may be changed");
            }
          }
          if (length($lastmodified) != 0) {
            $info = ' (' . $lastmodified . ')';
          } else {
            $info = '';
          }
          $quotedinfo = quotemeta $info;
        } else {
          $info = ' (NG)';
          $quotedinfo = quotemeta $info;
        }
        if ((length($cn->{TYPE}) == 0) or ($cn->{TYPE} =~ /^[ ]*\([^\)]*\)$/)) {
          $cn->{TYPE} = $info;
        } elsif ($cn->{TYPE} =~ /([ ]*\([^\)]*\))$/) {
          my $tmp = quotemeta $1;
          $cn->{TYPE} =~ s/$tmp/$info/;
        } else {
          $cn->{TYPE} .= $info;
        }
        $kind = $cn->{KIND};
        if ($info eq ' (NG)') {
          DebugPrint(" (NG)");
          if ($kind =~ / \(\) \+/) {
            # do nothing ...
          } elsif ($kind =~ / \(\) \-/) {
            $kind =~ s/ \(\) \-/ \(\) \+/;
          } elsif ($kind =~ / \(\)/) {
            $kind =~ s/ \(\)/ \(\) \+/;
          }
        } elsif ((not ($prevtype =~ /$quotedinfo/)) and (not ($info eq ' (NG)')) and (not $prevtype =~ / \(NG\)/) and (not $volatile)) {
          DebugPrint(" updated");
          if (($cn->{KIND} =~ /\?/)) { # and defined($cn->{CHILD}) %% here for node with native flag (?) check if link is added ... also check if deleted ...
            %found_link = ();
            if (not $foundchecknode) { # actually not used ... think later ...
              $foundchecknode = 1;
              &addurlstopushed($root);
            }
            if (length($content) == 0) {
              $request2 = new HTTP::Request('GET' => $url);
              $response2 = $webagent2->request($request2);
              $content = $response2->content;
            }
            $currentnode = $cn;
            $baseurl = $url;
            $baseurl =~ s/[^\/]+\.(html|htm|shtml)$//;
            $baseurl = quotemeta $baseurl;
            $parser = HTML::LinkExtor->new(\&link_callback, $url);
            $parser->parse($content);
            $cn2 = $currentnode->{CHILD};
            if (defined($cn2)) {
              while (1) {
                $ncn2 = $cn2->{NEXT};
                if (not $found_link{$cn2->{TEXT}}) {
                  &addurlstodeleted($cn2);
                  delnode($cn2);
                }
                $cn2 = $ncn2;
                if (not defined($cn2)) {
                  last;
                }
              }
            }
          }
          if ($kind =~ / \(\) \+/) {
            $kind =~ s/ \(\) \+/ \(\) \-/;
          } elsif ($kind =~ / \(\) \-/) {
            # do nothing ...
          } elsif ($kind =~ / \(\)/) {
            $kind =~ s/ \(\)/ \(\) \-/;
          }
        } else {
          DebugPrint(" not changed");
          if (($cn->{KIND} =~ /\?/)) { # and defined($cn->{CHILD}) %% actually this is needed ... because of ...
            %found_link = ();
            if (not $foundchecknode) { # actually not used ... think later ...
              $foundchecknode = 1;
              &addurlstopushed($root);
            }
            if (length($content) == 0) {
              $request2 = new HTTP::Request('GET' => $url);
              $response2 = $webagent2->request($request2);
              $content = $response2->content;
            }
            $currentnode = $cn;
            $baseurl = $url;
            $baseurl =~ s/[^\/]+\.(html|htm|shtml)$//;
            $baseurl = quotemeta $baseurl;
            $parser = HTML::LinkExtor->new(\&link_callback, $url);
            $parser->parse($content);
            $cn2 = $currentnode->{CHILD};
            if (defined($cn2)) {
              while (1) {
                $ncn2 = $cn2->{NEXT};
                if (not $found_link{$cn2->{TEXT}}) {
                  &addurlstodeleted($cn2);
                  delnode($cn2);
                }
                $cn2 = $ncn2;
                if (not defined($cn2)) {
                  last;
                }
              }
            }
          }
          if ($kind =~ / \(\) \+/) {
            $kind =~ s/ \(\) \+/ \(\)/;
          } elsif ($kind =~ / \(\) \-/) {
            $kind =~ s/ \(\) \-/ \(\)/;
          }
        }
        $cn->{KIND} = $kind;
        checklinkupdate($cn);
      }
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub link_callback {
  my($tag, %links) = @_;
  $tag = lc($tag); # maybe not needed ...
  if (($tag eq 'a') or ($tag eq 'frame')) { # or ($tag eq 'option') not functioning ...
    foreach $key (keys %links) {
      my $ref = $links{$key};
      my $url = $ref->as_string();
      if (not ($url =~ /\.[^\.\/]+$/) and not ($url =~ /\/$/)) { # this is hack ...
        $url .= '/';
      }
      $url =~ s/%0A[%09]*//; # this is hack ... think later ...
      $found_link{$url} = 1;
      if (($url =~ /^http/) and ($url =~ /(\/|\.(html|htm|shtml|cgi|doc|ppt|pdf|txt|xls))$/) and (not $url =~ /\#/) and (not defined $pushed{$url})) { # think later ...
        if ((not defined($mask)) or (length($mask) == 0) or ($url =~ /$mask/)) {
          if ((not defined($excludemask)) or (length($excludemask) == 0) or (not $url =~ /$excludemask/)) {
            DebugPrint(" added $url");
            &addtopushed($url);
            my $name = $url;
            $name =~ s/$baseurl//;
            $name =~ s/\.(html|htm|shtml|cgi|doc|ppt|pdf|txt|xls)$//;
            $name =~ s/^(http|https):\/\///; # actually this is needed for https case ...
            $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; # [[CGI-Perl̊bu(p04)!http://www.parkcity.ne.jp/~chaichan/src/perl04.htm]]
            my $nd = &addchildnode($currentnode, $name, ' () - ! ', '', $url);
            if ($deleted{$url}) { # actually moved ... so not New! ... think later ...
              if ($isgenerative{$url}) {
                $nd->{KIND} = ' () - ? '; # updated is better? think later ...
              } else {
                $nd->{KIND} = ' () - '; # updated is better? think later ...
              }
            }
            if ($tag eq 'frame') {
              $nd->{KIND} = ' () - ! / ? '; # try this ...
            }
          }
        }
      }
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  if ($uselog) {
    print LOG "$str\n";
  } else {
    print STDERR "$str\n";
  }
}
