# File: VRMLReader_Perl.pl
# Date            Author        number of nodes
# 2004/4/23       Walking Lint  374
# 2004/4/8        Walking Lint  374
# 2003/12/28      Walking Lint  377
# 2003/10/3       Walking@Lint 328
# 2003/9/27       Walking@Lint 312
# 2003/5/17       Walking Lint  299
# 2003/4/16       Walking Lint  293
# 2003/4/16       Walking Lint  305 (StyleSheetReader_Perl->VRMLReader_Perl)
# 2003/4/15       Walking Lint  305
# 2003/4/15       Walking Lint  488 (HtmlReader_Perl->StyleSheetReader_Perl)
# 2003/4/15       Walking Lint  488
# 2003/4/15       Walking Lint  464 (JavaScriptReader_Perl->HtmlReader_Perl)
# 2003/3/20       Walking Lint  464
# 2003/3/19       Walking Lint  397
# 2003/3/18       Walking Lint  341
# 2003/3/14       Walking Lint  358 (JavaReader_Perl->JavaScriptReader_Perl)
# 2003/3/13       Walking Lint  353 (PerlReader_Perl->JavaReader_Perl)
# 2003/3/10       Walking Lint  341
# 2003/3/7        Walking Lint  339
# 2003/3/7        Walking Lint  287 (RubyReader_Perl->PerlReader_Perl)
# 2002/12/1       Walking Lint  287
# 2002/11/24      Walking Lint  287
# 2002/11/23      Walking Lint  173
# 2002/11/13      Walking Lint  240 (CVTree_Perl->RubyReader_Perl)
# 2002/11/10      Walking Lint  245
# 2002/11/8       Walking Lint  244
# 2002/11/6       Walking Lint  225
# 2002/11/1       Walking Lint  226
# 2002/10/23      Walking Lint  218 (CVTree->CVTree_Perl)
# 2002/10/16      Walking Lint  155
# 2002/10/15      Walking Lint  144
# 2002/10/8       Walking Lint  137
# 2002/10/1       Walking Lint  135
# 2002/9/30       Walking Lint  128
# 2002/9/30       Walking Lint  182 (ExtractCategorizedText_Perl->CVTree)
# 2002/9/28       Walking Lint  182
# 2002/9/22       Walking Lint  178
# 2002/7/16       Walking Lint  143 (GenCategorizedText_Perl->ExtractCategorizedText_Perl)
# 2002/7/15       Walking Lint  126
# 2002/7/4        Walking Lint  141 (GenCategorizedLinkLog_Perl->GenCategorizedText_Perl)
# 2002/6/7        Walking Lint  136
# 2002/6/4        Walking Lint  131
# 2002/4/21       Walking Lint  120
# 2002/4/12       Walking Lint  112
# 2002/4/4        Walking Lint  85

=pod

=head1 NAME

VRMLReader_Perl.pl - VRML reader

=head1 DESCRIPTION

activate as plug-in or filter

=head1 AUTHOR

Walking Lint

=cut

use lib '.';
use CVTree_Perl;
use File::Basename;
use Time::localtime;
$bracepattern = '\{[\t ]*((?:(?:[^\{\}]|\{[^\}]*\})*|))[\t ]*\}';
$comment_begin = 'url[ \t]+"javascript:';
$comment_end = '"';
$from_file = shift;
DebugPrint("from_file = $from_file");
$to_file = $from_file;
$to_file =~ s/\..+/.pat/;
my $root = {};
$tm = localtime;
$basename = '';
if (length($from_file) != 0) {
  $basename = basename($from_file);
} else {
  $basename = 'NewFile.wrl';
}
$file_comment = 'File: ' . $basename . ' CR' . 'LF Date            Author        number of nodes CR' . 'LF ';
$date = sprintf("%d/%d/%d", $tm->year + 1900, $tm->mon + 1, $tm->mday);
$file_comment .=  $date;
&initnode($root, 'root', '', '', $file_comment);
&gentree($root, $from_file);
&treatindents($root); # treat some indent problems ...
&savetree($root, $to_file);
DebugPrint("generated $to_file");
sub extractparams {
  my($line) = @_;
  $kind = ' () ';
  $type = '';
  $text = '';
  $linewithoutindent = $line;
  $linewithoutindent =~ s/^[\t ]+//;
  DebugPrint("input line = $linewithoutindent");
  if ($in_comment) {
    $linewithoutindent =~ s/$comment_end[.\n]*$//;
    if ($line =~ /$comment_end/) {
      $in_comment = 0;
      if (length($linewithoutindent) == 0) {
        DebugPrint("null end comment");
        return 1;
      }
    }
    $text = $line;
    $name = 'script';
    $indentedcomment = $text;
    DebugPrint("comment2 " . $indentedcomment);
    return 0;
  } elsif (($line =~ /$comment_begin/)) { # and not ($line =~ /$comment_end/)
    $in_comment = 1;
    if ($linewithoutindent =~ /^$comment_begin[ \t\n]*$/) {
      $indentedcomment = '';
      $level = length($1);
      DebugPrint("null begin comment");
      return 1;
    }
  }
  $line =~ /^([\t ]*)(.*)/; # this is hack ...
  $linewithoutindentandcomment = $2;
  $name = $2;
  $level = length($1);
  DebugPrint("level = $level");
  $argline = '';
  $name =~ s/[ \t]+$//;
  $name =~ s/^([ \t]*[\]\}])+[ \t]*//;
  DebugPrint("name = [" . $name . "] text = [" . $text . "]");
  if (length($name) == 0) {
    return 1; # skip this line ... think later ...
  } elsif ($name =~ /\#VRML V2.0 utf8/) {
    return 1;
  } elsif ($name =~ /^\#(.*)$/) { # comment
    $name = '_';
    $text = $1;
    $indentedcomment = $text; # this is needed ...
    DebugPrint("comment - $text");
  } elsif ($name =~ /^DEF[ \t]*([^{ \t]+)[ \t]*([^{ \t]+)[ \t]*([\{\[])?$/) { # open DEF { or [ tag
    $name = $2;
    $type = 'DEF ' . $1;
    DebugPrint("open DEF tag");
  } elsif ($name =~ /^DEF[ \t]*([^{ \t]+)[ \t]*([^{ \t]+)[ \t]*[\{\[][ \t]*[\}\]]$/) { # open DEF {}
    $name = $2;
    $type = 'DEF ' . $1;
    DebugPrint("open close DEF tag");
  } elsif ($name =~ /^([^ ]+)[ \t]+DEF[ \t]*([^{ \t]+)[ \t]*([^{ \t]+)[ \t]*([\{\[])?$/) { # open DEF { or [ tag
    $name = $3;
    $type = $1 . ' DEF ' . $2;
    DebugPrint("open DEF tag");
  } elsif ($name =~ /^field[\t ]+([^ \t]+)[ \t]+([^ \t]+)[ \t]+(.*)$/) { # field
    $name = $2;
    $type = 'field ' . $1 . '  ' . $3;
    $kind = ' (out) ';
    DebugPrint("field");
  } elsif ($name =~ /^PROTO[\t ]+([^ \t\[]+)[\t ]*\[$/) { # PROTO
    $name = $1;
    DebugPrint("PROTO");
  } elsif ($name =~ /^ROUTE[\t ]+([^ \t]+)[\t ]+TO[\t ]+(.+)/) { # ROUTE
    $name = $2;
    $type = '  ' . $1;
    $kind = ' (out) ';
    DebugPrint("ROUTE");
  } elsif ($name =~ /^USE[\t ]+(.+)$/) { # USE
    $name = 'USE';
    DebugPrint("USE");
    $type = $1;
  } elsif ($name =~ /^([^{ \t]+)[ \t]*([^{ \t]+)[ \t]*\{[ \t]*\}$/) { # empty tag pair
    $name = $2;
    $type = $1;
    DebugPrint("open tag");
  } elsif ($name =~ /^([^{ \t]+)[ \t]*[\{\[][ \t]*$/) { # open { or [ tag
    $name = $1;
    DebugPrint("open tag");
  } elsif ($name =~ /^([^{ \t]+)[ \t]*([^{ \t]+)[ \t]*[\{\[]$/) { # open named { or [ tag
    if ($1 eq 'children') {
      $name = $1 . ' ' . $2; # may be hack ...
    } else {
      $name = $2;
      $type = $1;
    }
    DebugPrint("open named tag");
  } elsif ($name =~ /^([a-zA-Z_][^ \t]*)[\t ]+IS[\t ]+(.+)$/) { # IS
    $name = $1;
    DebugPrint("IS");
    $kind = ' (out) ';
    $type = '  ' . $2;
  } elsif ($name =~ /^([a-zA-Z_][^ \t]*)[\t ]+(.+)$/) { # attribute
    $name = $1;
    $type = $2;
    DebugPrint("attribute - $name");
    if (not $type =~ /^USE[ \t]/) {
      $kind = ' (out) ';
      $type = '  ' . $type;
    }
  } elsif (length($text) != 0) { # not sure but ...
    $name = '_text';
    $text = $linewithoutindent;
    DebugPrint("not supported yet - $text");
  } else {
    $text = $name;
    $name = '_text';
    DebugPrint("else $name");
  }
  return 0;
}
sub gentree {
  my($nd, $from_file) = @_;
  # gen tree from fn ...
  $prevname = '';
  $previndentedcomment = '';
  $prevlevel = -1;
  @prevlevels = ();
  push @prevlevels, $prevlevel; # not sure if needed ...
  my $cur = $nd;
  $first = 1;
  $in_comment = 0;
  if (length($from_file) != 0) {
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $infilehandle = 'IN'; # see [[SAGE - Perl Practicum - Know All the Angles!http://www.usenix.org/publications/perl/perl02.html]]
  } else {
    $infilehandle = 'STDIN';
  }
  # may be better to add filter ... think later ...
  while (<$infilehandle>) {
    push @lines, $_;
  }
  @processed_lines = ();
  &process_multi_statement(\@lines, \@processed_lines);
  foreach (@processed_lines) {
    $_ =~ s/[\n\t ]+$//;
    if ((length($_) != 0)) {
      if (&extractparams($_)) {
        $prevname = '';
        next;
      }
      # construct tree here ...
      if ($prevlevel < $level) {
        DebugPrint("** 1 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        push @prevlevels, $prevlevel;
        $cur = addchildnode($cur, $name, $kind, $type, $text);
      } elsif ($prevlevel == $level) {
        DebugPrint("** 2 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        if (($name eq '_') and ($prevname eq '_')) { # ($cur->{NAME} eq '_')
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
        } elsif (($name eq 'script') and ($prevname eq 'script')) {
          if (not $cur->{TEXT} =~ / \CRLF /) {
            $cur->{TEXT} = $previndentedcomment . " \CRLF " . $indentedcomment;
          } else {
            $cur->{TEXT} .= " \CRLF " . $indentedcomment;
          }
        } elsif (($name eq '_text') and ($prevname eq '_text')) { # ($cur->{NAME} eq '_text')
          $cur->{TEXT} .= " \CRLF " . $text;
        } else {
          $cur = addnode($cur, $name, $kind, $type, $text);
        }
      } else {
        DebugPrint("** 3 prevlevel = $prevlevel level = $level cur = $cur->{NAME}");
        until ($prevlevel <= $level) {
          $cur = $cur->{PARENT};
          $prevlevel = pop @prevlevels;
        }
        DebugPrint("typ = $typ");
        $cur = addnode($cur, $name, $kind, $type, $text);
        DebugPrint("text = " . $text);
      }
      $prevname = $name;
      $previndentedcomment = $indentedcomment;
      $prevlevel = $level;
      my $argkind = " \(in\) \& ";
      if ($kind =~ /~/) {
        if ($name =~ /\(([^\)]+)\)$/) {
          $name =~ s/[\t ]*\(([^\)]+)\)$//;
          $cur->{NAME} = $name;
          $argline2 = $1;
          my @args2 = reverse split(/[\t ]*,[\t ]*/, $argline2);
          foreach $arg (@args2) {
            if ($arg =~ /=/) {
              $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
              &addchildnode($cur, $1, $argkind, '  ' . $2, '');
            } else {
              &addchildnode($cur, $arg, $argkind, '', '');
            }
          }
        }
      }
      if (length($argline) != 0) {
        if ($argline =~ /\|[\t ]*([^\|]+)\|[\t ]*(.*)/) { # this is block arg
          $argline = $1;
          $body = $2;
          $body =~ s/[\t ]*}$//;
          $argline =~ s/[\t ]*$//;
          $argkind .= '~ ';
        }
        my @args = split(/[\t ]*,[\t ]*/, $argline);
        foreach $arg (@args) {
          if ($arg =~ /=/) {
            $arg =~ /([^=]*)[\t ]*=[\t ]*(.*)/;
            &addchildnode($cur, $1, $argkind, '  ' . $2, '');
          } else {
            &addchildnode($cur, $arg, $argkind, '', '');
          }
        }
        if (length($body) != 0) {
          &extractparams($body);
          &addchildnode($cur, $name, $kind, $type, $text);
        }
      }
    }
  }
  if (length($from_file) != 0) {
    close IN;
  }
}
sub getcondandstmt {
  my($str) = @_;
  @chars = split(//, $str);
  $pre = '';
  $post = '';
  $level = 0;
  foreach $char (@chars) {
    if ($char eq '(') {
      $level++;
      if ($level > 1) {
        $pre .= $char;
      }
    } elsif ($char eq ')') {
      $level--;
      if ($level == 0) {
        last;
      } else {
        $pre .= $char;
      }
    } else {
      $pre .= $char;
    }
  }
  $post = substr($str, length($pre) + 2);
  return ($pre, $post);
}
sub process_multi_statement {
  my($from_array_ref, $to_array_ref) = @_;
  foreach $line (@$from_array_ref) {
    if ($line =~ /^([ \t]*)([^ \t\#]+)[ \t]*([^\{]+)$bracepattern[ \t]*(#.+)?$/) { # pattern for line line control statement
      push @$to_array_ref, $1 . $2 . ' ' . $3 . '{' . $5;
      $indent = $1;
      $block = $4;
      push @$to_array_ref, $indent . '  ' . $block; # try this ...
    } else {
      push @$to_array_ref, $line;
    }
  }
}
sub rescuetree {
  my($nd) = @_;
  if (not defined($nd->{NEXT})) {
    return;
  }
  $cn = $nd->{NEXT};
  while (1) {
    if (defined($cn->{NEXT})) {
      $ncn = $cn->{NEXT};
      $found_next = 1;
    } else {
      $found_next = 0;
    }
    &delnode($cn);
    &addchildnode2($nd, $cn);
    if (not $found_next) {
      last;
    }
    $cn = $ncn;
  }
}
sub treatindents {
  my($nd) = @_;
  &treatindentsbody($nd);
  if (defined($nd->{CHILD})) {
    my $cn = $nd->{CHILD};
    while (1) {
      treatindents($cn);
      if (not defined($cn->{NEXT})) {
        last;
      }
      $cn = $cn->{NEXT};
    }
  }
}
sub treatindentsbody {
  my($nd) = @_;
  if (($nd->{NAME} eq '_') or ($nd->{NAME} eq 'script')) { # delete common indent
    @lines = split(/ \CRLF /, $nd->{TEXT});
    $min = 999;
    foreach $line (@lines) {
      $line =~ /^([\t ]*)/;
      $indent = $1;
      if (length($indent) < $min) {
        $min = length($indent);
      }
    }
    if ($min > 0) {
      @newlines = ();
      foreach $line (@lines) {
        $line =~ s/^([\t ]{$min})//;
        push @newlines, $line;
      }
      $nd->{TEXT} = join(" \CRLF ", @newlines);
    }
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR $str . "\n";
}
sub Trace {
  my($str) = @_;
  print STDERR $str . "\n";
}
