# File: Weblog_Perl.pl
# Date            Author        number of nodes
# 2002/11/29      Walking Lint  68
# 2002/11/27      Walking Lint  62
# 2002/11/21      Walking Lint  60
# 2002/11/18      Walking Lint  59
# 2002/11/9       Walking Lint  44 (Weblog_Perl->Weblog_Perl)
# 2002/11/2       Walking Lint  32
# 2002/11/2       Walking Lint  32 (Weblog_Perl->Weblog_Perl)
# 2002/11/2       Walking Lint  59 (LoopUpInWeblog_Perl->Weblog_Perl)
# 2002/9/10       Walking Lint  59 (Zips2Adrs_Perl->LoopUpInWeblog_Perl)
# 2002/9/5        Walking Lint  58
# 2002/9/5        Walking Lint  58 (zips2adrs_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  66 (Zips2Adrs_Perl->zips2adrs_Perl)
# 2002/8/16       Walking Lint  57 (zip2adr_Perl->Zips2Adrs_Perl)
# 2002/8/16       Walking Lint  35 (zup2adr_Perl->zip2adr_Perl)
# 2002/7/15       Walking Lint  19 (grep_Perl->zup2adr_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

Weblog_Perl.pl - grep weblog

=head1 DESCRIPTION

perl.exe Weblog_Perl.pl _Perl E:

=head1 AUTHOR

Walking Lint

=cut

$word = shift;
$weblogfolder = shift;
$dir = $weblogfolder;
opendir DIR, $dir or die "opendir() failed: $!";
@files = grep !/^\.\.?$/, readdir DIR;
@files = grep /^20[0-9]+.pat$/, @files; # it is assumed ...
closedir DIR;
@htmlelements = ('a', 'center', 'div', 'li', 'ol', 'p', 'table', 'td', 'tr', 'ul');
foreach $file (reverse sort @files) {
  $from_file = $dir . "\\" . $file;
  open IN, $from_file or die("Cannot open $from_file: $!\n");
  while (<IN>) {
    $_ =~ /^(\t*)([^\(]+)/;
    $level = length($1);
    $name = $2;
    $name =~ s/( )+$//;
    $path{$level} = $name;
    if (($_ =~ /id="menu"/) or ($_ =~ /menu\.pat/)) { # this is hack ...
      last;
    }
    if (/$word/i) {
      ($category, @groups) = split(/( \(\) \/\/ \%\% | \(\) \/\/  \%\% | \CRLF  \CRLF )/, $_);
      $category =~ s/^\t+//;
      $founddate = 0;
      @selectedpath = ();
      foreach $i (1..$level) {
        if ($path{$i} =~ /^20[0-9\/]+/) {
          $founddate = 1;
        }
        if ($founddate and not $path{$i} =~ /^_/ and not ishtmlelement($path{$i})) {
          push @selectedpath, $path{$i};
        }
      }
      $html_file = $from_file;
      $html_file =~ s/\.pat$/.html/;
      $first = 1;
      foreach $group (@groups) {
        if ($group =~ /$word/i) {
          if ($first) { # this is hack ... think later ...
            $first = 0;
            $pathstr = join(' > ', @selectedpath);
            if (length($pathstr) != 0) {
              print $pathstr . " (" . $html_file . ")\n\n";
            } else {
              print $html_file . "\n\n";
            }
          }
          $group =~ s/ \CRLF /\n\t/g;
          $group =~ s/($word)/*$1*/gi;
          $group =~ s/[\n]+$//;
          $group .= "\n"; # think later ...
          print "\t$group";
        }
      }
      if (not $first) {
        print "\n";
      }
    }
  }
  close IN;
}
sub ishtmlelement {
  my($str) = @_;
  foreach $htmlelement (@htmlelements) {
    if ($str eq $htmlelement) {
      return 1;
    }
  }
  return 0;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
