# File: dump_Perl.pl
# Date            Author        number of nodes
# 2005/3/29       Walking Lint  84
# 2005/3/13       Walking Lint  78
# 2005/2/28       Walking Lint  78
# 2003/8/31       Walking@Lint 82
# 2003/8/8        Walking@Lint 76
# 2003/5/12       Walking Lint  70
# 2002/9/27       Walking Lint  53
# 2002/9/5        Walking Lint  46
# 2002/4/5        Walking Lint  37
# 2002/4/4        Walking Lint  34

=pod

=head1 NAME

dump_Perl.pl - dump

=head1 DESCRIPTION

activate as program/filter

=head1 AUTHOR

Walking Lint

=cut

$addr = 0;
$line = "";
$ascii = "";
$from_file = shift;
$inline = 0;
if (length($from_file) != 0) {
  open IN, $from_file or die("Can't open $from_file: $!\n");
} else {
  $templatesfolder = $ENV{TEMPLATESFOLDER};
  $templatesfolder =~ s/"//g;
  $tmp_file = $templatesfolder . '\dump_Perl_tmp'; # customize here to set dummy file
  open OUT, ">$tmp_file";
  @lines = ();
  while (<STDIN>) {
    push @lines, $_;
  }
  print OUT @lines;
  print @lines;
  close OUT;
  open IN, $tmp_file || die("Can't open $tmp_file: $!\n");
  if ($#lines == 0) { # $# is num of lines - 1
    $inline = 1;
    $origline = $lines[0];
  }
}
binmode IN;
while (($c = getc (IN)) ne '') {
  $byte = sprintf ("%02X", unpack ("C", $c));
  $ascii .= $c;
  unless ($inline) {
    $line .= $byte;
    $byte_cnt++;
    if ($byte_cnt > 0 && $byte_cnt %4 == 0) {
      $line .= " ";
    }
    if ($byte_cnt == 16) {
      &dispLine($addr, $line, $ascii);
      $addr += 16;
      $byte_cnt = 0;
      $line = "";
      $ascii = "";
    }
  } else {
    $line .= '\x' . $byte;
  }
}
close IN;
if ($inline) {
  print ' = ' . $line . ' (';
  &dispAscii($ascii);
  print ')';
} else {
  if ($byte_cnt > 0) {
    &dispLine($addr, $line, $ascii);
  }
}
sub dispAscii {
  my($ascii) = @_;
  my $line = '';
  foreach $n (split (//, $ascii)) {
    if (ord ($n) >= 0x20 && ord ($n) <= 0x7f) {
      $line .= $n;
    } else {
      $line .= ".";
    }
  }
  print "$line";
}
sub dispLine {
  my($addr, $line, $ascii) = @_;
  $str = sprintf ("%08X", $addr)." : ";
  $line =~ s/^/$str/;
  $line .= "   ";
  $line .= "  " x (16 - $byte_cnt);
  $line .= " " x ((16 - $byte_cnt +3) / 4);
  print "$line";
  &dispAscii($ascii);
  print "\n";
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
