# File: findfile_Perl.pl
# Date            Author        number of nodes
# 2003/3/20       Walking Lint  43
# 2003/3/3        Walking Lint  34
# 2002/12/9       Walking Lint  17 (find_Perl->findfile_Perl)
# 2002/12/8       Walking Lint  17
# 2001/8/15       Walking Lint  17 (Filter3_Perl->find_Perl)

=pod

=head1 NAME

findfile_Perl.pl - find file

=head1 DESCRIPTION

ex. perl.exe findfile_Perl.pl test C:\memo\cv\templates

=head1 AUTHOR

Walking Lint

=cut

use Cwd;
use File::Find;
$str = shift;
$from = shift;
$firstlevelonly = shift;
if ($from =~ /̂$/) {
  $firstlevelonly = 1;
  $from =~ s/̂$//;
}
if (not -d $from) {
  die "$from is not directory";
}
@found_files = ();
if ($firstlevelonly) {
  opendir DIR, $from or die("Cannot open $from: $!");
  @from_files = grep !/^\.\.?$/, readdir DIR;
  closedir DIR;
  foreach $from_file (@from_files) {
    if ($from_file =~ /$str/i) {
      $from_file = cwd . "/" . $from_file;
      $from_file =~ s/\//\\/g;
      push @found_files, "$from_file";
    }
  }
} else {
  find(\&check_file, $from);
}
sub check_file {
  $file_to_check = $_;
  if ($file_to_check =~ /$str/i) {
    $from_file = cwd . "/$_";
    $from_file =~ s/\//\\/g;
    push @found_files, "$from_file";
  }
}
foreach $file (sort {lc($a) cmp lc($b)} @found_files) {
  print "$file\n";
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
