# File: greprecursively_Perl.pl
# Date            Author        number of nodes
# 2002/12/20      Walking Lint  38
# 2002/12/8       Walking Lint  21 (grep_Perl->greprecursively_Perl)
# 2002/8/13       Walking Lint  19
# 2002/7/15       Walking Lint  19
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

greprecursively_Perl.pl - grep recursively str in files under the dir

=head1 DESCRIPTION

ex. perl.exe greprecursively_Perl.pl anydbm D:\Python22\pythoncb-examples

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
$str = shift;
$from = shift;
if (-d $from) {
  $from =~ s/\\$//;
  $from .= '\*';
}
&grepdirectory($str, $from);
sub grepdirectory {
  my($str, $from) = @_;
  my @dirs = ();
  $dir = dirname($from);
  chdir $dir;
  $from = basename($from);
  @from_files = eval('<' . $from . '>');
  foreach $from_file (@from_files) {
    $from_file = $dir . "\\" . $from_file;
    if (-d $from_file) {
      push @dirs, $from_file;
    }
    open IN, $from_file || die("Can't open $from_file: $!\n");
    while (<IN>) {
      print "$from_file: $.\t$_" if /$str/o;
    }
    close IN;
  }
  foreach $dir (@dirs) {
    DebugPrint("dir = $dir");
    &grepdirectory($str, $dir . '\*');
  }
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
