# File: multilinesed_Perl.pl
# Date            Author        number of nodes
# 2003/8/31       Walking@Lint 68
# 2002/11/23      Walking Lint  67
# 2002/10/4       Walking Lint  39
# 2002/9/6        Walking Lint  38 (sed_Perl->multilinesed_Perl)
# 2002/7/16       Walking Lint  29
# 2002/7/15       Walking Lint  19 (grep_Perl->sed_Perl)
# 2002/7/12       Walking Lint  15
# 2002/7/12       Walking Lint  15 (grep2_Perl->grep_Perl)
# 2002/7/11       Walking Lint  16
# 2002/7/11       Walking Lint  6 (grep_Perl->grep2_Perl)
# 2002/4/4        Walking Lint  5

=pod

=head1 NAME

sed_Perl.pl - sed files / sed filter

=head1 DESCRIPTION

ex. filter with "<p><img[^>]+><\/p>" "" "D:\My Weblog\generated\*.html"

=head1 AUTHOR

Walking Lint

=cut

use File::Basename;
use Cwd;
$from_str = shift;
DebugPrint("from_str = $from_str");
$to_str = shift;
$to_str = eval('"' . $to_str . '"'); # this is for using \n \t ...
DebugPrint("to_str = $to_str");
$from = shift;
DebugPrint("from = $from");
$/ = undef;
if (length($from) != 0) {
  $dir = dirname($from);
  chdir $dir;
  $from = basename($from);
  DebugPrint("from = $from");
  @from_files = eval('<' . $from . '>');
  if (($#from_files == -1) and -e $from) { # is this hack or not ...
    $from_file = $from;
    DebugPrint("from_file 1 = $from_file");
    open IN, $from_file || die("Can't open $from_file: $!\n");
    $to_file = 'new' . $from_file;
    open OUT, ">$to_file";
    $changed = 0;
    while (<IN>) {
      if (/$from_str/) {
        $changed = 1;
        $_ =~ s/$from_str/$to_str/gs;
        print STDERR "$dir\\$from_file: $.\t$_";
      }
      print OUT $_;
    }
    close OUT;
    close IN;
    if ($changed) {
      unlink $from_file;
      rename $to_file, $from_file;
    } else {
      unlink $to_file;
    }
  } else {
    foreach $from_file (@from_files) {
      DebugPrint("from_file 2 = $from_file");
      open IN, $from_file || die("Can't open $from_file: $!\n");
      $to_file = 'new' . $from_file;
      open OUT, ">$to_file";
      $changed = 0;
      while (<IN>) {
        if (/$from_str/) {
          $changed = 1;
          $_ =~ s/$from_str/$to_str/gs;
        }
        print OUT $_;
      }
      close OUT;
      close IN;
      if ($changed) {
        unlink $from_file;
        rename $to_file, $from_file;
      } else {
        unlink $to_file;
      }
    }
  }
} else {
  $/ = undef;
  $_ = <STDIN>;
  $_ =~ s/__EOF__[\n\r]*$//;
  $_ =~ s/$from_str/$to_str/gs;
  print $_;
}
sub DebugPrint {
  my($str) = @_;
  print STDERR "$str\n";
}
