//
// File: phy_hilbert_LSL.lsl
// Date            Author        number of nodes
// 2007/9/29       walkinglint   73
// 2007/9/29       walkinglint   73 (phy_hilbert->phy_hilbert_LSL)
// 2007/9/23
//
//
// 
// File: phy_hilbert.lsl
// Date            Author        number of nodes
// 2007/9/20       walkinglint   80
// 2007/9/20       walkinglint   80 (hilbert->phy_hilbert)
// 2007/9/18       walkinglint   80
// 2007/9/17       walkinglint   86
// 2007/9/13       walkinglint   73
// 2007/9/13
//
integer i;
integer level = 3;
float dist0 = 1.6;
float dist;
vector cur;
float x_pos = -0.6;
float y_pos = 1.0;
hilbertA(integer level) {
    if (level > 0) {
        hilbertB(level - 1);
        lineRel(0, dist);
        hilbertA(level - 1);
        lineRel(dist, 0);
        hilbertA(level - 1);
        lineRel(0, -dist);
        hilbertC(level - 1);
    }
}
hilbertB(integer level) {
    if (level > 0) {
        hilbertA(level - 1);
        lineRel(dist, 0);
        hilbertB(level - 1);
        lineRel(0, dist);
        hilbertB(level - 1);
        lineRel(-dist, 0);
        hilbertD(level - 1);
    }
}
hilbertC(integer level) {
    if (level > 0) {
        hilbertD(level - 1);
        lineRel(-dist, 0);
        hilbertC(level - 1);
        lineRel(0, -dist);
        hilbertC(level - 1);
        lineRel(dist, 0);
        hilbertA(level - 1);
    }
}
hilbertD(integer level) {
    if (level > 0) {
        hilbertC(level - 1);
        lineRel(0, -dist);
        hilbertD(level - 1);
        lineRel(-dist, 0);
        hilbertD(level - 1);
        lineRel(0, dist);
        hilbertB(level - 1);
    }
}
goToXY(float x, float y) {
    cur.x = x;
    cur.y = y;
}
lineRel(float deltaX, float deltaY) {
    llRezObject("phy_bar", llGetPos() + <cur.x + deltaX / 2, 0.0, cur.y + deltaY / 2>, ZERO_VECTOR, ZERO_ROTATION, (integer)(llFabs(deltaX * 10) * 100) + (integer)llFabs(deltaY * 10));
    llSleep(0.05);
    cur.x += deltaX;
    cur.y += deltaY;
}
default {
    state_entry() {
        llSetTimerEvent(59);
    }
    on_rez(integer param) {
        dist = dist0;
        for (i = level; i > 0; i--) {
            dist /= 2;
        }
        goToXY(x_pos, y_pos);
        hilbertA(level);        // start recursion
    }
    timer() {
        goToXY(x_pos, y_pos);
        hilbertA(level);        // start recursion
    }
}
