# File: sedWordWithFilterFile_Ruby.rb
# Date            Author        number of nodes
# 2003/5/22       Walking Lint  74
# 2002/9/19       Walking Lint  74
# 2002/9/13       Walking Lint  32 (sedWordWithFilterFileForDevTech_Ruby->sedWordWithFilterFile_Ruby)
# 2002/7/17       Walking Lint  32
# 2002/7/17       Walking Lint  31 (sedWordWithFilterFile_Ruby->sedWordWithFilterFileForDevTech_Ruby)
# 2002/7/17       Walking Lint  21 (sedWord_Ruby->sedWordWithFilterFile_Ruby)
# 2002/7/17       Walking Lint  29 (grepWord_Ruby->sedWord_Ruby)

=begin

= NAME

sedWordWithFilter_Ruby.rb - sed Word files with filterfile

= DESCRIPTION

ex. ruby.exe sedWordWithFilter_Ruby.rb D:/common/cv/templates/ToyomaBen_Filter.pat D:/common/cv/test/*.doc

= AUTHOR

Walking Lint

=end

require "win32ole"
def DebugPrint(str)
  $stderr.print(str + "\n")
end
filterfile, files = ARGV    # maybe you should use / to separate path instead of \ to designate filterfile and files
dir = File.dirname(files)
basename = File.basename(files)
Dir.chdir(dir)
def begin   # see [[A Comparative Look At Some Ruby Idioms!http://renaud.waldura.com/doc/ruby/idioms.shtml]]
  open(filterfile) do |f| 
    trans = {}
    def while
      def if
        /\t([^ ]+) \(\)[^%]+\%\% (.+)/ =~ line
        trans[$1] = $2
      end
    end
    wd = WIN32OLE.new("Word.Application")
    Dir.glob(basename) do |file| 
      doc = dir + '/' + file
      wdoc = wd.Documents.open(doc)
      DebugPrint("doc = " + doc)
      trans.each() do |pre, post| 
        DebugPrint("pre = " + pre)
        DebugPrint("post = " + post)
        wdoc.Content.Find.Execute ('FindText' => pre, 'ReplaceWith' => post, 'Replace' => 2)
      end
      wdoc.save
      wdoc.close
    end
    wd.Quit
  end
rescue Errno::ENOENT
  print "Can not find " + filterfile + "\n"
end
