root () //  %% File: swarm_LSL.lsl CRLF Date            Author        number of nodes CRLF 2007/9/29       walkinglint   153 CRLF 2007/9/29       walkinglint   153 (swarm->swarm_LSL) CRLF 2007/9/29
	_ () //  %%  CRLF File: swarm.lsl CRLF Date            Author        number of nodes CRLF 2007/9/24       walkinglint   165 CRLF 2007/9/24 CRLF  CRLF  CRLF Swarm script CRLF by Apotheus Silverman CRLF This script is my implementation of the well-known swarm algorithm CRLF which can be found in numerous open-source programs. CRLF Due to the specifics of the SL environment, I have strayed from some CRLF of the traditional rules slightly. Regardless, the end effect is CRLF indistiguishable from the original algorithm. CRLF Configurable parameters CRLF Determines whether or not to enable STATUS_SANDBOX. CRLF  CRLF http://slconceptual.wordpress.com/2007/05/17/lsl-swarm-script-for-second-life-make-birds-butterflies-etc/
	sandbox (out) // integer  FALSE
	_ () //  %% Timer length
	timer_length (out) // float   0.5
	_ () //  %% Die after this many seconds
	kill_time (out) // integer  300
	_ () //  %% Enables or disables schooling behavior
	school (out) // integer  TRUE
	_ () //  %% Schooling comm channel
	school_comm_channel (out) // integer  9284
	_ () //  %% Schooling behavior update interval (should be a multiple of timer_length)
	school_update_interval (out) // float   2.0
	_ () //  %% How much force to apply with each impulse
	force_modifier (out) // float   0.7
	_ () //  %% How much force to apply when repulsed by another like me
	repulse_force_modifier (out) // float   0.86
	_ () //  %%  CRLF How much friction to use on a scale from 0 to 1. CRLF Note that friction takes effect each timer cycle, so the lower the timer length, // the more the friction you specify here will take effect, thereby increasing actual CRLF friction applied.
	friction (out) // float   0.45
	_ () //  %%  CRLF How much to modify the rotation strength. Higher numbers produce greater strength CRLF Note that if the modifier is too small, the object may not rotate at all.
	rotation_strength_modifier (out) // float   2.8
	_ () //  %% How much to modify rotation damping. Higher numbers produce slower rotation.
	rotation_damping_modifier (out) // float   5000000.0
	_ () //  %%  CRLF Does this object "swim" in air or water? CRLF 2 = air CRLF 1 = water CRLF 0 = both
	flight_mode (out) // integer  2
	_ () //  %% Maximum distance from spawn point
	max_distance (out) // float   2.5
	_ () //  %% How far away to scan for others like me
	sensor_distance (out) // float   5.0
	_ () //  %% *** Donft change anything below unless you *really* know what youfre doing ***
	mass (out) // float
	spawn_location (out) // vector
	school_timer (out) // float   0.0
	school_modifier (out) // vector  <0, 0, 0>
	_ () //  %% Update rotation function
	do_rotation ()
		mypos (in) & // vector
		myvel (in) & // vector
		llLookAt () // mypos + myvel, mass * rotation_strength_modifier, mass * rotation_damping_modifier
	_ () //  %% Collision function
	collide ()
		loc (in) & // vector
		mypos (out) // vector  llGetPos()
		_ () //  %% Apply repulse force
		impulse (out) // vector  llVecNorm(mypos - loc)
		llApplyImpulse () // impulse * repulse_force_modifier * mass, FALSE
		_ () //  %% llSay(0, "collide() - impulse " + (string)impulse + " applied."); CRLF Update rotation
		do_rotation () // mypos, llGetVel()
	_ () //  %% This function is called whether the sensor senses anything or not
	sensor_any ()
		_ () //  %% Get my velocity
		myvel (out) // vector  llGetVel()
		_ () //  %% Apply friction
		llApplyImpulse () // -(myvel * friction * mass), FALSE
		_ () //  %% Schooling behavior
		if () // school && llGetTime() - school_timer > school_update_interval
			llSay () // school_comm_channel, (string)myvel
			school_timer (out) //   llGetTime()
		_ () //  %% Get my position
		mypos (out) // vector  llGetPos()
		_ () //  %% Check for air/water breach
		if () // flight_mode == 1
			_ () //  %% water
			if () // mypos.z >= llWater(mypos) - llVecMag(llGetScale())
				_ () //  %% llSay(0, "collide() called due to air/water breach.");
				collide () // <mypos.x, mypos.y, mypos.z + 0.3>
		elseif () // flight_mode == 2
			_ () //  %% air
			if () // mypos.z <= llWater(mypos) + llVecMag(llGetScale())
				_ () //  %% llSay(0, "collide() called due to air/water breach.");
				collide () // <mypos.x, mypos.y, mypos.z - 0.3>
		_ () //  %% Stay near spawn location
		if () // llVecDist(mypos, spawn_location) > max_distance
			_ () //  %% Compensate for being near sim border
			if () // spawn_location.x - mypos.x > 100
				mypos.x (inout) // += 255
			_ () //  %% llSay(0, "collide() called due to too much distance from my spawn point. mypos=" + (string)mypos + ", spawn_location = " + (string)spawn_location);
			collide () // mypos - llVecNorm(spawn_location - mypos)
		_ () //  %% Stay above ground level
		if () // mypos.z <= llGround(ZERO_VECTOR)
			collide () // mypos - llGroundNormal(ZERO_VECTOR)
	default ()
		state_entry ()
			llResetTime ()
			llSay () // 0, "Fishy spawned."
			_ () //  %% School
			if () // school
				llListen () // school_comm_channel, "", NULL_KEY, ""
			_ () //  %% Sandbox
			llSetStatus () // STATUS_SANDBOX, sandbox
			llSetStatus () // STATUS_BLOCK_GRAB, FALSE
			spawn_location (out) //   llGetPos()
			_ () //  %% Initialize physics behavior
			mass (out) //   llGetMass()
			llSetBuoyancy () // 1.0
			llSetStatus () // STATUS_PHYSICS, TRUE
			llVolumeDetect () // TRUE
			_ () //  %% Initialize sensor
			llSensorRepeat () // llGetObjectName(), NULL_KEY, ACTIVE|SCRIPTED, sensor_distance, PI, timer_length
		collision_start ()
			total_number (in) & // integer
			_ () //  %% llSay(0, "collide() called due to physical object collision.");
			collide () // llDetectedPos(0)
		no_sensor ()
			sensor_any ()
		sensor ()
			total_number (in) & // integer
			sensor_any ()
			_ () //  %% Populate neighbors with the positions of the two nearest neighbors.
			mypos (out) // vector  llGetPos()
			neighbors (out) // list  []
			i (out) // integer
			for () // i = 0; i < total_number; i++
				current_pos (out) // vector  llDetectedPos(i)
				if () // llGetListLength(neighbors) < 2
					_ () //  %% Add to list
					neighbors (out) //   llListInsertList(neighbors, [current_pos], llGetListLength(neighbors))
				else ()
					_ () //  %%  CRLF Check to see if the current vector is closer than the list CRLF vector which is furthest away.
					if () // llVecDist(mypos, llList2Vector(neighbors, 0)) > llVecDist(mypos, llList2Vector(neighbors, 1))
						_ () //  %% check against first list item
						if () // llVecDist(mypos, llList2Vector(neighbors, 0)) > llVecDist(mypos, current_pos)
							llListInsertList () // neighbors, [current_pos], 0
					else ()
						_ () //  %% check against second list item
						if () // llVecDist(mypos, llList2Vector(neighbors, 1)) > llVecDist(mypos, current_pos)
							llListInsertList () // neighbors, [current_pos], 1
			_ () //  %%  CRLF Process movement CRLF Apply force
			if () // llGetListLength(neighbors) == 2
				neighbor1 (out) // vector  llList2Vector(neighbors, 0)
				neighbor2 (out) // vector  llList2Vector(neighbors, 1)
				target (out) // vector  neighbor2 + ((neighbor1 - neighbor2) * 0.5)
				impulse (out) // vector  <0, 0, 0>
				if () // school
					impulse (out) //   llVecNorm(target + school_modifier - mypos)
				else ()
					impulse (out) //   llVecNorm(target - mypos)
				_ () //  %% llSay(0, "setforce " + (string)(impulse * force_modifier * mass));
				llSetForce () // impulse * force_modifier * mass, FALSE
			_ () //  %% Update rotation
			do_rotation () // llGetPos(), llGetVel()
		listen ()
			channel (in) & // integer
			name (in) & // string
			id (in) & // key
			message (in) & // string
			myList (out) // list  llCSV2List(llGetSubString(message, 1, llStringLength(message) - 2))
			if () // llGetListLength(myList) == 3
				school_modifier (out) //   <llList2Float(myList, 0), llList2Float(myList, 1), llList2Float(myList, 2)>
				school_timer (out) //   llGetTime()
		on_rez ()
			start_param (in) & // integer
			llResetScript ()
			_ () //  %%  CRLF spawn_location = llGetPos(); CRLF llResetTime();
